
/* Copyright (c) 2021-2022, Qualcomm Innovation Center, Inc. All rights reserved.
 *
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifndef __WCSS_SEQ_HWIOREG_UMAC_H__
#define __WCSS_SEQ_HWIOREG_UMAC_H__




#include "seq_hwio.h"
#include "wcss_seq_hwiobase.h"
#ifdef SCALE_INCLUDES
#include "HALhwio.h"
#else
#include "msmhwio.h"
#endif

#define WBM_REG_REG_BASE                                                                                        (UMAC_BASE      + 0x00034000)
#define WBM_REG_REG_BASE_SIZE                                                                                   0x4000
#define WBM_REG_REG_BASE_USED                                                                                   0x3124
#define WBM_REG_REG_BASE_PHYS                                                                                   (UMAC_BASE_PHYS + 0x00034000)
#define WBM_REG_REG_BASE_OFFS                                                                                   0x00034000

#define HWIO_WBM_R0_DUP_DET_START_COOKIE_ADDR(x)                                                                ((x) + 0x3c)
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_PHYS(x)                                                                ((x) + 0x3c)
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_OFFS                                                                   (0x3c)
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_RMSK                                                                      0xfffff
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_POR                                                                    0x00000000
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_POR_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_ATTR                                                                                0x3
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_IN(x)            \
                in_dword(HWIO_WBM_R0_DUP_DET_START_COOKIE_ADDR(x))
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_DUP_DET_START_COOKIE_ADDR(x), m)
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_DUP_DET_START_COOKIE_ADDR(x),v)
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_DUP_DET_START_COOKIE_ADDR(x),m,v,HWIO_WBM_R0_DUP_DET_START_COOKIE_IN(x))
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_DUP_DET_START_COOKIE_BMSK                                                 0xfffff
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_DUP_DET_START_COOKIE_SHFT                                                       0

#define HWIO_WBM_R0_SW_COOKIE_CFG0_ADDR(x)                                                                      ((x) + 0x40)
#define HWIO_WBM_R0_SW_COOKIE_CFG0_PHYS(x)                                                                      ((x) + 0x40)
#define HWIO_WBM_R0_SW_COOKIE_CFG0_OFFS                                                                         (0x40)
#define HWIO_WBM_R0_SW_COOKIE_CFG0_RMSK                                                                         0xffffffff
#define HWIO_WBM_R0_SW_COOKIE_CFG0_POR                                                                          0x00000000
#define HWIO_WBM_R0_SW_COOKIE_CFG0_POR_RMSK                                                                     0xffffffff
#define HWIO_WBM_R0_SW_COOKIE_CFG0_ATTR                                                                                      0x3
#define HWIO_WBM_R0_SW_COOKIE_CFG0_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_COOKIE_CFG0_ADDR(x))
#define HWIO_WBM_R0_SW_COOKIE_CFG0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_COOKIE_CFG0_ADDR(x), m)
#define HWIO_WBM_R0_SW_COOKIE_CFG0_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_COOKIE_CFG0_ADDR(x),v)
#define HWIO_WBM_R0_SW_COOKIE_CFG0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_COOKIE_CFG0_ADDR(x),m,v,HWIO_WBM_R0_SW_COOKIE_CFG0_IN(x))
#define HWIO_WBM_R0_SW_COOKIE_CFG0_CMEM_LUT_BASE_ADDR_31_0_BMSK                                                 0xffffffff
#define HWIO_WBM_R0_SW_COOKIE_CFG0_CMEM_LUT_BASE_ADDR_31_0_SHFT                                                          0

#define HWIO_WBM_R0_SW_COOKIE_CFG1_ADDR(x)                                                                      ((x) + 0x44)
#define HWIO_WBM_R0_SW_COOKIE_CFG1_PHYS(x)                                                                      ((x) + 0x44)
#define HWIO_WBM_R0_SW_COOKIE_CFG1_OFFS                                                                         (0x44)
#define HWIO_WBM_R0_SW_COOKIE_CFG1_RMSK                                                                            0x7ffff
#define HWIO_WBM_R0_SW_COOKIE_CFG1_POR                                                                          0x00011700
#define HWIO_WBM_R0_SW_COOKIE_CFG1_POR_RMSK                                                                     0xffffffff
#define HWIO_WBM_R0_SW_COOKIE_CFG1_ATTR                                                                                      0x3
#define HWIO_WBM_R0_SW_COOKIE_CFG1_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_COOKIE_CFG1_ADDR(x))
#define HWIO_WBM_R0_SW_COOKIE_CFG1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_COOKIE_CFG1_ADDR(x), m)
#define HWIO_WBM_R0_SW_COOKIE_CFG1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_COOKIE_CFG1_ADDR(x),v)
#define HWIO_WBM_R0_SW_COOKIE_CFG1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_COOKIE_CFG1_ADDR(x),m,v,HWIO_WBM_R0_SW_COOKIE_CFG1_IN(x))
#define HWIO_WBM_R0_SW_COOKIE_CFG1_PAGE_ALIGNMENT_BMSK                                                             0x40000
#define HWIO_WBM_R0_SW_COOKIE_CFG1_PAGE_ALIGNMENT_SHFT                                                                  18
#define HWIO_WBM_R0_SW_COOKIE_CFG1_COOKIE_OFFSET_MSB_BMSK                                                          0x3e000
#define HWIO_WBM_R0_SW_COOKIE_CFG1_COOKIE_OFFSET_MSB_SHFT                                                               13
#define HWIO_WBM_R0_SW_COOKIE_CFG1_COOKIE_PAGE_MSB_BMSK                                                             0x1f00
#define HWIO_WBM_R0_SW_COOKIE_CFG1_COOKIE_PAGE_MSB_SHFT                                                                  8
#define HWIO_WBM_R0_SW_COOKIE_CFG1_CMEM_LUT_BASE_ADDR_39_32_BMSK                                                      0xff
#define HWIO_WBM_R0_SW_COOKIE_CFG1_CMEM_LUT_BASE_ADDR_39_32_SHFT                                                         0

#define HWIO_WBM_R0_WBM_CFG_2_ADDR(x)                                                                           ((x) + 0x90)
#define HWIO_WBM_R0_WBM_CFG_2_PHYS(x)                                                                           ((x) + 0x90)
#define HWIO_WBM_R0_WBM_CFG_2_OFFS                                                                              (0x90)
#define HWIO_WBM_R0_WBM_CFG_2_RMSK                                                                                    0x7f
#define HWIO_WBM_R0_WBM_CFG_2_POR                                                                               0x00000040
#define HWIO_WBM_R0_WBM_CFG_2_POR_RMSK                                                                          0xffffffff
#define HWIO_WBM_R0_WBM_CFG_2_ATTR                                                                                           0x3
#define HWIO_WBM_R0_WBM_CFG_2_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_CFG_2_ADDR(x))
#define HWIO_WBM_R0_WBM_CFG_2_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_CFG_2_ADDR(x), m)
#define HWIO_WBM_R0_WBM_CFG_2_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_CFG_2_ADDR(x),v)
#define HWIO_WBM_R0_WBM_CFG_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_CFG_2_ADDR(x),m,v,HWIO_WBM_R0_WBM_CFG_2_IN(x))
#define HWIO_WBM_R0_WBM_CFG_2_COOKIE_DEBUG_SEL_BMSK                                                                   0x40
#define HWIO_WBM_R0_WBM_CFG_2_COOKIE_DEBUG_SEL_SHFT                                                                      6
#define HWIO_WBM_R0_WBM_CFG_2_TRANS_BUNCHING_UPDATE_BMSK                                                              0x20
#define HWIO_WBM_R0_WBM_CFG_2_TRANS_BUNCHING_UPDATE_SHFT                                                                 5
#define HWIO_WBM_R0_WBM_CFG_2_TRANS_BUNCHING_256B_EN_BMSK                                                             0x10
#define HWIO_WBM_R0_WBM_CFG_2_TRANS_BUNCHING_256B_EN_SHFT                                                                4
#define HWIO_WBM_R0_WBM_CFG_2_COOKIE_CONV_INDICATION_EN_BMSK                                                           0x8
#define HWIO_WBM_R0_WBM_CFG_2_COOKIE_CONV_INDICATION_EN_SHFT                                                             3
#define HWIO_WBM_R0_WBM_CFG_2_OUT_OF_ORDER_RELEASE_EN_BMSK                                                             0x4
#define HWIO_WBM_R0_WBM_CFG_2_OUT_OF_ORDER_RELEASE_EN_SHFT                                                               2
#define HWIO_WBM_R0_WBM_CFG_2_ERROR_PATH_COOKIE_CONV_EN_BMSK                                                           0x2
#define HWIO_WBM_R0_WBM_CFG_2_ERROR_PATH_COOKIE_CONV_EN_SHFT                                                             1
#define HWIO_WBM_R0_WBM_CFG_2_RELEASE_PATH_COOKIE_CONV_EN_BMSK                                                         0x1
#define HWIO_WBM_R0_WBM_CFG_2_RELEASE_PATH_COOKIE_CONV_EN_SHFT                                                           0

#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_ADDR(x)                                                               ((x) + 0x94)
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_PHYS(x)                                                               ((x) + 0x94)
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_OFFS                                                                  (0x94)
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_RMSK                                                                       0x1ff
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_POR                                                                   0x000001fe
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_ATTR                                                                               0x3
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_ADDR(x))
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_ADDR(x), m)
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_ADDR(x),v)
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_ADDR(x),m,v,HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_IN(x))
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM_COOKIE_CONV_GLOBAL_ENABLE_BMSK                                         0x100
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM_COOKIE_CONV_GLOBAL_ENABLE_SHFT                                             8
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW6_COOKIE_CONVERSION_EN_BMSK                                           0x80
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW6_COOKIE_CONVERSION_EN_SHFT                                              7
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW5_COOKIE_CONVERSION_EN_BMSK                                           0x40
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW5_COOKIE_CONVERSION_EN_SHFT                                              6
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW4_COOKIE_CONVERSION_EN_BMSK                                           0x20
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW4_COOKIE_CONVERSION_EN_SHFT                                              5
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW3_COOKIE_CONVERSION_EN_BMSK                                           0x10
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW3_COOKIE_CONVERSION_EN_SHFT                                              4
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW2_COOKIE_CONVERSION_EN_BMSK                                            0x8
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW2_COOKIE_CONVERSION_EN_SHFT                                              3
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW1_COOKIE_CONVERSION_EN_BMSK                                            0x4
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW1_COOKIE_CONVERSION_EN_SHFT                                              2
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW0_COOKIE_CONVERSION_EN_BMSK                                            0x2
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW0_COOKIE_CONVERSION_EN_SHFT                                              1
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2FW_COOKIE_CONVERSION_EN_BMSK                                             0x1
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2FW_COOKIE_CONVERSION_EN_SHFT                                               0

#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_ADDR(x)                                                                 ((x) + 0x98)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_PHYS(x)                                                                 ((x) + 0x98)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_OFFS                                                                    (0x98)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_RMSK                                                                    0xffffffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_POR                                                                     0x00000000
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_ATTR                                                                                 0x3
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_IN(x)            \
                in_dword(HWIO_WBM_R0_LINK_DESC_RING_CFG0_ADDR(x))
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_LINK_DESC_RING_CFG0_ADDR(x), m)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_LINK_DESC_RING_CFG0_ADDR(x),v)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_LINK_DESC_RING_CFG0_ADDR(x),m,v,HWIO_WBM_R0_LINK_DESC_RING_CFG0_IN(x))
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_WBM2REO_LINK_RING_WATERMARK_BMSK                                        0xffff0000
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_WBM2REO_LINK_RING_WATERMARK_SHFT                                                16
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_WBM2TQM_LINK_RING_WATERMARK_BMSK                                            0xffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_WBM2TQM_LINK_RING_WATERMARK_SHFT                                                 0

#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_ADDR(x)                                                                 ((x) + 0x9c)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_PHYS(x)                                                                 ((x) + 0x9c)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_OFFS                                                                    (0x9c)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_RMSK                                                                    0xffffffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_POR                                                                     0x00000000
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_ATTR                                                                                 0x3
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_IN(x)            \
                in_dword(HWIO_WBM_R0_LINK_DESC_RING_CFG1_ADDR(x))
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_LINK_DESC_RING_CFG1_ADDR(x), m)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_LINK_DESC_RING_CFG1_ADDR(x),v)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_LINK_DESC_RING_CFG1_ADDR(x),m,v,HWIO_WBM_R0_LINK_DESC_RING_CFG1_IN(x))
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_WBM2FW_LINK_RING_WATERMARK_BMSK                                         0xffff0000
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_WBM2FW_LINK_RING_WATERMARK_SHFT                                                 16
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_WBM2SW_LINK_RING_WATERMARK_BMSK                                             0xffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_WBM2SW_LINK_RING_WATERMARK_SHFT                                                  0

#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_ADDR(x)                                                                 ((x) + 0xa0)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_PHYS(x)                                                                 ((x) + 0xa0)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_OFFS                                                                    (0xa0)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_RMSK                                                                        0xffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_POR                                                                     0x00000000
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_ATTR                                                                                 0x3
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_IN(x)            \
                in_dword(HWIO_WBM_R0_LINK_DESC_RING_CFG2_ADDR(x))
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_LINK_DESC_RING_CFG2_ADDR(x), m)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_LINK_DESC_RING_CFG2_ADDR(x),v)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_LINK_DESC_RING_CFG2_ADDR(x),m,v,HWIO_WBM_R0_LINK_DESC_RING_CFG2_IN(x))
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_WBM2RXDMA0_LINK_RING_WATERMARK_BMSK                                         0xffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_WBM2RXDMA0_LINK_RING_WATERMARK_SHFT                                              0

#define HWIO_WBM_R0_IDLE_LIST_CONTROL_ADDR(x)                                                                   ((x) + 0x210)
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_PHYS(x)                                                                   ((x) + 0x210)
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_OFFS                                                                      (0x210)
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_RMSK                                                                           0x7ff
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_POR                                                                       0x00000010
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_POR_RMSK                                                                  0xffffffff
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_ATTR                                                                                   0x3
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_IN(x)            \
                in_dword(HWIO_WBM_R0_IDLE_LIST_CONTROL_ADDR(x))
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_IDLE_LIST_CONTROL_ADDR(x), m)
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_IDLE_LIST_CONTROL_ADDR(x),v)
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_IDLE_LIST_CONTROL_ADDR(x),m,v,HWIO_WBM_R0_IDLE_LIST_CONTROL_IN(x))
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_SCATTER_BUFFER_SIZE_BMSK                                                       0x7fc
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_SCATTER_BUFFER_SIZE_SHFT                                                           2
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_LINK_DESC_IDLE_LIST_MODE_BMSK                                                    0x2
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_LINK_DESC_IDLE_LIST_MODE_SHFT                                                      1
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_BUFFER_IDLE_LIST_MODE_BMSK                                                       0x1
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_BUFFER_IDLE_LIST_MODE_SHFT                                                         0

#define HWIO_WBM_R0_IDLE_LIST_SIZE_ADDR(x)                                                                      ((x) + 0x214)
#define HWIO_WBM_R0_IDLE_LIST_SIZE_PHYS(x)                                                                      ((x) + 0x214)
#define HWIO_WBM_R0_IDLE_LIST_SIZE_OFFS                                                                         (0x214)
#define HWIO_WBM_R0_IDLE_LIST_SIZE_RMSK                                                                         0xffffffff
#define HWIO_WBM_R0_IDLE_LIST_SIZE_POR                                                                          0x00020002
#define HWIO_WBM_R0_IDLE_LIST_SIZE_POR_RMSK                                                                     0xffffffff
#define HWIO_WBM_R0_IDLE_LIST_SIZE_ATTR                                                                                      0x3
#define HWIO_WBM_R0_IDLE_LIST_SIZE_IN(x)            \
                in_dword(HWIO_WBM_R0_IDLE_LIST_SIZE_ADDR(x))
#define HWIO_WBM_R0_IDLE_LIST_SIZE_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_IDLE_LIST_SIZE_ADDR(x), m)
#define HWIO_WBM_R0_IDLE_LIST_SIZE_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_IDLE_LIST_SIZE_ADDR(x),v)
#define HWIO_WBM_R0_IDLE_LIST_SIZE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_IDLE_LIST_SIZE_ADDR(x),m,v,HWIO_WBM_R0_IDLE_LIST_SIZE_IN(x))
#define HWIO_WBM_R0_IDLE_LIST_SIZE_SCATTER_RING_SIZE_OF_IDLE_LINK_DESC_LIST_BMSK                                0xffff0000
#define HWIO_WBM_R0_IDLE_LIST_SIZE_SCATTER_RING_SIZE_OF_IDLE_LINK_DESC_LIST_SHFT                                        16
#define HWIO_WBM_R0_IDLE_LIST_SIZE_SCATTER_RING_SIZE_OF_IDLE_BUF_LIST_BMSK                                          0xffff
#define HWIO_WBM_R0_IDLE_LIST_SIZE_SCATTER_RING_SIZE_OF_IDLE_BUF_LIST_SHFT                                               0

#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_ADDR(x)                                                   ((x) + 0x220)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_PHYS(x)                                                   ((x) + 0x220)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_OFFS                                                      (0x220)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_POR                                                       0x00000000
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_POR_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_ATTR                                                                   0x3
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_IN(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_BASE_ADDRESS_31_0_BMSK                                    0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_BASE_ADDRESS_31_0_SHFT                                             0

#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_ADDR(x)                                                   ((x) + 0x224)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_PHYS(x)                                                   ((x) + 0x224)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_OFFS                                                      (0x224)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_POR                                                       0x00000000
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_POR_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_ATTR                                                                   0x3
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_IN(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_ADDRESS_MATCH_TAG_BMSK                                    0xffffff00
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_ADDRESS_MATCH_TAG_SHFT                                             8
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_BASE_ADDRESS_39_32_BMSK                                         0xff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_BASE_ADDRESS_39_32_SHFT                                            0

#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_ADDR(x)                                               ((x) + 0x230)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_PHYS(x)                                               ((x) + 0x230)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_OFFS                                                  (0x230)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_POR                                                   0x00000000
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_POR_RMSK                                              0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_ATTR                                                               0x3
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_IN(x)            \
                in_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_ADDR(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_ADDR(x), m)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_ADDR(x),v)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_ADDR(x),m,v,HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_IN(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_BUFFER_ADDRESS_31_0_BMSK                              0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_BUFFER_ADDRESS_31_0_SHFT                                       0

#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_ADDR(x)                                               ((x) + 0x234)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_PHYS(x)                                               ((x) + 0x234)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_OFFS                                                  (0x234)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_RMSK                                                    0x1fffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_POR                                                   0x00000000
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_POR_RMSK                                              0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_ATTR                                                               0x3
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_IN(x)            \
                in_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_ADDR(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_ADDR(x), m)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_ADDR(x),v)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_ADDR(x),m,v,HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_IN(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_HEAD_POINTER_OFFSET_BMSK                                0x1fff00
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_HEAD_POINTER_OFFSET_SHFT                                       8
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_BUFFER_ADDRESS_39_32_BMSK                                   0xff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_BUFFER_ADDRESS_39_32_SHFT                                      0

#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_ADDR(x)                                               ((x) + 0x240)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_PHYS(x)                                               ((x) + 0x240)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_OFFS                                                  (0x240)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_POR                                                   0x00000000
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_POR_RMSK                                              0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_ATTR                                                               0x3
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_IN(x)            \
                in_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_ADDR(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_ADDR(x), m)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_ADDR(x),v)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_ADDR(x),m,v,HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_IN(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_BUFFER_ADDRESS_31_0_BMSK                              0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_BUFFER_ADDRESS_31_0_SHFT                                       0

#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_ADDR(x)                                               ((x) + 0x244)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_PHYS(x)                                               ((x) + 0x244)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_OFFS                                                  (0x244)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_RMSK                                                    0x1fffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_POR                                                   0x00000000
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_POR_RMSK                                              0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_ATTR                                                               0x3
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_IN(x)            \
                in_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_ADDR(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_ADDR(x), m)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_ADDR(x),v)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_ADDR(x),m,v,HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_IN(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_TAIL_POINTER_OFFSET_BMSK                                0x1fff00
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_TAIL_POINTER_OFFSET_SHFT                                       8
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_BUFFER_ADDRESS_39_32_BMSK                                   0xff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_BUFFER_ADDRESS_39_32_SHFT                                      0

#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_ADDR(x)                                                          ((x) + 0x24c)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_PHYS(x)                                                          ((x) + 0x24c)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_OFFS                                                             (0x24c)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_RMSK                                                                0xfffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_POR                                                              0x00000000
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_ATTR                                                                          0x3
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_IN(x)            \
                in_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_ADDR(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_ADDR(x), m)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_ADDR(x),v)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_ADDR(x),m,v,HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_IN(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_SCAT_HEAD_PTR_BMSK                                                  0xfffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_SCAT_HEAD_PTR_SHFT                                                        0

#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_ADDR(x)                                                          ((x) + 0x254)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_PHYS(x)                                                          ((x) + 0x254)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_OFFS                                                             (0x254)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_RMSK                                                                0xfffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_POR                                                              0x00000000
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_ATTR                                                                          0x3
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_IN(x)            \
                in_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_ADDR(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_ADDR(x), m)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_ADDR(x),v)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_ADDR(x),m,v,HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_IN(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_SCAT_TAIL_PTR_BMSK                                                  0xfffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_SCAT_TAIL_PTR_SHFT                                                        0

#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_ADDR(x)                                                            ((x) + 0x34c)
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_PHYS(x)                                                            ((x) + 0x34c)
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_OFFS                                                               (0x34c)
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_POR                                                                0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_ATTR                                                                            0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                            0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                     0

#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_ADDR(x)                                                            ((x) + 0x350)
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_PHYS(x)                                                            ((x) + 0x350)
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_OFFS                                                               (0x350)
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_RMSK                                                                 0xffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_POR                                                                0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_ATTR                                                                            0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                       0xffff00
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                              8
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                  0xff
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                     0

#define HWIO_WBM_R0_SW_RELEASE_RING_ID_ADDR(x)                                                                  ((x) + 0x354)
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_PHYS(x)                                                                  ((x) + 0x354)
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_OFFS                                                                     (0x354)
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_RMSK                                                                           0xff
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_POR                                                                      0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_POR_RMSK                                                                 0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_ATTR                                                                                  0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                                0xff
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                                   0

#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_ADDR(x)                                                              ((x) + 0x358)
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_PHYS(x)                                                              ((x) + 0x358)
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_OFFS                                                                 (0x358)
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_RMSK                                                                 0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_POR                                                                  0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_ATTR                                                                              0x1
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                 0xffff0000
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                         16
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                     0xffff
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                          0

#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_ADDR(x)                                                                ((x) + 0x35c)
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_PHYS(x)                                                                ((x) + 0x35c)
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_OFFS                                                                   (0x35c)
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_RMSK                                                                     0x3fffff
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_POR                                                                    0x00000080
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_POR_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_ATTR                                                                                0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                       0x3fc000
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                             14
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                        0x3000
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                            12
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                         0xf00
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                             8
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                            0x80
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                               7
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                             0x40
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                                6
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                       0x20
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                          5
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                        0x10
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                           4
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                             0x8
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                               3
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                             0x4
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                               2
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                          0x2
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                            1
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                          0x1
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                            0

#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_ADDR(x)                                                         ((x) + 0x368)
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_PHYS(x)                                                         ((x) + 0x368)
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_OFFS                                                            (0x368)
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_POR                                                             0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_ATTR                                                                         0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                       0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                                0

#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_ADDR(x)                                                         ((x) + 0x36c)
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_PHYS(x)                                                         ((x) + 0x36c)
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_OFFS                                                            (0x36c)
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_RMSK                                                                  0xff
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_POR                                                             0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_ATTR                                                                         0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                             0xff
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                                0

#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                              ((x) + 0x37c)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                              ((x) + 0x37c)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                 (0x37c)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_POR                                                  0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                             0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                              0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                       0xffff0000
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                               16
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                   0x8000
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                       15
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                             0x7fff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                  0

#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                              ((x) + 0x380)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                              ((x) + 0x380)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                 (0x380)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                     0xffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_POR                                                  0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                             0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                              0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                       0xffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                            0

#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x)                                                 ((x) + 0x384)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_PHYS(x)                                                 ((x) + 0x384)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_OFFS                                                    (0x384)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_POR                                                     0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_ATTR                                                                 0x1
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                      0xffff0000
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                              16
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                 0x8000
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                     15
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                           0x7fff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                0

#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                              ((x) + 0x388)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                              ((x) + 0x388)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                 (0x388)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                      0x3ff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_POR                                                  0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                             0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                              0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                   0x3ff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                       0

#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                             ((x) + 0x38c)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                             ((x) + 0x38c)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OFFS                                                (0x38c)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                       0x7
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_POR                                                 0x00000003
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                             0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                  0x7
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                    0

#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                            ((x) + 0x390)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                            ((x) + 0x390)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_OFFS                                               (0x390)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                 0xffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_POR                                                0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                            0x1
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                  0xff0000
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                        16
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                 0xffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                      0

#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                       ((x) + 0x394)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                       ((x) + 0x394)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                          (0x394)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_POR                                                           0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                       ((x) + 0x398)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                       ((x) + 0x398)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                          (0x398)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_POR                                                           0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                   0x100
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                       8
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_ADDR(x)                                                           ((x) + 0x39c)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_PHYS(x)                                                           ((x) + 0x39c)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_OFFS                                                              (0x39c)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_POR                                                               0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_ATTR                                                                           0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                                 0

#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                     ((x) + 0x3bc)
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                     ((x) + 0x3bc)
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                        (0x3bc)
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                            0xffff
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                         0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                     0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                         0xffff
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                              0

#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_ADDR(x)                                                              ((x) + 0x3c0)
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_PHYS(x)                                                              ((x) + 0x3c0)
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_OFFS                                                                 (0x3c0)
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_RMSK                                                                 0xffff003f
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_POR                                                                  0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_ATTR                                                                              0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                        0xffff0000
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                16
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                               0x3f
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                  0

#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_LSB_ADDR(x)                                                           ((x) + 0x3c4)
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_LSB_PHYS(x)                                                           ((x) + 0x3c4)
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_LSB_OFFS                                                              (0x3c4)
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_LSB_POR                                                               0x00000000
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_LSB_ATTR                                                                           0x3
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_SW1_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW1_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW1_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW1_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_SW1_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                           0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                    0

#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_MSB_ADDR(x)                                                           ((x) + 0x3c8)
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_MSB_PHYS(x)                                                           ((x) + 0x3c8)
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_MSB_OFFS                                                              (0x3c8)
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_MSB_RMSK                                                                0xffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_MSB_POR                                                               0x00000000
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_MSB_ATTR                                                                           0x3
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_SW1_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW1_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW1_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW1_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_SW1_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xffff00
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                             8
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                 0xff
#define HWIO_WBM_R0_SW1_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                    0

#define HWIO_WBM_R0_SW1_RELEASE_RING_ID_ADDR(x)                                                                 ((x) + 0x3cc)
#define HWIO_WBM_R0_SW1_RELEASE_RING_ID_PHYS(x)                                                                 ((x) + 0x3cc)
#define HWIO_WBM_R0_SW1_RELEASE_RING_ID_OFFS                                                                    (0x3cc)
#define HWIO_WBM_R0_SW1_RELEASE_RING_ID_RMSK                                                                          0xff
#define HWIO_WBM_R0_SW1_RELEASE_RING_ID_POR                                                                     0x00000000
#define HWIO_WBM_R0_SW1_RELEASE_RING_ID_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_ID_ATTR                                                                                 0x3
#define HWIO_WBM_R0_SW1_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_SW1_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW1_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_SW1_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW1_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_SW1_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW1_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_SW1_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                               0xff
#define HWIO_WBM_R0_SW1_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                                  0

#define HWIO_WBM_R0_SW1_RELEASE_RING_STATUS_ADDR(x)                                                             ((x) + 0x3d0)
#define HWIO_WBM_R0_SW1_RELEASE_RING_STATUS_PHYS(x)                                                             ((x) + 0x3d0)
#define HWIO_WBM_R0_SW1_RELEASE_RING_STATUS_OFFS                                                                (0x3d0)
#define HWIO_WBM_R0_SW1_RELEASE_RING_STATUS_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_STATUS_POR                                                                 0x00000000
#define HWIO_WBM_R0_SW1_RELEASE_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_STATUS_ATTR                                                                             0x1
#define HWIO_WBM_R0_SW1_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_SW1_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW1_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_SW1_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                0xffff0000
#define HWIO_WBM_R0_SW1_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                        16
#define HWIO_WBM_R0_SW1_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                    0xffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                         0

#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_ADDR(x)                                                               ((x) + 0x3d4)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_PHYS(x)                                                               ((x) + 0x3d4)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_OFFS                                                                  (0x3d4)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_RMSK                                                                    0x3fffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_POR                                                                   0x00000080
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_ATTR                                                                               0x3
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_SW1_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW1_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW1_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW1_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_SW1_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                      0x3fc000
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                            14
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                       0x3000
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                           12
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                        0xf00
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                            8
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                           0x80
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                              7
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                            0x40
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                               6
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                      0x20
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                         5
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                       0x10
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                          4
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                            0x8
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                              3
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                            0x4
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                              2
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                         0x2
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                           1
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                         0x1
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                           0

#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_LSB_ADDR(x)                                                        ((x) + 0x3e0)
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_LSB_PHYS(x)                                                        ((x) + 0x3e0)
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_LSB_OFFS                                                           (0x3e0)
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_LSB_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_LSB_POR                                                            0x00000000
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_LSB_ATTR                                                                        0x3
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                      0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                               0

#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_MSB_ADDR(x)                                                        ((x) + 0x3e4)
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_MSB_PHYS(x)                                                        ((x) + 0x3e4)
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_MSB_OFFS                                                           (0x3e4)
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_MSB_RMSK                                                                 0xff
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_MSB_POR                                                            0x00000000
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_MSB_ATTR                                                                        0x3
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                            0xff
#define HWIO_WBM_R0_SW1_RELEASE_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                               0

#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                             ((x) + 0x3f4)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                             ((x) + 0x3f4)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                (0x3f4)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX0_POR                                                 0x00000000
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                             0x3
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                             ((x) + 0x3f8)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                             ((x) + 0x3f8)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                (0x3f8)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                    0xffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX1_POR                                                 0x00000000
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                             0x3
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                      0xffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                           0

#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x)                                                ((x) + 0x3fc)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_STATUS_PHYS(x)                                                ((x) + 0x3fc)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_STATUS_OFFS                                                   (0x3fc)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_STATUS_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_STATUS_POR                                                    0x00000000
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_STATUS_ATTR                                                                0x1
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                     0xffff0000
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                             16
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                0x8000
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                    15
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                          0x7fff
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                               0

#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                             ((x) + 0x400)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                             ((x) + 0x400)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                (0x400)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                     0x3ff
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_EMPTY_COUNTER_POR                                                 0x00000000
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                             0x3
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                  0x3ff
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                      0

#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                            ((x) + 0x404)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                            ((x) + 0x404)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OFFS                                               (0x404)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                      0x7
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_TIMER_POR                                                0x00000003
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                            0x3
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                 0x7
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                   0

#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                           ((x) + 0x408)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                           ((x) + 0x408)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_STATUS_OFFS                                              (0x408)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                0xffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_STATUS_POR                                               0x00000000
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                          0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                           0x1
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                 0xff0000
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                       16
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                0xffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                     0

#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                      ((x) + 0x40c)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                      ((x) + 0x40c)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                         (0x40c)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_LSB_POR                                                          0x00000000
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                      ((x) + 0x410)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                      ((x) + 0x410)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                         (0x410)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_MSB_POR                                                          0x00000000
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                  0x100
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                      8
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_DATA_ADDR(x)                                                          ((x) + 0x414)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_DATA_PHYS(x)                                                          ((x) + 0x414)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_DATA_OFFS                                                             (0x414)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_DATA_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_DATA_POR                                                              0x00000000
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_DATA_ATTR                                                                          0x3
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                                0

#define HWIO_WBM_R0_SW1_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                    ((x) + 0x434)
#define HWIO_WBM_R0_SW1_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                    ((x) + 0x434)
#define HWIO_WBM_R0_SW1_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                       (0x434)
#define HWIO_WBM_R0_SW1_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                           0xffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                        0x00000000
#define HWIO_WBM_R0_SW1_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                    0x3
#define HWIO_WBM_R0_SW1_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_SW1_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW1_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_SW1_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW1_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_SW1_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW1_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_SW1_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                        0xffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                             0

#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_1_ADDR(x)                                                             ((x) + 0x438)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_1_PHYS(x)                                                             ((x) + 0x438)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_1_OFFS                                                                (0x438)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_1_RMSK                                                                0xffff003f
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_1_POR                                                                 0x00000000
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_1_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_1_ATTR                                                                             0x3
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_SW1_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW1_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW1_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW1_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_SW1_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                       0xffff0000
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                               16
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                              0x3f
#define HWIO_WBM_R0_SW1_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                 0

#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_LSB_ADDR(x)                                                           ((x) + 0x43c)
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_LSB_PHYS(x)                                                           ((x) + 0x43c)
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_LSB_OFFS                                                              (0x43c)
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_LSB_POR                                                               0x00000000
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_LSB_ATTR                                                                           0x3
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_PPE_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_PPE_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_PPE_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_PPE_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_PPE_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                           0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                    0

#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_MSB_ADDR(x)                                                           ((x) + 0x440)
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_MSB_PHYS(x)                                                           ((x) + 0x440)
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_MSB_OFFS                                                              (0x440)
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_MSB_RMSK                                                                0xffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_MSB_POR                                                               0x00000000
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_MSB_ATTR                                                                           0x3
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_PPE_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_PPE_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_PPE_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_PPE_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_PPE_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xffff00
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                             8
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                 0xff
#define HWIO_WBM_R0_PPE_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                    0

#define HWIO_WBM_R0_PPE_RELEASE_RING_ID_ADDR(x)                                                                 ((x) + 0x444)
#define HWIO_WBM_R0_PPE_RELEASE_RING_ID_PHYS(x)                                                                 ((x) + 0x444)
#define HWIO_WBM_R0_PPE_RELEASE_RING_ID_OFFS                                                                    (0x444)
#define HWIO_WBM_R0_PPE_RELEASE_RING_ID_RMSK                                                                          0xff
#define HWIO_WBM_R0_PPE_RELEASE_RING_ID_POR                                                                     0x00000000
#define HWIO_WBM_R0_PPE_RELEASE_RING_ID_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_ID_ATTR                                                                                 0x3
#define HWIO_WBM_R0_PPE_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_PPE_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_PPE_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_PPE_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_PPE_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_PPE_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_PPE_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_PPE_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                               0xff
#define HWIO_WBM_R0_PPE_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                                  0

#define HWIO_WBM_R0_PPE_RELEASE_RING_STATUS_ADDR(x)                                                             ((x) + 0x448)
#define HWIO_WBM_R0_PPE_RELEASE_RING_STATUS_PHYS(x)                                                             ((x) + 0x448)
#define HWIO_WBM_R0_PPE_RELEASE_RING_STATUS_OFFS                                                                (0x448)
#define HWIO_WBM_R0_PPE_RELEASE_RING_STATUS_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_STATUS_POR                                                                 0x00000000
#define HWIO_WBM_R0_PPE_RELEASE_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_STATUS_ATTR                                                                             0x1
#define HWIO_WBM_R0_PPE_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_PPE_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_PPE_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_PPE_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                0xffff0000
#define HWIO_WBM_R0_PPE_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                        16
#define HWIO_WBM_R0_PPE_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                    0xffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                         0

#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_ADDR(x)                                                               ((x) + 0x44c)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_PHYS(x)                                                               ((x) + 0x44c)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_OFFS                                                                  (0x44c)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_RMSK                                                                    0x3fffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_POR                                                                   0x00000080
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_ATTR                                                                               0x3
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_PPE_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_PPE_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_PPE_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_PPE_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_PPE_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                      0x3fc000
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                            14
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                       0x3000
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                           12
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                        0xf00
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                            8
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                           0x80
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                              7
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                            0x40
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                               6
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                      0x20
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                         5
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                       0x10
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                          4
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                            0x8
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                              3
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                            0x4
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                              2
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                         0x2
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                           1
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                         0x1
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                           0

#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_LSB_ADDR(x)                                                        ((x) + 0x458)
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_LSB_PHYS(x)                                                        ((x) + 0x458)
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_LSB_OFFS                                                           (0x458)
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_LSB_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_LSB_POR                                                            0x00000000
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_LSB_ATTR                                                                        0x3
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                      0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                               0

#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_MSB_ADDR(x)                                                        ((x) + 0x45c)
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_MSB_PHYS(x)                                                        ((x) + 0x45c)
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_MSB_OFFS                                                           (0x45c)
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_MSB_RMSK                                                                 0xff
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_MSB_POR                                                            0x00000000
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_MSB_ATTR                                                                        0x3
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                            0xff
#define HWIO_WBM_R0_PPE_RELEASE_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                               0

#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                             ((x) + 0x46c)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                             ((x) + 0x46c)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                (0x46c)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX0_POR                                                 0x00000000
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                             0x3
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                             ((x) + 0x470)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                             ((x) + 0x470)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                (0x470)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                    0xffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX1_POR                                                 0x00000000
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                             0x3
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                      0xffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                           0

#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x)                                                ((x) + 0x474)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_STATUS_PHYS(x)                                                ((x) + 0x474)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_STATUS_OFFS                                                   (0x474)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_STATUS_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_STATUS_POR                                                    0x00000000
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_STATUS_ATTR                                                                0x1
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                     0xffff0000
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                             16
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                0x8000
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                    15
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                          0x7fff
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                               0

#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                             ((x) + 0x478)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                             ((x) + 0x478)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                (0x478)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                     0x3ff
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_EMPTY_COUNTER_POR                                                 0x00000000
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                             0x3
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                  0x3ff
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                      0

#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                            ((x) + 0x47c)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                            ((x) + 0x47c)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OFFS                                               (0x47c)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                      0x7
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_TIMER_POR                                                0x00000003
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                            0x3
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                 0x7
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                   0

#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                           ((x) + 0x480)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                           ((x) + 0x480)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_STATUS_OFFS                                              (0x480)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                0xffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_STATUS_POR                                               0x00000000
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                          0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                           0x1
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                 0xff0000
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                       16
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                0xffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                     0

#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                      ((x) + 0x484)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                      ((x) + 0x484)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                         (0x484)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_LSB_POR                                                          0x00000000
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                      ((x) + 0x488)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                      ((x) + 0x488)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                         (0x488)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_MSB_POR                                                          0x00000000
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                  0x100
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                      8
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_DATA_ADDR(x)                                                          ((x) + 0x48c)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_DATA_PHYS(x)                                                          ((x) + 0x48c)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_DATA_OFFS                                                             (0x48c)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_DATA_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_DATA_POR                                                              0x00000000
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_DATA_ATTR                                                                          0x3
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                                0

#define HWIO_WBM_R0_PPE_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                    ((x) + 0x4ac)
#define HWIO_WBM_R0_PPE_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                    ((x) + 0x4ac)
#define HWIO_WBM_R0_PPE_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                       (0x4ac)
#define HWIO_WBM_R0_PPE_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                           0xffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                        0x00000000
#define HWIO_WBM_R0_PPE_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                    0x3
#define HWIO_WBM_R0_PPE_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_PPE_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_PPE_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_PPE_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_PPE_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_PPE_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_PPE_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_PPE_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                        0xffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                             0

#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_1_ADDR(x)                                                             ((x) + 0x4b0)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_1_PHYS(x)                                                             ((x) + 0x4b0)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_1_OFFS                                                                (0x4b0)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_1_RMSK                                                                0xffff003f
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_1_POR                                                                 0x00000000
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_1_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_1_ATTR                                                                             0x3
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_PPE_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_PPE_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_PPE_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_PPE_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_PPE_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                       0xffff0000
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                               16
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                              0x3f
#define HWIO_WBM_R0_PPE_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                 0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_ADDR(x)                                                           ((x) + 0xa54)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_PHYS(x)                                                           ((x) + 0xa54)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_OFFS                                                              (0xa54)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_POR                                                               0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                    0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_ADDR(x)                                                           ((x) + 0xa58)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_PHYS(x)                                                           ((x) + 0xa58)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_OFFS                                                              (0xa58)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_RMSK                                                                0xffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_POR                                                               0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xffff00
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_RING_SIZE_SHFT                                                             8
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                 0xff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                    0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_ADDR(x)                                                                 ((x) + 0xa5c)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_PHYS(x)                                                                 ((x) + 0xa5c)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_OFFS                                                                    (0xa5c)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_RMSK                                                                        0xffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_POR                                                                     0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_ATTR                                                                                 0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_RING_ID_BMSK                                                                0xff00
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_RING_ID_SHFT                                                                     8
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_ENTRY_SIZE_BMSK                                                               0xff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_ENTRY_SIZE_SHFT                                                                  0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_ADDR(x)                                                             ((x) + 0xa60)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_PHYS(x)                                                             ((x) + 0xa60)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_OFFS                                                                (0xa60)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_ATTR                                                                             0x1
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                0xffff0000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                        16
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_NUM_VALID_WORDS_BMSK                                                    0xffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_NUM_VALID_WORDS_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_ADDR(x)                                                               ((x) + 0xa64)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_PHYS(x)                                                               ((x) + 0xa64)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_OFFS                                                                  (0xa64)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_RMSK                                                                   0x7ffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_POR                                                                   0x00000080
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_ATTR                                                                               0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                           0x4000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                  26
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_LOOP_CNT_BMSK                                                          0x3c00000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_LOOP_CNT_SHFT                                                                 22
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SPARE_CONTROL_BMSK                                                      0x3fc000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SPARE_CONTROL_SHFT                                                            14
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SRNG_SM_STATE2_BMSK                                                       0x3000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SRNG_SM_STATE2_SHFT                                                           12
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SRNG_SM_STATE1_BMSK                                                        0xf00
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SRNG_SM_STATE1_SHFT                                                            8
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SRNG_IS_IDLE_BMSK                                                           0x80
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SRNG_IS_IDLE_SHFT                                                              7
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SRNG_ENABLE_BMSK                                                            0x40
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SRNG_ENABLE_SHFT                                                               6
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                      0x20
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                         5
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                       0x10
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                          4
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_MSI_SWAP_BIT_BMSK                                                            0x8
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_MSI_SWAP_BIT_SHFT                                                              3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SECURITY_BIT_BMSK                                                            0x4
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SECURITY_BIT_SHFT                                                              2
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_LOOPCNT_DISABLE_BMSK                                                         0x2
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_LOOPCNT_DISABLE_SHFT                                                           1
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_RING_ID_DISABLE_BMSK                                                         0x1
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_RING_ID_DISABLE_SHFT                                                           0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_ADDR(x)                                                        ((x) + 0xa68)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_PHYS(x)                                                        ((x) + 0xa68)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_OFFS                                                           (0xa68)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_POR                                                            0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_ATTR                                                                        0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                               0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_ADDR(x)                                                        ((x) + 0xa6c)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_PHYS(x)                                                        ((x) + 0xa6c)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_OFFS                                                           (0xa6c)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_RMSK                                                                 0xff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_POR                                                            0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_ATTR                                                                        0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                            0xff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                               0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_ADDR(x)                                                 ((x) + 0xa78)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_PHYS(x)                                                 ((x) + 0xa78)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_OFFS                                                    (0xa78)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_POR                                                     0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_POR_RMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_ATTR                                                                 0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                          0xffff0000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                  16
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                      0x8000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                          15
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                0x7fff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                     0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_ADDR(x)                                                ((x) + 0xa7c)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_PHYS(x)                                                ((x) + 0xa7c)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_OFFS                                                   (0xa7c)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_ATTR                                                                0x1
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                     0xffff0000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                             16
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                             0x8000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                 15
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                          0x7fff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                               0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                              ((x) + 0xa80)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                              ((x) + 0xa80)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_OFFS                                                 (0xa80)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_RMSK                                                      0x3ff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_POR                                                  0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                             0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_ATTR                                                              0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                    0x3ff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                        0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_ADDR(x)                                                      ((x) + 0xa9c)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_PHYS(x)                                                      ((x) + 0xa9c)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_OFFS                                                         (0xa9c)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_ADDR(x)                                                      ((x) + 0xaa0)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_PHYS(x)                                                      ((x) + 0xaa0)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_OFFS                                                         (0xaa0)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                  0x100
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                      8
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_ADDR(x)                                                          ((x) + 0xaa4)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_PHYS(x)                                                          ((x) + 0xaa4)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_OFFS                                                             (0xaa4)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_POR                                                              0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_ATTR                                                                          0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_VALUE_SHFT                                                                0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                ((x) + 0xaa8)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                ((x) + 0xaa8)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_OFFS                                                   (0xaa8)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_RMSK                                                   0xffc0ffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                        0xff000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                24
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                         0x800000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                               23
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                       0x400000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                             22
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                        0xffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                             0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_ADDR(x)                                                      ((x) + 0xaac)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_PHYS(x)                                                      ((x) + 0xaac)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_OFFS                                                         (0xaac)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_ADDR(x)                                                      ((x) + 0xab0)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_PHYS(x)                                                      ((x) + 0xab0)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_OFFS                                                         (0xab0)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                  0x100
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                      8
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_ADDR(x)                                                          ((x) + 0xab4)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_PHYS(x)                                                          ((x) + 0xab4)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_OFFS                                                             (0xab4)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_POR                                                              0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_ATTR                                                                          0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_VALUE_SHFT                                                                0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_ADDR(x)                                                    ((x) + 0xac4)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_PHYS(x)                                                    ((x) + 0xac4)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_OFFS                                                       (0xac4)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_RMSK                                                           0xffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                        0xffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                             0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_ADDR(x)                                                             ((x) + 0xac8)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_PHYS(x)                                                             ((x) + 0xac8)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_OFFS                                                                (0xac8)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_RMSK                                                                0xffff003f
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_ATTR                                                                             0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                       0xffff0000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                               16
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                              0x3f
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                 0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_ADDR(x)                                                         ((x) + 0xd0c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_PHYS(x)                                                         ((x) + 0xd0c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_OFFS                                                            (0xd0c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                         0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                  0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_ADDR(x)                                                         ((x) + 0xd10)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_PHYS(x)                                                         ((x) + 0xd10)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_OFFS                                                            (0xd10)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_RMSK                                                             0xfffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_RING_SIZE_BMSK                                                   0xfffff00
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_RING_SIZE_SHFT                                                           8
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                               0xff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                  0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_ADDR(x)                                                               ((x) + 0xd14)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_PHYS(x)                                                               ((x) + 0xd14)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_OFFS                                                                  (0xd14)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_RMSK                                                                      0xffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_POR                                                                   0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_ATTR                                                                               0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_RING_ID_BMSK                                                              0xff00
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_RING_ID_SHFT                                                                   8
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_ENTRY_SIZE_BMSK                                                             0xff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_ENTRY_SIZE_SHFT                                                                0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_ADDR(x)                                                           ((x) + 0xd18)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_PHYS(x)                                                           ((x) + 0xd18)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_OFFS                                                              (0xd18)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_POR                                                               0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_ATTR                                                                           0x1
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                              0xffff0000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                      16
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_NUM_VALID_WORDS_BMSK                                                  0xffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_NUM_VALID_WORDS_SHFT                                                       0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_ADDR(x)                                                             ((x) + 0xd1c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_PHYS(x)                                                             ((x) + 0xd1c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_OFFS                                                                (0xd1c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_RMSK                                                                 0x7ffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_POR                                                                 0x00000080
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_ATTR                                                                             0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                         0x4000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                26
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_LOOP_CNT_BMSK                                                        0x3c00000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_LOOP_CNT_SHFT                                                               22
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SPARE_CONTROL_BMSK                                                    0x3fc000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SPARE_CONTROL_SHFT                                                          14
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SRNG_SM_STATE2_BMSK                                                     0x3000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SRNG_SM_STATE2_SHFT                                                         12
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SRNG_SM_STATE1_BMSK                                                      0xf00
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SRNG_SM_STATE1_SHFT                                                          8
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SRNG_IS_IDLE_BMSK                                                         0x80
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SRNG_IS_IDLE_SHFT                                                            7
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SRNG_ENABLE_BMSK                                                          0x40
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SRNG_ENABLE_SHFT                                                             6
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                    0x20
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                       5
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                     0x10
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                        4
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_MSI_SWAP_BIT_BMSK                                                          0x8
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_MSI_SWAP_BIT_SHFT                                                            3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SECURITY_BIT_BMSK                                                          0x4
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SECURITY_BIT_SHFT                                                            2
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_LOOPCNT_DISABLE_BMSK                                                       0x2
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_LOOPCNT_DISABLE_SHFT                                                         1
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_RING_ID_DISABLE_BMSK                                                       0x1
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_RING_ID_DISABLE_SHFT                                                         0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_ADDR(x)                                                      ((x) + 0xd20)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_PHYS(x)                                                      ((x) + 0xd20)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_OFFS                                                         (0xd20)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                    0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                             0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_ADDR(x)                                                      ((x) + 0xd24)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_PHYS(x)                                                      ((x) + 0xd24)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_OFFS                                                         (0xd24)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_RMSK                                                               0xff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                          0xff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                             0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_ADDR(x)                                                      ((x) + 0xd28)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_PHYS(x)                                                      ((x) + 0xd28)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_OFFS                                                         (0xd28)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                    0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                             0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_ADDR(x)                                                      ((x) + 0xd2c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_PHYS(x)                                                      ((x) + 0xd2c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_OFFS                                                         (0xd2c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_RMSK                                                               0xff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                          0xff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                             0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_ADDR(x)                                               ((x) + 0xd30)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_PHYS(x)                                               ((x) + 0xd30)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_OFFS                                                  (0xd30)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_POR                                                   0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_POR_RMSK                                              0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_ATTR                                                               0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                        0xffff0000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                16
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                    0x8000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                        15
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                              0x7fff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                   0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_ADDR(x)                                              ((x) + 0xd34)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_PHYS(x)                                              ((x) + 0xd34)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_OFFS                                                 (0xd34)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_POR                                                  0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_POR_RMSK                                             0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_ATTR                                                              0x1
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                   0xffff0000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                           16
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                           0x8000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                               15
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                        0x7fff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                             0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                            ((x) + 0xd38)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                            ((x) + 0xd38)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_OFFS                                               (0xd38)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_RMSK                                                    0x3ff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_POR                                                0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_ATTR                                                            0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                  0x3ff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                      0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                           ((x) + 0xd3c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                           ((x) + 0xd3c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_OFFS                                              (0xd3c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_RMSK                                              0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_POR                                               0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                          0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                           0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                    0xffff0000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                            16
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                0x8000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                    15
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                          0x7fff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                               0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                           ((x) + 0xd40)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                           ((x) + 0xd40)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_OFFS                                              (0xd40)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                  0xffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_POR                                               0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                          0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                           0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                    0xffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                         0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_ADDR(x)                                              ((x) + 0xd44)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_PHYS(x)                                              ((x) + 0xd44)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_OFFS                                                 (0xd44)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_POR                                                  0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_POR_RMSK                                             0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_ATTR                                                              0x1
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                   0xffff0000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                           16
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                              0x8000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                  15
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                        0x7fff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                             0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                           ((x) + 0xd48)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                           ((x) + 0xd48)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_OFFS                                              (0xd48)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                   0x3ff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_POR                                               0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                          0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                           0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                0x3ff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                    0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                          ((x) + 0xd4c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                          ((x) + 0xd4c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_OFFS                                             (0xd4c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                    0x7
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_POR                                              0x00000003
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                         0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                          0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                               0x7
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                 0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                         ((x) + 0xd50)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                         ((x) + 0xd50)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_OFFS                                            (0xd50)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_RMSK                                             0xfffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_POR                                             0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                        0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                         0x1
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                              0xff00000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                     20
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                             0xfffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                   0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x)                                              ((x) + 0xd54)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_PHYS(x)                                              ((x) + 0xd54)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_OFFS                                                 (0xd54)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_RMSK                                                 0xffcfffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_POR                                                  0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_POR_RMSK                                             0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_ATTR                                                              0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                      0xff000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                              24
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                       0x800000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                             23
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                     0x400000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                           22
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                     0xfffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                           0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_ADDR(x)                                                  ((x) + 0xd58)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_PHYS(x)                                                  ((x) + 0xd58)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_OFFS                                                     (0xd58)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_RMSK                                                         0xffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                      0xffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                           0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_ADDR(x)                                                           ((x) + 0xd5c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_PHYS(x)                                                           ((x) + 0xd5c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_OFFS                                                              (0xd5c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_RMSK                                                              0xffff003f
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_POR                                                               0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                     0xffff0000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                             16
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                            0x3f
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                               0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_ADDR(x)                                                       ((x) + 0xdd8)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_PHYS(x)                                                       ((x) + 0xdd8)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_OFFS                                                          (0xdd8)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_ADDR(x)                                                       ((x) + 0xddc)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_PHYS(x)                                                       ((x) + 0xddc)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_OFFS                                                          (0xddc)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_RMSK                                                           0xfffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                 0xfffff00
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                         8
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                             0xff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_ADDR(x)                                                             ((x) + 0xde0)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_PHYS(x)                                                             ((x) + 0xde0)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_OFFS                                                                (0xde0)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_RMSK                                                                    0xffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_ATTR                                                                             0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_RING_ID_BMSK                                                            0xff00
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_RING_ID_SHFT                                                                 8
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                           0xff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                              0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_ADDR(x)                                                         ((x) + 0xde4)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_PHYS(x)                                                         ((x) + 0xde4)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_OFFS                                                            (0xde4)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_ATTR                                                                         0x1
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                            0xffff0000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                    16
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                0xffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                     0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_ADDR(x)                                                           ((x) + 0xde8)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_PHYS(x)                                                           ((x) + 0xde8)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_OFFS                                                              (0xde8)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_RMSK                                                               0x7ffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_POR                                                               0x00000080
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                       0x4000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                              26
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_LOOP_CNT_BMSK                                                      0x3c00000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_LOOP_CNT_SHFT                                                             22
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                  0x3fc000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                        14
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                   0x3000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                       12
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                    0xf00
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                        8
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                       0x80
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                          7
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                        0x40
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                           6
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                  0x20
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                     5
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                   0x10
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                      4
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                        0x8
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                          3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                        0x4
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                          2
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                     0x2
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                       1
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                     0x1
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                       0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_ADDR(x)                                                    ((x) + 0xdec)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_PHYS(x)                                                    ((x) + 0xdec)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_OFFS                                                       (0xdec)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                  0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_ADDR(x)                                                    ((x) + 0xdf0)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_PHYS(x)                                                    ((x) + 0xdf0)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_OFFS                                                       (0xdf0)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_RMSK                                                             0xff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                        0xff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x)                                             ((x) + 0xdfc)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_PHYS(x)                                             ((x) + 0xdfc)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_OFFS                                                (0xdfc)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_RMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x)                                            ((x) + 0xe00)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_PHYS(x)                                            ((x) + 0xe00)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_OFFS                                               (0xe00)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_ATTR                                                            0x1
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                 0xffff0000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                         16
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                         0x8000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                             15
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                      0x7fff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                           0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                          ((x) + 0xe04)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                          ((x) + 0xe04)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_OFFS                                             (0xe04)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_RMSK                                                  0x3ff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_POR                                              0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_ATTR                                                          0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                0x3ff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                    0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                  ((x) + 0xe20)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                  ((x) + 0xe20)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                     (0xe20)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                  ((x) + 0xe24)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                  ((x) + 0xe24)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                     (0xe24)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_ADDR(x)                                                      ((x) + 0xe28)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_PHYS(x)                                                      ((x) + 0xe28)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_OFFS                                                         (0xe28)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x)                                            ((x) + 0xe2c)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_PHYS(x)                                            ((x) + 0xe2c)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_OFFS                                               (0xe2c)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_RMSK                                               0xffcfffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_ATTR                                                            0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                    0xff000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                            24
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                     0x800000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                           23
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                   0x400000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                         22
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                   0xfffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_ADDR(x)                                                  ((x) + 0xe30)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_PHYS(x)                                                  ((x) + 0xe30)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_OFFS                                                     (0xe30)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_ADDR(x)                                                  ((x) + 0xe34)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_PHYS(x)                                                  ((x) + 0xe34)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_OFFS                                                     (0xe34)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_ADDR(x)                                                      ((x) + 0xe38)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_PHYS(x)                                                      ((x) + 0xe38)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_OFFS                                                         (0xe38)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                ((x) + 0xe48)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                ((x) + 0xe48)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                   (0xe48)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                       0xffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                    0xffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_ADDR(x)                                                         ((x) + 0xe4c)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_PHYS(x)                                                         ((x) + 0xe4c)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_OFFS                                                            (0xe4c)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_RMSK                                                            0xffff003f
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                   0xffff0000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                           16
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                          0x3f
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                             0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_ADDR(x)                                                       ((x) + 0xe50)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_PHYS(x)                                                       ((x) + 0xe50)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_OFFS                                                          (0xe50)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_ADDR(x)                                                       ((x) + 0xe54)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_PHYS(x)                                                       ((x) + 0xe54)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_OFFS                                                          (0xe54)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_RMSK                                                           0xfffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                 0xfffff00
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                         8
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                             0xff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_ADDR(x)                                                             ((x) + 0xe58)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_PHYS(x)                                                             ((x) + 0xe58)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_OFFS                                                                (0xe58)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_RMSK                                                                    0xffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_ATTR                                                                             0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_RING_ID_BMSK                                                            0xff00
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_RING_ID_SHFT                                                                 8
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                           0xff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                              0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_ADDR(x)                                                         ((x) + 0xe5c)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_PHYS(x)                                                         ((x) + 0xe5c)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_OFFS                                                            (0xe5c)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_ATTR                                                                         0x1
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                            0xffff0000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                    16
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                0xffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                     0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_ADDR(x)                                                           ((x) + 0xe60)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_PHYS(x)                                                           ((x) + 0xe60)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_OFFS                                                              (0xe60)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_RMSK                                                               0x7ffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_POR                                                               0x00000080
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                       0x4000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                              26
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_LOOP_CNT_BMSK                                                      0x3c00000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_LOOP_CNT_SHFT                                                             22
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                  0x3fc000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                        14
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                   0x3000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                       12
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                    0xf00
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                        8
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                       0x80
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                          7
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                        0x40
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                           6
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                  0x20
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                     5
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                   0x10
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                      4
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                        0x8
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                          3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                        0x4
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                          2
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                     0x2
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                       1
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                     0x1
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                       0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_ADDR(x)                                                    ((x) + 0xe64)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_PHYS(x)                                                    ((x) + 0xe64)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_OFFS                                                       (0xe64)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                  0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_ADDR(x)                                                    ((x) + 0xe68)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_PHYS(x)                                                    ((x) + 0xe68)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_OFFS                                                       (0xe68)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_RMSK                                                             0xff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                        0xff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x)                                             ((x) + 0xe74)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_PHYS(x)                                             ((x) + 0xe74)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_OFFS                                                (0xe74)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_RMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x)                                            ((x) + 0xe78)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_PHYS(x)                                            ((x) + 0xe78)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_OFFS                                               (0xe78)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_ATTR                                                            0x1
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                 0xffff0000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                         16
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                         0x8000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                             15
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                      0x7fff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                           0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                          ((x) + 0xe7c)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                          ((x) + 0xe7c)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_OFFS                                             (0xe7c)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_RMSK                                                  0x3ff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_POR                                              0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_ATTR                                                          0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                0x3ff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                    0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                  ((x) + 0xe98)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                  ((x) + 0xe98)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                     (0xe98)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                  ((x) + 0xe9c)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                  ((x) + 0xe9c)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                     (0xe9c)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_ADDR(x)                                                      ((x) + 0xea0)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_PHYS(x)                                                      ((x) + 0xea0)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_OFFS                                                         (0xea0)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x)                                            ((x) + 0xea4)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_PHYS(x)                                            ((x) + 0xea4)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_OFFS                                               (0xea4)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_RMSK                                               0xffcfffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_ATTR                                                            0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                    0xff000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                            24
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                     0x800000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                           23
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                   0x400000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                         22
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                   0xfffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_ADDR(x)                                                  ((x) + 0xea8)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_PHYS(x)                                                  ((x) + 0xea8)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_OFFS                                                     (0xea8)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_ADDR(x)                                                  ((x) + 0xeac)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_PHYS(x)                                                  ((x) + 0xeac)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_OFFS                                                     (0xeac)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_ADDR(x)                                                      ((x) + 0xeb0)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_PHYS(x)                                                      ((x) + 0xeb0)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_OFFS                                                         (0xeb0)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                ((x) + 0xec0)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                ((x) + 0xec0)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                   (0xec0)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                       0xffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                    0xffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_ADDR(x)                                                         ((x) + 0xec4)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_PHYS(x)                                                         ((x) + 0xec4)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_OFFS                                                            (0xec4)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_RMSK                                                            0xffff003f
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                   0xffff0000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                           16
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                          0x3f
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                             0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_ADDR(x)                                                       ((x) + 0xec8)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_PHYS(x)                                                       ((x) + 0xec8)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_OFFS                                                          (0xec8)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_ADDR(x)                                                       ((x) + 0xecc)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_PHYS(x)                                                       ((x) + 0xecc)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_OFFS                                                          (0xecc)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_RMSK                                                           0xfffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                 0xfffff00
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                         8
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                             0xff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_ADDR(x)                                                             ((x) + 0xed0)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_PHYS(x)                                                             ((x) + 0xed0)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_OFFS                                                                (0xed0)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_RMSK                                                                    0xffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_ATTR                                                                             0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_RING_ID_BMSK                                                            0xff00
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_RING_ID_SHFT                                                                 8
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                           0xff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                              0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_ADDR(x)                                                         ((x) + 0xed4)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_PHYS(x)                                                         ((x) + 0xed4)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_OFFS                                                            (0xed4)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_ATTR                                                                         0x1
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                            0xffff0000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                    16
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                0xffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                     0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_ADDR(x)                                                           ((x) + 0xed8)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_PHYS(x)                                                           ((x) + 0xed8)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_OFFS                                                              (0xed8)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_RMSK                                                               0x7ffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_POR                                                               0x00000080
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                       0x4000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                              26
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_LOOP_CNT_BMSK                                                      0x3c00000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_LOOP_CNT_SHFT                                                             22
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                  0x3fc000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                        14
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                   0x3000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                       12
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                    0xf00
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                        8
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                       0x80
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                          7
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                        0x40
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                           6
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                  0x20
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                     5
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                   0x10
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                      4
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                        0x8
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                          3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                        0x4
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                          2
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                     0x2
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                       1
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                     0x1
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                       0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_ADDR(x)                                                    ((x) + 0xedc)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_PHYS(x)                                                    ((x) + 0xedc)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_OFFS                                                       (0xedc)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                  0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_ADDR(x)                                                    ((x) + 0xee0)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_PHYS(x)                                                    ((x) + 0xee0)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_OFFS                                                       (0xee0)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_RMSK                                                             0xff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                        0xff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x)                                             ((x) + 0xeec)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_PHYS(x)                                             ((x) + 0xeec)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_OFFS                                                (0xeec)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_RMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x)                                            ((x) + 0xef0)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_PHYS(x)                                            ((x) + 0xef0)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_OFFS                                               (0xef0)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_ATTR                                                            0x1
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                 0xffff0000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                         16
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                         0x8000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                             15
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                      0x7fff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                           0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                          ((x) + 0xef4)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                          ((x) + 0xef4)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_OFFS                                             (0xef4)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_RMSK                                                  0x3ff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_POR                                              0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_ATTR                                                          0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                0x3ff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                    0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                  ((x) + 0xf10)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                  ((x) + 0xf10)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                     (0xf10)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                  ((x) + 0xf14)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                  ((x) + 0xf14)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                     (0xf14)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_ADDR(x)                                                      ((x) + 0xf18)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_PHYS(x)                                                      ((x) + 0xf18)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_OFFS                                                         (0xf18)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x)                                            ((x) + 0xf1c)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_PHYS(x)                                            ((x) + 0xf1c)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_OFFS                                               (0xf1c)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_RMSK                                               0xffcfffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_ATTR                                                            0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                    0xff000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                            24
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                     0x800000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                           23
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                   0x400000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                         22
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                   0xfffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_ADDR(x)                                                  ((x) + 0xf20)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_PHYS(x)                                                  ((x) + 0xf20)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_OFFS                                                     (0xf20)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_ADDR(x)                                                  ((x) + 0xf24)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_PHYS(x)                                                  ((x) + 0xf24)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_OFFS                                                     (0xf24)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_ADDR(x)                                                      ((x) + 0xf28)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_PHYS(x)                                                      ((x) + 0xf28)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_OFFS                                                         (0xf28)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                ((x) + 0xf38)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                ((x) + 0xf38)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                   (0xf38)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                       0xffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                    0xffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_ADDR(x)                                                         ((x) + 0xf3c)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_PHYS(x)                                                         ((x) + 0xf3c)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_OFFS                                                            (0xf3c)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_RMSK                                                            0xffff003f
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                   0xffff0000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                           16
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                          0x3f
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                             0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_ADDR(x)                                                       ((x) + 0xf40)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_PHYS(x)                                                       ((x) + 0xf40)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_OFFS                                                          (0xf40)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_ADDR(x)                                                       ((x) + 0xf44)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_PHYS(x)                                                       ((x) + 0xf44)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_OFFS                                                          (0xf44)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_RMSK                                                           0xfffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                 0xfffff00
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                         8
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                             0xff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_ADDR(x)                                                             ((x) + 0xf48)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_PHYS(x)                                                             ((x) + 0xf48)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_OFFS                                                                (0xf48)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_RMSK                                                                    0xffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_ATTR                                                                             0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_RING_ID_BMSK                                                            0xff00
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_RING_ID_SHFT                                                                 8
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                           0xff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                              0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_ADDR(x)                                                         ((x) + 0xf4c)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_PHYS(x)                                                         ((x) + 0xf4c)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_OFFS                                                            (0xf4c)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_ATTR                                                                         0x1
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                            0xffff0000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                    16
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                0xffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                     0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_ADDR(x)                                                           ((x) + 0xf50)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_PHYS(x)                                                           ((x) + 0xf50)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_OFFS                                                              (0xf50)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_RMSK                                                               0x7ffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_POR                                                               0x00000080
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                       0x4000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                              26
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_LOOP_CNT_BMSK                                                      0x3c00000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_LOOP_CNT_SHFT                                                             22
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                  0x3fc000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                        14
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                   0x3000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                       12
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                    0xf00
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                        8
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                       0x80
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                          7
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                        0x40
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                           6
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                  0x20
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                     5
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                   0x10
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                      4
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                        0x8
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                          3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                        0x4
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                          2
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                     0x2
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                       1
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                     0x1
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                       0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_ADDR(x)                                                    ((x) + 0xf54)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_PHYS(x)                                                    ((x) + 0xf54)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_OFFS                                                       (0xf54)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                  0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_ADDR(x)                                                    ((x) + 0xf58)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_PHYS(x)                                                    ((x) + 0xf58)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_OFFS                                                       (0xf58)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_RMSK                                                             0xff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                        0xff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x)                                             ((x) + 0xf64)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_PHYS(x)                                             ((x) + 0xf64)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_OFFS                                                (0xf64)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_RMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x)                                            ((x) + 0xf68)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_PHYS(x)                                            ((x) + 0xf68)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_OFFS                                               (0xf68)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_ATTR                                                            0x1
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                 0xffff0000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                         16
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                         0x8000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                             15
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                      0x7fff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                           0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                          ((x) + 0xf6c)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                          ((x) + 0xf6c)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_OFFS                                             (0xf6c)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_RMSK                                                  0x3ff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_POR                                              0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_ATTR                                                          0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                0x3ff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                    0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                  ((x) + 0xf88)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                  ((x) + 0xf88)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                     (0xf88)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                  ((x) + 0xf8c)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                  ((x) + 0xf8c)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                     (0xf8c)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_ADDR(x)                                                      ((x) + 0xf90)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_PHYS(x)                                                      ((x) + 0xf90)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_OFFS                                                         (0xf90)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x)                                            ((x) + 0xf94)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_PHYS(x)                                            ((x) + 0xf94)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_OFFS                                               (0xf94)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_RMSK                                               0xffcfffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_ATTR                                                            0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                    0xff000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                            24
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                     0x800000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                           23
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                   0x400000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                         22
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                   0xfffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_ADDR(x)                                                  ((x) + 0xf98)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_PHYS(x)                                                  ((x) + 0xf98)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_OFFS                                                     (0xf98)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_ADDR(x)                                                  ((x) + 0xf9c)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_PHYS(x)                                                  ((x) + 0xf9c)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_OFFS                                                     (0xf9c)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_ADDR(x)                                                      ((x) + 0xfa0)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_PHYS(x)                                                      ((x) + 0xfa0)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_OFFS                                                         (0xfa0)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                ((x) + 0xfb0)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                ((x) + 0xfb0)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                   (0xfb0)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                       0xffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                    0xffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_ADDR(x)                                                         ((x) + 0xfb4)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_PHYS(x)                                                         ((x) + 0xfb4)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_OFFS                                                            (0xfb4)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_RMSK                                                            0xffff003f
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                   0xffff0000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                           16
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                          0x3f
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                             0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_ADDR(x)                                                       ((x) + 0xfb8)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_PHYS(x)                                                       ((x) + 0xfb8)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_OFFS                                                          (0xfb8)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_ADDR(x)                                                       ((x) + 0xfbc)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_PHYS(x)                                                       ((x) + 0xfbc)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_OFFS                                                          (0xfbc)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_RMSK                                                           0xfffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                 0xfffff00
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                         8
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                             0xff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_ADDR(x)                                                             ((x) + 0xfc0)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_PHYS(x)                                                             ((x) + 0xfc0)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_OFFS                                                                (0xfc0)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_RMSK                                                                    0xffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_ATTR                                                                             0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_RING_ID_BMSK                                                            0xff00
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_RING_ID_SHFT                                                                 8
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                           0xff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                              0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_ADDR(x)                                                         ((x) + 0xfc4)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_PHYS(x)                                                         ((x) + 0xfc4)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_OFFS                                                            (0xfc4)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_ATTR                                                                         0x1
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                            0xffff0000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                    16
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                0xffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                     0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_ADDR(x)                                                           ((x) + 0xfc8)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_PHYS(x)                                                           ((x) + 0xfc8)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_OFFS                                                              (0xfc8)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_RMSK                                                               0x7ffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_POR                                                               0x00000080
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                       0x4000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                              26
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_LOOP_CNT_BMSK                                                      0x3c00000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_LOOP_CNT_SHFT                                                             22
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                  0x3fc000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                        14
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                   0x3000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                       12
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                    0xf00
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                        8
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                       0x80
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                          7
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                        0x40
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                           6
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                  0x20
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                     5
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                   0x10
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                      4
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                        0x8
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                          3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                        0x4
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                          2
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                     0x2
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                       1
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                     0x1
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                       0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_ADDR(x)                                                    ((x) + 0xfcc)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_PHYS(x)                                                    ((x) + 0xfcc)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_OFFS                                                       (0xfcc)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                  0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_ADDR(x)                                                    ((x) + 0xfd0)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_PHYS(x)                                                    ((x) + 0xfd0)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_OFFS                                                       (0xfd0)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_RMSK                                                             0xff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                        0xff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x)                                             ((x) + 0xfdc)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_PHYS(x)                                             ((x) + 0xfdc)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_OFFS                                                (0xfdc)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_RMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x)                                            ((x) + 0xfe0)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_PHYS(x)                                            ((x) + 0xfe0)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_OFFS                                               (0xfe0)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_ATTR                                                            0x1
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                 0xffff0000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                         16
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                         0x8000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                             15
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                      0x7fff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                           0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                          ((x) + 0xfe4)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                          ((x) + 0xfe4)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_OFFS                                             (0xfe4)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_RMSK                                                  0x3ff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_POR                                              0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_ATTR                                                          0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                0x3ff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                    0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                  ((x) + 0x1000)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                  ((x) + 0x1000)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                     (0x1000)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                  ((x) + 0x1004)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                  ((x) + 0x1004)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                     (0x1004)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_ADDR(x)                                                      ((x) + 0x1008)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_PHYS(x)                                                      ((x) + 0x1008)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_OFFS                                                         (0x1008)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x)                                            ((x) + 0x100c)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_PHYS(x)                                            ((x) + 0x100c)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_OFFS                                               (0x100c)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_RMSK                                               0xffcfffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_ATTR                                                            0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                    0xff000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                            24
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                     0x800000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                           23
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                   0x400000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                         22
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                   0xfffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_ADDR(x)                                                  ((x) + 0x1010)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_PHYS(x)                                                  ((x) + 0x1010)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_OFFS                                                     (0x1010)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_ADDR(x)                                                  ((x) + 0x1014)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_PHYS(x)                                                  ((x) + 0x1014)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_OFFS                                                     (0x1014)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_ADDR(x)                                                      ((x) + 0x1018)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_PHYS(x)                                                      ((x) + 0x1018)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_OFFS                                                         (0x1018)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                ((x) + 0x1028)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                ((x) + 0x1028)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                   (0x1028)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                       0xffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                    0xffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_ADDR(x)                                                         ((x) + 0x102c)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_PHYS(x)                                                         ((x) + 0x102c)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_OFFS                                                            (0x102c)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_RMSK                                                            0xffff003f
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                   0xffff0000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                           16
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                          0x3f
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                             0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_ADDR(x)                                                       ((x) + 0x1030)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_PHYS(x)                                                       ((x) + 0x1030)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_OFFS                                                          (0x1030)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_ADDR(x)                                                       ((x) + 0x1034)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_PHYS(x)                                                       ((x) + 0x1034)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_OFFS                                                          (0x1034)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_RMSK                                                           0xfffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                 0xfffff00
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                         8
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                             0xff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_ADDR(x)                                                             ((x) + 0x1038)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_PHYS(x)                                                             ((x) + 0x1038)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_OFFS                                                                (0x1038)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_RMSK                                                                    0xffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_ATTR                                                                             0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_RING_ID_BMSK                                                            0xff00
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_RING_ID_SHFT                                                                 8
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                           0xff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                              0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_ADDR(x)                                                         ((x) + 0x103c)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_PHYS(x)                                                         ((x) + 0x103c)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_OFFS                                                            (0x103c)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_ATTR                                                                         0x1
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                            0xffff0000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                    16
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                0xffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                     0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_ADDR(x)                                                           ((x) + 0x1040)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_PHYS(x)                                                           ((x) + 0x1040)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_OFFS                                                              (0x1040)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_RMSK                                                               0x7ffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_POR                                                               0x00000080
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                       0x4000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                              26
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_LOOP_CNT_BMSK                                                      0x3c00000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_LOOP_CNT_SHFT                                                             22
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                  0x3fc000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                        14
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                   0x3000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                       12
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                    0xf00
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                        8
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                       0x80
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                          7
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                        0x40
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                           6
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                  0x20
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                     5
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                   0x10
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                      4
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                        0x8
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                          3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                        0x4
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                          2
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                     0x2
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                       1
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                     0x1
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                       0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_ADDR(x)                                                    ((x) + 0x1044)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_PHYS(x)                                                    ((x) + 0x1044)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_OFFS                                                       (0x1044)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                  0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_ADDR(x)                                                    ((x) + 0x1048)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_PHYS(x)                                                    ((x) + 0x1048)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_OFFS                                                       (0x1048)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_RMSK                                                             0xff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                        0xff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x)                                             ((x) + 0x1054)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_PHYS(x)                                             ((x) + 0x1054)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_OFFS                                                (0x1054)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_RMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x)                                            ((x) + 0x1058)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_PHYS(x)                                            ((x) + 0x1058)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_OFFS                                               (0x1058)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_ATTR                                                            0x1
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                 0xffff0000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                         16
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                         0x8000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                             15
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                      0x7fff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                           0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                          ((x) + 0x105c)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                          ((x) + 0x105c)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_OFFS                                             (0x105c)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_RMSK                                                  0x3ff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_POR                                              0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_ATTR                                                          0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                0x3ff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                    0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                  ((x) + 0x1078)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                  ((x) + 0x1078)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                     (0x1078)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                  ((x) + 0x107c)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                  ((x) + 0x107c)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                     (0x107c)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_ADDR(x)                                                      ((x) + 0x1080)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_PHYS(x)                                                      ((x) + 0x1080)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_OFFS                                                         (0x1080)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x)                                            ((x) + 0x1084)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_PHYS(x)                                            ((x) + 0x1084)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_OFFS                                               (0x1084)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_RMSK                                               0xffcfffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_ATTR                                                            0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                    0xff000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                            24
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                     0x800000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                           23
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                   0x400000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                         22
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                   0xfffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_ADDR(x)                                                  ((x) + 0x1088)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_PHYS(x)                                                  ((x) + 0x1088)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_OFFS                                                     (0x1088)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_ADDR(x)                                                  ((x) + 0x108c)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_PHYS(x)                                                  ((x) + 0x108c)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_OFFS                                                     (0x108c)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_ADDR(x)                                                      ((x) + 0x1090)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_PHYS(x)                                                      ((x) + 0x1090)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_OFFS                                                         (0x1090)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                ((x) + 0x10a0)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                ((x) + 0x10a0)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                   (0x10a0)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                       0xffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                    0xffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_ADDR(x)                                                         ((x) + 0x10a4)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_PHYS(x)                                                         ((x) + 0x10a4)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_OFFS                                                            (0x10a4)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_RMSK                                                            0xffff003f
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                   0xffff0000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                           16
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                          0x3f
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                             0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_ADDR(x)                                                       ((x) + 0x10a8)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_PHYS(x)                                                       ((x) + 0x10a8)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_OFFS                                                          (0x10a8)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_ADDR(x)                                                       ((x) + 0x10ac)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_PHYS(x)                                                       ((x) + 0x10ac)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_OFFS                                                          (0x10ac)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_RMSK                                                           0xfffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                 0xfffff00
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                         8
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                             0xff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_ADDR(x)                                                             ((x) + 0x10b0)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_PHYS(x)                                                             ((x) + 0x10b0)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_OFFS                                                                (0x10b0)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_RMSK                                                                    0xffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_ATTR                                                                             0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_RING_ID_BMSK                                                            0xff00
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_RING_ID_SHFT                                                                 8
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                           0xff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                              0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_ADDR(x)                                                         ((x) + 0x10b4)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_PHYS(x)                                                         ((x) + 0x10b4)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_OFFS                                                            (0x10b4)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_ATTR                                                                         0x1
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                            0xffff0000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                    16
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                0xffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                     0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_ADDR(x)                                                           ((x) + 0x10b8)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_PHYS(x)                                                           ((x) + 0x10b8)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_OFFS                                                              (0x10b8)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_RMSK                                                               0x7ffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_POR                                                               0x00000080
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                       0x4000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                              26
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_LOOP_CNT_BMSK                                                      0x3c00000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_LOOP_CNT_SHFT                                                             22
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                  0x3fc000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                        14
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                   0x3000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                       12
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                    0xf00
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                        8
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                       0x80
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                          7
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                        0x40
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                           6
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                  0x20
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                     5
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                   0x10
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                      4
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                        0x8
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                          3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                        0x4
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                          2
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                     0x2
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                       1
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                     0x1
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                       0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_ADDR(x)                                                    ((x) + 0x10bc)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_PHYS(x)                                                    ((x) + 0x10bc)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_OFFS                                                       (0x10bc)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                  0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_ADDR(x)                                                    ((x) + 0x10c0)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_PHYS(x)                                                    ((x) + 0x10c0)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_OFFS                                                       (0x10c0)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_RMSK                                                             0xff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                        0xff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x)                                             ((x) + 0x10cc)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_PHYS(x)                                             ((x) + 0x10cc)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_OFFS                                                (0x10cc)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_RMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x)                                            ((x) + 0x10d0)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_PHYS(x)                                            ((x) + 0x10d0)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_OFFS                                               (0x10d0)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_ATTR                                                            0x1
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                 0xffff0000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                         16
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                         0x8000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                             15
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                      0x7fff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                           0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                          ((x) + 0x10d4)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                          ((x) + 0x10d4)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_OFFS                                             (0x10d4)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_RMSK                                                  0x3ff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_POR                                              0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_ATTR                                                          0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                0x3ff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                    0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                  ((x) + 0x10f0)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                  ((x) + 0x10f0)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                     (0x10f0)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                  ((x) + 0x10f4)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                  ((x) + 0x10f4)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                     (0x10f4)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_ADDR(x)                                                      ((x) + 0x10f8)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_PHYS(x)                                                      ((x) + 0x10f8)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_OFFS                                                         (0x10f8)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x)                                            ((x) + 0x10fc)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_PHYS(x)                                            ((x) + 0x10fc)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_OFFS                                               (0x10fc)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_RMSK                                               0xffcfffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_ATTR                                                            0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                    0xff000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                            24
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                     0x800000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                           23
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                   0x400000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                         22
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                   0xfffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_ADDR(x)                                                  ((x) + 0x1100)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_PHYS(x)                                                  ((x) + 0x1100)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_OFFS                                                     (0x1100)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_ADDR(x)                                                  ((x) + 0x1104)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_PHYS(x)                                                  ((x) + 0x1104)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_OFFS                                                     (0x1104)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_ADDR(x)                                                      ((x) + 0x1108)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_PHYS(x)                                                      ((x) + 0x1108)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_OFFS                                                         (0x1108)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                ((x) + 0x1118)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                ((x) + 0x1118)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                   (0x1118)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                       0xffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                    0xffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_ADDR(x)                                                         ((x) + 0x111c)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_PHYS(x)                                                         ((x) + 0x111c)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_OFFS                                                            (0x111c)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_RMSK                                                            0xffff003f
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                   0xffff0000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                           16
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                          0x3f
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                             0

#define HWIO_WBM_R2_SW_RELEASE_RING_HP_ADDR(x)                                                                  ((x) + 0x3010)
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_PHYS(x)                                                                  ((x) + 0x3010)
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_OFFS                                                                     (0x3010)
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_RMSK                                                                         0xffff
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_POR                                                                      0x00000000
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_POR_RMSK                                                                 0xffffffff
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_ATTR                                                                                  0x3
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_SW_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_SW_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_SW_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_SW_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_SW_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_HEAD_PTR_BMSK                                                                0xffff
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                     0

#define HWIO_WBM_R2_SW_RELEASE_RING_TP_ADDR(x)                                                                  ((x) + 0x3014)
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_PHYS(x)                                                                  ((x) + 0x3014)
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_OFFS                                                                     (0x3014)
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_RMSK                                                                         0xffff
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_POR                                                                      0x00000000
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_POR_RMSK                                                                 0xffffffff
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_ATTR                                                                                  0x3
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_SW_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_SW_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_SW_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_SW_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_SW_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_TAIL_PTR_BMSK                                                                0xffff
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                     0

#define HWIO_WBM_R2_SW1_RELEASE_RING_HP_ADDR(x)                                                                 ((x) + 0x3018)
#define HWIO_WBM_R2_SW1_RELEASE_RING_HP_PHYS(x)                                                                 ((x) + 0x3018)
#define HWIO_WBM_R2_SW1_RELEASE_RING_HP_OFFS                                                                    (0x3018)
#define HWIO_WBM_R2_SW1_RELEASE_RING_HP_RMSK                                                                        0xffff
#define HWIO_WBM_R2_SW1_RELEASE_RING_HP_POR                                                                     0x00000000
#define HWIO_WBM_R2_SW1_RELEASE_RING_HP_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R2_SW1_RELEASE_RING_HP_ATTR                                                                                 0x3
#define HWIO_WBM_R2_SW1_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_SW1_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_SW1_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_SW1_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_SW1_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_SW1_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_SW1_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_SW1_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_SW1_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_SW1_RELEASE_RING_HP_HEAD_PTR_BMSK                                                               0xffff
#define HWIO_WBM_R2_SW1_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                    0

#define HWIO_WBM_R2_SW1_RELEASE_RING_TP_ADDR(x)                                                                 ((x) + 0x301c)
#define HWIO_WBM_R2_SW1_RELEASE_RING_TP_PHYS(x)                                                                 ((x) + 0x301c)
#define HWIO_WBM_R2_SW1_RELEASE_RING_TP_OFFS                                                                    (0x301c)
#define HWIO_WBM_R2_SW1_RELEASE_RING_TP_RMSK                                                                        0xffff
#define HWIO_WBM_R2_SW1_RELEASE_RING_TP_POR                                                                     0x00000000
#define HWIO_WBM_R2_SW1_RELEASE_RING_TP_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R2_SW1_RELEASE_RING_TP_ATTR                                                                                 0x3
#define HWIO_WBM_R2_SW1_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_SW1_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_SW1_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_SW1_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_SW1_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_SW1_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_SW1_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_SW1_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_SW1_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_SW1_RELEASE_RING_TP_TAIL_PTR_BMSK                                                               0xffff
#define HWIO_WBM_R2_SW1_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                    0

#define HWIO_WBM_R2_PPE_RELEASE_RING_HP_ADDR(x)                                                                 ((x) + 0x3020)
#define HWIO_WBM_R2_PPE_RELEASE_RING_HP_PHYS(x)                                                                 ((x) + 0x3020)
#define HWIO_WBM_R2_PPE_RELEASE_RING_HP_OFFS                                                                    (0x3020)
#define HWIO_WBM_R2_PPE_RELEASE_RING_HP_RMSK                                                                        0xffff
#define HWIO_WBM_R2_PPE_RELEASE_RING_HP_POR                                                                     0x00000000
#define HWIO_WBM_R2_PPE_RELEASE_RING_HP_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R2_PPE_RELEASE_RING_HP_ATTR                                                                                 0x3
#define HWIO_WBM_R2_PPE_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_PPE_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_PPE_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_PPE_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_PPE_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_PPE_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_PPE_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_PPE_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_PPE_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_PPE_RELEASE_RING_HP_HEAD_PTR_BMSK                                                               0xffff
#define HWIO_WBM_R2_PPE_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                    0

#define HWIO_WBM_R2_PPE_RELEASE_RING_TP_ADDR(x)                                                                 ((x) + 0x3024)
#define HWIO_WBM_R2_PPE_RELEASE_RING_TP_PHYS(x)                                                                 ((x) + 0x3024)
#define HWIO_WBM_R2_PPE_RELEASE_RING_TP_OFFS                                                                    (0x3024)
#define HWIO_WBM_R2_PPE_RELEASE_RING_TP_RMSK                                                                        0xffff
#define HWIO_WBM_R2_PPE_RELEASE_RING_TP_POR                                                                     0x00000000
#define HWIO_WBM_R2_PPE_RELEASE_RING_TP_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R2_PPE_RELEASE_RING_TP_ATTR                                                                                 0x3
#define HWIO_WBM_R2_PPE_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_PPE_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_PPE_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_PPE_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_PPE_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_PPE_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_PPE_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_PPE_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_PPE_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_PPE_RELEASE_RING_TP_TAIL_PTR_BMSK                                                               0xffff
#define HWIO_WBM_R2_PPE_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                    0

#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_ADDR(x)                                                               ((x) + 0x30b8)
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_PHYS(x)                                                               ((x) + 0x30b8)
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_OFFS                                                                  (0x30b8)
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_RMSK                                                                     0xfffff
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_POR                                                                   0x00000000
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_ATTR                                                                               0x3
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_HEAD_PTR_BMSK                                                            0xfffff
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_HEAD_PTR_SHFT                                                                  0

#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_ADDR(x)                                                               ((x) + 0x30bc)
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_PHYS(x)                                                               ((x) + 0x30bc)
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_OFFS                                                                  (0x30bc)
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_RMSK                                                                     0xfffff
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_POR                                                                   0x00000000
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_ATTR                                                                               0x3
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_TAIL_PTR_BMSK                                                            0xfffff
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_TAIL_PTR_SHFT                                                                  0

#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_ADDR(x)                                                             ((x) + 0x30c8)
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_PHYS(x)                                                             ((x) + 0x30c8)
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_OFFS                                                                (0x30c8)
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_HEAD_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_ADDR(x)                                                             ((x) + 0x30cc)
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_PHYS(x)                                                             ((x) + 0x30cc)
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_OFFS                                                                (0x30cc)
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_TAIL_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_ADDR(x)                                                             ((x) + 0x30d0)
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_PHYS(x)                                                             ((x) + 0x30d0)
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_OFFS                                                                (0x30d0)
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_HEAD_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_ADDR(x)                                                             ((x) + 0x30d4)
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_PHYS(x)                                                             ((x) + 0x30d4)
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_OFFS                                                                (0x30d4)
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_TAIL_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_ADDR(x)                                                             ((x) + 0x30d8)
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_PHYS(x)                                                             ((x) + 0x30d8)
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_OFFS                                                                (0x30d8)
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_HEAD_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_ADDR(x)                                                             ((x) + 0x30dc)
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_PHYS(x)                                                             ((x) + 0x30dc)
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_OFFS                                                                (0x30dc)
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_TAIL_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_ADDR(x)                                                             ((x) + 0x30e0)
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_PHYS(x)                                                             ((x) + 0x30e0)
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_OFFS                                                                (0x30e0)
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_HEAD_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_ADDR(x)                                                             ((x) + 0x30e4)
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_PHYS(x)                                                             ((x) + 0x30e4)
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_OFFS                                                                (0x30e4)
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_TAIL_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_ADDR(x)                                                             ((x) + 0x30e8)
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_PHYS(x)                                                             ((x) + 0x30e8)
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_OFFS                                                                (0x30e8)
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_HEAD_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_ADDR(x)                                                             ((x) + 0x30ec)
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_PHYS(x)                                                             ((x) + 0x30ec)
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_OFFS                                                                (0x30ec)
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_TAIL_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_ADDR(x)                                                             ((x) + 0x30f0)
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_PHYS(x)                                                             ((x) + 0x30f0)
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_OFFS                                                                (0x30f0)
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_HEAD_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_ADDR(x)                                                             ((x) + 0x30f4)
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_PHYS(x)                                                             ((x) + 0x30f4)
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_OFFS                                                                (0x30f4)
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_TAIL_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_ADDR(x)                                                             ((x) + 0x30f8)
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_PHYS(x)                                                             ((x) + 0x30f8)
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_OFFS                                                                (0x30f8)
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_HEAD_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_ADDR(x)                                                             ((x) + 0x30fc)
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_PHYS(x)                                                             ((x) + 0x30fc)
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_OFFS                                                                (0x30fc)
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_TAIL_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                0

#define REO_REG_REG_BASE                                                                                     (UMAC_BASE      + 0x00038000)
#define REO_REG_REG_BASE_SIZE                                                                                0x4000
#define REO_REG_REG_BASE_USED                                                                                0x30ac
#define REO_REG_REG_BASE_PHYS                                                                                (UMAC_BASE_PHYS + 0x00038000)
#define REO_REG_REG_BASE_OFFS                                                                                0x00038000

#define HWIO_REO_R0_GENERAL_ENABLE_ADDR(x)                                                                   ((x) + 0x0)
#define HWIO_REO_R0_GENERAL_ENABLE_PHYS(x)                                                                   ((x) + 0x0)
#define HWIO_REO_R0_GENERAL_ENABLE_OFFS                                                                      (0x0)
#define HWIO_REO_R0_GENERAL_ENABLE_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_GENERAL_ENABLE_POR                                                                       0x00000100
#define HWIO_REO_R0_GENERAL_ENABLE_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_GENERAL_ENABLE_ATTR                                                                                   0x3
#define HWIO_REO_R0_GENERAL_ENABLE_IN(x)            \
                in_dword(HWIO_REO_R0_GENERAL_ENABLE_ADDR(x))
#define HWIO_REO_R0_GENERAL_ENABLE_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_GENERAL_ENABLE_ADDR(x), m)
#define HWIO_REO_R0_GENERAL_ENABLE_OUT(x, v)            \
                out_dword(HWIO_REO_R0_GENERAL_ENABLE_ADDR(x),v)
#define HWIO_REO_R0_GENERAL_ENABLE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_GENERAL_ENABLE_ADDR(x),m,v,HWIO_REO_R0_GENERAL_ENABLE_IN(x))
#define HWIO_REO_R0_GENERAL_ENABLE_SW2REO1_RING_ENABLE_BMSK                                                  0x80000000
#define HWIO_REO_R0_GENERAL_ENABLE_SW2REO1_RING_ENABLE_SHFT                                                          31
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW6_RING_ENABLE_BMSK                                                  0x40000000
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW6_RING_ENABLE_SHFT                                                          30
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW5_RING_ENABLE_BMSK                                                  0x20000000
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW5_RING_ENABLE_SHFT                                                          29
#define HWIO_REO_R0_GENERAL_ENABLE_INVALIDATE_CACHE_FOR_ZERO_VLD_BMSK                                        0x10000000
#define HWIO_REO_R0_GENERAL_ENABLE_INVALIDATE_CACHE_FOR_ZERO_VLD_SHFT                                                28
#define HWIO_REO_R0_GENERAL_ENABLE_STRUCT_SWAP_DELINK_BMSK                                                    0x8000000
#define HWIO_REO_R0_GENERAL_ENABLE_STRUCT_SWAP_DELINK_SHFT                                                           27
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW8_RING_ENABLE_BMSK                                                   0x4000000
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW8_RING_ENABLE_SHFT                                                          26
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW7_RING_ENABLE_BMSK                                                   0x2000000
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW7_RING_ENABLE_SHFT                                                          25
#define HWIO_REO_R0_GENERAL_ENABLE_SW2REO3_RING_ENABLE_BMSK                                                   0x1000000
#define HWIO_REO_R0_GENERAL_ENABLE_SW2REO3_RING_ENABLE_SHFT                                                          24
#define HWIO_REO_R0_GENERAL_ENABLE_SW2REO2_RING_ENABLE_BMSK                                                    0x800000
#define HWIO_REO_R0_GENERAL_ENABLE_SW2REO2_RING_ENABLE_SHFT                                                          23
#define HWIO_REO_R0_GENERAL_ENABLE_SW2REO_RING_ENABLE_BMSK                                                     0x400000
#define HWIO_REO_R0_GENERAL_ENABLE_SW2REO_RING_ENABLE_SHFT                                                           22
#define HWIO_REO_R0_GENERAL_ENABLE_REO_CMD_RING_ENABLE_BMSK                                                    0x200000
#define HWIO_REO_R0_GENERAL_ENABLE_REO_CMD_RING_ENABLE_SHFT                                                          21
#define HWIO_REO_R0_GENERAL_ENABLE_REO_STATUS_RING_ENABLE_BMSK                                                 0x100000
#define HWIO_REO_R0_GENERAL_ENABLE_REO_STATUS_RING_ENABLE_SHFT                                                       20
#define HWIO_REO_R0_GENERAL_ENABLE_REO_RELEASE_RING_ENABLE_BMSK                                                 0x80000
#define HWIO_REO_R0_GENERAL_ENABLE_REO_RELEASE_RING_ENABLE_SHFT                                                      19
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW0_RING_ENABLE_BMSK                                                     0x40000
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW0_RING_ENABLE_SHFT                                                          18
#define HWIO_REO_R0_GENERAL_ENABLE_REO2FW_RING_ENABLE_BMSK                                                      0x20000
#define HWIO_REO_R0_GENERAL_ENABLE_REO2FW_RING_ENABLE_SHFT                                                           17
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW4_RING_ENABLE_BMSK                                                     0x10000
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW4_RING_ENABLE_SHFT                                                          16
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW3_RING_ENABLE_BMSK                                                      0x8000
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW3_RING_ENABLE_SHFT                                                          15
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW2_RING_ENABLE_BMSK                                                      0x4000
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW2_RING_ENABLE_SHFT                                                          14
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW1_RING_ENABLE_BMSK                                                      0x2000
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW1_RING_ENABLE_SHFT                                                          13
#define HWIO_REO_R0_GENERAL_ENABLE_WBM2REO_LINK_RING_ENABLE_BMSK                                                 0x1000
#define HWIO_REO_R0_GENERAL_ENABLE_WBM2REO_LINK_RING_ENABLE_SHFT                                                     12
#define HWIO_REO_R0_GENERAL_ENABLE_RXDMA2REO_RING_ENABLE_BMSK                                                     0xe00
#define HWIO_REO_R0_GENERAL_ENABLE_RXDMA2REO_RING_ENABLE_SHFT                                                         9
#define HWIO_REO_R0_GENERAL_ENABLE_GLOBAL_PN_CHK_BMSK                                                             0x100
#define HWIO_REO_R0_GENERAL_ENABLE_GLOBAL_PN_CHK_SHFT                                                                 8
#define HWIO_REO_R0_GENERAL_ENABLE_BACKUP_1_BMSK                                                                   0xe0
#define HWIO_REO_R0_GENERAL_ENABLE_BACKUP_1_SHFT                                                                      5
#define HWIO_REO_R0_GENERAL_ENABLE_REO2PPE_RING_ENABLE_BMSK                                                        0x10
#define HWIO_REO_R0_GENERAL_ENABLE_REO2PPE_RING_ENABLE_SHFT                                                           4
#define HWIO_REO_R0_GENERAL_ENABLE_AGING_FLUSH_ENABLE_BMSK                                                          0x8
#define HWIO_REO_R0_GENERAL_ENABLE_AGING_FLUSH_ENABLE_SHFT                                                            3
#define HWIO_REO_R0_GENERAL_ENABLE_AGING_LIST_ENABLE_BMSK                                                           0x4
#define HWIO_REO_R0_GENERAL_ENABLE_AGING_LIST_ENABLE_SHFT                                                             2
#define HWIO_REO_R0_GENERAL_ENABLE_REO_HWREORDER_DISABLE_BMSK                                                       0x2
#define HWIO_REO_R0_GENERAL_ENABLE_REO_HWREORDER_DISABLE_SHFT                                                         1
#define HWIO_REO_R0_GENERAL_ENABLE_REO_ENABLE_BMSK                                                                  0x1
#define HWIO_REO_R0_GENERAL_ENABLE_REO_ENABLE_SHFT                                                                    0

#define HWIO_REO_R0_CACHE_CTL_CONFIG_ADDR(x)                                                                 ((x) + 0xd50)
#define HWIO_REO_R0_CACHE_CTL_CONFIG_PHYS(x)                                                                 ((x) + 0xd50)
#define HWIO_REO_R0_CACHE_CTL_CONFIG_OFFS                                                                    (0xd50)
#define HWIO_REO_R0_CACHE_CTL_CONFIG_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_CACHE_CTL_CONFIG_POR                                                                     0x008609ff
#define HWIO_REO_R0_CACHE_CTL_CONFIG_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_CACHE_CTL_CONFIG_ATTR                                                                                 0x3
#define HWIO_REO_R0_CACHE_CTL_CONFIG_IN(x)            \
in_dword(HWIO_REO_R0_CACHE_CTL_CONFIG_ADDR(x))
#define HWIO_REO_R0_CACHE_CTL_CONFIG_INM(x, m)            \
in_dword_masked(HWIO_REO_R0_CACHE_CTL_CONFIG_ADDR(x), m)
#define HWIO_REO_R0_CACHE_CTL_CONFIG_OUT(x, v)            \
out_dword(HWIO_REO_R0_CACHE_CTL_CONFIG_ADDR(x),v)
#define HWIO_REO_R0_CACHE_CTL_CONFIG_OUTM(x,m,v) \
out_dword_masked_ns(HWIO_REO_R0_CACHE_CTL_CONFIG_ADDR(x),m,v,HWIO_REO_R0_CACHE_CTL_CONFIG_IN(x))
#define HWIO_REO_R0_CACHE_CTL_CONFIG_DESC_TYPE_SWAP_BMSK                                                     0xff000000
#define HWIO_REO_R0_CACHE_CTL_CONFIG_DESC_TYPE_SWAP_SHFT                                                             24
#define HWIO_REO_R0_CACHE_CTL_CONFIG_ENABLE_LEGACY_SWAP_BMSK                                                   0x800000
#define HWIO_REO_R0_CACHE_CTL_CONFIG_ENABLE_LEGACY_SWAP_SHFT                                                         23
#define HWIO_REO_R0_CACHE_CTL_CONFIG_WRITE_STRUCT_SWAP_BMSK                                                    0x400000
#define HWIO_REO_R0_CACHE_CTL_CONFIG_WRITE_STRUCT_SWAP_SHFT                                                          22
#define HWIO_REO_R0_CACHE_CTL_CONFIG_READ_STRUCT_SWAP_BMSK                                                     0x200000
#define HWIO_REO_R0_CACHE_CTL_CONFIG_READ_STRUCT_SWAP_SHFT                                                           21
#define HWIO_REO_R0_CACHE_CTL_CONFIG_WRITE_SECURITY_BMSK                                                       0x100000
#define HWIO_REO_R0_CACHE_CTL_CONFIG_WRITE_SECURITY_SHFT                                                             20
#define HWIO_REO_R0_CACHE_CTL_CONFIG_READ_SECURITY_BMSK                                                         0x80000
#define HWIO_REO_R0_CACHE_CTL_CONFIG_READ_SECURITY_SHFT                                                              19
#define HWIO_REO_R0_CACHE_CTL_CONFIG_BG_FLUSH_POST_WRITE_BMSK                                                   0x40000
#define HWIO_REO_R0_CACHE_CTL_CONFIG_BG_FLUSH_POST_WRITE_SHFT                                                        18
#define HWIO_REO_R0_CACHE_CTL_CONFIG_CLIENT_FLUSH_POST_WRITE_BMSK                                               0x20000
#define HWIO_REO_R0_CACHE_CTL_CONFIG_CLIENT_FLUSH_POST_WRITE_SHFT                                                    17
#define HWIO_REO_R0_CACHE_CTL_CONFIG_CACHE_EMPTY_THRESHOLD_BMSK                                                 0x1fe00
#define HWIO_REO_R0_CACHE_CTL_CONFIG_CACHE_EMPTY_THRESHOLD_SHFT                                                       9
#define HWIO_REO_R0_CACHE_CTL_CONFIG_CACHE_LINE_USE_NUM_BMSK                                                      0x1ff
#define HWIO_REO_R0_CACHE_CTL_CONFIG_CACHE_LINE_USE_NUM_SHFT                                                          0

#define HWIO_REO_R0_CACHE_CTL_CONTROL_ADDR(x)                                                                ((x) + 0xd54)
#define HWIO_REO_R0_CACHE_CTL_CONTROL_PHYS(x)                                                                ((x) + 0xd54)
#define HWIO_REO_R0_CACHE_CTL_CONTROL_OFFS                                                                   (0xd54)
#define HWIO_REO_R0_CACHE_CTL_CONTROL_RMSK                                                                          0x3
#define HWIO_REO_R0_CACHE_CTL_CONTROL_POR                                                                    0x00000000
#define HWIO_REO_R0_CACHE_CTL_CONTROL_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_CACHE_CTL_CONTROL_ATTR                                                                                0x3
#define HWIO_REO_R0_CACHE_CTL_CONTROL_IN(x)            \
in_dword(HWIO_REO_R0_CACHE_CTL_CONTROL_ADDR(x))
#define HWIO_REO_R0_CACHE_CTL_CONTROL_INM(x, m)            \
in_dword_masked(HWIO_REO_R0_CACHE_CTL_CONTROL_ADDR(x), m)
#define HWIO_REO_R0_CACHE_CTL_CONTROL_OUT(x, v)            \
out_dword(HWIO_REO_R0_CACHE_CTL_CONTROL_ADDR(x),v)
#define HWIO_REO_R0_CACHE_CTL_CONTROL_OUTM(x,m,v) \
out_dword_masked_ns(HWIO_REO_R0_CACHE_CTL_CONTROL_ADDR(x),m,v,HWIO_REO_R0_CACHE_CTL_CONTROL_IN(x))
#define HWIO_REO_R0_CACHE_CTL_CONTROL_WRITE_POSTED_FOR_NON_POSTED_LINE_FLUSH_BMSK                                   0x2
#define HWIO_REO_R0_CACHE_CTL_CONTROL_WRITE_POSTED_FOR_NON_POSTED_LINE_FLUSH_SHFT                                     1
#define HWIO_REO_R0_CACHE_CTL_CONTROL_CACHE_RESET_BMSK                                                              0x1
#define HWIO_REO_R0_CACHE_CTL_CONTROL_CACHE_RESET_SHFT                                                                0

#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_ADDR(x)                                                             ((x) + 0xd58)
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_PHYS(x)                                                             ((x) + 0xd58)
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_OFFS                                                                (0xd58)
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_RMSK                                                                 0x1ffffff
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_POR                                                                 0x00000000
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_POR_RMSK                                                            0xffffffff
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_ATTR                                                                             0x3
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_IN(x)            \
in_dword(HWIO_REO_R0_CACHE_CTL_CONFIG_SET_ADDR(x))
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_INM(x, m)            \
in_dword_masked(HWIO_REO_R0_CACHE_CTL_CONFIG_SET_ADDR(x), m)
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_OUT(x, v)            \
out_dword(HWIO_REO_R0_CACHE_CTL_CONFIG_SET_ADDR(x),v)
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_OUTM(x,m,v) \
out_dword_masked_ns(HWIO_REO_R0_CACHE_CTL_CONFIG_SET_ADDR(x),m,v,HWIO_REO_R0_CACHE_CTL_CONFIG_SET_IN(x))
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_CONFIG_SET_BMSK                                                      0x1ffffff
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_CONFIG_SET_SHFT                                                              0

#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_ADDR(x)                                                               ((x) + 0xd5c)
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_PHYS(x)                                                               ((x) + 0xd5c)
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_OFFS                                                                  (0xd5c)
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_RMSK                                                                       0x3ff
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_POR                                                                   0x000000f0
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_POR_RMSK                                                              0xffffffff
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_ATTR                                                                               0x3
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_IN(x)            \
in_dword(HWIO_REO_R0_CACHE_CTL_SET_SIZE_ADDR(x))
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_INM(x, m)            \
in_dword_masked(HWIO_REO_R0_CACHE_CTL_SET_SIZE_ADDR(x), m)
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_OUT(x, v)            \
out_dword(HWIO_REO_R0_CACHE_CTL_SET_SIZE_ADDR(x),v)
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_OUTM(x,m,v) \
out_dword_masked_ns(HWIO_REO_R0_CACHE_CTL_SET_SIZE_ADDR(x),m,v,HWIO_REO_R0_CACHE_CTL_SET_SIZE_IN(x))
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_SET1_SIZE_BMSK                                                             0x3ff
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_SET1_SIZE_SHFT                                                                 0

#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_ADDR(x)                                                           ((x) + 0xd60)
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_PHYS(x)                                                           ((x) + 0xd60)
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_OFFS                                                              (0xd60)
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_RMSK                                                                     0x7
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_POR                                                               0x00000002
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_ATTR                                                                           0x3
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_IN(x)            \
in_dword(HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_ADDR(x))
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_INM(x, m)            \
in_dword_masked(HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_ADDR(x), m)
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_OUT(x, v)            \
out_dword(HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_ADDR(x),v)
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_OUTM(x,m,v) \
out_dword_masked_ns(HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_ADDR(x),m,v,HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_IN(x))
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_VC_ID_BMSK                                                               0x4
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_VC_ID_SHFT                                                                 2
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_GXI_PRIORITY_BMSK                                                        0x3
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_GXI_PRIORITY_SHFT                                                          0
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_ADDR(x)                                                       ((x) + 0x4)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_PHYS(x)                                                       ((x) + 0x4)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_OFFS                                                          (0x4)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_RMSK                                                          0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_POR                                                           0x76543210
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_ATTR                                                                       0x3
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_IN(x)            \
                in_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_ADDR(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_ADDR(x), m)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_ADDR(x),v)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_ADDR(x),m,v,HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_IN(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_7_BMSK                                      0xf0000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_7_SHFT                                              28
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_6_BMSK                                       0xf000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_6_SHFT                                              24
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_5_BMSK                                        0xf00000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_5_SHFT                                              20
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_4_BMSK                                         0xf0000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_4_SHFT                                              16
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_3_BMSK                                          0xf000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_3_SHFT                                              12
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_2_BMSK                                           0xf00
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_2_SHFT                                               8
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_1_BMSK                                            0xf0
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_1_SHFT                                               4
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_0_BMSK                                             0xf
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_0_SHFT                                               0

#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_ADDR(x)                                                       ((x) + 0x8)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_PHYS(x)                                                       ((x) + 0x8)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_OFFS                                                          (0x8)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_RMSK                                                          0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_POR                                                           0x6666ba98
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_ATTR                                                                       0x3
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_IN(x)            \
                in_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_ADDR(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_ADDR(x), m)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_ADDR(x),v)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_ADDR(x),m,v,HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_IN(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_15_BMSK                                     0xf0000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_15_SHFT                                             28
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_14_BMSK                                      0xf000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_14_SHFT                                             24
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_13_BMSK                                       0xf00000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_13_SHFT                                             20
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_12_BMSK                                        0xf0000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_12_SHFT                                             16
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_11_BMSK                                         0xf000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_11_SHFT                                             12
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_10_BMSK                                          0xf00
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_10_SHFT                                              8
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_9_BMSK                                            0xf0
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_9_SHFT                                               4
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_8_BMSK                                             0xf
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_8_SHFT                                               0

#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_ADDR(x)                                                       ((x) + 0xc)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_PHYS(x)                                                       ((x) + 0xc)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_OFFS                                                          (0xc)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_RMSK                                                          0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_POR                                                           0x66666666
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_ATTR                                                                       0x3
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_IN(x)            \
                in_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_ADDR(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_ADDR(x), m)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_OUT(x, v)            \
                out_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_ADDR(x),v)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_ADDR(x),m,v,HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_IN(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_23_BMSK                                     0xf0000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_23_SHFT                                             28
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_22_BMSK                                      0xf000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_22_SHFT                                             24
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_21_BMSK                                       0xf00000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_21_SHFT                                             20
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_20_BMSK                                        0xf0000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_20_SHFT                                             16
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_19_BMSK                                         0xf000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_19_SHFT                                             12
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_18_BMSK                                          0xf00
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_18_SHFT                                              8
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_17_BMSK                                           0xf0
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_17_SHFT                                              4
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_16_BMSK                                            0xf
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_16_SHFT                                              0

#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_ADDR(x)                                                       ((x) + 0x10)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_PHYS(x)                                                       ((x) + 0x10)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_OFFS                                                          (0x10)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_RMSK                                                          0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_POR                                                           0x66666666
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_ATTR                                                                       0x3
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_IN(x)            \
                in_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_ADDR(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_ADDR(x), m)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_OUT(x, v)            \
                out_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_ADDR(x),v)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_ADDR(x),m,v,HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_IN(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_31_BMSK                                     0xf0000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_31_SHFT                                             28
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_30_BMSK                                      0xf000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_30_SHFT                                             24
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_29_BMSK                                       0xf00000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_29_SHFT                                             20
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_28_BMSK                                        0xf0000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_28_SHFT                                             16
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_27_BMSK                                         0xf000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_27_SHFT                                             12
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_26_BMSK                                          0xf00
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_26_SHFT                                              8
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_25_BMSK                                           0xf0
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_25_SHFT                                              4
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_24_BMSK                                            0xf
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_24_SHFT                                              0

#define HWIO_REO_R0_SW_COOKIE_CFG0_ADDR(x)                                                                   ((x) + 0x50)
#define HWIO_REO_R0_SW_COOKIE_CFG0_PHYS(x)                                                                   ((x) + 0x50)
#define HWIO_REO_R0_SW_COOKIE_CFG0_OFFS                                                                      (0x50)
#define HWIO_REO_R0_SW_COOKIE_CFG0_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_SW_COOKIE_CFG0_POR                                                                       0x00000000
#define HWIO_REO_R0_SW_COOKIE_CFG0_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_SW_COOKIE_CFG0_ATTR                                                                                   0x3
#define HWIO_REO_R0_SW_COOKIE_CFG0_IN(x)            \
                in_dword(HWIO_REO_R0_SW_COOKIE_CFG0_ADDR(x))
#define HWIO_REO_R0_SW_COOKIE_CFG0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW_COOKIE_CFG0_ADDR(x), m)
#define HWIO_REO_R0_SW_COOKIE_CFG0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW_COOKIE_CFG0_ADDR(x),v)
#define HWIO_REO_R0_SW_COOKIE_CFG0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW_COOKIE_CFG0_ADDR(x),m,v,HWIO_REO_R0_SW_COOKIE_CFG0_IN(x))
#define HWIO_REO_R0_SW_COOKIE_CFG0_CMEM_LUT_BASE_ADDR_31_0_BMSK                                              0xffffffff
#define HWIO_REO_R0_SW_COOKIE_CFG0_CMEM_LUT_BASE_ADDR_31_0_SHFT                                                       0

#define HWIO_REO_R0_SW_COOKIE_CFG1_ADDR(x)                                                                   ((x) + 0x54)
#define HWIO_REO_R0_SW_COOKIE_CFG1_PHYS(x)                                                                   ((x) + 0x54)
#define HWIO_REO_R0_SW_COOKIE_CFG1_OFFS                                                                      (0x54)
#define HWIO_REO_R0_SW_COOKIE_CFG1_RMSK                                                                        0x1fffff
#define HWIO_REO_R0_SW_COOKIE_CFG1_POR                                                                       0x00111700
#define HWIO_REO_R0_SW_COOKIE_CFG1_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_SW_COOKIE_CFG1_ATTR                                                                                   0x3
#define HWIO_REO_R0_SW_COOKIE_CFG1_IN(x)            \
                in_dword(HWIO_REO_R0_SW_COOKIE_CFG1_ADDR(x))
#define HWIO_REO_R0_SW_COOKIE_CFG1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW_COOKIE_CFG1_ADDR(x), m)
#define HWIO_REO_R0_SW_COOKIE_CFG1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW_COOKIE_CFG1_ADDR(x),v)
#define HWIO_REO_R0_SW_COOKIE_CFG1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW_COOKIE_CFG1_ADDR(x),m,v,HWIO_REO_R0_SW_COOKIE_CFG1_IN(x))
#define HWIO_REO_R0_SW_COOKIE_CFG1_SW_COOKIE_CONVERT_GLOBAL_ENABLE_BMSK                                        0x100000
#define HWIO_REO_R0_SW_COOKIE_CFG1_SW_COOKIE_CONVERT_GLOBAL_ENABLE_SHFT                                              20
#define HWIO_REO_R0_SW_COOKIE_CFG1_SW_COOKIE_CONVERT_ENABLE_BMSK                                                0x80000
#define HWIO_REO_R0_SW_COOKIE_CFG1_SW_COOKIE_CONVERT_ENABLE_SHFT                                                     19
#define HWIO_REO_R0_SW_COOKIE_CFG1_PAGE_ALIGNMENT_BMSK                                                          0x40000
#define HWIO_REO_R0_SW_COOKIE_CFG1_PAGE_ALIGNMENT_SHFT                                                               18
#define HWIO_REO_R0_SW_COOKIE_CFG1_COOKIE_OFFSET_MSB_BMSK                                                       0x3e000
#define HWIO_REO_R0_SW_COOKIE_CFG1_COOKIE_OFFSET_MSB_SHFT                                                            13
#define HWIO_REO_R0_SW_COOKIE_CFG1_COOKIE_PAGE_MSB_BMSK                                                          0x1f00
#define HWIO_REO_R0_SW_COOKIE_CFG1_COOKIE_PAGE_MSB_SHFT                                                               8
#define HWIO_REO_R0_SW_COOKIE_CFG1_CMEM_LUT_BASE_ADDR_39_32_BMSK                                                   0xff
#define HWIO_REO_R0_SW_COOKIE_CFG1_CMEM_LUT_BASE_ADDR_39_32_SHFT                                                      0

#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_ADDR(x)                                                             ((x) + 0x58)
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_PHYS(x)                                                             ((x) + 0x58)
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_OFFS                                                                (0x58)
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_POR                                                                 0x00000000
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_POR_RMSK                                                            0xffffffff
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_ATTR                                                                             0x3
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_IN(x)            \
                in_dword(HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_ADDR(x))
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_ADDR(x), m)
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_OUT(x, v)            \
                out_dword(HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_ADDR(x),v)
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_ADDR(x),m,v,HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_IN(x))
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_VALUE_BMSK                                                          0xffffffff
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_VALUE_SHFT                                                                   0

#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_ADDR(x)                                                             ((x) + 0x5c)
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_PHYS(x)                                                             ((x) + 0x5c)
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_OFFS                                                                (0x5c)
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_POR                                                                 0x00000000
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_POR_RMSK                                                            0xffffffff
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_ATTR                                                                             0x3
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_IN(x)            \
                in_dword(HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_ADDR(x))
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_ADDR(x), m)
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_OUT(x, v)            \
                out_dword(HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_ADDR(x),v)
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_ADDR(x),m,v,HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_IN(x))
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_VALUE_BMSK                                                          0xffffffff
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_VALUE_SHFT                                                                   0

#define HWIO_REO_R0_QDESC_ADDR_READ_ADDR(x)                                                                  ((x) + 0x60)
#define HWIO_REO_R0_QDESC_ADDR_READ_PHYS(x)                                                                  ((x) + 0x60)
#define HWIO_REO_R0_QDESC_ADDR_READ_OFFS                                                                     (0x60)
#define HWIO_REO_R0_QDESC_ADDR_READ_RMSK                                                                          0x1ff
#define HWIO_REO_R0_QDESC_ADDR_READ_POR                                                                      0x00000000
#define HWIO_REO_R0_QDESC_ADDR_READ_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_QDESC_ADDR_READ_ATTR                                                                                  0x3
#define HWIO_REO_R0_QDESC_ADDR_READ_IN(x)            \
                in_dword(HWIO_REO_R0_QDESC_ADDR_READ_ADDR(x))
#define HWIO_REO_R0_QDESC_ADDR_READ_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_QDESC_ADDR_READ_ADDR(x), m)
#define HWIO_REO_R0_QDESC_ADDR_READ_OUT(x, v)            \
                out_dword(HWIO_REO_R0_QDESC_ADDR_READ_ADDR(x),v)
#define HWIO_REO_R0_QDESC_ADDR_READ_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_QDESC_ADDR_READ_ADDR(x),m,v,HWIO_REO_R0_QDESC_ADDR_READ_IN(x))
#define HWIO_REO_R0_QDESC_ADDR_READ_GXI_SWAP_BMSK                                                                 0x100
#define HWIO_REO_R0_QDESC_ADDR_READ_GXI_SWAP_SHFT                                                                     8
#define HWIO_REO_R0_QDESC_ADDR_READ_LUT_FEATURE_ENABLE_BMSK                                                        0x80
#define HWIO_REO_R0_QDESC_ADDR_READ_LUT_FEATURE_ENABLE_SHFT                                                           7
#define HWIO_REO_R0_QDESC_ADDR_READ_CLEAR_QDESC_ARRAY_BMSK                                                         0x40
#define HWIO_REO_R0_QDESC_ADDR_READ_CLEAR_QDESC_ARRAY_SHFT                                                            6
#define HWIO_REO_R0_QDESC_ADDR_READ_INDEX_BMSK                                                                     0x3f
#define HWIO_REO_R0_QDESC_ADDR_READ_INDEX_SHFT                                                                        0

#define HWIO_REO_R0_QDESC_ADDR_LOWER_ADDR(x)                                                                 ((x) + 0x64)
#define HWIO_REO_R0_QDESC_ADDR_LOWER_PHYS(x)                                                                 ((x) + 0x64)
#define HWIO_REO_R0_QDESC_ADDR_LOWER_OFFS                                                                    (0x64)
#define HWIO_REO_R0_QDESC_ADDR_LOWER_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_QDESC_ADDR_LOWER_POR                                                                     0x00000000
#define HWIO_REO_R0_QDESC_ADDR_LOWER_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_QDESC_ADDR_LOWER_ATTR                                                                                 0x1
#define HWIO_REO_R0_QDESC_ADDR_LOWER_IN(x)            \
                in_dword(HWIO_REO_R0_QDESC_ADDR_LOWER_ADDR(x))
#define HWIO_REO_R0_QDESC_ADDR_LOWER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_QDESC_ADDR_LOWER_ADDR(x), m)
#define HWIO_REO_R0_QDESC_ADDR_LOWER_QDESC_ADDR_BMSK                                                         0xffffffff
#define HWIO_REO_R0_QDESC_ADDR_LOWER_QDESC_ADDR_SHFT                                                                  0

#define HWIO_REO_R0_QDESC_ADDR_HIGHER_ADDR(x)                                                                ((x) + 0x68)
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_PHYS(x)                                                                ((x) + 0x68)
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_OFFS                                                                   (0x68)
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_RMSK                                                                    0x3ffffff
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_POR                                                                    0x00000000
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_ATTR                                                                                0x1
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_IN(x)            \
                in_dword(HWIO_REO_R0_QDESC_ADDR_HIGHER_ADDR(x))
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_QDESC_ADDR_HIGHER_ADDR(x), m)
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_Q_INDEX_BMSK                                                            0x3ffff00
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_Q_INDEX_SHFT                                                                    8
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_QDESC_ADDR_BMSK                                                              0xff
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_QDESC_ADDR_SHFT                                                                 0

#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_ADDR(x)                                                             ((x) + 0x6c)
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_PHYS(x)                                                             ((x) + 0x6c)
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_OFFS                                                                (0x6c)
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_RMSK                                                                    0x1fff
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_POR                                                                 0x00000000
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_POR_RMSK                                                            0xffffffff
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_ATTR                                                                             0x3
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_IN(x)            \
                in_dword(HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_ADDR(x))
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_ADDR(x), m)
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_ADDR(x),v)
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_ADDR(x),m,v,HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_IN(x))
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_MAX_SUPPORTED_BMSK                                                      0x1fff
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_MAX_SUPPORTED_SHFT                                                           0

#define HWIO_REO_R0_RX_STATS_CMD_ADDR(x)                                                                     ((x) + 0x70)
#define HWIO_REO_R0_RX_STATS_CMD_PHYS(x)                                                                     ((x) + 0x70)
#define HWIO_REO_R0_RX_STATS_CMD_OFFS                                                                        (0x70)
#define HWIO_REO_R0_RX_STATS_CMD_RMSK                                                                              0xff
#define HWIO_REO_R0_RX_STATS_CMD_POR                                                                         0x00000000
#define HWIO_REO_R0_RX_STATS_CMD_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_RX_STATS_CMD_ATTR                                                                                     0x3
#define HWIO_REO_R0_RX_STATS_CMD_IN(x)            \
                in_dword(HWIO_REO_R0_RX_STATS_CMD_ADDR(x))
#define HWIO_REO_R0_RX_STATS_CMD_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RX_STATS_CMD_ADDR(x), m)
#define HWIO_REO_R0_RX_STATS_CMD_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RX_STATS_CMD_ADDR(x),v)
#define HWIO_REO_R0_RX_STATS_CMD_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RX_STATS_CMD_ADDR(x),m,v,HWIO_REO_R0_RX_STATS_CMD_IN(x))
#define HWIO_REO_R0_RX_STATS_CMD_CLEAR_ALL_VDEV_ID_RX_STATS_BMSK                                                   0x80
#define HWIO_REO_R0_RX_STATS_CMD_CLEAR_ALL_VDEV_ID_RX_STATS_SHFT                                                      7
#define HWIO_REO_R0_RX_STATS_CMD_CLEAR_SINGLE_VDEV_RX_STATS_BMSK                                                   0x40
#define HWIO_REO_R0_RX_STATS_CMD_CLEAR_SINGLE_VDEV_RX_STATS_SHFT                                                      6
#define HWIO_REO_R0_RX_STATS_CMD_VDEV_ID_BMSK                                                                      0x3f
#define HWIO_REO_R0_RX_STATS_CMD_VDEV_ID_SHFT                                                                         0

#define HWIO_REO_R0_RX_STATS_LOWER_ADDR(x)                                                                   ((x) + 0x74)
#define HWIO_REO_R0_RX_STATS_LOWER_PHYS(x)                                                                   ((x) + 0x74)
#define HWIO_REO_R0_RX_STATS_LOWER_OFFS                                                                      (0x74)
#define HWIO_REO_R0_RX_STATS_LOWER_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_RX_STATS_LOWER_POR                                                                       0x00000000
#define HWIO_REO_R0_RX_STATS_LOWER_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_RX_STATS_LOWER_ATTR                                                                                   0x1
#define HWIO_REO_R0_RX_STATS_LOWER_IN(x)            \
                in_dword(HWIO_REO_R0_RX_STATS_LOWER_ADDR(x))
#define HWIO_REO_R0_RX_STATS_LOWER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RX_STATS_LOWER_ADDR(x), m)
#define HWIO_REO_R0_RX_STATS_LOWER_MSDU_BYTE_COUNT_BMSK                                                      0xffffffff
#define HWIO_REO_R0_RX_STATS_LOWER_MSDU_BYTE_COUNT_SHFT                                                               0

#define HWIO_REO_R0_RX_STATS_HIGHER_ADDR(x)                                                                  ((x) + 0x78)
#define HWIO_REO_R0_RX_STATS_HIGHER_PHYS(x)                                                                  ((x) + 0x78)
#define HWIO_REO_R0_RX_STATS_HIGHER_OFFS                                                                     (0x78)
#define HWIO_REO_R0_RX_STATS_HIGHER_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_RX_STATS_HIGHER_POR                                                                      0x00000000
#define HWIO_REO_R0_RX_STATS_HIGHER_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_RX_STATS_HIGHER_ATTR                                                                                  0x1
#define HWIO_REO_R0_RX_STATS_HIGHER_IN(x)            \
                in_dword(HWIO_REO_R0_RX_STATS_HIGHER_ADDR(x))
#define HWIO_REO_R0_RX_STATS_HIGHER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RX_STATS_HIGHER_ADDR(x), m)
#define HWIO_REO_R0_RX_STATS_HIGHER_MSDU_COUNT_BMSK                                                          0xfffffff0
#define HWIO_REO_R0_RX_STATS_HIGHER_MSDU_COUNT_SHFT                                                                   4
#define HWIO_REO_R0_RX_STATS_HIGHER_MSDU_BYTE_COUNT_BMSK                                                            0xf
#define HWIO_REO_R0_RX_STATS_HIGHER_MSDU_BYTE_COUNT_SHFT                                                              0

#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_ADDR(x)                                                            ((x) + 0x28c)
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_PHYS(x)                                                            ((x) + 0x28c)
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_OFFS                                                               (0x28c)
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_POR                                                                0x00000000
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_ATTR                                                                            0x3
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                            0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                     0

#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_ADDR(x)                                                            ((x) + 0x290)
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_PHYS(x)                                                            ((x) + 0x290)
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_OFFS                                                               (0x290)
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_RMSK                                                                 0xffffff
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_POR                                                                0x00000000
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_ATTR                                                                            0x3
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_RING_SIZE_BMSK                                                       0xffff00
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_RING_SIZE_SHFT                                                              8
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                  0xff
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                     0

#define HWIO_REO_R0_REO_CMD_RING_ID_ADDR(x)                                                                  ((x) + 0x294)
#define HWIO_REO_R0_REO_CMD_RING_ID_PHYS(x)                                                                  ((x) + 0x294)
#define HWIO_REO_R0_REO_CMD_RING_ID_OFFS                                                                     (0x294)
#define HWIO_REO_R0_REO_CMD_RING_ID_RMSK                                                                           0xff
#define HWIO_REO_R0_REO_CMD_RING_ID_POR                                                                      0x00000000
#define HWIO_REO_R0_REO_CMD_RING_ID_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_ID_ATTR                                                                                  0x3
#define HWIO_REO_R0_REO_CMD_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_ID_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_ID_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_ID_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_ID_ENTRY_SIZE_BMSK                                                                0xff
#define HWIO_REO_R0_REO_CMD_RING_ID_ENTRY_SIZE_SHFT                                                                   0

#define HWIO_REO_R0_REO_CMD_RING_STATUS_ADDR(x)                                                              ((x) + 0x298)
#define HWIO_REO_R0_REO_CMD_RING_STATUS_PHYS(x)                                                              ((x) + 0x298)
#define HWIO_REO_R0_REO_CMD_RING_STATUS_OFFS                                                                 (0x298)
#define HWIO_REO_R0_REO_CMD_RING_STATUS_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_STATUS_POR                                                                  0x00000000
#define HWIO_REO_R0_REO_CMD_RING_STATUS_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_STATUS_ATTR                                                                              0x1
#define HWIO_REO_R0_REO_CMD_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                 0xffff0000
#define HWIO_REO_R0_REO_CMD_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                         16
#define HWIO_REO_R0_REO_CMD_RING_STATUS_NUM_VALID_WORDS_BMSK                                                     0xffff
#define HWIO_REO_R0_REO_CMD_RING_STATUS_NUM_VALID_WORDS_SHFT                                                          0

#define HWIO_REO_R0_REO_CMD_RING_MISC_ADDR(x)                                                                ((x) + 0x29c)
#define HWIO_REO_R0_REO_CMD_RING_MISC_PHYS(x)                                                                ((x) + 0x29c)
#define HWIO_REO_R0_REO_CMD_RING_MISC_OFFS                                                                   (0x29c)
#define HWIO_REO_R0_REO_CMD_RING_MISC_RMSK                                                                     0x3fffff
#define HWIO_REO_R0_REO_CMD_RING_MISC_POR                                                                    0x00000080
#define HWIO_REO_R0_REO_CMD_RING_MISC_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_MISC_ATTR                                                                                0x3
#define HWIO_REO_R0_REO_CMD_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_MISC_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_MISC_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_MISC_SPARE_CONTROL_BMSK                                                       0x3fc000
#define HWIO_REO_R0_REO_CMD_RING_MISC_SPARE_CONTROL_SHFT                                                             14
#define HWIO_REO_R0_REO_CMD_RING_MISC_SRNG_SM_STATE2_BMSK                                                        0x3000
#define HWIO_REO_R0_REO_CMD_RING_MISC_SRNG_SM_STATE2_SHFT                                                            12
#define HWIO_REO_R0_REO_CMD_RING_MISC_SRNG_SM_STATE1_BMSK                                                         0xf00
#define HWIO_REO_R0_REO_CMD_RING_MISC_SRNG_SM_STATE1_SHFT                                                             8
#define HWIO_REO_R0_REO_CMD_RING_MISC_SRNG_IS_IDLE_BMSK                                                            0x80
#define HWIO_REO_R0_REO_CMD_RING_MISC_SRNG_IS_IDLE_SHFT                                                               7
#define HWIO_REO_R0_REO_CMD_RING_MISC_SRNG_ENABLE_BMSK                                                             0x40
#define HWIO_REO_R0_REO_CMD_RING_MISC_SRNG_ENABLE_SHFT                                                                6
#define HWIO_REO_R0_REO_CMD_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                       0x20
#define HWIO_REO_R0_REO_CMD_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                          5
#define HWIO_REO_R0_REO_CMD_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                        0x10
#define HWIO_REO_R0_REO_CMD_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                           4
#define HWIO_REO_R0_REO_CMD_RING_MISC_MSI_SWAP_BIT_BMSK                                                             0x8
#define HWIO_REO_R0_REO_CMD_RING_MISC_MSI_SWAP_BIT_SHFT                                                               3
#define HWIO_REO_R0_REO_CMD_RING_MISC_SECURITY_BIT_BMSK                                                             0x4
#define HWIO_REO_R0_REO_CMD_RING_MISC_SECURITY_BIT_SHFT                                                               2
#define HWIO_REO_R0_REO_CMD_RING_MISC_LOOPCNT_DISABLE_BMSK                                                          0x2
#define HWIO_REO_R0_REO_CMD_RING_MISC_LOOPCNT_DISABLE_SHFT                                                            1
#define HWIO_REO_R0_REO_CMD_RING_MISC_RING_ID_DISABLE_BMSK                                                          0x1
#define HWIO_REO_R0_REO_CMD_RING_MISC_RING_ID_DISABLE_SHFT                                                            0

#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_ADDR(x)                                                         ((x) + 0x2a8)
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_PHYS(x)                                                         ((x) + 0x2a8)
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_OFFS                                                            (0x2a8)
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_RMSK                                                            0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                       0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                                0

#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_ADDR(x)                                                         ((x) + 0x2ac)
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_PHYS(x)                                                         ((x) + 0x2ac)
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_OFFS                                                            (0x2ac)
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_RMSK                                                                  0xff
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                             0xff
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                                0

#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                              ((x) + 0x2bc)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                              ((x) + 0x2bc)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                 (0x2bc)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                 0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_POR                                                  0x00000000
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                             0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                              0x3
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                       0xffff0000
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                               16
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                   0x8000
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                       15
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                             0x7fff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                  0

#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                              ((x) + 0x2c0)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                              ((x) + 0x2c0)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                 (0x2c0)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                     0xffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_POR                                                  0x00000000
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                             0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                              0x3
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                       0xffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                            0

#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_ADDR(x)                                                 ((x) + 0x2c4)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_PHYS(x)                                                 ((x) + 0x2c4)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_OFFS                                                    (0x2c4)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_RMSK                                                    0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_POR                                                     0x00000000
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_ATTR                                                                 0x1
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                      0xffff0000
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                              16
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                 0x8000
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                     15
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                           0x7fff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                0

#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                              ((x) + 0x2c8)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                              ((x) + 0x2c8)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                 (0x2c8)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                      0x3ff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_POR                                                  0x00000000
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                             0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                              0x3
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                   0x3ff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                       0

#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                             ((x) + 0x2cc)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                             ((x) + 0x2cc)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_OFFS                                                (0x2cc)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                       0x7
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_POR                                                 0x00000003
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                            0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                             0x3
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                  0x7
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                    0

#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                            ((x) + 0x2d0)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                            ((x) + 0x2d0)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_OFFS                                               (0x2d0)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                 0xffffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_POR                                                0x00000000
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                            0x1
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                  0xff0000
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                        16
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                 0xffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                      0

#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_ADDR(x)                                                       ((x) + 0x2d4)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_PHYS(x)                                                       ((x) + 0x2d4)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_OFFS                                                          (0x2d4)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_ADDR(x)                                                       ((x) + 0x2d8)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_PHYS(x)                                                       ((x) + 0x2d8)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_OFFS                                                          (0x2d8)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_ADDR(x)                                                           ((x) + 0x2dc)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_PHYS(x)                                                           ((x) + 0x2dc)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_OFFS                                                              (0x2dc)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_ADDR(x)                                                     ((x) + 0x2fc)
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_PHYS(x)                                                     ((x) + 0x2fc)
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_OFFS                                                        (0x2fc)
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_RMSK                                                            0xffff
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_POR                                                         0x00000000
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_POR_RMSK                                                    0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_ATTR                                                                     0x3
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                         0xffff
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                              0

#define HWIO_REO_R0_REO_CMD_RING_MISC_1_ADDR(x)                                                              ((x) + 0x300)
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_PHYS(x)                                                              ((x) + 0x300)
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_OFFS                                                                 (0x300)
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_RMSK                                                                 0xffff003f
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_POR                                                                  0x00000000
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_ATTR                                                                              0x3
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_MISC_1_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                        0xffff0000
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                16
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                               0x3f
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                  0

#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_ADDR(x)                                                             ((x) + 0x304)
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_PHYS(x)                                                             ((x) + 0x304)
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_OFFS                                                                (0x304)
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_RMSK                                                                0xffffffff
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_POR                                                                 0x00000000
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_POR_RMSK                                                            0xffffffff
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_ATTR                                                                             0x3
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                             0xffffffff
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                      0

#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_ADDR(x)                                                             ((x) + 0x308)
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_PHYS(x)                                                             ((x) + 0x308)
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_OFFS                                                                (0x308)
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_RMSK                                                                  0xffffff
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_POR                                                                 0x00000000
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_POR_RMSK                                                            0xffffffff
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_ATTR                                                                             0x3
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_RING_SIZE_BMSK                                                        0xffff00
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_RING_SIZE_SHFT                                                               8
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                   0xff
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                      0

#define HWIO_REO_R0_SW2REO_RING_ID_ADDR(x)                                                                   ((x) + 0x30c)
#define HWIO_REO_R0_SW2REO_RING_ID_PHYS(x)                                                                   ((x) + 0x30c)
#define HWIO_REO_R0_SW2REO_RING_ID_OFFS                                                                      (0x30c)
#define HWIO_REO_R0_SW2REO_RING_ID_RMSK                                                                            0xff
#define HWIO_REO_R0_SW2REO_RING_ID_POR                                                                       0x00000000
#define HWIO_REO_R0_SW2REO_RING_ID_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_SW2REO_RING_ID_ATTR                                                                                   0x3
#define HWIO_REO_R0_SW2REO_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_ID_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_ID_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_ID_IN(x))
#define HWIO_REO_R0_SW2REO_RING_ID_ENTRY_SIZE_BMSK                                                                 0xff
#define HWIO_REO_R0_SW2REO_RING_ID_ENTRY_SIZE_SHFT                                                                    0

#define HWIO_REO_R0_SW2REO_RING_STATUS_ADDR(x)                                                               ((x) + 0x310)
#define HWIO_REO_R0_SW2REO_RING_STATUS_PHYS(x)                                                               ((x) + 0x310)
#define HWIO_REO_R0_SW2REO_RING_STATUS_OFFS                                                                  (0x310)
#define HWIO_REO_R0_SW2REO_RING_STATUS_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_SW2REO_RING_STATUS_POR                                                                   0x00000000
#define HWIO_REO_R0_SW2REO_RING_STATUS_POR_RMSK                                                              0xffffffff
#define HWIO_REO_R0_SW2REO_RING_STATUS_ATTR                                                                               0x1
#define HWIO_REO_R0_SW2REO_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                  0xffff0000
#define HWIO_REO_R0_SW2REO_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                          16
#define HWIO_REO_R0_SW2REO_RING_STATUS_NUM_VALID_WORDS_BMSK                                                      0xffff
#define HWIO_REO_R0_SW2REO_RING_STATUS_NUM_VALID_WORDS_SHFT                                                           0

#define HWIO_REO_R0_SW2REO_RING_MISC_ADDR(x)                                                                 ((x) + 0x314)
#define HWIO_REO_R0_SW2REO_RING_MISC_PHYS(x)                                                                 ((x) + 0x314)
#define HWIO_REO_R0_SW2REO_RING_MISC_OFFS                                                                    (0x314)
#define HWIO_REO_R0_SW2REO_RING_MISC_RMSK                                                                      0x3fffff
#define HWIO_REO_R0_SW2REO_RING_MISC_POR                                                                     0x00000080
#define HWIO_REO_R0_SW2REO_RING_MISC_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_SW2REO_RING_MISC_ATTR                                                                                 0x3
#define HWIO_REO_R0_SW2REO_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_MISC_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_MISC_IN(x))
#define HWIO_REO_R0_SW2REO_RING_MISC_SPARE_CONTROL_BMSK                                                        0x3fc000
#define HWIO_REO_R0_SW2REO_RING_MISC_SPARE_CONTROL_SHFT                                                              14
#define HWIO_REO_R0_SW2REO_RING_MISC_SRNG_SM_STATE2_BMSK                                                         0x3000
#define HWIO_REO_R0_SW2REO_RING_MISC_SRNG_SM_STATE2_SHFT                                                             12
#define HWIO_REO_R0_SW2REO_RING_MISC_SRNG_SM_STATE1_BMSK                                                          0xf00
#define HWIO_REO_R0_SW2REO_RING_MISC_SRNG_SM_STATE1_SHFT                                                              8
#define HWIO_REO_R0_SW2REO_RING_MISC_SRNG_IS_IDLE_BMSK                                                             0x80
#define HWIO_REO_R0_SW2REO_RING_MISC_SRNG_IS_IDLE_SHFT                                                                7
#define HWIO_REO_R0_SW2REO_RING_MISC_SRNG_ENABLE_BMSK                                                              0x40
#define HWIO_REO_R0_SW2REO_RING_MISC_SRNG_ENABLE_SHFT                                                                 6
#define HWIO_REO_R0_SW2REO_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                        0x20
#define HWIO_REO_R0_SW2REO_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                           5
#define HWIO_REO_R0_SW2REO_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                         0x10
#define HWIO_REO_R0_SW2REO_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                            4
#define HWIO_REO_R0_SW2REO_RING_MISC_MSI_SWAP_BIT_BMSK                                                              0x8
#define HWIO_REO_R0_SW2REO_RING_MISC_MSI_SWAP_BIT_SHFT                                                                3
#define HWIO_REO_R0_SW2REO_RING_MISC_SECURITY_BIT_BMSK                                                              0x4
#define HWIO_REO_R0_SW2REO_RING_MISC_SECURITY_BIT_SHFT                                                                2
#define HWIO_REO_R0_SW2REO_RING_MISC_LOOPCNT_DISABLE_BMSK                                                           0x2
#define HWIO_REO_R0_SW2REO_RING_MISC_LOOPCNT_DISABLE_SHFT                                                             1
#define HWIO_REO_R0_SW2REO_RING_MISC_RING_ID_DISABLE_BMSK                                                           0x1
#define HWIO_REO_R0_SW2REO_RING_MISC_RING_ID_DISABLE_SHFT                                                             0

#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_ADDR(x)                                                          ((x) + 0x320)
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_PHYS(x)                                                          ((x) + 0x320)
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_OFFS                                                             (0x320)
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_RMSK                                                             0xffffffff
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_POR                                                              0x00000000
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_POR_RMSK                                                         0xffffffff
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_ATTR                                                                          0x3
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                        0xffffffff
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                                 0

#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_ADDR(x)                                                          ((x) + 0x324)
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_PHYS(x)                                                          ((x) + 0x324)
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_OFFS                                                             (0x324)
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_RMSK                                                                   0xff
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_POR                                                              0x00000000
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_POR_RMSK                                                         0xffffffff
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_ATTR                                                                          0x3
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                              0xff
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                                 0

#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                               ((x) + 0x334)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                               ((x) + 0x334)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                  (0x334)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                  0xffffffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_POR                                                   0x00000000
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                              0xffffffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                               0x3
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                        0xffff0000
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                                16
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                    0x8000
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                        15
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                              0x7fff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                   0

#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                               ((x) + 0x338)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                               ((x) + 0x338)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                  (0x338)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                      0xffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_POR                                                   0x00000000
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                              0xffffffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                               0x3
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                        0xffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                             0

#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_ADDR(x)                                                  ((x) + 0x33c)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_PHYS(x)                                                  ((x) + 0x33c)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_OFFS                                                     (0x33c)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_RMSK                                                     0xffffffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_POR                                                      0x00000000
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_POR_RMSK                                                 0xffffffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_ATTR                                                                  0x1
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                       0xffff0000
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                               16
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                  0x8000
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                      15
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                            0x7fff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                 0

#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                               ((x) + 0x340)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                               ((x) + 0x340)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                  (0x340)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                       0x3ff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_POR                                                   0x00000000
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                              0xffffffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                               0x3
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                    0x3ff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                        0

#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                              ((x) + 0x344)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                              ((x) + 0x344)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_OFFS                                                 (0x344)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                        0x7
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_POR                                                  0x00000003
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                             0xffffffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                              0x3
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                   0x7
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                     0

#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                             ((x) + 0x348)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                             ((x) + 0x348)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_OFFS                                                (0x348)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                  0xffffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_POR                                                 0x00000000
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                            0xffffffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                             0x1
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                   0xff0000
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                         16
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                  0xffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                       0

#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_ADDR(x)                                                        ((x) + 0x34c)
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_PHYS(x)                                                        ((x) + 0x34c)
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_OFFS                                                           (0x34c)
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_RMSK                                                           0xffffffff
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_POR                                                            0x00000000
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_ATTR                                                                        0x3
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_ADDR_BMSK                                                      0xffffffff
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_ADDR_SHFT                                                               0

#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_ADDR(x)                                                        ((x) + 0x350)
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_PHYS(x)                                                        ((x) + 0x350)
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_OFFS                                                           (0x350)
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_RMSK                                                                0x1ff
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_POR                                                            0x00000000
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_ATTR                                                                        0x3
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                    0x100
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                        8
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_ADDR_BMSK                                                            0xff
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_ADDR_SHFT                                                               0

#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_ADDR(x)                                                            ((x) + 0x354)
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_PHYS(x)                                                            ((x) + 0x354)
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_OFFS                                                               (0x354)
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_RMSK                                                               0xffffffff
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_POR                                                                0x00000000
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_ATTR                                                                            0x3
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_VALUE_BMSK                                                         0xffffffff
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_VALUE_SHFT                                                                  0

#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_ADDR(x)                                                      ((x) + 0x374)
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_PHYS(x)                                                      ((x) + 0x374)
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_OFFS                                                         (0x374)
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_RMSK                                                             0xffff
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_POR                                                          0x00000000
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_POR_RMSK                                                     0xffffffff
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_ATTR                                                                      0x3
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                          0xffff
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                               0

#define HWIO_REO_R0_SW2REO_RING_MISC_1_ADDR(x)                                                               ((x) + 0x378)
#define HWIO_REO_R0_SW2REO_RING_MISC_1_PHYS(x)                                                               ((x) + 0x378)
#define HWIO_REO_R0_SW2REO_RING_MISC_1_OFFS                                                                  (0x378)
#define HWIO_REO_R0_SW2REO_RING_MISC_1_RMSK                                                                  0xffff003f
#define HWIO_REO_R0_SW2REO_RING_MISC_1_POR                                                                   0x00000000
#define HWIO_REO_R0_SW2REO_RING_MISC_1_POR_RMSK                                                              0xffffffff
#define HWIO_REO_R0_SW2REO_RING_MISC_1_ATTR                                                                               0x3
#define HWIO_REO_R0_SW2REO_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_MISC_1_IN(x))
#define HWIO_REO_R0_SW2REO_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                         0xffff0000
#define HWIO_REO_R0_SW2REO_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                 16
#define HWIO_REO_R0_SW2REO_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                                0x3f
#define HWIO_REO_R0_SW2REO_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                   0

#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_ADDR(x)                                                            ((x) + 0x37c)
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_PHYS(x)                                                            ((x) + 0x37c)
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_OFFS                                                               (0x37c)
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_POR                                                                0x00000000
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_ATTR                                                                            0x3
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                            0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                     0

#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_ADDR(x)                                                            ((x) + 0x380)
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_PHYS(x)                                                            ((x) + 0x380)
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_OFFS                                                               (0x380)
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_RMSK                                                                 0xffffff
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_POR                                                                0x00000000
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_ATTR                                                                            0x3
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_RING_SIZE_BMSK                                                       0xffff00
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_RING_SIZE_SHFT                                                              8
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                  0xff
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                     0

#define HWIO_REO_R0_SW2REO1_RING_ID_ADDR(x)                                                                  ((x) + 0x384)
#define HWIO_REO_R0_SW2REO1_RING_ID_PHYS(x)                                                                  ((x) + 0x384)
#define HWIO_REO_R0_SW2REO1_RING_ID_OFFS                                                                     (0x384)
#define HWIO_REO_R0_SW2REO1_RING_ID_RMSK                                                                           0xff
#define HWIO_REO_R0_SW2REO1_RING_ID_POR                                                                      0x00000000
#define HWIO_REO_R0_SW2REO1_RING_ID_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_ID_ATTR                                                                                  0x3
#define HWIO_REO_R0_SW2REO1_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_ID_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_ID_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_ID_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_ID_ENTRY_SIZE_BMSK                                                                0xff
#define HWIO_REO_R0_SW2REO1_RING_ID_ENTRY_SIZE_SHFT                                                                   0

#define HWIO_REO_R0_SW2REO1_RING_STATUS_ADDR(x)                                                              ((x) + 0x388)
#define HWIO_REO_R0_SW2REO1_RING_STATUS_PHYS(x)                                                              ((x) + 0x388)
#define HWIO_REO_R0_SW2REO1_RING_STATUS_OFFS                                                                 (0x388)
#define HWIO_REO_R0_SW2REO1_RING_STATUS_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_STATUS_POR                                                                  0x00000000
#define HWIO_REO_R0_SW2REO1_RING_STATUS_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_STATUS_ATTR                                                                              0x1
#define HWIO_REO_R0_SW2REO1_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                 0xffff0000
#define HWIO_REO_R0_SW2REO1_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                         16
#define HWIO_REO_R0_SW2REO1_RING_STATUS_NUM_VALID_WORDS_BMSK                                                     0xffff
#define HWIO_REO_R0_SW2REO1_RING_STATUS_NUM_VALID_WORDS_SHFT                                                          0

#define HWIO_REO_R0_SW2REO1_RING_MISC_ADDR(x)                                                                ((x) + 0x38c)
#define HWIO_REO_R0_SW2REO1_RING_MISC_PHYS(x)                                                                ((x) + 0x38c)
#define HWIO_REO_R0_SW2REO1_RING_MISC_OFFS                                                                   (0x38c)
#define HWIO_REO_R0_SW2REO1_RING_MISC_RMSK                                                                     0x3fffff
#define HWIO_REO_R0_SW2REO1_RING_MISC_POR                                                                    0x00000080
#define HWIO_REO_R0_SW2REO1_RING_MISC_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_MISC_ATTR                                                                                0x3
#define HWIO_REO_R0_SW2REO1_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_MISC_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_MISC_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_MISC_SPARE_CONTROL_BMSK                                                       0x3fc000
#define HWIO_REO_R0_SW2REO1_RING_MISC_SPARE_CONTROL_SHFT                                                             14
#define HWIO_REO_R0_SW2REO1_RING_MISC_SRNG_SM_STATE2_BMSK                                                        0x3000
#define HWIO_REO_R0_SW2REO1_RING_MISC_SRNG_SM_STATE2_SHFT                                                            12
#define HWIO_REO_R0_SW2REO1_RING_MISC_SRNG_SM_STATE1_BMSK                                                         0xf00
#define HWIO_REO_R0_SW2REO1_RING_MISC_SRNG_SM_STATE1_SHFT                                                             8
#define HWIO_REO_R0_SW2REO1_RING_MISC_SRNG_IS_IDLE_BMSK                                                            0x80
#define HWIO_REO_R0_SW2REO1_RING_MISC_SRNG_IS_IDLE_SHFT                                                               7
#define HWIO_REO_R0_SW2REO1_RING_MISC_SRNG_ENABLE_BMSK                                                             0x40
#define HWIO_REO_R0_SW2REO1_RING_MISC_SRNG_ENABLE_SHFT                                                                6
#define HWIO_REO_R0_SW2REO1_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                       0x20
#define HWIO_REO_R0_SW2REO1_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                          5
#define HWIO_REO_R0_SW2REO1_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                        0x10
#define HWIO_REO_R0_SW2REO1_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                           4
#define HWIO_REO_R0_SW2REO1_RING_MISC_MSI_SWAP_BIT_BMSK                                                             0x8
#define HWIO_REO_R0_SW2REO1_RING_MISC_MSI_SWAP_BIT_SHFT                                                               3
#define HWIO_REO_R0_SW2REO1_RING_MISC_SECURITY_BIT_BMSK                                                             0x4
#define HWIO_REO_R0_SW2REO1_RING_MISC_SECURITY_BIT_SHFT                                                               2
#define HWIO_REO_R0_SW2REO1_RING_MISC_LOOPCNT_DISABLE_BMSK                                                          0x2
#define HWIO_REO_R0_SW2REO1_RING_MISC_LOOPCNT_DISABLE_SHFT                                                            1
#define HWIO_REO_R0_SW2REO1_RING_MISC_RING_ID_DISABLE_BMSK                                                          0x1
#define HWIO_REO_R0_SW2REO1_RING_MISC_RING_ID_DISABLE_SHFT                                                            0

#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_ADDR(x)                                                         ((x) + 0x398)
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_PHYS(x)                                                         ((x) + 0x398)
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_OFFS                                                            (0x398)
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_RMSK                                                            0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_POR                                                             0x00000000
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_ATTR                                                                         0x3
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                       0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                                0

#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_ADDR(x)                                                         ((x) + 0x39c)
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_PHYS(x)                                                         ((x) + 0x39c)
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_OFFS                                                            (0x39c)
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_RMSK                                                                  0xff
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_POR                                                             0x00000000
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_ATTR                                                                         0x3
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                             0xff
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                                0

#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                              ((x) + 0x3ac)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                              ((x) + 0x3ac)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                 (0x3ac)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                 0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_POR                                                  0x00000000
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                             0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                              0x3
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                       0xffff0000
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                               16
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                   0x8000
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                       15
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                             0x7fff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                  0

#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                              ((x) + 0x3b0)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                              ((x) + 0x3b0)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                 (0x3b0)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                     0xffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_POR                                                  0x00000000
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                             0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                              0x3
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                       0xffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                            0

#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_ADDR(x)                                                 ((x) + 0x3b4)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_PHYS(x)                                                 ((x) + 0x3b4)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_OFFS                                                    (0x3b4)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_RMSK                                                    0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_POR                                                     0x00000000
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_ATTR                                                                 0x1
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                      0xffff0000
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                              16
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                 0x8000
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                     15
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                           0x7fff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                0

#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                              ((x) + 0x3b8)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                              ((x) + 0x3b8)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                 (0x3b8)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                      0x3ff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_POR                                                  0x00000000
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                             0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                              0x3
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                   0x3ff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                       0

#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                             ((x) + 0x3bc)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                             ((x) + 0x3bc)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_OFFS                                                (0x3bc)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                       0x7
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_POR                                                 0x00000003
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                            0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                             0x3
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                  0x7
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                    0

#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                            ((x) + 0x3c0)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                            ((x) + 0x3c0)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_OFFS                                               (0x3c0)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                 0xffffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_POR                                                0x00000000
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                            0x1
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                  0xff0000
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                        16
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                 0xffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                      0

#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_ADDR(x)                                                       ((x) + 0x3c4)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_PHYS(x)                                                       ((x) + 0x3c4)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_OFFS                                                          (0x3c4)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_ADDR(x)                                                       ((x) + 0x3c8)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_PHYS(x)                                                       ((x) + 0x3c8)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_OFFS                                                          (0x3c8)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_ADDR(x)                                                           ((x) + 0x3cc)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_PHYS(x)                                                           ((x) + 0x3cc)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_OFFS                                                              (0x3cc)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_ADDR(x)                                                     ((x) + 0x3ec)
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_PHYS(x)                                                     ((x) + 0x3ec)
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_OFFS                                                        (0x3ec)
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_RMSK                                                            0xffff
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_POR                                                         0x00000000
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_POR_RMSK                                                    0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_ATTR                                                                     0x3
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                         0xffff
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                              0

#define HWIO_REO_R0_SW2REO1_RING_MISC_1_ADDR(x)                                                              ((x) + 0x3f0)
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_PHYS(x)                                                              ((x) + 0x3f0)
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_OFFS                                                                 (0x3f0)
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_RMSK                                                                 0xffff003f
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_POR                                                                  0x00000000
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_ATTR                                                                              0x3
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_MISC_1_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                        0xffff0000
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                16
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                               0x3f
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                  0

#define HWIO_REO_R0_SW2REO2_RING_BASE_LSB_ADDR(x)                                                            ((x) + 0x3f4)
#define HWIO_REO_R0_SW2REO2_RING_BASE_LSB_PHYS(x)                                                            ((x) + 0x3f4)
#define HWIO_REO_R0_SW2REO2_RING_BASE_LSB_OFFS                                                               (0x3f4)
#define HWIO_REO_R0_SW2REO2_RING_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_BASE_LSB_POR                                                                0x00000000
#define HWIO_REO_R0_SW2REO2_RING_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_BASE_LSB_ATTR                                                                            0x3
#define HWIO_REO_R0_SW2REO2_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO2_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_SW2REO2_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO2_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO2_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO2_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO2_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO2_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO2_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_SW2REO2_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                            0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                     0

#define HWIO_REO_R0_SW2REO2_RING_BASE_MSB_ADDR(x)                                                            ((x) + 0x3f8)
#define HWIO_REO_R0_SW2REO2_RING_BASE_MSB_PHYS(x)                                                            ((x) + 0x3f8)
#define HWIO_REO_R0_SW2REO2_RING_BASE_MSB_OFFS                                                               (0x3f8)
#define HWIO_REO_R0_SW2REO2_RING_BASE_MSB_RMSK                                                                 0xffffff
#define HWIO_REO_R0_SW2REO2_RING_BASE_MSB_POR                                                                0x00000000
#define HWIO_REO_R0_SW2REO2_RING_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_BASE_MSB_ATTR                                                                            0x3
#define HWIO_REO_R0_SW2REO2_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO2_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_SW2REO2_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO2_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO2_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO2_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO2_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO2_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO2_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_SW2REO2_RING_BASE_MSB_RING_SIZE_BMSK                                                       0xffff00
#define HWIO_REO_R0_SW2REO2_RING_BASE_MSB_RING_SIZE_SHFT                                                              8
#define HWIO_REO_R0_SW2REO2_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                  0xff
#define HWIO_REO_R0_SW2REO2_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                     0

#define HWIO_REO_R0_SW2REO2_RING_ID_ADDR(x)                                                                  ((x) + 0x3fc)
#define HWIO_REO_R0_SW2REO2_RING_ID_PHYS(x)                                                                  ((x) + 0x3fc)
#define HWIO_REO_R0_SW2REO2_RING_ID_OFFS                                                                     (0x3fc)
#define HWIO_REO_R0_SW2REO2_RING_ID_RMSK                                                                           0xff
#define HWIO_REO_R0_SW2REO2_RING_ID_POR                                                                      0x00000000
#define HWIO_REO_R0_SW2REO2_RING_ID_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_ID_ATTR                                                                                  0x3
#define HWIO_REO_R0_SW2REO2_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO2_RING_ID_ADDR(x))
#define HWIO_REO_R0_SW2REO2_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO2_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_SW2REO2_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO2_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_SW2REO2_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO2_RING_ID_ADDR(x),m,v,HWIO_REO_R0_SW2REO2_RING_ID_IN(x))
#define HWIO_REO_R0_SW2REO2_RING_ID_ENTRY_SIZE_BMSK                                                                0xff
#define HWIO_REO_R0_SW2REO2_RING_ID_ENTRY_SIZE_SHFT                                                                   0

#define HWIO_REO_R0_SW2REO2_RING_STATUS_ADDR(x)                                                              ((x) + 0x400)
#define HWIO_REO_R0_SW2REO2_RING_STATUS_PHYS(x)                                                              ((x) + 0x400)
#define HWIO_REO_R0_SW2REO2_RING_STATUS_OFFS                                                                 (0x400)
#define HWIO_REO_R0_SW2REO2_RING_STATUS_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_STATUS_POR                                                                  0x00000000
#define HWIO_REO_R0_SW2REO2_RING_STATUS_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_STATUS_ATTR                                                                              0x1
#define HWIO_REO_R0_SW2REO2_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO2_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_SW2REO2_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO2_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_SW2REO2_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                 0xffff0000
#define HWIO_REO_R0_SW2REO2_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                         16
#define HWIO_REO_R0_SW2REO2_RING_STATUS_NUM_VALID_WORDS_BMSK                                                     0xffff
#define HWIO_REO_R0_SW2REO2_RING_STATUS_NUM_VALID_WORDS_SHFT                                                          0

#define HWIO_REO_R0_SW2REO2_RING_MISC_ADDR(x)                                                                ((x) + 0x404)
#define HWIO_REO_R0_SW2REO2_RING_MISC_PHYS(x)                                                                ((x) + 0x404)
#define HWIO_REO_R0_SW2REO2_RING_MISC_OFFS                                                                   (0x404)
#define HWIO_REO_R0_SW2REO2_RING_MISC_RMSK                                                                     0x3fffff
#define HWIO_REO_R0_SW2REO2_RING_MISC_POR                                                                    0x00000080
#define HWIO_REO_R0_SW2REO2_RING_MISC_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_MISC_ATTR                                                                                0x3
#define HWIO_REO_R0_SW2REO2_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO2_RING_MISC_ADDR(x))
#define HWIO_REO_R0_SW2REO2_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO2_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_SW2REO2_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO2_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_SW2REO2_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO2_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_SW2REO2_RING_MISC_IN(x))
#define HWIO_REO_R0_SW2REO2_RING_MISC_SPARE_CONTROL_BMSK                                                       0x3fc000
#define HWIO_REO_R0_SW2REO2_RING_MISC_SPARE_CONTROL_SHFT                                                             14
#define HWIO_REO_R0_SW2REO2_RING_MISC_SRNG_SM_STATE2_BMSK                                                        0x3000
#define HWIO_REO_R0_SW2REO2_RING_MISC_SRNG_SM_STATE2_SHFT                                                            12
#define HWIO_REO_R0_SW2REO2_RING_MISC_SRNG_SM_STATE1_BMSK                                                         0xf00
#define HWIO_REO_R0_SW2REO2_RING_MISC_SRNG_SM_STATE1_SHFT                                                             8
#define HWIO_REO_R0_SW2REO2_RING_MISC_SRNG_IS_IDLE_BMSK                                                            0x80
#define HWIO_REO_R0_SW2REO2_RING_MISC_SRNG_IS_IDLE_SHFT                                                               7
#define HWIO_REO_R0_SW2REO2_RING_MISC_SRNG_ENABLE_BMSK                                                             0x40
#define HWIO_REO_R0_SW2REO2_RING_MISC_SRNG_ENABLE_SHFT                                                                6
#define HWIO_REO_R0_SW2REO2_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                       0x20
#define HWIO_REO_R0_SW2REO2_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                          5
#define HWIO_REO_R0_SW2REO2_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                        0x10
#define HWIO_REO_R0_SW2REO2_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                           4
#define HWIO_REO_R0_SW2REO2_RING_MISC_MSI_SWAP_BIT_BMSK                                                             0x8
#define HWIO_REO_R0_SW2REO2_RING_MISC_MSI_SWAP_BIT_SHFT                                                               3
#define HWIO_REO_R0_SW2REO2_RING_MISC_SECURITY_BIT_BMSK                                                             0x4
#define HWIO_REO_R0_SW2REO2_RING_MISC_SECURITY_BIT_SHFT                                                               2
#define HWIO_REO_R0_SW2REO2_RING_MISC_LOOPCNT_DISABLE_BMSK                                                          0x2
#define HWIO_REO_R0_SW2REO2_RING_MISC_LOOPCNT_DISABLE_SHFT                                                            1
#define HWIO_REO_R0_SW2REO2_RING_MISC_RING_ID_DISABLE_BMSK                                                          0x1
#define HWIO_REO_R0_SW2REO2_RING_MISC_RING_ID_DISABLE_SHFT                                                            0

#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_LSB_ADDR(x)                                                         ((x) + 0x410)
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_LSB_PHYS(x)                                                         ((x) + 0x410)
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_LSB_OFFS                                                            (0x410)
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_LSB_RMSK                                                            0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_LSB_POR                                                             0x00000000
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_LSB_ATTR                                                                         0x3
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO2_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO2_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO2_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO2_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO2_RING_TP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                       0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                                0

#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_MSB_ADDR(x)                                                         ((x) + 0x414)
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_MSB_PHYS(x)                                                         ((x) + 0x414)
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_MSB_OFFS                                                            (0x414)
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_MSB_RMSK                                                                  0xff
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_MSB_POR                                                             0x00000000
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_MSB_ATTR                                                                         0x3
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO2_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO2_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO2_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO2_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO2_RING_TP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                             0xff
#define HWIO_REO_R0_SW2REO2_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                                0

#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                              ((x) + 0x424)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                              ((x) + 0x424)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                 (0x424)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                 0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX0_POR                                                  0x00000000
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                             0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                              0x3
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                       0xffff0000
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                               16
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                   0x8000
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                       15
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                             0x7fff
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                  0

#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                              ((x) + 0x428)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                              ((x) + 0x428)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                 (0x428)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                     0xffff
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX1_POR                                                  0x00000000
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                             0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                              0x3
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                       0xffff
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                            0

#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_STATUS_ADDR(x)                                                 ((x) + 0x42c)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_STATUS_PHYS(x)                                                 ((x) + 0x42c)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_STATUS_OFFS                                                    (0x42c)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_STATUS_RMSK                                                    0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_STATUS_POR                                                     0x00000000
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_STATUS_ATTR                                                                 0x1
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                      0xffff0000
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                              16
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                 0x8000
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                     15
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                           0x7fff
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                0

#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                              ((x) + 0x430)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                              ((x) + 0x430)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                 (0x430)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                      0x3ff
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_EMPTY_COUNTER_POR                                                  0x00000000
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                             0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                              0x3
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_REO_R0_SW2REO2_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                   0x3ff
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                       0

#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                             ((x) + 0x434)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                             ((x) + 0x434)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_TIMER_OFFS                                                (0x434)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                       0x7
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_TIMER_POR                                                 0x00000003
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                            0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                             0x3
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                  0x7
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                    0

#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                            ((x) + 0x438)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                            ((x) + 0x438)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_STATUS_OFFS                                               (0x438)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                 0xffffff
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_STATUS_POR                                                0x00000000
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                            0x1
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                  0xff0000
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                        16
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                 0xffff
#define HWIO_REO_R0_SW2REO2_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                      0

#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_LSB_ADDR(x)                                                       ((x) + 0x43c)
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_LSB_PHYS(x)                                                       ((x) + 0x43c)
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_LSB_OFFS                                                          (0x43c)
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_MSB_ADDR(x)                                                       ((x) + 0x440)
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_MSB_PHYS(x)                                                       ((x) + 0x440)
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_MSB_OFFS                                                          (0x440)
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_SW2REO2_RING_MSI1_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_SW2REO2_RING_MSI1_DATA_ADDR(x)                                                           ((x) + 0x444)
#define HWIO_REO_R0_SW2REO2_RING_MSI1_DATA_PHYS(x)                                                           ((x) + 0x444)
#define HWIO_REO_R0_SW2REO2_RING_MSI1_DATA_OFFS                                                              (0x444)
#define HWIO_REO_R0_SW2REO2_RING_MSI1_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_MSI1_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_SW2REO2_RING_MSI1_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_MSI1_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_SW2REO2_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO2_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_SW2REO2_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO2_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_SW2REO2_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO2_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_SW2REO2_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO2_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_SW2REO2_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_SW2REO2_RING_MSI1_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_MSI1_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_SW2REO2_RING_HP_TP_SW_OFFSET_ADDR(x)                                                     ((x) + 0x464)
#define HWIO_REO_R0_SW2REO2_RING_HP_TP_SW_OFFSET_PHYS(x)                                                     ((x) + 0x464)
#define HWIO_REO_R0_SW2REO2_RING_HP_TP_SW_OFFSET_OFFS                                                        (0x464)
#define HWIO_REO_R0_SW2REO2_RING_HP_TP_SW_OFFSET_RMSK                                                            0xffff
#define HWIO_REO_R0_SW2REO2_RING_HP_TP_SW_OFFSET_POR                                                         0x00000000
#define HWIO_REO_R0_SW2REO2_RING_HP_TP_SW_OFFSET_POR_RMSK                                                    0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_HP_TP_SW_OFFSET_ATTR                                                                     0x3
#define HWIO_REO_R0_SW2REO2_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO2_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_SW2REO2_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO2_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_SW2REO2_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO2_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_SW2REO2_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO2_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_SW2REO2_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_SW2REO2_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                         0xffff
#define HWIO_REO_R0_SW2REO2_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                              0

#define HWIO_REO_R0_SW2REO2_RING_MISC_1_ADDR(x)                                                              ((x) + 0x468)
#define HWIO_REO_R0_SW2REO2_RING_MISC_1_PHYS(x)                                                              ((x) + 0x468)
#define HWIO_REO_R0_SW2REO2_RING_MISC_1_OFFS                                                                 (0x468)
#define HWIO_REO_R0_SW2REO2_RING_MISC_1_RMSK                                                                 0xffff003f
#define HWIO_REO_R0_SW2REO2_RING_MISC_1_POR                                                                  0x00000000
#define HWIO_REO_R0_SW2REO2_RING_MISC_1_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_SW2REO2_RING_MISC_1_ATTR                                                                              0x3
#define HWIO_REO_R0_SW2REO2_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO2_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_SW2REO2_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO2_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_SW2REO2_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO2_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_SW2REO2_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO2_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_SW2REO2_RING_MISC_1_IN(x))
#define HWIO_REO_R0_SW2REO2_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                        0xffff0000
#define HWIO_REO_R0_SW2REO2_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                16
#define HWIO_REO_R0_SW2REO2_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                               0x3f
#define HWIO_REO_R0_SW2REO2_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                  0

#define HWIO_REO_R0_SW2REO3_RING_BASE_LSB_ADDR(x)                                                            ((x) + 0x46c)
#define HWIO_REO_R0_SW2REO3_RING_BASE_LSB_PHYS(x)                                                            ((x) + 0x46c)
#define HWIO_REO_R0_SW2REO3_RING_BASE_LSB_OFFS                                                               (0x46c)
#define HWIO_REO_R0_SW2REO3_RING_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_BASE_LSB_POR                                                                0x00000000
#define HWIO_REO_R0_SW2REO3_RING_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_BASE_LSB_ATTR                                                                            0x3
#define HWIO_REO_R0_SW2REO3_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO3_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_SW2REO3_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO3_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO3_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO3_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO3_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO3_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO3_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_SW2REO3_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                            0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                     0

#define HWIO_REO_R0_SW2REO3_RING_BASE_MSB_ADDR(x)                                                            ((x) + 0x470)
#define HWIO_REO_R0_SW2REO3_RING_BASE_MSB_PHYS(x)                                                            ((x) + 0x470)
#define HWIO_REO_R0_SW2REO3_RING_BASE_MSB_OFFS                                                               (0x470)
#define HWIO_REO_R0_SW2REO3_RING_BASE_MSB_RMSK                                                                 0xffffff
#define HWIO_REO_R0_SW2REO3_RING_BASE_MSB_POR                                                                0x00000000
#define HWIO_REO_R0_SW2REO3_RING_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_BASE_MSB_ATTR                                                                            0x3
#define HWIO_REO_R0_SW2REO3_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO3_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_SW2REO3_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO3_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO3_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO3_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO3_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO3_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO3_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_SW2REO3_RING_BASE_MSB_RING_SIZE_BMSK                                                       0xffff00
#define HWIO_REO_R0_SW2REO3_RING_BASE_MSB_RING_SIZE_SHFT                                                              8
#define HWIO_REO_R0_SW2REO3_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                  0xff
#define HWIO_REO_R0_SW2REO3_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                     0

#define HWIO_REO_R0_SW2REO3_RING_ID_ADDR(x)                                                                  ((x) + 0x474)
#define HWIO_REO_R0_SW2REO3_RING_ID_PHYS(x)                                                                  ((x) + 0x474)
#define HWIO_REO_R0_SW2REO3_RING_ID_OFFS                                                                     (0x474)
#define HWIO_REO_R0_SW2REO3_RING_ID_RMSK                                                                           0xff
#define HWIO_REO_R0_SW2REO3_RING_ID_POR                                                                      0x00000000
#define HWIO_REO_R0_SW2REO3_RING_ID_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_ID_ATTR                                                                                  0x3
#define HWIO_REO_R0_SW2REO3_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO3_RING_ID_ADDR(x))
#define HWIO_REO_R0_SW2REO3_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO3_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_SW2REO3_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO3_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_SW2REO3_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO3_RING_ID_ADDR(x),m,v,HWIO_REO_R0_SW2REO3_RING_ID_IN(x))
#define HWIO_REO_R0_SW2REO3_RING_ID_ENTRY_SIZE_BMSK                                                                0xff
#define HWIO_REO_R0_SW2REO3_RING_ID_ENTRY_SIZE_SHFT                                                                   0

#define HWIO_REO_R0_SW2REO3_RING_STATUS_ADDR(x)                                                              ((x) + 0x478)
#define HWIO_REO_R0_SW2REO3_RING_STATUS_PHYS(x)                                                              ((x) + 0x478)
#define HWIO_REO_R0_SW2REO3_RING_STATUS_OFFS                                                                 (0x478)
#define HWIO_REO_R0_SW2REO3_RING_STATUS_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_STATUS_POR                                                                  0x00000000
#define HWIO_REO_R0_SW2REO3_RING_STATUS_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_STATUS_ATTR                                                                              0x1
#define HWIO_REO_R0_SW2REO3_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO3_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_SW2REO3_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO3_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_SW2REO3_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                 0xffff0000
#define HWIO_REO_R0_SW2REO3_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                         16
#define HWIO_REO_R0_SW2REO3_RING_STATUS_NUM_VALID_WORDS_BMSK                                                     0xffff
#define HWIO_REO_R0_SW2REO3_RING_STATUS_NUM_VALID_WORDS_SHFT                                                          0

#define HWIO_REO_R0_SW2REO3_RING_MISC_ADDR(x)                                                                ((x) + 0x47c)
#define HWIO_REO_R0_SW2REO3_RING_MISC_PHYS(x)                                                                ((x) + 0x47c)
#define HWIO_REO_R0_SW2REO3_RING_MISC_OFFS                                                                   (0x47c)
#define HWIO_REO_R0_SW2REO3_RING_MISC_RMSK                                                                     0x3fffff
#define HWIO_REO_R0_SW2REO3_RING_MISC_POR                                                                    0x00000080
#define HWIO_REO_R0_SW2REO3_RING_MISC_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_MISC_ATTR                                                                                0x3
#define HWIO_REO_R0_SW2REO3_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO3_RING_MISC_ADDR(x))
#define HWIO_REO_R0_SW2REO3_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO3_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_SW2REO3_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO3_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_SW2REO3_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO3_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_SW2REO3_RING_MISC_IN(x))
#define HWIO_REO_R0_SW2REO3_RING_MISC_SPARE_CONTROL_BMSK                                                       0x3fc000
#define HWIO_REO_R0_SW2REO3_RING_MISC_SPARE_CONTROL_SHFT                                                             14
#define HWIO_REO_R0_SW2REO3_RING_MISC_SRNG_SM_STATE2_BMSK                                                        0x3000
#define HWIO_REO_R0_SW2REO3_RING_MISC_SRNG_SM_STATE2_SHFT                                                            12
#define HWIO_REO_R0_SW2REO3_RING_MISC_SRNG_SM_STATE1_BMSK                                                         0xf00
#define HWIO_REO_R0_SW2REO3_RING_MISC_SRNG_SM_STATE1_SHFT                                                             8
#define HWIO_REO_R0_SW2REO3_RING_MISC_SRNG_IS_IDLE_BMSK                                                            0x80
#define HWIO_REO_R0_SW2REO3_RING_MISC_SRNG_IS_IDLE_SHFT                                                               7
#define HWIO_REO_R0_SW2REO3_RING_MISC_SRNG_ENABLE_BMSK                                                             0x40
#define HWIO_REO_R0_SW2REO3_RING_MISC_SRNG_ENABLE_SHFT                                                                6
#define HWIO_REO_R0_SW2REO3_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                       0x20
#define HWIO_REO_R0_SW2REO3_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                          5
#define HWIO_REO_R0_SW2REO3_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                        0x10
#define HWIO_REO_R0_SW2REO3_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                           4
#define HWIO_REO_R0_SW2REO3_RING_MISC_MSI_SWAP_BIT_BMSK                                                             0x8
#define HWIO_REO_R0_SW2REO3_RING_MISC_MSI_SWAP_BIT_SHFT                                                               3
#define HWIO_REO_R0_SW2REO3_RING_MISC_SECURITY_BIT_BMSK                                                             0x4
#define HWIO_REO_R0_SW2REO3_RING_MISC_SECURITY_BIT_SHFT                                                               2
#define HWIO_REO_R0_SW2REO3_RING_MISC_LOOPCNT_DISABLE_BMSK                                                          0x2
#define HWIO_REO_R0_SW2REO3_RING_MISC_LOOPCNT_DISABLE_SHFT                                                            1
#define HWIO_REO_R0_SW2REO3_RING_MISC_RING_ID_DISABLE_BMSK                                                          0x1
#define HWIO_REO_R0_SW2REO3_RING_MISC_RING_ID_DISABLE_SHFT                                                            0

#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_LSB_ADDR(x)                                                         ((x) + 0x488)
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_LSB_PHYS(x)                                                         ((x) + 0x488)
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_LSB_OFFS                                                            (0x488)
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_LSB_RMSK                                                            0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_LSB_POR                                                             0x00000000
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_LSB_ATTR                                                                         0x3
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO3_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO3_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO3_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO3_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO3_RING_TP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                       0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                                0

#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_MSB_ADDR(x)                                                         ((x) + 0x48c)
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_MSB_PHYS(x)                                                         ((x) + 0x48c)
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_MSB_OFFS                                                            (0x48c)
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_MSB_RMSK                                                                  0xff
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_MSB_POR                                                             0x00000000
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_MSB_ATTR                                                                         0x3
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO3_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO3_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO3_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO3_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO3_RING_TP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                             0xff
#define HWIO_REO_R0_SW2REO3_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                                0

#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                              ((x) + 0x49c)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                              ((x) + 0x49c)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                 (0x49c)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                 0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX0_POR                                                  0x00000000
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                             0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                              0x3
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                       0xffff0000
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                               16
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                   0x8000
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                       15
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                             0x7fff
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                  0

#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                              ((x) + 0x4a0)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                              ((x) + 0x4a0)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                 (0x4a0)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                     0xffff
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX1_POR                                                  0x00000000
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                             0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                              0x3
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                       0xffff
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                            0

#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_STATUS_ADDR(x)                                                 ((x) + 0x4a4)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_STATUS_PHYS(x)                                                 ((x) + 0x4a4)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_STATUS_OFFS                                                    (0x4a4)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_STATUS_RMSK                                                    0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_STATUS_POR                                                     0x00000000
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_STATUS_ATTR                                                                 0x1
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                      0xffff0000
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                              16
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                 0x8000
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                     15
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                           0x7fff
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                0

#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                              ((x) + 0x4a8)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                              ((x) + 0x4a8)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                 (0x4a8)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                      0x3ff
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_EMPTY_COUNTER_POR                                                  0x00000000
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                             0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                              0x3
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO3_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO3_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO3_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO3_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_REO_R0_SW2REO3_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                   0x3ff
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                       0

#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                             ((x) + 0x4ac)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                             ((x) + 0x4ac)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_TIMER_OFFS                                                (0x4ac)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                       0x7
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_TIMER_POR                                                 0x00000003
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                            0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                             0x3
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                  0x7
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                    0

#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                            ((x) + 0x4b0)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                            ((x) + 0x4b0)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_STATUS_OFFS                                               (0x4b0)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                 0xffffff
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_STATUS_POR                                                0x00000000
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                            0x1
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                  0xff0000
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                        16
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                 0xffff
#define HWIO_REO_R0_SW2REO3_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                      0

#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_LSB_ADDR(x)                                                       ((x) + 0x4b4)
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_LSB_PHYS(x)                                                       ((x) + 0x4b4)
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_LSB_OFFS                                                          (0x4b4)
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_MSB_ADDR(x)                                                       ((x) + 0x4b8)
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_MSB_PHYS(x)                                                       ((x) + 0x4b8)
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_MSB_OFFS                                                          (0x4b8)
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_SW2REO3_RING_MSI1_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_SW2REO3_RING_MSI1_DATA_ADDR(x)                                                           ((x) + 0x4bc)
#define HWIO_REO_R0_SW2REO3_RING_MSI1_DATA_PHYS(x)                                                           ((x) + 0x4bc)
#define HWIO_REO_R0_SW2REO3_RING_MSI1_DATA_OFFS                                                              (0x4bc)
#define HWIO_REO_R0_SW2REO3_RING_MSI1_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_MSI1_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_SW2REO3_RING_MSI1_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_MSI1_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_SW2REO3_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO3_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_SW2REO3_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO3_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_SW2REO3_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO3_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_SW2REO3_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO3_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_SW2REO3_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_SW2REO3_RING_MSI1_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_MSI1_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_SW2REO3_RING_HP_TP_SW_OFFSET_ADDR(x)                                                     ((x) + 0x4dc)
#define HWIO_REO_R0_SW2REO3_RING_HP_TP_SW_OFFSET_PHYS(x)                                                     ((x) + 0x4dc)
#define HWIO_REO_R0_SW2REO3_RING_HP_TP_SW_OFFSET_OFFS                                                        (0x4dc)
#define HWIO_REO_R0_SW2REO3_RING_HP_TP_SW_OFFSET_RMSK                                                            0xffff
#define HWIO_REO_R0_SW2REO3_RING_HP_TP_SW_OFFSET_POR                                                         0x00000000
#define HWIO_REO_R0_SW2REO3_RING_HP_TP_SW_OFFSET_POR_RMSK                                                    0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_HP_TP_SW_OFFSET_ATTR                                                                     0x3
#define HWIO_REO_R0_SW2REO3_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO3_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_SW2REO3_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO3_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_SW2REO3_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO3_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_SW2REO3_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO3_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_SW2REO3_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_SW2REO3_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                         0xffff
#define HWIO_REO_R0_SW2REO3_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                              0

#define HWIO_REO_R0_SW2REO3_RING_MISC_1_ADDR(x)                                                              ((x) + 0x4e0)
#define HWIO_REO_R0_SW2REO3_RING_MISC_1_PHYS(x)                                                              ((x) + 0x4e0)
#define HWIO_REO_R0_SW2REO3_RING_MISC_1_OFFS                                                                 (0x4e0)
#define HWIO_REO_R0_SW2REO3_RING_MISC_1_RMSK                                                                 0xffff003f
#define HWIO_REO_R0_SW2REO3_RING_MISC_1_POR                                                                  0x00000000
#define HWIO_REO_R0_SW2REO3_RING_MISC_1_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_SW2REO3_RING_MISC_1_ATTR                                                                              0x3
#define HWIO_REO_R0_SW2REO3_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO3_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_SW2REO3_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO3_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_SW2REO3_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO3_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_SW2REO3_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO3_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_SW2REO3_RING_MISC_1_IN(x))
#define HWIO_REO_R0_SW2REO3_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                        0xffff0000
#define HWIO_REO_R0_SW2REO3_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                16
#define HWIO_REO_R0_SW2REO3_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                               0x3f
#define HWIO_REO_R0_SW2REO3_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                  0

#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_ADDR(x)                                                            ((x) + 0x4e4)
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_PHYS(x)                                                            ((x) + 0x4e4)
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_OFFS                                                               (0x4e4)
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                            0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                     0

#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_ADDR(x)                                                            ((x) + 0x4e8)
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_PHYS(x)                                                            ((x) + 0x4e8)
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_OFFS                                                               (0x4e8)
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_RMSK                                                                0xfffffff
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xfffff00
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_RING_SIZE_SHFT                                                              8
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                  0xff
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                     0

#define HWIO_REO_R0_REO2SW1_RING_ID_ADDR(x)                                                                  ((x) + 0x4ec)
#define HWIO_REO_R0_REO2SW1_RING_ID_PHYS(x)                                                                  ((x) + 0x4ec)
#define HWIO_REO_R0_REO2SW1_RING_ID_OFFS                                                                     (0x4ec)
#define HWIO_REO_R0_REO2SW1_RING_ID_RMSK                                                                         0xffff
#define HWIO_REO_R0_REO2SW1_RING_ID_POR                                                                      0x00000000
#define HWIO_REO_R0_REO2SW1_RING_ID_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_ID_ATTR                                                                                  0x3
#define HWIO_REO_R0_REO2SW1_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_ID_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_ID_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_ID_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_ID_RING_ID_BMSK                                                                 0xff00
#define HWIO_REO_R0_REO2SW1_RING_ID_RING_ID_SHFT                                                                      8
#define HWIO_REO_R0_REO2SW1_RING_ID_ENTRY_SIZE_BMSK                                                                0xff
#define HWIO_REO_R0_REO2SW1_RING_ID_ENTRY_SIZE_SHFT                                                                   0

#define HWIO_REO_R0_REO2SW1_RING_STATUS_ADDR(x)                                                              ((x) + 0x4f0)
#define HWIO_REO_R0_REO2SW1_RING_STATUS_PHYS(x)                                                              ((x) + 0x4f0)
#define HWIO_REO_R0_REO2SW1_RING_STATUS_OFFS                                                                 (0x4f0)
#define HWIO_REO_R0_REO2SW1_RING_STATUS_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_STATUS_POR                                                                  0x00000000
#define HWIO_REO_R0_REO2SW1_RING_STATUS_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_STATUS_ATTR                                                                              0x1
#define HWIO_REO_R0_REO2SW1_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                 0xffff0000
#define HWIO_REO_R0_REO2SW1_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                         16
#define HWIO_REO_R0_REO2SW1_RING_STATUS_NUM_VALID_WORDS_BMSK                                                     0xffff
#define HWIO_REO_R0_REO2SW1_RING_STATUS_NUM_VALID_WORDS_SHFT                                                          0

#define HWIO_REO_R0_REO2SW1_RING_MISC_ADDR(x)                                                                ((x) + 0x4f4)
#define HWIO_REO_R0_REO2SW1_RING_MISC_PHYS(x)                                                                ((x) + 0x4f4)
#define HWIO_REO_R0_REO2SW1_RING_MISC_OFFS                                                                   (0x4f4)
#define HWIO_REO_R0_REO2SW1_RING_MISC_RMSK                                                                    0x7ffffff
#define HWIO_REO_R0_REO2SW1_RING_MISC_POR                                                                    0x00000080
#define HWIO_REO_R0_REO2SW1_RING_MISC_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MISC_ATTR                                                                                0x3
#define HWIO_REO_R0_REO2SW1_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_MISC_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_MISC_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                            0x4000000
#define HWIO_REO_R0_REO2SW1_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                   26
#define HWIO_REO_R0_REO2SW1_RING_MISC_LOOP_CNT_BMSK                                                           0x3c00000
#define HWIO_REO_R0_REO2SW1_RING_MISC_LOOP_CNT_SHFT                                                                  22
#define HWIO_REO_R0_REO2SW1_RING_MISC_SPARE_CONTROL_BMSK                                                       0x3fc000
#define HWIO_REO_R0_REO2SW1_RING_MISC_SPARE_CONTROL_SHFT                                                             14
#define HWIO_REO_R0_REO2SW1_RING_MISC_SRNG_SM_STATE2_BMSK                                                        0x3000
#define HWIO_REO_R0_REO2SW1_RING_MISC_SRNG_SM_STATE2_SHFT                                                            12
#define HWIO_REO_R0_REO2SW1_RING_MISC_SRNG_SM_STATE1_BMSK                                                         0xf00
#define HWIO_REO_R0_REO2SW1_RING_MISC_SRNG_SM_STATE1_SHFT                                                             8
#define HWIO_REO_R0_REO2SW1_RING_MISC_SRNG_IS_IDLE_BMSK                                                            0x80
#define HWIO_REO_R0_REO2SW1_RING_MISC_SRNG_IS_IDLE_SHFT                                                               7
#define HWIO_REO_R0_REO2SW1_RING_MISC_SRNG_ENABLE_BMSK                                                             0x40
#define HWIO_REO_R0_REO2SW1_RING_MISC_SRNG_ENABLE_SHFT                                                                6
#define HWIO_REO_R0_REO2SW1_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                       0x20
#define HWIO_REO_R0_REO2SW1_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                          5
#define HWIO_REO_R0_REO2SW1_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                        0x10
#define HWIO_REO_R0_REO2SW1_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                           4
#define HWIO_REO_R0_REO2SW1_RING_MISC_MSI_SWAP_BIT_BMSK                                                             0x8
#define HWIO_REO_R0_REO2SW1_RING_MISC_MSI_SWAP_BIT_SHFT                                                               3
#define HWIO_REO_R0_REO2SW1_RING_MISC_SECURITY_BIT_BMSK                                                             0x4
#define HWIO_REO_R0_REO2SW1_RING_MISC_SECURITY_BIT_SHFT                                                               2
#define HWIO_REO_R0_REO2SW1_RING_MISC_LOOPCNT_DISABLE_BMSK                                                          0x2
#define HWIO_REO_R0_REO2SW1_RING_MISC_LOOPCNT_DISABLE_SHFT                                                            1
#define HWIO_REO_R0_REO2SW1_RING_MISC_RING_ID_DISABLE_BMSK                                                          0x1
#define HWIO_REO_R0_REO2SW1_RING_MISC_RING_ID_DISABLE_SHFT                                                            0

#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_ADDR(x)                                                         ((x) + 0x4f8)
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_PHYS(x)                                                         ((x) + 0x4f8)
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_OFFS                                                            (0x4f8)
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_RMSK                                                            0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                       0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                0

#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_ADDR(x)                                                         ((x) + 0x4fc)
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_PHYS(x)                                                         ((x) + 0x4fc)
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_OFFS                                                            (0x4fc)
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_RMSK                                                                  0xff
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                             0xff
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                0

#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_ADDR(x)                                                  ((x) + 0x508)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_PHYS(x)                                                  ((x) + 0x508)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_OFFS                                                     (0x508)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_RMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_POR                                                      0x00000000
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_POR_RMSK                                                 0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_ATTR                                                                  0x3
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                           0xffff0000
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                   16
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                       0x8000
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                           15
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                 0x7fff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                      0

#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_ADDR(x)                                                 ((x) + 0x50c)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_PHYS(x)                                                 ((x) + 0x50c)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_OFFS                                                    (0x50c)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_RMSK                                                    0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_POR                                                     0x00000000
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_ATTR                                                                 0x1
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                      0xffff0000
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                              16
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                              0x8000
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                  15
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                           0x7fff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                0

#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                               ((x) + 0x510)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                               ((x) + 0x510)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_OFFS                                                  (0x510)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_RMSK                                                       0x3ff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_POR                                                   0x00000000
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                              0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_ATTR                                                               0x3
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                     0x3ff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                         0

#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_ADDR(x)                                                       ((x) + 0x52c)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_PHYS(x)                                                       ((x) + 0x52c)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_OFFS                                                          (0x52c)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_ADDR(x)                                                       ((x) + 0x530)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_PHYS(x)                                                       ((x) + 0x530)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_OFFS                                                          (0x530)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_ADDR(x)                                                           ((x) + 0x534)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_PHYS(x)                                                           ((x) + 0x534)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_OFFS                                                              (0x534)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                 ((x) + 0x538)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                 ((x) + 0x538)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_OFFS                                                    (0x538)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_RMSK                                                    0xffcfffff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_POR                                                     0x00000000
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_ATTR                                                                 0x3
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                         0xff000000
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                 24
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                          0x800000
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                23
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                        0x400000
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                              22
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                        0xfffff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                              0

#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_ADDR(x)                                                       ((x) + 0x53c)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_PHYS(x)                                                       ((x) + 0x53c)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_OFFS                                                          (0x53c)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_ADDR(x)                                                       ((x) + 0x540)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_PHYS(x)                                                       ((x) + 0x540)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_OFFS                                                          (0x540)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_ADDR(x)                                                           ((x) + 0x544)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_PHYS(x)                                                           ((x) + 0x544)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_OFFS                                                              (0x544)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_ADDR(x)                                                     ((x) + 0x554)
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_PHYS(x)                                                     ((x) + 0x554)
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_OFFS                                                        (0x554)
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_RMSK                                                            0xffff
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_POR                                                         0x00000000
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_POR_RMSK                                                    0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_ATTR                                                                     0x3
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                         0xffff
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                              0

#define HWIO_REO_R0_REO2SW1_RING_MISC_1_ADDR(x)                                                              ((x) + 0x558)
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_PHYS(x)                                                              ((x) + 0x558)
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_OFFS                                                                 (0x558)
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_RMSK                                                                 0xffff003f
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_POR                                                                  0x00000000
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_ATTR                                                                              0x3
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_MISC_1_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                        0xffff0000
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                16
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                               0x3f
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                  0

#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_ADDR(x)                                                            ((x) + 0x55c)
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_PHYS(x)                                                            ((x) + 0x55c)
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_OFFS                                                               (0x55c)
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                            0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                     0

#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_ADDR(x)                                                            ((x) + 0x560)
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_PHYS(x)                                                            ((x) + 0x560)
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_OFFS                                                               (0x560)
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_RMSK                                                                0xfffffff
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xfffff00
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_RING_SIZE_SHFT                                                              8
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                  0xff
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                     0

#define HWIO_REO_R0_REO2SW2_RING_ID_ADDR(x)                                                                  ((x) + 0x564)
#define HWIO_REO_R0_REO2SW2_RING_ID_PHYS(x)                                                                  ((x) + 0x564)
#define HWIO_REO_R0_REO2SW2_RING_ID_OFFS                                                                     (0x564)
#define HWIO_REO_R0_REO2SW2_RING_ID_RMSK                                                                         0xffff
#define HWIO_REO_R0_REO2SW2_RING_ID_POR                                                                      0x00000000
#define HWIO_REO_R0_REO2SW2_RING_ID_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_ID_ATTR                                                                                  0x3
#define HWIO_REO_R0_REO2SW2_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_ID_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_ID_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_ID_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_ID_RING_ID_BMSK                                                                 0xff00
#define HWIO_REO_R0_REO2SW2_RING_ID_RING_ID_SHFT                                                                      8
#define HWIO_REO_R0_REO2SW2_RING_ID_ENTRY_SIZE_BMSK                                                                0xff
#define HWIO_REO_R0_REO2SW2_RING_ID_ENTRY_SIZE_SHFT                                                                   0

#define HWIO_REO_R0_REO2SW2_RING_STATUS_ADDR(x)                                                              ((x) + 0x568)
#define HWIO_REO_R0_REO2SW2_RING_STATUS_PHYS(x)                                                              ((x) + 0x568)
#define HWIO_REO_R0_REO2SW2_RING_STATUS_OFFS                                                                 (0x568)
#define HWIO_REO_R0_REO2SW2_RING_STATUS_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_STATUS_POR                                                                  0x00000000
#define HWIO_REO_R0_REO2SW2_RING_STATUS_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_STATUS_ATTR                                                                              0x1
#define HWIO_REO_R0_REO2SW2_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                 0xffff0000
#define HWIO_REO_R0_REO2SW2_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                         16
#define HWIO_REO_R0_REO2SW2_RING_STATUS_NUM_VALID_WORDS_BMSK                                                     0xffff
#define HWIO_REO_R0_REO2SW2_RING_STATUS_NUM_VALID_WORDS_SHFT                                                          0

#define HWIO_REO_R0_REO2SW2_RING_MISC_ADDR(x)                                                                ((x) + 0x56c)
#define HWIO_REO_R0_REO2SW2_RING_MISC_PHYS(x)                                                                ((x) + 0x56c)
#define HWIO_REO_R0_REO2SW2_RING_MISC_OFFS                                                                   (0x56c)
#define HWIO_REO_R0_REO2SW2_RING_MISC_RMSK                                                                    0x7ffffff
#define HWIO_REO_R0_REO2SW2_RING_MISC_POR                                                                    0x00000080
#define HWIO_REO_R0_REO2SW2_RING_MISC_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MISC_ATTR                                                                                0x3
#define HWIO_REO_R0_REO2SW2_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_MISC_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_MISC_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                            0x4000000
#define HWIO_REO_R0_REO2SW2_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                   26
#define HWIO_REO_R0_REO2SW2_RING_MISC_LOOP_CNT_BMSK                                                           0x3c00000
#define HWIO_REO_R0_REO2SW2_RING_MISC_LOOP_CNT_SHFT                                                                  22
#define HWIO_REO_R0_REO2SW2_RING_MISC_SPARE_CONTROL_BMSK                                                       0x3fc000
#define HWIO_REO_R0_REO2SW2_RING_MISC_SPARE_CONTROL_SHFT                                                             14
#define HWIO_REO_R0_REO2SW2_RING_MISC_SRNG_SM_STATE2_BMSK                                                        0x3000
#define HWIO_REO_R0_REO2SW2_RING_MISC_SRNG_SM_STATE2_SHFT                                                            12
#define HWIO_REO_R0_REO2SW2_RING_MISC_SRNG_SM_STATE1_BMSK                                                         0xf00
#define HWIO_REO_R0_REO2SW2_RING_MISC_SRNG_SM_STATE1_SHFT                                                             8
#define HWIO_REO_R0_REO2SW2_RING_MISC_SRNG_IS_IDLE_BMSK                                                            0x80
#define HWIO_REO_R0_REO2SW2_RING_MISC_SRNG_IS_IDLE_SHFT                                                               7
#define HWIO_REO_R0_REO2SW2_RING_MISC_SRNG_ENABLE_BMSK                                                             0x40
#define HWIO_REO_R0_REO2SW2_RING_MISC_SRNG_ENABLE_SHFT                                                                6
#define HWIO_REO_R0_REO2SW2_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                       0x20
#define HWIO_REO_R0_REO2SW2_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                          5
#define HWIO_REO_R0_REO2SW2_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                        0x10
#define HWIO_REO_R0_REO2SW2_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                           4
#define HWIO_REO_R0_REO2SW2_RING_MISC_MSI_SWAP_BIT_BMSK                                                             0x8
#define HWIO_REO_R0_REO2SW2_RING_MISC_MSI_SWAP_BIT_SHFT                                                               3
#define HWIO_REO_R0_REO2SW2_RING_MISC_SECURITY_BIT_BMSK                                                             0x4
#define HWIO_REO_R0_REO2SW2_RING_MISC_SECURITY_BIT_SHFT                                                               2
#define HWIO_REO_R0_REO2SW2_RING_MISC_LOOPCNT_DISABLE_BMSK                                                          0x2
#define HWIO_REO_R0_REO2SW2_RING_MISC_LOOPCNT_DISABLE_SHFT                                                            1
#define HWIO_REO_R0_REO2SW2_RING_MISC_RING_ID_DISABLE_BMSK                                                          0x1
#define HWIO_REO_R0_REO2SW2_RING_MISC_RING_ID_DISABLE_SHFT                                                            0

#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_ADDR(x)                                                         ((x) + 0x570)
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_PHYS(x)                                                         ((x) + 0x570)
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_OFFS                                                            (0x570)
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_RMSK                                                            0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                       0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                0

#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_ADDR(x)                                                         ((x) + 0x574)
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_PHYS(x)                                                         ((x) + 0x574)
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_OFFS                                                            (0x574)
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_RMSK                                                                  0xff
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                             0xff
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                0

#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_ADDR(x)                                                  ((x) + 0x580)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_PHYS(x)                                                  ((x) + 0x580)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_OFFS                                                     (0x580)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_RMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_POR                                                      0x00000000
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_POR_RMSK                                                 0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_ATTR                                                                  0x3
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                           0xffff0000
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                   16
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                       0x8000
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                           15
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                 0x7fff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                      0

#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_ADDR(x)                                                 ((x) + 0x584)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_PHYS(x)                                                 ((x) + 0x584)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_OFFS                                                    (0x584)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_RMSK                                                    0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_POR                                                     0x00000000
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_ATTR                                                                 0x1
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                      0xffff0000
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                              16
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                              0x8000
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                  15
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                           0x7fff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                0

#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                               ((x) + 0x588)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                               ((x) + 0x588)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_OFFS                                                  (0x588)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_RMSK                                                       0x3ff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_POR                                                   0x00000000
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                              0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_ATTR                                                               0x3
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                     0x3ff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                         0

#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_ADDR(x)                                                       ((x) + 0x5a4)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_PHYS(x)                                                       ((x) + 0x5a4)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_OFFS                                                          (0x5a4)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_ADDR(x)                                                       ((x) + 0x5a8)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_PHYS(x)                                                       ((x) + 0x5a8)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_OFFS                                                          (0x5a8)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_ADDR(x)                                                           ((x) + 0x5ac)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_PHYS(x)                                                           ((x) + 0x5ac)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_OFFS                                                              (0x5ac)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                 ((x) + 0x5b0)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                 ((x) + 0x5b0)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_OFFS                                                    (0x5b0)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_RMSK                                                    0xffcfffff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_POR                                                     0x00000000
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_ATTR                                                                 0x3
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                         0xff000000
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                 24
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                          0x800000
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                23
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                        0x400000
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                              22
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                        0xfffff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                              0

#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_ADDR(x)                                                       ((x) + 0x5b4)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_PHYS(x)                                                       ((x) + 0x5b4)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_OFFS                                                          (0x5b4)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_ADDR(x)                                                       ((x) + 0x5b8)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_PHYS(x)                                                       ((x) + 0x5b8)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_OFFS                                                          (0x5b8)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_ADDR(x)                                                           ((x) + 0x5bc)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_PHYS(x)                                                           ((x) + 0x5bc)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_OFFS                                                              (0x5bc)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_ADDR(x)                                                     ((x) + 0x5cc)
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_PHYS(x)                                                     ((x) + 0x5cc)
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_OFFS                                                        (0x5cc)
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_RMSK                                                            0xffff
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_POR                                                         0x00000000
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_POR_RMSK                                                    0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_ATTR                                                                     0x3
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                         0xffff
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                              0

#define HWIO_REO_R0_REO2SW2_RING_MISC_1_ADDR(x)                                                              ((x) + 0x5d0)
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_PHYS(x)                                                              ((x) + 0x5d0)
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_OFFS                                                                 (0x5d0)
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_RMSK                                                                 0xffff003f
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_POR                                                                  0x00000000
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_ATTR                                                                              0x3
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_MISC_1_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                        0xffff0000
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                16
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                               0x3f
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                  0

#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_ADDR(x)                                                            ((x) + 0x5d4)
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_PHYS(x)                                                            ((x) + 0x5d4)
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_OFFS                                                               (0x5d4)
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                            0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                     0

#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_ADDR(x)                                                            ((x) + 0x5d8)
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_PHYS(x)                                                            ((x) + 0x5d8)
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_OFFS                                                               (0x5d8)
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_RMSK                                                                0xfffffff
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xfffff00
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_RING_SIZE_SHFT                                                              8
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                  0xff
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                     0

#define HWIO_REO_R0_REO2SW3_RING_ID_ADDR(x)                                                                  ((x) + 0x5dc)
#define HWIO_REO_R0_REO2SW3_RING_ID_PHYS(x)                                                                  ((x) + 0x5dc)
#define HWIO_REO_R0_REO2SW3_RING_ID_OFFS                                                                     (0x5dc)
#define HWIO_REO_R0_REO2SW3_RING_ID_RMSK                                                                         0xffff
#define HWIO_REO_R0_REO2SW3_RING_ID_POR                                                                      0x00000000
#define HWIO_REO_R0_REO2SW3_RING_ID_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_ID_ATTR                                                                                  0x3
#define HWIO_REO_R0_REO2SW3_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_ID_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_ID_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_ID_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_ID_RING_ID_BMSK                                                                 0xff00
#define HWIO_REO_R0_REO2SW3_RING_ID_RING_ID_SHFT                                                                      8
#define HWIO_REO_R0_REO2SW3_RING_ID_ENTRY_SIZE_BMSK                                                                0xff
#define HWIO_REO_R0_REO2SW3_RING_ID_ENTRY_SIZE_SHFT                                                                   0

#define HWIO_REO_R0_REO2SW3_RING_STATUS_ADDR(x)                                                              ((x) + 0x5e0)
#define HWIO_REO_R0_REO2SW3_RING_STATUS_PHYS(x)                                                              ((x) + 0x5e0)
#define HWIO_REO_R0_REO2SW3_RING_STATUS_OFFS                                                                 (0x5e0)
#define HWIO_REO_R0_REO2SW3_RING_STATUS_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_STATUS_POR                                                                  0x00000000
#define HWIO_REO_R0_REO2SW3_RING_STATUS_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_STATUS_ATTR                                                                              0x1
#define HWIO_REO_R0_REO2SW3_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                 0xffff0000
#define HWIO_REO_R0_REO2SW3_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                         16
#define HWIO_REO_R0_REO2SW3_RING_STATUS_NUM_VALID_WORDS_BMSK                                                     0xffff
#define HWIO_REO_R0_REO2SW3_RING_STATUS_NUM_VALID_WORDS_SHFT                                                          0

#define HWIO_REO_R0_REO2SW3_RING_MISC_ADDR(x)                                                                ((x) + 0x5e4)
#define HWIO_REO_R0_REO2SW3_RING_MISC_PHYS(x)                                                                ((x) + 0x5e4)
#define HWIO_REO_R0_REO2SW3_RING_MISC_OFFS                                                                   (0x5e4)
#define HWIO_REO_R0_REO2SW3_RING_MISC_RMSK                                                                    0x7ffffff
#define HWIO_REO_R0_REO2SW3_RING_MISC_POR                                                                    0x00000080
#define HWIO_REO_R0_REO2SW3_RING_MISC_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MISC_ATTR                                                                                0x3
#define HWIO_REO_R0_REO2SW3_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_MISC_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_MISC_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                            0x4000000
#define HWIO_REO_R0_REO2SW3_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                   26
#define HWIO_REO_R0_REO2SW3_RING_MISC_LOOP_CNT_BMSK                                                           0x3c00000
#define HWIO_REO_R0_REO2SW3_RING_MISC_LOOP_CNT_SHFT                                                                  22
#define HWIO_REO_R0_REO2SW3_RING_MISC_SPARE_CONTROL_BMSK                                                       0x3fc000
#define HWIO_REO_R0_REO2SW3_RING_MISC_SPARE_CONTROL_SHFT                                                             14
#define HWIO_REO_R0_REO2SW3_RING_MISC_SRNG_SM_STATE2_BMSK                                                        0x3000
#define HWIO_REO_R0_REO2SW3_RING_MISC_SRNG_SM_STATE2_SHFT                                                            12
#define HWIO_REO_R0_REO2SW3_RING_MISC_SRNG_SM_STATE1_BMSK                                                         0xf00
#define HWIO_REO_R0_REO2SW3_RING_MISC_SRNG_SM_STATE1_SHFT                                                             8
#define HWIO_REO_R0_REO2SW3_RING_MISC_SRNG_IS_IDLE_BMSK                                                            0x80
#define HWIO_REO_R0_REO2SW3_RING_MISC_SRNG_IS_IDLE_SHFT                                                               7
#define HWIO_REO_R0_REO2SW3_RING_MISC_SRNG_ENABLE_BMSK                                                             0x40
#define HWIO_REO_R0_REO2SW3_RING_MISC_SRNG_ENABLE_SHFT                                                                6
#define HWIO_REO_R0_REO2SW3_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                       0x20
#define HWIO_REO_R0_REO2SW3_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                          5
#define HWIO_REO_R0_REO2SW3_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                        0x10
#define HWIO_REO_R0_REO2SW3_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                           4
#define HWIO_REO_R0_REO2SW3_RING_MISC_MSI_SWAP_BIT_BMSK                                                             0x8
#define HWIO_REO_R0_REO2SW3_RING_MISC_MSI_SWAP_BIT_SHFT                                                               3
#define HWIO_REO_R0_REO2SW3_RING_MISC_SECURITY_BIT_BMSK                                                             0x4
#define HWIO_REO_R0_REO2SW3_RING_MISC_SECURITY_BIT_SHFT                                                               2
#define HWIO_REO_R0_REO2SW3_RING_MISC_LOOPCNT_DISABLE_BMSK                                                          0x2
#define HWIO_REO_R0_REO2SW3_RING_MISC_LOOPCNT_DISABLE_SHFT                                                            1
#define HWIO_REO_R0_REO2SW3_RING_MISC_RING_ID_DISABLE_BMSK                                                          0x1
#define HWIO_REO_R0_REO2SW3_RING_MISC_RING_ID_DISABLE_SHFT                                                            0

#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_ADDR(x)                                                         ((x) + 0x5e8)
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_PHYS(x)                                                         ((x) + 0x5e8)
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_OFFS                                                            (0x5e8)
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_RMSK                                                            0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                       0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                0

#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_ADDR(x)                                                         ((x) + 0x5ec)
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_PHYS(x)                                                         ((x) + 0x5ec)
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_OFFS                                                            (0x5ec)
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_RMSK                                                                  0xff
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                             0xff
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                0

#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_ADDR(x)                                                  ((x) + 0x5f8)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_PHYS(x)                                                  ((x) + 0x5f8)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_OFFS                                                     (0x5f8)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_RMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_POR                                                      0x00000000
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_POR_RMSK                                                 0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_ATTR                                                                  0x3
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                           0xffff0000
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                   16
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                       0x8000
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                           15
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                 0x7fff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                      0

#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_ADDR(x)                                                 ((x) + 0x5fc)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_PHYS(x)                                                 ((x) + 0x5fc)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_OFFS                                                    (0x5fc)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_RMSK                                                    0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_POR                                                     0x00000000
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_ATTR                                                                 0x1
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                      0xffff0000
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                              16
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                              0x8000
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                  15
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                           0x7fff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                0

#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                               ((x) + 0x600)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                               ((x) + 0x600)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_OFFS                                                  (0x600)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_RMSK                                                       0x3ff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_POR                                                   0x00000000
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                              0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_ATTR                                                               0x3
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                     0x3ff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                         0

#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_ADDR(x)                                                       ((x) + 0x61c)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_PHYS(x)                                                       ((x) + 0x61c)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_OFFS                                                          (0x61c)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_ADDR(x)                                                       ((x) + 0x620)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_PHYS(x)                                                       ((x) + 0x620)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_OFFS                                                          (0x620)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_ADDR(x)                                                           ((x) + 0x624)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_PHYS(x)                                                           ((x) + 0x624)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_OFFS                                                              (0x624)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                 ((x) + 0x628)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                 ((x) + 0x628)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_OFFS                                                    (0x628)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_RMSK                                                    0xffcfffff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_POR                                                     0x00000000
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_ATTR                                                                 0x3
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                         0xff000000
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                 24
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                          0x800000
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                23
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                        0x400000
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                              22
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                        0xfffff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                              0

#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_ADDR(x)                                                       ((x) + 0x62c)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_PHYS(x)                                                       ((x) + 0x62c)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_OFFS                                                          (0x62c)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_ADDR(x)                                                       ((x) + 0x630)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_PHYS(x)                                                       ((x) + 0x630)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_OFFS                                                          (0x630)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_ADDR(x)                                                           ((x) + 0x634)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_PHYS(x)                                                           ((x) + 0x634)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_OFFS                                                              (0x634)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_ADDR(x)                                                     ((x) + 0x644)
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_PHYS(x)                                                     ((x) + 0x644)
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_OFFS                                                        (0x644)
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_RMSK                                                            0xffff
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_POR                                                         0x00000000
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_POR_RMSK                                                    0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_ATTR                                                                     0x3
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                         0xffff
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                              0

#define HWIO_REO_R0_REO2SW3_RING_MISC_1_ADDR(x)                                                              ((x) + 0x648)
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_PHYS(x)                                                              ((x) + 0x648)
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_OFFS                                                                 (0x648)
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_RMSK                                                                 0xffff003f
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_POR                                                                  0x00000000
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_ATTR                                                                              0x3
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_MISC_1_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                        0xffff0000
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                16
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                               0x3f
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                  0

#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_ADDR(x)                                                            ((x) + 0x64c)
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_PHYS(x)                                                            ((x) + 0x64c)
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_OFFS                                                               (0x64c)
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                            0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                     0

#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_ADDR(x)                                                            ((x) + 0x650)
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_PHYS(x)                                                            ((x) + 0x650)
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_OFFS                                                               (0x650)
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_RMSK                                                                0xfffffff
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xfffff00
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_RING_SIZE_SHFT                                                              8
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                  0xff
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                     0

#define HWIO_REO_R0_REO2SW4_RING_ID_ADDR(x)                                                                  ((x) + 0x654)
#define HWIO_REO_R0_REO2SW4_RING_ID_PHYS(x)                                                                  ((x) + 0x654)
#define HWIO_REO_R0_REO2SW4_RING_ID_OFFS                                                                     (0x654)
#define HWIO_REO_R0_REO2SW4_RING_ID_RMSK                                                                         0xffff
#define HWIO_REO_R0_REO2SW4_RING_ID_POR                                                                      0x00000000
#define HWIO_REO_R0_REO2SW4_RING_ID_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_ID_ATTR                                                                                  0x3
#define HWIO_REO_R0_REO2SW4_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_ID_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_ID_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_ID_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_ID_RING_ID_BMSK                                                                 0xff00
#define HWIO_REO_R0_REO2SW4_RING_ID_RING_ID_SHFT                                                                      8
#define HWIO_REO_R0_REO2SW4_RING_ID_ENTRY_SIZE_BMSK                                                                0xff
#define HWIO_REO_R0_REO2SW4_RING_ID_ENTRY_SIZE_SHFT                                                                   0

#define HWIO_REO_R0_REO2SW4_RING_STATUS_ADDR(x)                                                              ((x) + 0x658)
#define HWIO_REO_R0_REO2SW4_RING_STATUS_PHYS(x)                                                              ((x) + 0x658)
#define HWIO_REO_R0_REO2SW4_RING_STATUS_OFFS                                                                 (0x658)
#define HWIO_REO_R0_REO2SW4_RING_STATUS_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_STATUS_POR                                                                  0x00000000
#define HWIO_REO_R0_REO2SW4_RING_STATUS_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_STATUS_ATTR                                                                              0x1
#define HWIO_REO_R0_REO2SW4_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                 0xffff0000
#define HWIO_REO_R0_REO2SW4_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                         16
#define HWIO_REO_R0_REO2SW4_RING_STATUS_NUM_VALID_WORDS_BMSK                                                     0xffff
#define HWIO_REO_R0_REO2SW4_RING_STATUS_NUM_VALID_WORDS_SHFT                                                          0

#define HWIO_REO_R0_REO2SW4_RING_MISC_ADDR(x)                                                                ((x) + 0x65c)
#define HWIO_REO_R0_REO2SW4_RING_MISC_PHYS(x)                                                                ((x) + 0x65c)
#define HWIO_REO_R0_REO2SW4_RING_MISC_OFFS                                                                   (0x65c)
#define HWIO_REO_R0_REO2SW4_RING_MISC_RMSK                                                                    0x7ffffff
#define HWIO_REO_R0_REO2SW4_RING_MISC_POR                                                                    0x00000080
#define HWIO_REO_R0_REO2SW4_RING_MISC_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MISC_ATTR                                                                                0x3
#define HWIO_REO_R0_REO2SW4_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_MISC_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_MISC_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                            0x4000000
#define HWIO_REO_R0_REO2SW4_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                   26
#define HWIO_REO_R0_REO2SW4_RING_MISC_LOOP_CNT_BMSK                                                           0x3c00000
#define HWIO_REO_R0_REO2SW4_RING_MISC_LOOP_CNT_SHFT                                                                  22
#define HWIO_REO_R0_REO2SW4_RING_MISC_SPARE_CONTROL_BMSK                                                       0x3fc000
#define HWIO_REO_R0_REO2SW4_RING_MISC_SPARE_CONTROL_SHFT                                                             14
#define HWIO_REO_R0_REO2SW4_RING_MISC_SRNG_SM_STATE2_BMSK                                                        0x3000
#define HWIO_REO_R0_REO2SW4_RING_MISC_SRNG_SM_STATE2_SHFT                                                            12
#define HWIO_REO_R0_REO2SW4_RING_MISC_SRNG_SM_STATE1_BMSK                                                         0xf00
#define HWIO_REO_R0_REO2SW4_RING_MISC_SRNG_SM_STATE1_SHFT                                                             8
#define HWIO_REO_R0_REO2SW4_RING_MISC_SRNG_IS_IDLE_BMSK                                                            0x80
#define HWIO_REO_R0_REO2SW4_RING_MISC_SRNG_IS_IDLE_SHFT                                                               7
#define HWIO_REO_R0_REO2SW4_RING_MISC_SRNG_ENABLE_BMSK                                                             0x40
#define HWIO_REO_R0_REO2SW4_RING_MISC_SRNG_ENABLE_SHFT                                                                6
#define HWIO_REO_R0_REO2SW4_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                       0x20
#define HWIO_REO_R0_REO2SW4_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                          5
#define HWIO_REO_R0_REO2SW4_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                        0x10
#define HWIO_REO_R0_REO2SW4_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                           4
#define HWIO_REO_R0_REO2SW4_RING_MISC_MSI_SWAP_BIT_BMSK                                                             0x8
#define HWIO_REO_R0_REO2SW4_RING_MISC_MSI_SWAP_BIT_SHFT                                                               3
#define HWIO_REO_R0_REO2SW4_RING_MISC_SECURITY_BIT_BMSK                                                             0x4
#define HWIO_REO_R0_REO2SW4_RING_MISC_SECURITY_BIT_SHFT                                                               2
#define HWIO_REO_R0_REO2SW4_RING_MISC_LOOPCNT_DISABLE_BMSK                                                          0x2
#define HWIO_REO_R0_REO2SW4_RING_MISC_LOOPCNT_DISABLE_SHFT                                                            1
#define HWIO_REO_R0_REO2SW4_RING_MISC_RING_ID_DISABLE_BMSK                                                          0x1
#define HWIO_REO_R0_REO2SW4_RING_MISC_RING_ID_DISABLE_SHFT                                                            0

#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_ADDR(x)                                                         ((x) + 0x660)
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_PHYS(x)                                                         ((x) + 0x660)
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_OFFS                                                            (0x660)
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_RMSK                                                            0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                       0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                0

#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_ADDR(x)                                                         ((x) + 0x664)
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_PHYS(x)                                                         ((x) + 0x664)
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_OFFS                                                            (0x664)
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_RMSK                                                                  0xff
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                             0xff
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                0

#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_ADDR(x)                                                  ((x) + 0x670)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_PHYS(x)                                                  ((x) + 0x670)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_OFFS                                                     (0x670)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_RMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_POR                                                      0x00000000
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_POR_RMSK                                                 0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_ATTR                                                                  0x3
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                           0xffff0000
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                   16
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                       0x8000
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                           15
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                 0x7fff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                      0

#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_ADDR(x)                                                 ((x) + 0x674)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_PHYS(x)                                                 ((x) + 0x674)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_OFFS                                                    (0x674)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_RMSK                                                    0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_POR                                                     0x00000000
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_ATTR                                                                 0x1
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                      0xffff0000
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                              16
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                              0x8000
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                  15
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                           0x7fff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                0

#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                               ((x) + 0x678)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                               ((x) + 0x678)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_OFFS                                                  (0x678)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_RMSK                                                       0x3ff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_POR                                                   0x00000000
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                              0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_ATTR                                                               0x3
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                     0x3ff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                         0

#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_ADDR(x)                                                       ((x) + 0x694)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_PHYS(x)                                                       ((x) + 0x694)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_OFFS                                                          (0x694)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_ADDR(x)                                                       ((x) + 0x698)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_PHYS(x)                                                       ((x) + 0x698)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_OFFS                                                          (0x698)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_ADDR(x)                                                           ((x) + 0x69c)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_PHYS(x)                                                           ((x) + 0x69c)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_OFFS                                                              (0x69c)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                 ((x) + 0x6a0)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                 ((x) + 0x6a0)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_OFFS                                                    (0x6a0)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_RMSK                                                    0xffcfffff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_POR                                                     0x00000000
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_ATTR                                                                 0x3
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                         0xff000000
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                 24
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                          0x800000
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                23
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                        0x400000
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                              22
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                        0xfffff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                              0

#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_ADDR(x)                                                       ((x) + 0x6a4)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_PHYS(x)                                                       ((x) + 0x6a4)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_OFFS                                                          (0x6a4)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_ADDR(x)                                                       ((x) + 0x6a8)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_PHYS(x)                                                       ((x) + 0x6a8)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_OFFS                                                          (0x6a8)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_ADDR(x)                                                           ((x) + 0x6ac)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_PHYS(x)                                                           ((x) + 0x6ac)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_OFFS                                                              (0x6ac)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_ADDR(x)                                                     ((x) + 0x6bc)
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_PHYS(x)                                                     ((x) + 0x6bc)
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_OFFS                                                        (0x6bc)
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_RMSK                                                            0xffff
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_POR                                                         0x00000000
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_POR_RMSK                                                    0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_ATTR                                                                     0x3
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                         0xffff
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                              0

#define HWIO_REO_R0_REO2SW4_RING_MISC_1_ADDR(x)                                                              ((x) + 0x6c0)
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_PHYS(x)                                                              ((x) + 0x6c0)
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_OFFS                                                                 (0x6c0)
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_RMSK                                                                 0xffff003f
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_POR                                                                  0x00000000
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_ATTR                                                                              0x3
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_MISC_1_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                        0xffff0000
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                16
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                               0x3f
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                  0

#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_ADDR(x)                                                            ((x) + 0x6c4)
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_PHYS(x)                                                            ((x) + 0x6c4)
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_OFFS                                                               (0x6c4)
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                            0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                     0

#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_ADDR(x)                                                            ((x) + 0x6c8)
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_PHYS(x)                                                            ((x) + 0x6c8)
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_OFFS                                                               (0x6c8)
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_RMSK                                                                0xfffffff
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xfffff00
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_RING_SIZE_SHFT                                                              8
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                  0xff
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                     0

#define HWIO_REO_R0_REO2SW5_RING_ID_ADDR(x)                                                                  ((x) + 0x6cc)
#define HWIO_REO_R0_REO2SW5_RING_ID_PHYS(x)                                                                  ((x) + 0x6cc)
#define HWIO_REO_R0_REO2SW5_RING_ID_OFFS                                                                     (0x6cc)
#define HWIO_REO_R0_REO2SW5_RING_ID_RMSK                                                                         0xffff
#define HWIO_REO_R0_REO2SW5_RING_ID_POR                                                                      0x00000000
#define HWIO_REO_R0_REO2SW5_RING_ID_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_ID_ATTR                                                                                  0x3
#define HWIO_REO_R0_REO2SW5_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_ID_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_ID_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_ID_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_ID_RING_ID_BMSK                                                                 0xff00
#define HWIO_REO_R0_REO2SW5_RING_ID_RING_ID_SHFT                                                                      8
#define HWIO_REO_R0_REO2SW5_RING_ID_ENTRY_SIZE_BMSK                                                                0xff
#define HWIO_REO_R0_REO2SW5_RING_ID_ENTRY_SIZE_SHFT                                                                   0

#define HWIO_REO_R0_REO2SW5_RING_STATUS_ADDR(x)                                                              ((x) + 0x6d0)
#define HWIO_REO_R0_REO2SW5_RING_STATUS_PHYS(x)                                                              ((x) + 0x6d0)
#define HWIO_REO_R0_REO2SW5_RING_STATUS_OFFS                                                                 (0x6d0)
#define HWIO_REO_R0_REO2SW5_RING_STATUS_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_STATUS_POR                                                                  0x00000000
#define HWIO_REO_R0_REO2SW5_RING_STATUS_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_STATUS_ATTR                                                                              0x1
#define HWIO_REO_R0_REO2SW5_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                 0xffff0000
#define HWIO_REO_R0_REO2SW5_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                         16
#define HWIO_REO_R0_REO2SW5_RING_STATUS_NUM_VALID_WORDS_BMSK                                                     0xffff
#define HWIO_REO_R0_REO2SW5_RING_STATUS_NUM_VALID_WORDS_SHFT                                                          0

#define HWIO_REO_R0_REO2SW5_RING_MISC_ADDR(x)                                                                ((x) + 0x6d4)
#define HWIO_REO_R0_REO2SW5_RING_MISC_PHYS(x)                                                                ((x) + 0x6d4)
#define HWIO_REO_R0_REO2SW5_RING_MISC_OFFS                                                                   (0x6d4)
#define HWIO_REO_R0_REO2SW5_RING_MISC_RMSK                                                                    0x7ffffff
#define HWIO_REO_R0_REO2SW5_RING_MISC_POR                                                                    0x00000080
#define HWIO_REO_R0_REO2SW5_RING_MISC_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MISC_ATTR                                                                                0x3
#define HWIO_REO_R0_REO2SW5_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_MISC_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_MISC_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                            0x4000000
#define HWIO_REO_R0_REO2SW5_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                   26
#define HWIO_REO_R0_REO2SW5_RING_MISC_LOOP_CNT_BMSK                                                           0x3c00000
#define HWIO_REO_R0_REO2SW5_RING_MISC_LOOP_CNT_SHFT                                                                  22
#define HWIO_REO_R0_REO2SW5_RING_MISC_SPARE_CONTROL_BMSK                                                       0x3fc000
#define HWIO_REO_R0_REO2SW5_RING_MISC_SPARE_CONTROL_SHFT                                                             14
#define HWIO_REO_R0_REO2SW5_RING_MISC_SRNG_SM_STATE2_BMSK                                                        0x3000
#define HWIO_REO_R0_REO2SW5_RING_MISC_SRNG_SM_STATE2_SHFT                                                            12
#define HWIO_REO_R0_REO2SW5_RING_MISC_SRNG_SM_STATE1_BMSK                                                         0xf00
#define HWIO_REO_R0_REO2SW5_RING_MISC_SRNG_SM_STATE1_SHFT                                                             8
#define HWIO_REO_R0_REO2SW5_RING_MISC_SRNG_IS_IDLE_BMSK                                                            0x80
#define HWIO_REO_R0_REO2SW5_RING_MISC_SRNG_IS_IDLE_SHFT                                                               7
#define HWIO_REO_R0_REO2SW5_RING_MISC_SRNG_ENABLE_BMSK                                                             0x40
#define HWIO_REO_R0_REO2SW5_RING_MISC_SRNG_ENABLE_SHFT                                                                6
#define HWIO_REO_R0_REO2SW5_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                       0x20
#define HWIO_REO_R0_REO2SW5_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                          5
#define HWIO_REO_R0_REO2SW5_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                        0x10
#define HWIO_REO_R0_REO2SW5_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                           4
#define HWIO_REO_R0_REO2SW5_RING_MISC_MSI_SWAP_BIT_BMSK                                                             0x8
#define HWIO_REO_R0_REO2SW5_RING_MISC_MSI_SWAP_BIT_SHFT                                                               3
#define HWIO_REO_R0_REO2SW5_RING_MISC_SECURITY_BIT_BMSK                                                             0x4
#define HWIO_REO_R0_REO2SW5_RING_MISC_SECURITY_BIT_SHFT                                                               2
#define HWIO_REO_R0_REO2SW5_RING_MISC_LOOPCNT_DISABLE_BMSK                                                          0x2
#define HWIO_REO_R0_REO2SW5_RING_MISC_LOOPCNT_DISABLE_SHFT                                                            1
#define HWIO_REO_R0_REO2SW5_RING_MISC_RING_ID_DISABLE_BMSK                                                          0x1
#define HWIO_REO_R0_REO2SW5_RING_MISC_RING_ID_DISABLE_SHFT                                                            0

#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_ADDR(x)                                                         ((x) + 0x6d8)
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_PHYS(x)                                                         ((x) + 0x6d8)
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_OFFS                                                            (0x6d8)
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_RMSK                                                            0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                       0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                0

#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_ADDR(x)                                                         ((x) + 0x6dc)
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_PHYS(x)                                                         ((x) + 0x6dc)
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_OFFS                                                            (0x6dc)
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_RMSK                                                                  0xff
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                             0xff
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                0

#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_ADDR(x)                                                  ((x) + 0x6e8)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_PHYS(x)                                                  ((x) + 0x6e8)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_OFFS                                                     (0x6e8)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_RMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_POR                                                      0x00000000
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_POR_RMSK                                                 0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_ATTR                                                                  0x3
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                           0xffff0000
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                   16
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                       0x8000
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                           15
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                 0x7fff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                      0

#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_ADDR(x)                                                 ((x) + 0x6ec)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_PHYS(x)                                                 ((x) + 0x6ec)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_OFFS                                                    (0x6ec)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_RMSK                                                    0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_POR                                                     0x00000000
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_ATTR                                                                 0x1
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                      0xffff0000
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                              16
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                              0x8000
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                  15
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                           0x7fff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                0

#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                               ((x) + 0x6f0)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                               ((x) + 0x6f0)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_OFFS                                                  (0x6f0)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_RMSK                                                       0x3ff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_POR                                                   0x00000000
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                              0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_ATTR                                                               0x3
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                     0x3ff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                         0

#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_ADDR(x)                                                       ((x) + 0x70c)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_PHYS(x)                                                       ((x) + 0x70c)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_OFFS                                                          (0x70c)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_ADDR(x)                                                       ((x) + 0x710)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_PHYS(x)                                                       ((x) + 0x710)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_OFFS                                                          (0x710)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_ADDR(x)                                                           ((x) + 0x714)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_PHYS(x)                                                           ((x) + 0x714)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_OFFS                                                              (0x714)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                 ((x) + 0x718)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                 ((x) + 0x718)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_OFFS                                                    (0x718)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_RMSK                                                    0xffcfffff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_POR                                                     0x00000000
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_ATTR                                                                 0x3
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                         0xff000000
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                 24
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                          0x800000
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                23
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                        0x400000
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                              22
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                        0xfffff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                              0

#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_ADDR(x)                                                       ((x) + 0x71c)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_PHYS(x)                                                       ((x) + 0x71c)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_OFFS                                                          (0x71c)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_ADDR(x)                                                       ((x) + 0x720)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_PHYS(x)                                                       ((x) + 0x720)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_OFFS                                                          (0x720)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_ADDR(x)                                                           ((x) + 0x724)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_PHYS(x)                                                           ((x) + 0x724)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_OFFS                                                              (0x724)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_ADDR(x)                                                     ((x) + 0x734)
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_PHYS(x)                                                     ((x) + 0x734)
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_OFFS                                                        (0x734)
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_RMSK                                                            0xffff
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_POR                                                         0x00000000
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_POR_RMSK                                                    0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_ATTR                                                                     0x3
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                         0xffff
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                              0

#define HWIO_REO_R0_REO2SW5_RING_MISC_1_ADDR(x)                                                              ((x) + 0x738)
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_PHYS(x)                                                              ((x) + 0x738)
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_OFFS                                                                 (0x738)
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_RMSK                                                                 0xffff003f
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_POR                                                                  0x00000000
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_ATTR                                                                              0x3
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_MISC_1_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                        0xffff0000
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                16
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                               0x3f
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                  0

#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_ADDR(x)                                                            ((x) + 0x73c)
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_PHYS(x)                                                            ((x) + 0x73c)
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_OFFS                                                               (0x73c)
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                            0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                     0

#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_ADDR(x)                                                            ((x) + 0x740)
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_PHYS(x)                                                            ((x) + 0x740)
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_OFFS                                                               (0x740)
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_RMSK                                                                0xfffffff
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xfffff00
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_RING_SIZE_SHFT                                                              8
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                  0xff
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                     0

#define HWIO_REO_R0_REO2SW6_RING_ID_ADDR(x)                                                                  ((x) + 0x744)
#define HWIO_REO_R0_REO2SW6_RING_ID_PHYS(x)                                                                  ((x) + 0x744)
#define HWIO_REO_R0_REO2SW6_RING_ID_OFFS                                                                     (0x744)
#define HWIO_REO_R0_REO2SW6_RING_ID_RMSK                                                                         0xffff
#define HWIO_REO_R0_REO2SW6_RING_ID_POR                                                                      0x00000000
#define HWIO_REO_R0_REO2SW6_RING_ID_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_ID_ATTR                                                                                  0x3
#define HWIO_REO_R0_REO2SW6_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_ID_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_ID_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_ID_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_ID_RING_ID_BMSK                                                                 0xff00
#define HWIO_REO_R0_REO2SW6_RING_ID_RING_ID_SHFT                                                                      8
#define HWIO_REO_R0_REO2SW6_RING_ID_ENTRY_SIZE_BMSK                                                                0xff
#define HWIO_REO_R0_REO2SW6_RING_ID_ENTRY_SIZE_SHFT                                                                   0

#define HWIO_REO_R0_REO2SW6_RING_STATUS_ADDR(x)                                                              ((x) + 0x748)
#define HWIO_REO_R0_REO2SW6_RING_STATUS_PHYS(x)                                                              ((x) + 0x748)
#define HWIO_REO_R0_REO2SW6_RING_STATUS_OFFS                                                                 (0x748)
#define HWIO_REO_R0_REO2SW6_RING_STATUS_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_STATUS_POR                                                                  0x00000000
#define HWIO_REO_R0_REO2SW6_RING_STATUS_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_STATUS_ATTR                                                                              0x1
#define HWIO_REO_R0_REO2SW6_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                 0xffff0000
#define HWIO_REO_R0_REO2SW6_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                         16
#define HWIO_REO_R0_REO2SW6_RING_STATUS_NUM_VALID_WORDS_BMSK                                                     0xffff
#define HWIO_REO_R0_REO2SW6_RING_STATUS_NUM_VALID_WORDS_SHFT                                                          0

#define HWIO_REO_R0_REO2SW6_RING_MISC_ADDR(x)                                                                ((x) + 0x74c)
#define HWIO_REO_R0_REO2SW6_RING_MISC_PHYS(x)                                                                ((x) + 0x74c)
#define HWIO_REO_R0_REO2SW6_RING_MISC_OFFS                                                                   (0x74c)
#define HWIO_REO_R0_REO2SW6_RING_MISC_RMSK                                                                    0x7ffffff
#define HWIO_REO_R0_REO2SW6_RING_MISC_POR                                                                    0x00000080
#define HWIO_REO_R0_REO2SW6_RING_MISC_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MISC_ATTR                                                                                0x3
#define HWIO_REO_R0_REO2SW6_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_MISC_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_MISC_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                            0x4000000
#define HWIO_REO_R0_REO2SW6_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                   26
#define HWIO_REO_R0_REO2SW6_RING_MISC_LOOP_CNT_BMSK                                                           0x3c00000
#define HWIO_REO_R0_REO2SW6_RING_MISC_LOOP_CNT_SHFT                                                                  22
#define HWIO_REO_R0_REO2SW6_RING_MISC_SPARE_CONTROL_BMSK                                                       0x3fc000
#define HWIO_REO_R0_REO2SW6_RING_MISC_SPARE_CONTROL_SHFT                                                             14
#define HWIO_REO_R0_REO2SW6_RING_MISC_SRNG_SM_STATE2_BMSK                                                        0x3000
#define HWIO_REO_R0_REO2SW6_RING_MISC_SRNG_SM_STATE2_SHFT                                                            12
#define HWIO_REO_R0_REO2SW6_RING_MISC_SRNG_SM_STATE1_BMSK                                                         0xf00
#define HWIO_REO_R0_REO2SW6_RING_MISC_SRNG_SM_STATE1_SHFT                                                             8
#define HWIO_REO_R0_REO2SW6_RING_MISC_SRNG_IS_IDLE_BMSK                                                            0x80
#define HWIO_REO_R0_REO2SW6_RING_MISC_SRNG_IS_IDLE_SHFT                                                               7
#define HWIO_REO_R0_REO2SW6_RING_MISC_SRNG_ENABLE_BMSK                                                             0x40
#define HWIO_REO_R0_REO2SW6_RING_MISC_SRNG_ENABLE_SHFT                                                                6
#define HWIO_REO_R0_REO2SW6_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                       0x20
#define HWIO_REO_R0_REO2SW6_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                          5
#define HWIO_REO_R0_REO2SW6_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                        0x10
#define HWIO_REO_R0_REO2SW6_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                           4
#define HWIO_REO_R0_REO2SW6_RING_MISC_MSI_SWAP_BIT_BMSK                                                             0x8
#define HWIO_REO_R0_REO2SW6_RING_MISC_MSI_SWAP_BIT_SHFT                                                               3
#define HWIO_REO_R0_REO2SW6_RING_MISC_SECURITY_BIT_BMSK                                                             0x4
#define HWIO_REO_R0_REO2SW6_RING_MISC_SECURITY_BIT_SHFT                                                               2
#define HWIO_REO_R0_REO2SW6_RING_MISC_LOOPCNT_DISABLE_BMSK                                                          0x2
#define HWIO_REO_R0_REO2SW6_RING_MISC_LOOPCNT_DISABLE_SHFT                                                            1
#define HWIO_REO_R0_REO2SW6_RING_MISC_RING_ID_DISABLE_BMSK                                                          0x1
#define HWIO_REO_R0_REO2SW6_RING_MISC_RING_ID_DISABLE_SHFT                                                            0

#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_ADDR(x)                                                         ((x) + 0x750)
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_PHYS(x)                                                         ((x) + 0x750)
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_OFFS                                                            (0x750)
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_RMSK                                                            0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                       0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                0

#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_ADDR(x)                                                         ((x) + 0x754)
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_PHYS(x)                                                         ((x) + 0x754)
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_OFFS                                                            (0x754)
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_RMSK                                                                  0xff
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                             0xff
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                0

#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_ADDR(x)                                                  ((x) + 0x760)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_PHYS(x)                                                  ((x) + 0x760)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_OFFS                                                     (0x760)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_RMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_POR                                                      0x00000000
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_POR_RMSK                                                 0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_ATTR                                                                  0x3
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                           0xffff0000
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                   16
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                       0x8000
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                           15
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                 0x7fff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                      0

#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_ADDR(x)                                                 ((x) + 0x764)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_PHYS(x)                                                 ((x) + 0x764)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_OFFS                                                    (0x764)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_RMSK                                                    0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_POR                                                     0x00000000
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_ATTR                                                                 0x1
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                      0xffff0000
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                              16
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                              0x8000
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                  15
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                           0x7fff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                0

#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                               ((x) + 0x768)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                               ((x) + 0x768)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_OFFS                                                  (0x768)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_RMSK                                                       0x3ff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_POR                                                   0x00000000
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                              0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_ATTR                                                               0x3
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                     0x3ff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                         0

#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_ADDR(x)                                                       ((x) + 0x784)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_PHYS(x)                                                       ((x) + 0x784)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_OFFS                                                          (0x784)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_ADDR(x)                                                       ((x) + 0x788)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_PHYS(x)                                                       ((x) + 0x788)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_OFFS                                                          (0x788)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_ADDR(x)                                                           ((x) + 0x78c)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_PHYS(x)                                                           ((x) + 0x78c)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_OFFS                                                              (0x78c)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                 ((x) + 0x790)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                 ((x) + 0x790)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_OFFS                                                    (0x790)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_RMSK                                                    0xffcfffff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_POR                                                     0x00000000
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_ATTR                                                                 0x3
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                         0xff000000
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                 24
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                          0x800000
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                23
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                        0x400000
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                              22
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                        0xfffff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                              0

#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_ADDR(x)                                                       ((x) + 0x794)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_PHYS(x)                                                       ((x) + 0x794)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_OFFS                                                          (0x794)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_ADDR(x)                                                       ((x) + 0x798)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_PHYS(x)                                                       ((x) + 0x798)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_OFFS                                                          (0x798)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_ADDR(x)                                                           ((x) + 0x79c)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_PHYS(x)                                                           ((x) + 0x79c)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_OFFS                                                              (0x79c)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_ADDR(x)                                                     ((x) + 0x7ac)
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_PHYS(x)                                                     ((x) + 0x7ac)
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_OFFS                                                        (0x7ac)
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_RMSK                                                            0xffff
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_POR                                                         0x00000000
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_POR_RMSK                                                    0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_ATTR                                                                     0x3
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                         0xffff
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                              0

#define HWIO_REO_R0_REO2SW6_RING_MISC_1_ADDR(x)                                                              ((x) + 0x7b0)
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_PHYS(x)                                                              ((x) + 0x7b0)
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_OFFS                                                                 (0x7b0)
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_RMSK                                                                 0xffff003f
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_POR                                                                  0x00000000
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_ATTR                                                                              0x3
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_MISC_1_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                        0xffff0000
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                16
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                               0x3f
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                  0

#define HWIO_REO_R0_REO2SW7_RING_BASE_LSB_ADDR(x)                                                            ((x) + 0x7b4)
#define HWIO_REO_R0_REO2SW7_RING_BASE_LSB_PHYS(x)                                                            ((x) + 0x7b4)
#define HWIO_REO_R0_REO2SW7_RING_BASE_LSB_OFFS                                                               (0x7b4)
#define HWIO_REO_R0_REO2SW7_RING_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_BASE_LSB_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW7_RING_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_BASE_LSB_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW7_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW7_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW7_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW7_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW7_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW7_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW7_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW7_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW7_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW7_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                            0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                     0

#define HWIO_REO_R0_REO2SW7_RING_BASE_MSB_ADDR(x)                                                            ((x) + 0x7b8)
#define HWIO_REO_R0_REO2SW7_RING_BASE_MSB_PHYS(x)                                                            ((x) + 0x7b8)
#define HWIO_REO_R0_REO2SW7_RING_BASE_MSB_OFFS                                                               (0x7b8)
#define HWIO_REO_R0_REO2SW7_RING_BASE_MSB_RMSK                                                                0xfffffff
#define HWIO_REO_R0_REO2SW7_RING_BASE_MSB_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW7_RING_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_BASE_MSB_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW7_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW7_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW7_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW7_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW7_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW7_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW7_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW7_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW7_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW7_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xfffff00
#define HWIO_REO_R0_REO2SW7_RING_BASE_MSB_RING_SIZE_SHFT                                                              8
#define HWIO_REO_R0_REO2SW7_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                  0xff
#define HWIO_REO_R0_REO2SW7_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                     0

#define HWIO_REO_R0_REO2SW7_RING_ID_ADDR(x)                                                                  ((x) + 0x7bc)
#define HWIO_REO_R0_REO2SW7_RING_ID_PHYS(x)                                                                  ((x) + 0x7bc)
#define HWIO_REO_R0_REO2SW7_RING_ID_OFFS                                                                     (0x7bc)
#define HWIO_REO_R0_REO2SW7_RING_ID_RMSK                                                                         0xffff
#define HWIO_REO_R0_REO2SW7_RING_ID_POR                                                                      0x00000000
#define HWIO_REO_R0_REO2SW7_RING_ID_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_ID_ATTR                                                                                  0x3
#define HWIO_REO_R0_REO2SW7_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW7_RING_ID_ADDR(x))
#define HWIO_REO_R0_REO2SW7_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW7_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_REO2SW7_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW7_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_REO2SW7_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW7_RING_ID_ADDR(x),m,v,HWIO_REO_R0_REO2SW7_RING_ID_IN(x))
#define HWIO_REO_R0_REO2SW7_RING_ID_RING_ID_BMSK                                                                 0xff00
#define HWIO_REO_R0_REO2SW7_RING_ID_RING_ID_SHFT                                                                      8
#define HWIO_REO_R0_REO2SW7_RING_ID_ENTRY_SIZE_BMSK                                                                0xff
#define HWIO_REO_R0_REO2SW7_RING_ID_ENTRY_SIZE_SHFT                                                                   0

#define HWIO_REO_R0_REO2SW7_RING_STATUS_ADDR(x)                                                              ((x) + 0x7c0)
#define HWIO_REO_R0_REO2SW7_RING_STATUS_PHYS(x)                                                              ((x) + 0x7c0)
#define HWIO_REO_R0_REO2SW7_RING_STATUS_OFFS                                                                 (0x7c0)
#define HWIO_REO_R0_REO2SW7_RING_STATUS_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_STATUS_POR                                                                  0x00000000
#define HWIO_REO_R0_REO2SW7_RING_STATUS_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_STATUS_ATTR                                                                              0x1
#define HWIO_REO_R0_REO2SW7_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW7_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW7_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW7_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW7_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                 0xffff0000
#define HWIO_REO_R0_REO2SW7_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                         16
#define HWIO_REO_R0_REO2SW7_RING_STATUS_NUM_VALID_WORDS_BMSK                                                     0xffff
#define HWIO_REO_R0_REO2SW7_RING_STATUS_NUM_VALID_WORDS_SHFT                                                          0

#define HWIO_REO_R0_REO2SW7_RING_MISC_ADDR(x)                                                                ((x) + 0x7c4)
#define HWIO_REO_R0_REO2SW7_RING_MISC_PHYS(x)                                                                ((x) + 0x7c4)
#define HWIO_REO_R0_REO2SW7_RING_MISC_OFFS                                                                   (0x7c4)
#define HWIO_REO_R0_REO2SW7_RING_MISC_RMSK                                                                    0x7ffffff
#define HWIO_REO_R0_REO2SW7_RING_MISC_POR                                                                    0x00000080
#define HWIO_REO_R0_REO2SW7_RING_MISC_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_MISC_ATTR                                                                                0x3
#define HWIO_REO_R0_REO2SW7_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW7_RING_MISC_ADDR(x))
#define HWIO_REO_R0_REO2SW7_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW7_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_REO2SW7_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW7_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_REO2SW7_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW7_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_REO2SW7_RING_MISC_IN(x))
#define HWIO_REO_R0_REO2SW7_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                            0x4000000
#define HWIO_REO_R0_REO2SW7_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                   26
#define HWIO_REO_R0_REO2SW7_RING_MISC_LOOP_CNT_BMSK                                                           0x3c00000
#define HWIO_REO_R0_REO2SW7_RING_MISC_LOOP_CNT_SHFT                                                                  22
#define HWIO_REO_R0_REO2SW7_RING_MISC_SPARE_CONTROL_BMSK                                                       0x3fc000
#define HWIO_REO_R0_REO2SW7_RING_MISC_SPARE_CONTROL_SHFT                                                             14
#define HWIO_REO_R0_REO2SW7_RING_MISC_SRNG_SM_STATE2_BMSK                                                        0x3000
#define HWIO_REO_R0_REO2SW7_RING_MISC_SRNG_SM_STATE2_SHFT                                                            12
#define HWIO_REO_R0_REO2SW7_RING_MISC_SRNG_SM_STATE1_BMSK                                                         0xf00
#define HWIO_REO_R0_REO2SW7_RING_MISC_SRNG_SM_STATE1_SHFT                                                             8
#define HWIO_REO_R0_REO2SW7_RING_MISC_SRNG_IS_IDLE_BMSK                                                            0x80
#define HWIO_REO_R0_REO2SW7_RING_MISC_SRNG_IS_IDLE_SHFT                                                               7
#define HWIO_REO_R0_REO2SW7_RING_MISC_SRNG_ENABLE_BMSK                                                             0x40
#define HWIO_REO_R0_REO2SW7_RING_MISC_SRNG_ENABLE_SHFT                                                                6
#define HWIO_REO_R0_REO2SW7_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                       0x20
#define HWIO_REO_R0_REO2SW7_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                          5
#define HWIO_REO_R0_REO2SW7_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                        0x10
#define HWIO_REO_R0_REO2SW7_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                           4
#define HWIO_REO_R0_REO2SW7_RING_MISC_MSI_SWAP_BIT_BMSK                                                             0x8
#define HWIO_REO_R0_REO2SW7_RING_MISC_MSI_SWAP_BIT_SHFT                                                               3
#define HWIO_REO_R0_REO2SW7_RING_MISC_SECURITY_BIT_BMSK                                                             0x4
#define HWIO_REO_R0_REO2SW7_RING_MISC_SECURITY_BIT_SHFT                                                               2
#define HWIO_REO_R0_REO2SW7_RING_MISC_LOOPCNT_DISABLE_BMSK                                                          0x2
#define HWIO_REO_R0_REO2SW7_RING_MISC_LOOPCNT_DISABLE_SHFT                                                            1
#define HWIO_REO_R0_REO2SW7_RING_MISC_RING_ID_DISABLE_BMSK                                                          0x1
#define HWIO_REO_R0_REO2SW7_RING_MISC_RING_ID_DISABLE_SHFT                                                            0

#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_LSB_ADDR(x)                                                         ((x) + 0x7c8)
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_LSB_PHYS(x)                                                         ((x) + 0x7c8)
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_LSB_OFFS                                                            (0x7c8)
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_LSB_RMSK                                                            0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_LSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_LSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW7_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW7_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW7_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW7_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW7_RING_HP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                       0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                0

#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_MSB_ADDR(x)                                                         ((x) + 0x7cc)
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_MSB_PHYS(x)                                                         ((x) + 0x7cc)
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_MSB_OFFS                                                            (0x7cc)
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_MSB_RMSK                                                                  0xff
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_MSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_MSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW7_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW7_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW7_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW7_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW7_RING_HP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                             0xff
#define HWIO_REO_R0_REO2SW7_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                0

#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_SETUP_ADDR(x)                                                  ((x) + 0x7d8)
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_SETUP_PHYS(x)                                                  ((x) + 0x7d8)
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_SETUP_OFFS                                                     (0x7d8)
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_SETUP_RMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_SETUP_POR                                                      0x00000000
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_SETUP_POR_RMSK                                                 0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_SETUP_ATTR                                                                  0x3
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                           0xffff0000
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                   16
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                       0x8000
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                           15
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                 0x7fff
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                      0

#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_STATUS_ADDR(x)                                                 ((x) + 0x7dc)
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_STATUS_PHYS(x)                                                 ((x) + 0x7dc)
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_STATUS_OFFS                                                    (0x7dc)
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_STATUS_RMSK                                                    0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_STATUS_POR                                                     0x00000000
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_STATUS_ATTR                                                                 0x1
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                      0xffff0000
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                              16
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                              0x8000
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                  15
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                           0x7fff
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                0

#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                               ((x) + 0x7e0)
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                               ((x) + 0x7e0)
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_FULL_COUNTER_OFFS                                                  (0x7e0)
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_FULL_COUNTER_RMSK                                                       0x3ff
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_FULL_COUNTER_POR                                                   0x00000000
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                              0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_FULL_COUNTER_ATTR                                                               0x3
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW7_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW7_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW7_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW7_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_REO_R0_REO2SW7_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                     0x3ff
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                         0

#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_LSB_ADDR(x)                                                       ((x) + 0x7fc)
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_LSB_PHYS(x)                                                       ((x) + 0x7fc)
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_LSB_OFFS                                                          (0x7fc)
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_MSB_ADDR(x)                                                       ((x) + 0x800)
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_MSB_PHYS(x)                                                       ((x) + 0x800)
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_MSB_OFFS                                                          (0x800)
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_REO2SW7_RING_MSI1_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW7_RING_MSI1_DATA_ADDR(x)                                                           ((x) + 0x804)
#define HWIO_REO_R0_REO2SW7_RING_MSI1_DATA_PHYS(x)                                                           ((x) + 0x804)
#define HWIO_REO_R0_REO2SW7_RING_MSI1_DATA_OFFS                                                              (0x804)
#define HWIO_REO_R0_REO2SW7_RING_MSI1_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_MSI1_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW7_RING_MSI1_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_MSI1_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW7_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW7_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW7_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW7_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW7_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW7_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW7_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW7_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW7_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_REO2SW7_RING_MSI1_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_MSI1_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                 ((x) + 0x808)
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                 ((x) + 0x808)
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_OFFS                                                    (0x808)
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_RMSK                                                    0xffcfffff
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_POR                                                     0x00000000
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_ATTR                                                                 0x3
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                         0xff000000
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                 24
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                          0x800000
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                23
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                        0x400000
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                              22
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                        0xfffff
#define HWIO_REO_R0_REO2SW7_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                              0

#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_LSB_ADDR(x)                                                       ((x) + 0x80c)
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_LSB_PHYS(x)                                                       ((x) + 0x80c)
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_LSB_OFFS                                                          (0x80c)
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_MSB_ADDR(x)                                                       ((x) + 0x810)
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_MSB_PHYS(x)                                                       ((x) + 0x810)
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_MSB_OFFS                                                          (0x810)
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_REO2SW7_RING_MSI2_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW7_RING_MSI2_DATA_ADDR(x)                                                           ((x) + 0x814)
#define HWIO_REO_R0_REO2SW7_RING_MSI2_DATA_PHYS(x)                                                           ((x) + 0x814)
#define HWIO_REO_R0_REO2SW7_RING_MSI2_DATA_OFFS                                                              (0x814)
#define HWIO_REO_R0_REO2SW7_RING_MSI2_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_MSI2_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW7_RING_MSI2_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_MSI2_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW7_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW7_RING_MSI2_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW7_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW7_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW7_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW7_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW7_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW7_RING_MSI2_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW7_RING_MSI2_DATA_IN(x))
#define HWIO_REO_R0_REO2SW7_RING_MSI2_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_MSI2_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_REO2SW7_RING_HP_TP_SW_OFFSET_ADDR(x)                                                     ((x) + 0x824)
#define HWIO_REO_R0_REO2SW7_RING_HP_TP_SW_OFFSET_PHYS(x)                                                     ((x) + 0x824)
#define HWIO_REO_R0_REO2SW7_RING_HP_TP_SW_OFFSET_OFFS                                                        (0x824)
#define HWIO_REO_R0_REO2SW7_RING_HP_TP_SW_OFFSET_RMSK                                                            0xffff
#define HWIO_REO_R0_REO2SW7_RING_HP_TP_SW_OFFSET_POR                                                         0x00000000
#define HWIO_REO_R0_REO2SW7_RING_HP_TP_SW_OFFSET_POR_RMSK                                                    0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_HP_TP_SW_OFFSET_ATTR                                                                     0x3
#define HWIO_REO_R0_REO2SW7_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW7_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_REO2SW7_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW7_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_REO2SW7_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW7_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_REO2SW7_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW7_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_REO2SW7_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_REO2SW7_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                         0xffff
#define HWIO_REO_R0_REO2SW7_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                              0

#define HWIO_REO_R0_REO2SW7_RING_MISC_1_ADDR(x)                                                              ((x) + 0x828)
#define HWIO_REO_R0_REO2SW7_RING_MISC_1_PHYS(x)                                                              ((x) + 0x828)
#define HWIO_REO_R0_REO2SW7_RING_MISC_1_OFFS                                                                 (0x828)
#define HWIO_REO_R0_REO2SW7_RING_MISC_1_RMSK                                                                 0xffff003f
#define HWIO_REO_R0_REO2SW7_RING_MISC_1_POR                                                                  0x00000000
#define HWIO_REO_R0_REO2SW7_RING_MISC_1_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO2SW7_RING_MISC_1_ATTR                                                                              0x3
#define HWIO_REO_R0_REO2SW7_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW7_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_REO2SW7_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW7_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_REO2SW7_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW7_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_REO2SW7_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW7_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_REO2SW7_RING_MISC_1_IN(x))
#define HWIO_REO_R0_REO2SW7_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                        0xffff0000
#define HWIO_REO_R0_REO2SW7_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                16
#define HWIO_REO_R0_REO2SW7_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                               0x3f
#define HWIO_REO_R0_REO2SW7_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                  0

#define HWIO_REO_R0_REO2SW8_RING_BASE_LSB_ADDR(x)                                                            ((x) + 0x82c)
#define HWIO_REO_R0_REO2SW8_RING_BASE_LSB_PHYS(x)                                                            ((x) + 0x82c)
#define HWIO_REO_R0_REO2SW8_RING_BASE_LSB_OFFS                                                               (0x82c)
#define HWIO_REO_R0_REO2SW8_RING_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_BASE_LSB_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW8_RING_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_BASE_LSB_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW8_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW8_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW8_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW8_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW8_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW8_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW8_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW8_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW8_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW8_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                            0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                     0

#define HWIO_REO_R0_REO2SW8_RING_BASE_MSB_ADDR(x)                                                            ((x) + 0x830)
#define HWIO_REO_R0_REO2SW8_RING_BASE_MSB_PHYS(x)                                                            ((x) + 0x830)
#define HWIO_REO_R0_REO2SW8_RING_BASE_MSB_OFFS                                                               (0x830)
#define HWIO_REO_R0_REO2SW8_RING_BASE_MSB_RMSK                                                                0xfffffff
#define HWIO_REO_R0_REO2SW8_RING_BASE_MSB_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW8_RING_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_BASE_MSB_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW8_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW8_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW8_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW8_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW8_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW8_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW8_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW8_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW8_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW8_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xfffff00
#define HWIO_REO_R0_REO2SW8_RING_BASE_MSB_RING_SIZE_SHFT                                                              8
#define HWIO_REO_R0_REO2SW8_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                  0xff
#define HWIO_REO_R0_REO2SW8_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                     0

#define HWIO_REO_R0_REO2SW8_RING_ID_ADDR(x)                                                                  ((x) + 0x834)
#define HWIO_REO_R0_REO2SW8_RING_ID_PHYS(x)                                                                  ((x) + 0x834)
#define HWIO_REO_R0_REO2SW8_RING_ID_OFFS                                                                     (0x834)
#define HWIO_REO_R0_REO2SW8_RING_ID_RMSK                                                                         0xffff
#define HWIO_REO_R0_REO2SW8_RING_ID_POR                                                                      0x00000000
#define HWIO_REO_R0_REO2SW8_RING_ID_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_ID_ATTR                                                                                  0x3
#define HWIO_REO_R0_REO2SW8_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW8_RING_ID_ADDR(x))
#define HWIO_REO_R0_REO2SW8_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW8_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_REO2SW8_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW8_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_REO2SW8_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW8_RING_ID_ADDR(x),m,v,HWIO_REO_R0_REO2SW8_RING_ID_IN(x))
#define HWIO_REO_R0_REO2SW8_RING_ID_RING_ID_BMSK                                                                 0xff00
#define HWIO_REO_R0_REO2SW8_RING_ID_RING_ID_SHFT                                                                      8
#define HWIO_REO_R0_REO2SW8_RING_ID_ENTRY_SIZE_BMSK                                                                0xff
#define HWIO_REO_R0_REO2SW8_RING_ID_ENTRY_SIZE_SHFT                                                                   0

#define HWIO_REO_R0_REO2SW8_RING_STATUS_ADDR(x)                                                              ((x) + 0x838)
#define HWIO_REO_R0_REO2SW8_RING_STATUS_PHYS(x)                                                              ((x) + 0x838)
#define HWIO_REO_R0_REO2SW8_RING_STATUS_OFFS                                                                 (0x838)
#define HWIO_REO_R0_REO2SW8_RING_STATUS_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_STATUS_POR                                                                  0x00000000
#define HWIO_REO_R0_REO2SW8_RING_STATUS_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_STATUS_ATTR                                                                              0x1
#define HWIO_REO_R0_REO2SW8_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW8_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW8_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW8_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW8_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                 0xffff0000
#define HWIO_REO_R0_REO2SW8_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                         16
#define HWIO_REO_R0_REO2SW8_RING_STATUS_NUM_VALID_WORDS_BMSK                                                     0xffff
#define HWIO_REO_R0_REO2SW8_RING_STATUS_NUM_VALID_WORDS_SHFT                                                          0

#define HWIO_REO_R0_REO2SW8_RING_MISC_ADDR(x)                                                                ((x) + 0x83c)
#define HWIO_REO_R0_REO2SW8_RING_MISC_PHYS(x)                                                                ((x) + 0x83c)
#define HWIO_REO_R0_REO2SW8_RING_MISC_OFFS                                                                   (0x83c)
#define HWIO_REO_R0_REO2SW8_RING_MISC_RMSK                                                                    0x7ffffff
#define HWIO_REO_R0_REO2SW8_RING_MISC_POR                                                                    0x00000080
#define HWIO_REO_R0_REO2SW8_RING_MISC_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_MISC_ATTR                                                                                0x3
#define HWIO_REO_R0_REO2SW8_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW8_RING_MISC_ADDR(x))
#define HWIO_REO_R0_REO2SW8_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW8_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_REO2SW8_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW8_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_REO2SW8_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW8_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_REO2SW8_RING_MISC_IN(x))
#define HWIO_REO_R0_REO2SW8_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                            0x4000000
#define HWIO_REO_R0_REO2SW8_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                   26
#define HWIO_REO_R0_REO2SW8_RING_MISC_LOOP_CNT_BMSK                                                           0x3c00000
#define HWIO_REO_R0_REO2SW8_RING_MISC_LOOP_CNT_SHFT                                                                  22
#define HWIO_REO_R0_REO2SW8_RING_MISC_SPARE_CONTROL_BMSK                                                       0x3fc000
#define HWIO_REO_R0_REO2SW8_RING_MISC_SPARE_CONTROL_SHFT                                                             14
#define HWIO_REO_R0_REO2SW8_RING_MISC_SRNG_SM_STATE2_BMSK                                                        0x3000
#define HWIO_REO_R0_REO2SW8_RING_MISC_SRNG_SM_STATE2_SHFT                                                            12
#define HWIO_REO_R0_REO2SW8_RING_MISC_SRNG_SM_STATE1_BMSK                                                         0xf00
#define HWIO_REO_R0_REO2SW8_RING_MISC_SRNG_SM_STATE1_SHFT                                                             8
#define HWIO_REO_R0_REO2SW8_RING_MISC_SRNG_IS_IDLE_BMSK                                                            0x80
#define HWIO_REO_R0_REO2SW8_RING_MISC_SRNG_IS_IDLE_SHFT                                                               7
#define HWIO_REO_R0_REO2SW8_RING_MISC_SRNG_ENABLE_BMSK                                                             0x40
#define HWIO_REO_R0_REO2SW8_RING_MISC_SRNG_ENABLE_SHFT                                                                6
#define HWIO_REO_R0_REO2SW8_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                       0x20
#define HWIO_REO_R0_REO2SW8_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                          5
#define HWIO_REO_R0_REO2SW8_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                        0x10
#define HWIO_REO_R0_REO2SW8_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                           4
#define HWIO_REO_R0_REO2SW8_RING_MISC_MSI_SWAP_BIT_BMSK                                                             0x8
#define HWIO_REO_R0_REO2SW8_RING_MISC_MSI_SWAP_BIT_SHFT                                                               3
#define HWIO_REO_R0_REO2SW8_RING_MISC_SECURITY_BIT_BMSK                                                             0x4
#define HWIO_REO_R0_REO2SW8_RING_MISC_SECURITY_BIT_SHFT                                                               2
#define HWIO_REO_R0_REO2SW8_RING_MISC_LOOPCNT_DISABLE_BMSK                                                          0x2
#define HWIO_REO_R0_REO2SW8_RING_MISC_LOOPCNT_DISABLE_SHFT                                                            1
#define HWIO_REO_R0_REO2SW8_RING_MISC_RING_ID_DISABLE_BMSK                                                          0x1
#define HWIO_REO_R0_REO2SW8_RING_MISC_RING_ID_DISABLE_SHFT                                                            0

#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_LSB_ADDR(x)                                                         ((x) + 0x840)
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_LSB_PHYS(x)                                                         ((x) + 0x840)
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_LSB_OFFS                                                            (0x840)
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_LSB_RMSK                                                            0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_LSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_LSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW8_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW8_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW8_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW8_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW8_RING_HP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                       0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                0

#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_MSB_ADDR(x)                                                         ((x) + 0x844)
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_MSB_PHYS(x)                                                         ((x) + 0x844)
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_MSB_OFFS                                                            (0x844)
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_MSB_RMSK                                                                  0xff
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_MSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_MSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW8_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW8_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW8_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW8_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW8_RING_HP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                             0xff
#define HWIO_REO_R0_REO2SW8_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                0

#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_SETUP_ADDR(x)                                                  ((x) + 0x850)
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_SETUP_PHYS(x)                                                  ((x) + 0x850)
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_SETUP_OFFS                                                     (0x850)
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_SETUP_RMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_SETUP_POR                                                      0x00000000
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_SETUP_POR_RMSK                                                 0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_SETUP_ATTR                                                                  0x3
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                           0xffff0000
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                   16
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                       0x8000
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                           15
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                 0x7fff
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                      0

#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_STATUS_ADDR(x)                                                 ((x) + 0x854)
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_STATUS_PHYS(x)                                                 ((x) + 0x854)
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_STATUS_OFFS                                                    (0x854)
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_STATUS_RMSK                                                    0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_STATUS_POR                                                     0x00000000
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_STATUS_ATTR                                                                 0x1
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                      0xffff0000
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                              16
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                              0x8000
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                  15
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                           0x7fff
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                0

#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                               ((x) + 0x858)
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                               ((x) + 0x858)
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_FULL_COUNTER_OFFS                                                  (0x858)
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_FULL_COUNTER_RMSK                                                       0x3ff
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_FULL_COUNTER_POR                                                   0x00000000
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                              0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_FULL_COUNTER_ATTR                                                               0x3
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW8_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW8_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW8_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW8_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_REO_R0_REO2SW8_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                     0x3ff
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                         0

#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_LSB_ADDR(x)                                                       ((x) + 0x874)
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_LSB_PHYS(x)                                                       ((x) + 0x874)
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_LSB_OFFS                                                          (0x874)
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_MSB_ADDR(x)                                                       ((x) + 0x878)
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_MSB_PHYS(x)                                                       ((x) + 0x878)
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_MSB_OFFS                                                          (0x878)
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_REO2SW8_RING_MSI1_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW8_RING_MSI1_DATA_ADDR(x)                                                           ((x) + 0x87c)
#define HWIO_REO_R0_REO2SW8_RING_MSI1_DATA_PHYS(x)                                                           ((x) + 0x87c)
#define HWIO_REO_R0_REO2SW8_RING_MSI1_DATA_OFFS                                                              (0x87c)
#define HWIO_REO_R0_REO2SW8_RING_MSI1_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_MSI1_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW8_RING_MSI1_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_MSI1_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW8_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW8_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW8_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW8_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW8_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW8_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW8_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW8_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW8_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_REO2SW8_RING_MSI1_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_MSI1_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                 ((x) + 0x880)
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                 ((x) + 0x880)
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_OFFS                                                    (0x880)
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_RMSK                                                    0xffcfffff
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_POR                                                     0x00000000
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_ATTR                                                                 0x3
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                         0xff000000
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                 24
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                          0x800000
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                23
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                        0x400000
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                              22
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                        0xfffff
#define HWIO_REO_R0_REO2SW8_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                              0

#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_LSB_ADDR(x)                                                       ((x) + 0x884)
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_LSB_PHYS(x)                                                       ((x) + 0x884)
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_LSB_OFFS                                                          (0x884)
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_MSB_ADDR(x)                                                       ((x) + 0x888)
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_MSB_PHYS(x)                                                       ((x) + 0x888)
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_MSB_OFFS                                                          (0x888)
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_REO2SW8_RING_MSI2_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW8_RING_MSI2_DATA_ADDR(x)                                                           ((x) + 0x88c)
#define HWIO_REO_R0_REO2SW8_RING_MSI2_DATA_PHYS(x)                                                           ((x) + 0x88c)
#define HWIO_REO_R0_REO2SW8_RING_MSI2_DATA_OFFS                                                              (0x88c)
#define HWIO_REO_R0_REO2SW8_RING_MSI2_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_MSI2_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW8_RING_MSI2_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_MSI2_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW8_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW8_RING_MSI2_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW8_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW8_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW8_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW8_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW8_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW8_RING_MSI2_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW8_RING_MSI2_DATA_IN(x))
#define HWIO_REO_R0_REO2SW8_RING_MSI2_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_MSI2_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_REO2SW8_RING_HP_TP_SW_OFFSET_ADDR(x)                                                     ((x) + 0x89c)
#define HWIO_REO_R0_REO2SW8_RING_HP_TP_SW_OFFSET_PHYS(x)                                                     ((x) + 0x89c)
#define HWIO_REO_R0_REO2SW8_RING_HP_TP_SW_OFFSET_OFFS                                                        (0x89c)
#define HWIO_REO_R0_REO2SW8_RING_HP_TP_SW_OFFSET_RMSK                                                            0xffff
#define HWIO_REO_R0_REO2SW8_RING_HP_TP_SW_OFFSET_POR                                                         0x00000000
#define HWIO_REO_R0_REO2SW8_RING_HP_TP_SW_OFFSET_POR_RMSK                                                    0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_HP_TP_SW_OFFSET_ATTR                                                                     0x3
#define HWIO_REO_R0_REO2SW8_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW8_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_REO2SW8_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW8_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_REO2SW8_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW8_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_REO2SW8_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW8_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_REO2SW8_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_REO2SW8_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                         0xffff
#define HWIO_REO_R0_REO2SW8_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                              0

#define HWIO_REO_R0_REO2SW8_RING_MISC_1_ADDR(x)                                                              ((x) + 0x8a0)
#define HWIO_REO_R0_REO2SW8_RING_MISC_1_PHYS(x)                                                              ((x) + 0x8a0)
#define HWIO_REO_R0_REO2SW8_RING_MISC_1_OFFS                                                                 (0x8a0)
#define HWIO_REO_R0_REO2SW8_RING_MISC_1_RMSK                                                                 0xffff003f
#define HWIO_REO_R0_REO2SW8_RING_MISC_1_POR                                                                  0x00000000
#define HWIO_REO_R0_REO2SW8_RING_MISC_1_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO2SW8_RING_MISC_1_ATTR                                                                              0x3
#define HWIO_REO_R0_REO2SW8_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW8_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_REO2SW8_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW8_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_REO2SW8_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW8_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_REO2SW8_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW8_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_REO2SW8_RING_MISC_1_IN(x))
#define HWIO_REO_R0_REO2SW8_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                        0xffff0000
#define HWIO_REO_R0_REO2SW8_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                16
#define HWIO_REO_R0_REO2SW8_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                               0x3f
#define HWIO_REO_R0_REO2SW8_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                  0

#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_ADDR(x)                                                            ((x) + 0x8a4)
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_PHYS(x)                                                            ((x) + 0x8a4)
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_OFFS                                                               (0x8a4)
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                            0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                     0

#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_ADDR(x)                                                            ((x) + 0x8a8)
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_PHYS(x)                                                            ((x) + 0x8a8)
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_OFFS                                                               (0x8a8)
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_RMSK                                                                0xfffffff
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xfffff00
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_RING_SIZE_SHFT                                                              8
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                  0xff
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                     0

#define HWIO_REO_R0_REO2SW0_RING_ID_ADDR(x)                                                                  ((x) + 0x8ac)
#define HWIO_REO_R0_REO2SW0_RING_ID_PHYS(x)                                                                  ((x) + 0x8ac)
#define HWIO_REO_R0_REO2SW0_RING_ID_OFFS                                                                     (0x8ac)
#define HWIO_REO_R0_REO2SW0_RING_ID_RMSK                                                                         0xffff
#define HWIO_REO_R0_REO2SW0_RING_ID_POR                                                                      0x00000000
#define HWIO_REO_R0_REO2SW0_RING_ID_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_ID_ATTR                                                                                  0x3
#define HWIO_REO_R0_REO2SW0_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_ID_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_ID_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_ID_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_ID_RING_ID_BMSK                                                                 0xff00
#define HWIO_REO_R0_REO2SW0_RING_ID_RING_ID_SHFT                                                                      8
#define HWIO_REO_R0_REO2SW0_RING_ID_ENTRY_SIZE_BMSK                                                                0xff
#define HWIO_REO_R0_REO2SW0_RING_ID_ENTRY_SIZE_SHFT                                                                   0

#define HWIO_REO_R0_REO2SW0_RING_STATUS_ADDR(x)                                                              ((x) + 0x8b0)
#define HWIO_REO_R0_REO2SW0_RING_STATUS_PHYS(x)                                                              ((x) + 0x8b0)
#define HWIO_REO_R0_REO2SW0_RING_STATUS_OFFS                                                                 (0x8b0)
#define HWIO_REO_R0_REO2SW0_RING_STATUS_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_STATUS_POR                                                                  0x00000000
#define HWIO_REO_R0_REO2SW0_RING_STATUS_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_STATUS_ATTR                                                                              0x1
#define HWIO_REO_R0_REO2SW0_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                 0xffff0000
#define HWIO_REO_R0_REO2SW0_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                         16
#define HWIO_REO_R0_REO2SW0_RING_STATUS_NUM_VALID_WORDS_BMSK                                                     0xffff
#define HWIO_REO_R0_REO2SW0_RING_STATUS_NUM_VALID_WORDS_SHFT                                                          0

#define HWIO_REO_R0_REO2SW0_RING_MISC_ADDR(x)                                                                ((x) + 0x8b4)
#define HWIO_REO_R0_REO2SW0_RING_MISC_PHYS(x)                                                                ((x) + 0x8b4)
#define HWIO_REO_R0_REO2SW0_RING_MISC_OFFS                                                                   (0x8b4)
#define HWIO_REO_R0_REO2SW0_RING_MISC_RMSK                                                                    0x7ffffff
#define HWIO_REO_R0_REO2SW0_RING_MISC_POR                                                                    0x00000080
#define HWIO_REO_R0_REO2SW0_RING_MISC_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MISC_ATTR                                                                                0x3
#define HWIO_REO_R0_REO2SW0_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_MISC_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_MISC_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                            0x4000000
#define HWIO_REO_R0_REO2SW0_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                   26
#define HWIO_REO_R0_REO2SW0_RING_MISC_LOOP_CNT_BMSK                                                           0x3c00000
#define HWIO_REO_R0_REO2SW0_RING_MISC_LOOP_CNT_SHFT                                                                  22
#define HWIO_REO_R0_REO2SW0_RING_MISC_SPARE_CONTROL_BMSK                                                       0x3fc000
#define HWIO_REO_R0_REO2SW0_RING_MISC_SPARE_CONTROL_SHFT                                                             14
#define HWIO_REO_R0_REO2SW0_RING_MISC_SRNG_SM_STATE2_BMSK                                                        0x3000
#define HWIO_REO_R0_REO2SW0_RING_MISC_SRNG_SM_STATE2_SHFT                                                            12
#define HWIO_REO_R0_REO2SW0_RING_MISC_SRNG_SM_STATE1_BMSK                                                         0xf00
#define HWIO_REO_R0_REO2SW0_RING_MISC_SRNG_SM_STATE1_SHFT                                                             8
#define HWIO_REO_R0_REO2SW0_RING_MISC_SRNG_IS_IDLE_BMSK                                                            0x80
#define HWIO_REO_R0_REO2SW0_RING_MISC_SRNG_IS_IDLE_SHFT                                                               7
#define HWIO_REO_R0_REO2SW0_RING_MISC_SRNG_ENABLE_BMSK                                                             0x40
#define HWIO_REO_R0_REO2SW0_RING_MISC_SRNG_ENABLE_SHFT                                                                6
#define HWIO_REO_R0_REO2SW0_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                       0x20
#define HWIO_REO_R0_REO2SW0_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                          5
#define HWIO_REO_R0_REO2SW0_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                        0x10
#define HWIO_REO_R0_REO2SW0_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                           4
#define HWIO_REO_R0_REO2SW0_RING_MISC_MSI_SWAP_BIT_BMSK                                                             0x8
#define HWIO_REO_R0_REO2SW0_RING_MISC_MSI_SWAP_BIT_SHFT                                                               3
#define HWIO_REO_R0_REO2SW0_RING_MISC_SECURITY_BIT_BMSK                                                             0x4
#define HWIO_REO_R0_REO2SW0_RING_MISC_SECURITY_BIT_SHFT                                                               2
#define HWIO_REO_R0_REO2SW0_RING_MISC_LOOPCNT_DISABLE_BMSK                                                          0x2
#define HWIO_REO_R0_REO2SW0_RING_MISC_LOOPCNT_DISABLE_SHFT                                                            1
#define HWIO_REO_R0_REO2SW0_RING_MISC_RING_ID_DISABLE_BMSK                                                          0x1
#define HWIO_REO_R0_REO2SW0_RING_MISC_RING_ID_DISABLE_SHFT                                                            0

#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_ADDR(x)                                                         ((x) + 0x8b8)
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_PHYS(x)                                                         ((x) + 0x8b8)
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_OFFS                                                            (0x8b8)
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_RMSK                                                            0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                       0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                0

#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_ADDR(x)                                                         ((x) + 0x8bc)
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_PHYS(x)                                                         ((x) + 0x8bc)
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_OFFS                                                            (0x8bc)
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_RMSK                                                                  0xff
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                             0xff
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                0

#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_ADDR(x)                                                  ((x) + 0x8c8)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_PHYS(x)                                                  ((x) + 0x8c8)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_OFFS                                                     (0x8c8)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_RMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_POR                                                      0x00000000
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_POR_RMSK                                                 0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_ATTR                                                                  0x3
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                           0xffff0000
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                   16
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                       0x8000
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                           15
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                 0x7fff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                      0

#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_ADDR(x)                                                 ((x) + 0x8cc)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_PHYS(x)                                                 ((x) + 0x8cc)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_OFFS                                                    (0x8cc)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_RMSK                                                    0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_POR                                                     0x00000000
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_ATTR                                                                 0x1
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                      0xffff0000
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                              16
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                              0x8000
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                  15
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                           0x7fff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                0

#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                               ((x) + 0x8d0)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                               ((x) + 0x8d0)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_OFFS                                                  (0x8d0)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_RMSK                                                       0x3ff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_POR                                                   0x00000000
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                              0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_ATTR                                                               0x3
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                     0x3ff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                         0

#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_ADDR(x)                                                       ((x) + 0x8ec)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_PHYS(x)                                                       ((x) + 0x8ec)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_OFFS                                                          (0x8ec)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_ADDR(x)                                                       ((x) + 0x8f0)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_PHYS(x)                                                       ((x) + 0x8f0)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_OFFS                                                          (0x8f0)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_ADDR(x)                                                           ((x) + 0x8f4)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_PHYS(x)                                                           ((x) + 0x8f4)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_OFFS                                                              (0x8f4)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                 ((x) + 0x8f8)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                 ((x) + 0x8f8)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_OFFS                                                    (0x8f8)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_RMSK                                                    0xffcfffff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_POR                                                     0x00000000
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_ATTR                                                                 0x3
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                         0xff000000
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                 24
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                          0x800000
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                23
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                        0x400000
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                              22
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                        0xfffff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                              0

#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_ADDR(x)                                                       ((x) + 0x8fc)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_PHYS(x)                                                       ((x) + 0x8fc)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_OFFS                                                          (0x8fc)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_ADDR(x)                                                       ((x) + 0x900)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_PHYS(x)                                                       ((x) + 0x900)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_OFFS                                                          (0x900)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_ADDR(x)                                                           ((x) + 0x904)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_PHYS(x)                                                           ((x) + 0x904)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_OFFS                                                              (0x904)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_ADDR(x)                                                     ((x) + 0x914)
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_PHYS(x)                                                     ((x) + 0x914)
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_OFFS                                                        (0x914)
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_RMSK                                                            0xffff
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_POR                                                         0x00000000
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_POR_RMSK                                                    0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_ATTR                                                                     0x3
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                         0xffff
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                              0

#define HWIO_REO_R0_REO2SW0_RING_MISC_1_ADDR(x)                                                              ((x) + 0x918)
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_PHYS(x)                                                              ((x) + 0x918)
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_OFFS                                                                 (0x918)
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_RMSK                                                                 0xffff003f
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_POR                                                                  0x00000000
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_ATTR                                                                              0x3
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_MISC_1_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                        0xffff0000
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                16
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                               0x3f
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                  0

#define HWIO_REO_R0_REO2PPE_RING_BASE_LSB_ADDR(x)                                                            ((x) + 0x91c)
#define HWIO_REO_R0_REO2PPE_RING_BASE_LSB_PHYS(x)                                                            ((x) + 0x91c)
#define HWIO_REO_R0_REO2PPE_RING_BASE_LSB_OFFS                                                               (0x91c)
#define HWIO_REO_R0_REO2PPE_RING_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_BASE_LSB_POR                                                                0x00000000
#define HWIO_REO_R0_REO2PPE_RING_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_BASE_LSB_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2PPE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2PPE_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2PPE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2PPE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2PPE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2PPE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2PPE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2PPE_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2PPE_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2PPE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                            0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                     0

#define HWIO_REO_R0_REO2PPE_RING_BASE_MSB_ADDR(x)                                                            ((x) + 0x920)
#define HWIO_REO_R0_REO2PPE_RING_BASE_MSB_PHYS(x)                                                            ((x) + 0x920)
#define HWIO_REO_R0_REO2PPE_RING_BASE_MSB_OFFS                                                               (0x920)
#define HWIO_REO_R0_REO2PPE_RING_BASE_MSB_RMSK                                                                0xfffffff
#define HWIO_REO_R0_REO2PPE_RING_BASE_MSB_POR                                                                0x00000000
#define HWIO_REO_R0_REO2PPE_RING_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_BASE_MSB_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2PPE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2PPE_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2PPE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2PPE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2PPE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2PPE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2PPE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2PPE_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2PPE_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2PPE_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xfffff00
#define HWIO_REO_R0_REO2PPE_RING_BASE_MSB_RING_SIZE_SHFT                                                              8
#define HWIO_REO_R0_REO2PPE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                  0xff
#define HWIO_REO_R0_REO2PPE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                     0

#define HWIO_REO_R0_REO2PPE_RING_ID_ADDR(x)                                                                  ((x) + 0x924)
#define HWIO_REO_R0_REO2PPE_RING_ID_PHYS(x)                                                                  ((x) + 0x924)
#define HWIO_REO_R0_REO2PPE_RING_ID_OFFS                                                                     (0x924)
#define HWIO_REO_R0_REO2PPE_RING_ID_RMSK                                                                         0xffff
#define HWIO_REO_R0_REO2PPE_RING_ID_POR                                                                      0x00000000
#define HWIO_REO_R0_REO2PPE_RING_ID_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_ID_ATTR                                                                                  0x3
#define HWIO_REO_R0_REO2PPE_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_REO2PPE_RING_ID_ADDR(x))
#define HWIO_REO_R0_REO2PPE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2PPE_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_REO2PPE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2PPE_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_REO2PPE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2PPE_RING_ID_ADDR(x),m,v,HWIO_REO_R0_REO2PPE_RING_ID_IN(x))
#define HWIO_REO_R0_REO2PPE_RING_ID_RING_ID_BMSK                                                                 0xff00
#define HWIO_REO_R0_REO2PPE_RING_ID_RING_ID_SHFT                                                                      8
#define HWIO_REO_R0_REO2PPE_RING_ID_ENTRY_SIZE_BMSK                                                                0xff
#define HWIO_REO_R0_REO2PPE_RING_ID_ENTRY_SIZE_SHFT                                                                   0

#define HWIO_REO_R0_REO2PPE_RING_STATUS_ADDR(x)                                                              ((x) + 0x928)
#define HWIO_REO_R0_REO2PPE_RING_STATUS_PHYS(x)                                                              ((x) + 0x928)
#define HWIO_REO_R0_REO2PPE_RING_STATUS_OFFS                                                                 (0x928)
#define HWIO_REO_R0_REO2PPE_RING_STATUS_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_STATUS_POR                                                                  0x00000000
#define HWIO_REO_R0_REO2PPE_RING_STATUS_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_STATUS_ATTR                                                                              0x1
#define HWIO_REO_R0_REO2PPE_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2PPE_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2PPE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2PPE_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2PPE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                 0xffff0000
#define HWIO_REO_R0_REO2PPE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                         16
#define HWIO_REO_R0_REO2PPE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                     0xffff
#define HWIO_REO_R0_REO2PPE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                          0

#define HWIO_REO_R0_REO2PPE_RING_MISC_ADDR(x)                                                                ((x) + 0x92c)
#define HWIO_REO_R0_REO2PPE_RING_MISC_PHYS(x)                                                                ((x) + 0x92c)
#define HWIO_REO_R0_REO2PPE_RING_MISC_OFFS                                                                   (0x92c)
#define HWIO_REO_R0_REO2PPE_RING_MISC_RMSK                                                                    0x7ffffff
#define HWIO_REO_R0_REO2PPE_RING_MISC_POR                                                                    0x00000080
#define HWIO_REO_R0_REO2PPE_RING_MISC_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_MISC_ATTR                                                                                0x3
#define HWIO_REO_R0_REO2PPE_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_REO2PPE_RING_MISC_ADDR(x))
#define HWIO_REO_R0_REO2PPE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2PPE_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_REO2PPE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2PPE_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_REO2PPE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2PPE_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_REO2PPE_RING_MISC_IN(x))
#define HWIO_REO_R0_REO2PPE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                            0x4000000
#define HWIO_REO_R0_REO2PPE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                   26
#define HWIO_REO_R0_REO2PPE_RING_MISC_LOOP_CNT_BMSK                                                           0x3c00000
#define HWIO_REO_R0_REO2PPE_RING_MISC_LOOP_CNT_SHFT                                                                  22
#define HWIO_REO_R0_REO2PPE_RING_MISC_SPARE_CONTROL_BMSK                                                       0x3fc000
#define HWIO_REO_R0_REO2PPE_RING_MISC_SPARE_CONTROL_SHFT                                                             14
#define HWIO_REO_R0_REO2PPE_RING_MISC_SRNG_SM_STATE2_BMSK                                                        0x3000
#define HWIO_REO_R0_REO2PPE_RING_MISC_SRNG_SM_STATE2_SHFT                                                            12
#define HWIO_REO_R0_REO2PPE_RING_MISC_SRNG_SM_STATE1_BMSK                                                         0xf00
#define HWIO_REO_R0_REO2PPE_RING_MISC_SRNG_SM_STATE1_SHFT                                                             8
#define HWIO_REO_R0_REO2PPE_RING_MISC_SRNG_IS_IDLE_BMSK                                                            0x80
#define HWIO_REO_R0_REO2PPE_RING_MISC_SRNG_IS_IDLE_SHFT                                                               7
#define HWIO_REO_R0_REO2PPE_RING_MISC_SRNG_ENABLE_BMSK                                                             0x40
#define HWIO_REO_R0_REO2PPE_RING_MISC_SRNG_ENABLE_SHFT                                                                6
#define HWIO_REO_R0_REO2PPE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                       0x20
#define HWIO_REO_R0_REO2PPE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                          5
#define HWIO_REO_R0_REO2PPE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                        0x10
#define HWIO_REO_R0_REO2PPE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                           4
#define HWIO_REO_R0_REO2PPE_RING_MISC_MSI_SWAP_BIT_BMSK                                                             0x8
#define HWIO_REO_R0_REO2PPE_RING_MISC_MSI_SWAP_BIT_SHFT                                                               3
#define HWIO_REO_R0_REO2PPE_RING_MISC_SECURITY_BIT_BMSK                                                             0x4
#define HWIO_REO_R0_REO2PPE_RING_MISC_SECURITY_BIT_SHFT                                                               2
#define HWIO_REO_R0_REO2PPE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                          0x2
#define HWIO_REO_R0_REO2PPE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                            1
#define HWIO_REO_R0_REO2PPE_RING_MISC_RING_ID_DISABLE_BMSK                                                          0x1
#define HWIO_REO_R0_REO2PPE_RING_MISC_RING_ID_DISABLE_SHFT                                                            0

#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_LSB_ADDR(x)                                                         ((x) + 0x930)
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_LSB_PHYS(x)                                                         ((x) + 0x930)
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_LSB_OFFS                                                            (0x930)
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_LSB_RMSK                                                            0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_LSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_LSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2PPE_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2PPE_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2PPE_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2PPE_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2PPE_RING_HP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                       0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                0

#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_MSB_ADDR(x)                                                         ((x) + 0x934)
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_MSB_PHYS(x)                                                         ((x) + 0x934)
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_MSB_OFFS                                                            (0x934)
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_MSB_RMSK                                                                  0xff
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_MSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_MSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2PPE_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2PPE_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2PPE_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2PPE_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2PPE_RING_HP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                             0xff
#define HWIO_REO_R0_REO2PPE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                0

#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_SETUP_ADDR(x)                                                  ((x) + 0x940)
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_SETUP_PHYS(x)                                                  ((x) + 0x940)
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_SETUP_OFFS                                                     (0x940)
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_SETUP_RMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_SETUP_POR                                                      0x00000000
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_SETUP_POR_RMSK                                                 0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_SETUP_ATTR                                                                  0x3
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                           0xffff0000
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                   16
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                       0x8000
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                           15
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                 0x7fff
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                      0

#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_STATUS_ADDR(x)                                                 ((x) + 0x944)
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_STATUS_PHYS(x)                                                 ((x) + 0x944)
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_STATUS_OFFS                                                    (0x944)
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_STATUS_RMSK                                                    0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_STATUS_POR                                                     0x00000000
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_STATUS_ATTR                                                                 0x1
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                      0xffff0000
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                              16
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                              0x8000
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                  15
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                           0x7fff
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                0

#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                               ((x) + 0x948)
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                               ((x) + 0x948)
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_FULL_COUNTER_OFFS                                                  (0x948)
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_FULL_COUNTER_RMSK                                                       0x3ff
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_FULL_COUNTER_POR                                                   0x00000000
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                              0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_FULL_COUNTER_ATTR                                                               0x3
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_REO2PPE_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2PPE_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2PPE_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2PPE_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_REO_R0_REO2PPE_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                     0x3ff
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                         0

#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_LSB_ADDR(x)                                                       ((x) + 0x964)
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_LSB_PHYS(x)                                                       ((x) + 0x964)
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_LSB_OFFS                                                          (0x964)
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_MSB_ADDR(x)                                                       ((x) + 0x968)
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_MSB_PHYS(x)                                                       ((x) + 0x968)
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_MSB_OFFS                                                          (0x968)
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_REO2PPE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2PPE_RING_MSI1_DATA_ADDR(x)                                                           ((x) + 0x96c)
#define HWIO_REO_R0_REO2PPE_RING_MSI1_DATA_PHYS(x)                                                           ((x) + 0x96c)
#define HWIO_REO_R0_REO2PPE_RING_MSI1_DATA_OFFS                                                              (0x96c)
#define HWIO_REO_R0_REO2PPE_RING_MSI1_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_MSI1_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_REO2PPE_RING_MSI1_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_MSI1_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2PPE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2PPE_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_REO2PPE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2PPE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2PPE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2PPE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2PPE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2PPE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2PPE_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_REO2PPE_RING_MSI1_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_MSI1_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                 ((x) + 0x970)
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                 ((x) + 0x970)
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_OFFS                                                    (0x970)
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_RMSK                                                    0xffcfffff
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_POR                                                     0x00000000
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_ATTR                                                                 0x3
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                         0xff000000
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                 24
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                          0x800000
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                23
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                        0x400000
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                              22
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                        0xfffff
#define HWIO_REO_R0_REO2PPE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                              0

#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_LSB_ADDR(x)                                                       ((x) + 0x974)
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_LSB_PHYS(x)                                                       ((x) + 0x974)
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_LSB_OFFS                                                          (0x974)
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_LSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_LSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_MSB_ADDR(x)                                                       ((x) + 0x978)
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_MSB_PHYS(x)                                                       ((x) + 0x978)
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_MSB_OFFS                                                          (0x978)
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_MSB_POR                                                           0x00000000
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_MSB_ATTR                                                                       0x3
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                   0x100
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                       8
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_REO_R0_REO2PPE_RING_MSI2_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_REO_R0_REO2PPE_RING_MSI2_DATA_ADDR(x)                                                           ((x) + 0x97c)
#define HWIO_REO_R0_REO2PPE_RING_MSI2_DATA_PHYS(x)                                                           ((x) + 0x97c)
#define HWIO_REO_R0_REO2PPE_RING_MSI2_DATA_OFFS                                                              (0x97c)
#define HWIO_REO_R0_REO2PPE_RING_MSI2_DATA_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_MSI2_DATA_POR                                                               0x00000000
#define HWIO_REO_R0_REO2PPE_RING_MSI2_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_MSI2_DATA_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2PPE_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2PPE_RING_MSI2_DATA_ADDR(x))
#define HWIO_REO_R0_REO2PPE_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2PPE_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2PPE_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2PPE_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2PPE_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2PPE_RING_MSI2_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2PPE_RING_MSI2_DATA_IN(x))
#define HWIO_REO_R0_REO2PPE_RING_MSI2_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_MSI2_DATA_VALUE_SHFT                                                                 0

#define HWIO_REO_R0_REO2PPE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                     ((x) + 0x98c)
#define HWIO_REO_R0_REO2PPE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                     ((x) + 0x98c)
#define HWIO_REO_R0_REO2PPE_RING_HP_TP_SW_OFFSET_OFFS                                                        (0x98c)
#define HWIO_REO_R0_REO2PPE_RING_HP_TP_SW_OFFSET_RMSK                                                            0xffff
#define HWIO_REO_R0_REO2PPE_RING_HP_TP_SW_OFFSET_POR                                                         0x00000000
#define HWIO_REO_R0_REO2PPE_RING_HP_TP_SW_OFFSET_POR_RMSK                                                    0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_HP_TP_SW_OFFSET_ATTR                                                                     0x3
#define HWIO_REO_R0_REO2PPE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_REO2PPE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_REO2PPE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2PPE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_REO2PPE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2PPE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_REO2PPE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2PPE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_REO2PPE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_REO2PPE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                         0xffff
#define HWIO_REO_R0_REO2PPE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                              0

#define HWIO_REO_R0_REO2PPE_RING_MISC_1_ADDR(x)                                                              ((x) + 0x990)
#define HWIO_REO_R0_REO2PPE_RING_MISC_1_PHYS(x)                                                              ((x) + 0x990)
#define HWIO_REO_R0_REO2PPE_RING_MISC_1_OFFS                                                                 (0x990)
#define HWIO_REO_R0_REO2PPE_RING_MISC_1_RMSK                                                                 0xffff003f
#define HWIO_REO_R0_REO2PPE_RING_MISC_1_POR                                                                  0x00000000
#define HWIO_REO_R0_REO2PPE_RING_MISC_1_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO2PPE_RING_MISC_1_ATTR                                                                              0x3
#define HWIO_REO_R0_REO2PPE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_REO2PPE_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_REO2PPE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2PPE_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_REO2PPE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2PPE_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_REO2PPE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2PPE_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_REO2PPE_RING_MISC_1_IN(x))
#define HWIO_REO_R0_REO2PPE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                        0xffff0000
#define HWIO_REO_R0_REO2PPE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                16
#define HWIO_REO_R0_REO2PPE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                               0x3f
#define HWIO_REO_R0_REO2PPE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                  0

#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_ADDR(x)                                                         ((x) + 0xa84)

#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_PHYS(x)                                                         ((x) + 0xa84)
#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_OFFS                                                            (0xa84)
#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_RMSK                                                            0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                         0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                  0

#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_ADDR(x)                                                         ((x) + 0xa88)
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_PHYS(x)                                                         ((x) + 0xa88)
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_OFFS                                                            (0xa88)
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_RMSK                                                              0xffffff
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_POR                                                             0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_ATTR                                                                         0x3
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_RING_SIZE_BMSK                                                    0xffff00
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_RING_SIZE_SHFT                                                           8
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                               0xff
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                  0

#define HWIO_REO_R0_REO_STATUS_RING_ID_ADDR(x)                                                               ((x) + 0xa8c)
#define HWIO_REO_R0_REO_STATUS_RING_ID_PHYS(x)                                                               ((x) + 0xa8c)
#define HWIO_REO_R0_REO_STATUS_RING_ID_OFFS                                                                  (0xa8c)
#define HWIO_REO_R0_REO_STATUS_RING_ID_RMSK                                                                      0xffff
#define HWIO_REO_R0_REO_STATUS_RING_ID_POR                                                                   0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_ID_POR_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_ID_ATTR                                                                               0x3
#define HWIO_REO_R0_REO_STATUS_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_ID_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_ID_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_ID_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_ID_RING_ID_BMSK                                                              0xff00
#define HWIO_REO_R0_REO_STATUS_RING_ID_RING_ID_SHFT                                                                   8
#define HWIO_REO_R0_REO_STATUS_RING_ID_ENTRY_SIZE_BMSK                                                             0xff
#define HWIO_REO_R0_REO_STATUS_RING_ID_ENTRY_SIZE_SHFT                                                                0

#define HWIO_REO_R0_REO_STATUS_RING_STATUS_ADDR(x)                                                           ((x) + 0xa90)
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_PHYS(x)                                                           ((x) + 0xa90)
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_OFFS                                                              (0xa90)
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_POR                                                               0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_ATTR                                                                           0x1
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                              0xffff0000
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                      16
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_NUM_VALID_WORDS_BMSK                                                  0xffff
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_NUM_VALID_WORDS_SHFT                                                       0

#define HWIO_REO_R0_REO_STATUS_RING_MISC_ADDR(x)                                                             ((x) + 0xa94)
#define HWIO_REO_R0_REO_STATUS_RING_MISC_PHYS(x)                                                             ((x) + 0xa94)
#define HWIO_REO_R0_REO_STATUS_RING_MISC_OFFS                                                                (0xa94)
#define HWIO_REO_R0_REO_STATUS_RING_MISC_RMSK                                                                 0x7ffffff
#define HWIO_REO_R0_REO_STATUS_RING_MISC_POR                                                                 0x00000080
#define HWIO_REO_R0_REO_STATUS_RING_MISC_POR_RMSK                                                            0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MISC_ATTR                                                                             0x3
#define HWIO_REO_R0_REO_STATUS_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_MISC_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_MISC_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                         0x4000000
#define HWIO_REO_R0_REO_STATUS_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                26
#define HWIO_REO_R0_REO_STATUS_RING_MISC_LOOP_CNT_BMSK                                                        0x3c00000
#define HWIO_REO_R0_REO_STATUS_RING_MISC_LOOP_CNT_SHFT                                                               22
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SPARE_CONTROL_BMSK                                                    0x3fc000
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SPARE_CONTROL_SHFT                                                          14
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SRNG_SM_STATE2_BMSK                                                     0x3000
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SRNG_SM_STATE2_SHFT                                                         12
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SRNG_SM_STATE1_BMSK                                                      0xf00
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SRNG_SM_STATE1_SHFT                                                          8
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SRNG_IS_IDLE_BMSK                                                         0x80
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SRNG_IS_IDLE_SHFT                                                            7
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SRNG_ENABLE_BMSK                                                          0x40
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SRNG_ENABLE_SHFT                                                             6
#define HWIO_REO_R0_REO_STATUS_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                    0x20
#define HWIO_REO_R0_REO_STATUS_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                       5
#define HWIO_REO_R0_REO_STATUS_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                     0x10
#define HWIO_REO_R0_REO_STATUS_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                        4
#define HWIO_REO_R0_REO_STATUS_RING_MISC_MSI_SWAP_BIT_BMSK                                                          0x8
#define HWIO_REO_R0_REO_STATUS_RING_MISC_MSI_SWAP_BIT_SHFT                                                            3
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SECURITY_BIT_BMSK                                                          0x4
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SECURITY_BIT_SHFT                                                            2
#define HWIO_REO_R0_REO_STATUS_RING_MISC_LOOPCNT_DISABLE_BMSK                                                       0x2
#define HWIO_REO_R0_REO_STATUS_RING_MISC_LOOPCNT_DISABLE_SHFT                                                         1
#define HWIO_REO_R0_REO_STATUS_RING_MISC_RING_ID_DISABLE_BMSK                                                       0x1
#define HWIO_REO_R0_REO_STATUS_RING_MISC_RING_ID_DISABLE_SHFT                                                         0

#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_ADDR(x)                                                      ((x) + 0xa98)
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_PHYS(x)                                                      ((x) + 0xa98)
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_OFFS                                                         (0xa98)
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_RMSK                                                         0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_POR                                                          0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_ATTR                                                                      0x3
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                    0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                             0

#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_ADDR(x)                                                      ((x) + 0xa9c)
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_PHYS(x)                                                      ((x) + 0xa9c)
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_OFFS                                                         (0xa9c)
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_RMSK                                                               0xff
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_POR                                                          0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_ATTR                                                                      0x3
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                          0xff
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                             0

#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_ADDR(x)                                               ((x) + 0xaa8)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_PHYS(x)                                               ((x) + 0xaa8)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_OFFS                                                  (0xaa8)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_RMSK                                                  0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_POR                                                   0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_POR_RMSK                                              0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_ATTR                                                               0x3
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                        0xffff0000
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                16
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                    0x8000
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                        15
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                              0x7fff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                   0

#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_ADDR(x)                                              ((x) + 0xaac)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_PHYS(x)                                              ((x) + 0xaac)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_OFFS                                                 (0xaac)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_RMSK                                                 0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_POR                                                  0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_POR_RMSK                                             0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_ATTR                                                              0x1
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                   0xffff0000
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                           16
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                           0x8000
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                               15
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                        0x7fff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                             0

#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                            ((x) + 0xab0)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                            ((x) + 0xab0)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_OFFS                                               (0xab0)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_RMSK                                                    0x3ff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_POR                                                0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                           0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_ATTR                                                            0x3
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                  0x3ff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                      0

#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_ADDR(x)                                                    ((x) + 0xacc)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_PHYS(x)                                                    ((x) + 0xacc)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_OFFS                                                       (0xacc)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_RMSK                                                       0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_POR                                                        0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_POR_RMSK                                                   0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_ATTR                                                                    0x3
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_ADDR_BMSK                                                  0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_ADDR_SHFT                                                           0

#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_ADDR(x)                                                    ((x) + 0xad0)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_PHYS(x)                                                    ((x) + 0xad0)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_OFFS                                                       (0xad0)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_RMSK                                                            0x1ff
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_POR                                                        0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_POR_RMSK                                                   0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_ATTR                                                                    0x3
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                0x100
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                    8
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_ADDR_BMSK                                                        0xff
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_ADDR_SHFT                                                           0

#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_ADDR(x)                                                        ((x) + 0xad4)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_PHYS(x)                                                        ((x) + 0xad4)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_OFFS                                                           (0xad4)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_POR                                                            0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_POR_RMSK                                                       0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_ATTR                                                                        0x3
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_VALUE_BMSK                                                     0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_VALUE_SHFT                                                              0

#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_ADDR(x)                                              ((x) + 0xad8)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_PHYS(x)                                              ((x) + 0xad8)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_OFFS                                                 (0xad8)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_RMSK                                                 0xffc0ffff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_POR                                                  0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_POR_RMSK                                             0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_ATTR                                                              0x3
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                      0xff000000
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                              24
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                       0x800000
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                             23
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                     0x400000
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                           22
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                      0xffff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                           0

#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_ADDR(x)                                                    ((x) + 0xadc)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_PHYS(x)                                                    ((x) + 0xadc)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_OFFS                                                       (0xadc)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_RMSK                                                       0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_POR                                                        0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_POR_RMSK                                                   0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_ATTR                                                                    0x3
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_ADDR_BMSK                                                  0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_ADDR_SHFT                                                           0

#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_ADDR(x)                                                    ((x) + 0xae0)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_PHYS(x)                                                    ((x) + 0xae0)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_OFFS                                                       (0xae0)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_RMSK                                                            0x1ff
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_POR                                                        0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_POR_RMSK                                                   0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_ATTR                                                                    0x3
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                0x100
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                    8
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_ADDR_BMSK                                                        0xff
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_ADDR_SHFT                                                           0

#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_ADDR(x)                                                        ((x) + 0xae4)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_PHYS(x)                                                        ((x) + 0xae4)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_OFFS                                                           (0xae4)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_POR                                                            0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_POR_RMSK                                                       0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_ATTR                                                                        0x3
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_VALUE_BMSK                                                     0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_VALUE_SHFT                                                              0

#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_ADDR(x)                                                  ((x) + 0xaf4)
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_PHYS(x)                                                  ((x) + 0xaf4)
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_OFFS                                                     (0xaf4)
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_RMSK                                                         0xffff
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_POR                                                      0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_POR_RMSK                                                 0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_ATTR                                                                  0x3
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                      0xffff
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                           0

#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_ADDR(x)                                                           ((x) + 0xaf8)
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_PHYS(x)                                                           ((x) + 0xaf8)
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_OFFS                                                              (0xaf8)
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_RMSK                                                              0xffff003f
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_POR                                                               0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_ATTR                                                                           0x3
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_MISC_1_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                     0xffff0000
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                             16
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                            0x3f
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                               0

#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_ADDR(x)                                                             ((x) + 0xb08)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_PHYS(x)                                                             ((x) + 0xb08)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_OFFS                                                                (0xb08)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_RMSK                                                                0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_POR                                                                 0x000186a0
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_POR_RMSK                                                            0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_ATTR                                                                             0x3
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_THRESHOLD_IX_0_ADDR(x))
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_THRESHOLD_IX_0_ADDR(x), m)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_AGING_THRESHOLD_IX_0_ADDR(x),v)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_AGING_THRESHOLD_IX_0_ADDR(x),m,v,HWIO_REO_R0_AGING_THRESHOLD_IX_0_IN(x))
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_AGING_THRESHOLD_AC0_BMSK                                            0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_AGING_THRESHOLD_AC0_SHFT                                                     0

#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_ADDR(x)                                                             ((x) + 0xb0c)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_PHYS(x)                                                             ((x) + 0xb0c)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_OFFS                                                                (0xb0c)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_RMSK                                                                0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_POR                                                                 0x000186a0
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_POR_RMSK                                                            0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_ATTR                                                                             0x3
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_THRESHOLD_IX_1_ADDR(x))
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_THRESHOLD_IX_1_ADDR(x), m)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_AGING_THRESHOLD_IX_1_ADDR(x),v)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_AGING_THRESHOLD_IX_1_ADDR(x),m,v,HWIO_REO_R0_AGING_THRESHOLD_IX_1_IN(x))
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_AGING_THRESHOLD_AC1_BMSK                                            0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_AGING_THRESHOLD_AC1_SHFT                                                     0

#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_ADDR(x)                                                             ((x) + 0xb10)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_PHYS(x)                                                             ((x) + 0xb10)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_OFFS                                                                (0xb10)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_RMSK                                                                0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_POR                                                                 0x00009c40
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_POR_RMSK                                                            0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_ATTR                                                                             0x3
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_THRESHOLD_IX_2_ADDR(x))
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_THRESHOLD_IX_2_ADDR(x), m)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_OUT(x, v)            \
                out_dword(HWIO_REO_R0_AGING_THRESHOLD_IX_2_ADDR(x),v)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_AGING_THRESHOLD_IX_2_ADDR(x),m,v,HWIO_REO_R0_AGING_THRESHOLD_IX_2_IN(x))
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_AGING_THRESHOLD_AC2_BMSK                                            0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_AGING_THRESHOLD_AC2_SHFT                                                     0

#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_ADDR(x)                                                             ((x) + 0xb14)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_PHYS(x)                                                             ((x) + 0xb14)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_OFFS                                                                (0xb14)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_RMSK                                                                0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_POR                                                                 0x00009c40
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_POR_RMSK                                                            0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_ATTR                                                                             0x3
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_THRESHOLD_IX_3_ADDR(x))
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_THRESHOLD_IX_3_ADDR(x), m)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_OUT(x, v)            \
                out_dword(HWIO_REO_R0_AGING_THRESHOLD_IX_3_ADDR(x),v)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_AGING_THRESHOLD_IX_3_ADDR(x),m,v,HWIO_REO_R0_AGING_THRESHOLD_IX_3_IN(x))
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_AGING_THRESHOLD_AC3_BMSK                                            0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_AGING_THRESHOLD_AC3_SHFT                                                     0

#define HWIO_REO_R0_MISC_CTL_ADDR(x)                                                                         ((x) + 0xb7c)
#define HWIO_REO_R0_MISC_CTL_PHYS(x)                                                                         ((x) + 0xb7c)
#define HWIO_REO_R0_MISC_CTL_OFFS                                                                            (0xb7c)
#define HWIO_REO_R0_MISC_CTL_RMSK                                                                            0x3fffffff
#define HWIO_REO_R0_MISC_CTL_POR                                                                             0x0cac0008
#define HWIO_REO_R0_MISC_CTL_POR_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_MISC_CTL_ATTR                                                                                         0x3
#define HWIO_REO_R0_MISC_CTL_IN(x)            \
                in_dword(HWIO_REO_R0_MISC_CTL_ADDR(x))
#define HWIO_REO_R0_MISC_CTL_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_MISC_CTL_ADDR(x), m)
#define HWIO_REO_R0_MISC_CTL_OUT(x, v)            \
                out_dword(HWIO_REO_R0_MISC_CTL_ADDR(x),v)
#define HWIO_REO_R0_MISC_CTL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_MISC_CTL_ADDR(x),m,v,HWIO_REO_R0_MISC_CTL_IN(x))
#define HWIO_REO_R0_MISC_CTL_WCSS_INDICATION_BMSK                                                            0x20000000
#define HWIO_REO_R0_MISC_CTL_WCSS_INDICATION_SHFT                                                                    29
#define HWIO_REO_R0_MISC_CTL_SOFT_REORDER_DEST_RING_BMSK                                                     0x1e000000
#define HWIO_REO_R0_MISC_CTL_SOFT_REORDER_DEST_RING_SHFT                                                             25
#define HWIO_REO_R0_MISC_CTL_BAR_DEST_RING_BMSK                                                               0x1e00000
#define HWIO_REO_R0_MISC_CTL_BAR_DEST_RING_SHFT                                                                      21
#define HWIO_REO_R0_MISC_CTL_FRAGMENT_DEST_RING_BMSK                                                           0x1e0000
#define HWIO_REO_R0_MISC_CTL_FRAGMENT_DEST_RING_SHFT                                                                 17
#define HWIO_REO_R0_MISC_CTL_CACHE_FLUSH_Q_DESC_ONLY_BMSK                                                       0x10000
#define HWIO_REO_R0_MISC_CTL_CACHE_FLUSH_Q_DESC_ONLY_SHFT                                                            16
#define HWIO_REO_R0_MISC_CTL_MSI_ENABLE_CHK_BIT_BMSK                                                             0x8000
#define HWIO_REO_R0_MISC_CTL_MSI_ENABLE_CHK_BIT_SHFT                                                                 15
#define HWIO_REO_R0_MISC_CTL_SPARE_CONTROL_BMSK                                                                  0x7fff
#define HWIO_REO_R0_MISC_CTL_SPARE_CONTROL_SHFT                                                                       0

#define HWIO_REO_R2_REO_CMD_RING_HP_ADDR(x)                                                                  ((x) + 0x3020)
#define HWIO_REO_R2_REO_CMD_RING_HP_PHYS(x)                                                                  ((x) + 0x3020)
#define HWIO_REO_R2_REO_CMD_RING_HP_OFFS                                                                     (0x3020)
#define HWIO_REO_R2_REO_CMD_RING_HP_RMSK                                                                         0xffff
#define HWIO_REO_R2_REO_CMD_RING_HP_POR                                                                      0x00000000
#define HWIO_REO_R2_REO_CMD_RING_HP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_REO_CMD_RING_HP_ATTR                                                                                  0x3
#define HWIO_REO_R2_REO_CMD_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO_CMD_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO_CMD_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO_CMD_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO_CMD_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO_CMD_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO_CMD_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO_CMD_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO_CMD_RING_HP_IN(x))
#define HWIO_REO_R2_REO_CMD_RING_HP_HEAD_PTR_BMSK                                                                0xffff
#define HWIO_REO_R2_REO_CMD_RING_HP_HEAD_PTR_SHFT                                                                     0

#define HWIO_REO_R2_REO_CMD_RING_TP_ADDR(x)                                                                  ((x) + 0x3024)
#define HWIO_REO_R2_REO_CMD_RING_TP_PHYS(x)                                                                  ((x) + 0x3024)
#define HWIO_REO_R2_REO_CMD_RING_TP_OFFS                                                                     (0x3024)
#define HWIO_REO_R2_REO_CMD_RING_TP_RMSK                                                                         0xffff
#define HWIO_REO_R2_REO_CMD_RING_TP_POR                                                                      0x00000000
#define HWIO_REO_R2_REO_CMD_RING_TP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_REO_CMD_RING_TP_ATTR                                                                                  0x3
#define HWIO_REO_R2_REO_CMD_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO_CMD_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO_CMD_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO_CMD_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO_CMD_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO_CMD_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO_CMD_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO_CMD_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO_CMD_RING_TP_IN(x))
#define HWIO_REO_R2_REO_CMD_RING_TP_TAIL_PTR_BMSK                                                                0xffff
#define HWIO_REO_R2_REO_CMD_RING_TP_TAIL_PTR_SHFT                                                                     0

#define HWIO_REO_R2_SW2REO_RING_HP_ADDR(x)                                                                   ((x) + 0x3028)
#define HWIO_REO_R2_SW2REO_RING_HP_PHYS(x)                                                                   ((x) + 0x3028)
#define HWIO_REO_R2_SW2REO_RING_HP_OFFS                                                                      (0x3028)
#define HWIO_REO_R2_SW2REO_RING_HP_RMSK                                                                          0xffff
#define HWIO_REO_R2_SW2REO_RING_HP_POR                                                                       0x00000000
#define HWIO_REO_R2_SW2REO_RING_HP_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R2_SW2REO_RING_HP_ATTR                                                                                   0x3
#define HWIO_REO_R2_SW2REO_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_SW2REO_RING_HP_ADDR(x))
#define HWIO_REO_R2_SW2REO_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_SW2REO_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_SW2REO_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_SW2REO_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_SW2REO_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_SW2REO_RING_HP_ADDR(x),m,v,HWIO_REO_R2_SW2REO_RING_HP_IN(x))
#define HWIO_REO_R2_SW2REO_RING_HP_HEAD_PTR_BMSK                                                                 0xffff
#define HWIO_REO_R2_SW2REO_RING_HP_HEAD_PTR_SHFT                                                                      0

#define HWIO_REO_R2_SW2REO_RING_TP_ADDR(x)                                                                   ((x) + 0x302c)
#define HWIO_REO_R2_SW2REO_RING_TP_PHYS(x)                                                                   ((x) + 0x302c)
#define HWIO_REO_R2_SW2REO_RING_TP_OFFS                                                                      (0x302c)
#define HWIO_REO_R2_SW2REO_RING_TP_RMSK                                                                          0xffff
#define HWIO_REO_R2_SW2REO_RING_TP_POR                                                                       0x00000000
#define HWIO_REO_R2_SW2REO_RING_TP_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R2_SW2REO_RING_TP_ATTR                                                                                   0x3
#define HWIO_REO_R2_SW2REO_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_SW2REO_RING_TP_ADDR(x))
#define HWIO_REO_R2_SW2REO_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_SW2REO_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_SW2REO_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_SW2REO_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_SW2REO_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_SW2REO_RING_TP_ADDR(x),m,v,HWIO_REO_R2_SW2REO_RING_TP_IN(x))
#define HWIO_REO_R2_SW2REO_RING_TP_TAIL_PTR_BMSK                                                                 0xffff
#define HWIO_REO_R2_SW2REO_RING_TP_TAIL_PTR_SHFT                                                                      0

#define HWIO_REO_R2_SW2REO1_RING_HP_ADDR(x)                                                                  ((x) + 0x3030)
#define HWIO_REO_R2_SW2REO1_RING_HP_PHYS(x)                                                                  ((x) + 0x3030)
#define HWIO_REO_R2_SW2REO1_RING_HP_OFFS                                                                     (0x3030)
#define HWIO_REO_R2_SW2REO1_RING_HP_RMSK                                                                         0xffff
#define HWIO_REO_R2_SW2REO1_RING_HP_POR                                                                      0x00000000
#define HWIO_REO_R2_SW2REO1_RING_HP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_SW2REO1_RING_HP_ATTR                                                                                  0x3
#define HWIO_REO_R2_SW2REO1_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_SW2REO1_RING_HP_ADDR(x))
#define HWIO_REO_R2_SW2REO1_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_SW2REO1_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_SW2REO1_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_SW2REO1_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_SW2REO1_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_SW2REO1_RING_HP_ADDR(x),m,v,HWIO_REO_R2_SW2REO1_RING_HP_IN(x))
#define HWIO_REO_R2_SW2REO1_RING_HP_HEAD_PTR_BMSK                                                                0xffff
#define HWIO_REO_R2_SW2REO1_RING_HP_HEAD_PTR_SHFT                                                                     0

#define HWIO_REO_R2_SW2REO1_RING_TP_ADDR(x)                                                                  ((x) + 0x3034)
#define HWIO_REO_R2_SW2REO1_RING_TP_PHYS(x)                                                                  ((x) + 0x3034)
#define HWIO_REO_R2_SW2REO1_RING_TP_OFFS                                                                     (0x3034)
#define HWIO_REO_R2_SW2REO1_RING_TP_RMSK                                                                         0xffff
#define HWIO_REO_R2_SW2REO1_RING_TP_POR                                                                      0x00000000
#define HWIO_REO_R2_SW2REO1_RING_TP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_SW2REO1_RING_TP_ATTR                                                                                  0x3
#define HWIO_REO_R2_SW2REO1_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_SW2REO1_RING_TP_ADDR(x))
#define HWIO_REO_R2_SW2REO1_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_SW2REO1_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_SW2REO1_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_SW2REO1_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_SW2REO1_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_SW2REO1_RING_TP_ADDR(x),m,v,HWIO_REO_R2_SW2REO1_RING_TP_IN(x))
#define HWIO_REO_R2_SW2REO1_RING_TP_TAIL_PTR_BMSK                                                                0xffff
#define HWIO_REO_R2_SW2REO1_RING_TP_TAIL_PTR_SHFT                                                                     0

#define HWIO_REO_R2_SW2REO2_RING_HP_ADDR(x)                                                                  ((x) + 0x3038)
#define HWIO_REO_R2_SW2REO2_RING_HP_PHYS(x)                                                                  ((x) + 0x3038)
#define HWIO_REO_R2_SW2REO2_RING_HP_OFFS                                                                     (0x3038)
#define HWIO_REO_R2_SW2REO2_RING_HP_RMSK                                                                         0xffff
#define HWIO_REO_R2_SW2REO2_RING_HP_POR                                                                      0x00000000
#define HWIO_REO_R2_SW2REO2_RING_HP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_SW2REO2_RING_HP_ATTR                                                                                  0x3
#define HWIO_REO_R2_SW2REO2_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_SW2REO2_RING_HP_ADDR(x))
#define HWIO_REO_R2_SW2REO2_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_SW2REO2_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_SW2REO2_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_SW2REO2_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_SW2REO2_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_SW2REO2_RING_HP_ADDR(x),m,v,HWIO_REO_R2_SW2REO2_RING_HP_IN(x))
#define HWIO_REO_R2_SW2REO2_RING_HP_HEAD_PTR_BMSK                                                                0xffff
#define HWIO_REO_R2_SW2REO2_RING_HP_HEAD_PTR_SHFT                                                                     0

#define HWIO_REO_R2_SW2REO2_RING_TP_ADDR(x)                                                                  ((x) + 0x303c)
#define HWIO_REO_R2_SW2REO2_RING_TP_PHYS(x)                                                                  ((x) + 0x303c)
#define HWIO_REO_R2_SW2REO2_RING_TP_OFFS                                                                     (0x303c)
#define HWIO_REO_R2_SW2REO2_RING_TP_RMSK                                                                         0xffff
#define HWIO_REO_R2_SW2REO2_RING_TP_POR                                                                      0x00000000
#define HWIO_REO_R2_SW2REO2_RING_TP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_SW2REO2_RING_TP_ATTR                                                                                  0x3
#define HWIO_REO_R2_SW2REO2_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_SW2REO2_RING_TP_ADDR(x))
#define HWIO_REO_R2_SW2REO2_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_SW2REO2_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_SW2REO2_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_SW2REO2_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_SW2REO2_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_SW2REO2_RING_TP_ADDR(x),m,v,HWIO_REO_R2_SW2REO2_RING_TP_IN(x))
#define HWIO_REO_R2_SW2REO2_RING_TP_TAIL_PTR_BMSK                                                                0xffff
#define HWIO_REO_R2_SW2REO2_RING_TP_TAIL_PTR_SHFT                                                                     0

#define HWIO_REO_R2_SW2REO3_RING_HP_ADDR(x)                                                                  ((x) + 0x3040)
#define HWIO_REO_R2_SW2REO3_RING_HP_PHYS(x)                                                                  ((x) + 0x3040)
#define HWIO_REO_R2_SW2REO3_RING_HP_OFFS                                                                     (0x3040)
#define HWIO_REO_R2_SW2REO3_RING_HP_RMSK                                                                         0xffff
#define HWIO_REO_R2_SW2REO3_RING_HP_POR                                                                      0x00000000
#define HWIO_REO_R2_SW2REO3_RING_HP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_SW2REO3_RING_HP_ATTR                                                                                  0x3
#define HWIO_REO_R2_SW2REO3_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_SW2REO3_RING_HP_ADDR(x))
#define HWIO_REO_R2_SW2REO3_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_SW2REO3_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_SW2REO3_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_SW2REO3_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_SW2REO3_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_SW2REO3_RING_HP_ADDR(x),m,v,HWIO_REO_R2_SW2REO3_RING_HP_IN(x))
#define HWIO_REO_R2_SW2REO3_RING_HP_HEAD_PTR_BMSK                                                                0xffff
#define HWIO_REO_R2_SW2REO3_RING_HP_HEAD_PTR_SHFT                                                                     0

#define HWIO_REO_R2_SW2REO3_RING_TP_ADDR(x)                                                                  ((x) + 0x3044)
#define HWIO_REO_R2_SW2REO3_RING_TP_PHYS(x)                                                                  ((x) + 0x3044)
#define HWIO_REO_R2_SW2REO3_RING_TP_OFFS                                                                     (0x3044)
#define HWIO_REO_R2_SW2REO3_RING_TP_RMSK                                                                         0xffff
#define HWIO_REO_R2_SW2REO3_RING_TP_POR                                                                      0x00000000
#define HWIO_REO_R2_SW2REO3_RING_TP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_SW2REO3_RING_TP_ATTR                                                                                  0x3
#define HWIO_REO_R2_SW2REO3_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_SW2REO3_RING_TP_ADDR(x))
#define HWIO_REO_R2_SW2REO3_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_SW2REO3_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_SW2REO3_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_SW2REO3_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_SW2REO3_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_SW2REO3_RING_TP_ADDR(x),m,v,HWIO_REO_R2_SW2REO3_RING_TP_IN(x))
#define HWIO_REO_R2_SW2REO3_RING_TP_TAIL_PTR_BMSK                                                                0xffff
#define HWIO_REO_R2_SW2REO3_RING_TP_TAIL_PTR_SHFT                                                                     0

#define HWIO_REO_R2_REO2SW1_RING_HP_ADDR(x)                                                                  ((x) + 0x3048)
#define HWIO_REO_R2_REO2SW1_RING_HP_PHYS(x)                                                                  ((x) + 0x3048)
#define HWIO_REO_R2_REO2SW1_RING_HP_OFFS                                                                     (0x3048)
#define HWIO_REO_R2_REO2SW1_RING_HP_RMSK                                                                        0xfffff
#define HWIO_REO_R2_REO2SW1_RING_HP_POR                                                                      0x00000000
#define HWIO_REO_R2_REO2SW1_RING_HP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_REO2SW1_RING_HP_ATTR                                                                                  0x3
#define HWIO_REO_R2_REO2SW1_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW1_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO2SW1_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW1_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW1_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW1_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW1_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW1_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO2SW1_RING_HP_IN(x))
#define HWIO_REO_R2_REO2SW1_RING_HP_HEAD_PTR_BMSK                                                               0xfffff
#define HWIO_REO_R2_REO2SW1_RING_HP_HEAD_PTR_SHFT                                                                     0

#define HWIO_REO_R2_REO2SW1_RING_TP_ADDR(x)                                                                  ((x) + 0x304c)
#define HWIO_REO_R2_REO2SW1_RING_TP_PHYS(x)                                                                  ((x) + 0x304c)
#define HWIO_REO_R2_REO2SW1_RING_TP_OFFS                                                                     (0x304c)
#define HWIO_REO_R2_REO2SW1_RING_TP_RMSK                                                                        0xfffff
#define HWIO_REO_R2_REO2SW1_RING_TP_POR                                                                      0x00000000
#define HWIO_REO_R2_REO2SW1_RING_TP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_REO2SW1_RING_TP_ATTR                                                                                  0x3
#define HWIO_REO_R2_REO2SW1_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW1_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO2SW1_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW1_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW1_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW1_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW1_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW1_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO2SW1_RING_TP_IN(x))
#define HWIO_REO_R2_REO2SW1_RING_TP_TAIL_PTR_BMSK                                                               0xfffff
#define HWIO_REO_R2_REO2SW1_RING_TP_TAIL_PTR_SHFT                                                                     0

#define HWIO_REO_R2_REO2SW2_RING_HP_ADDR(x)                                                                  ((x) + 0x3050)
#define HWIO_REO_R2_REO2SW2_RING_HP_PHYS(x)                                                                  ((x) + 0x3050)
#define HWIO_REO_R2_REO2SW2_RING_HP_OFFS                                                                     (0x3050)
#define HWIO_REO_R2_REO2SW2_RING_HP_RMSK                                                                        0xfffff
#define HWIO_REO_R2_REO2SW2_RING_HP_POR                                                                      0x00000000
#define HWIO_REO_R2_REO2SW2_RING_HP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_REO2SW2_RING_HP_ATTR                                                                                  0x3
#define HWIO_REO_R2_REO2SW2_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW2_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO2SW2_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW2_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW2_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW2_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW2_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW2_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO2SW2_RING_HP_IN(x))
#define HWIO_REO_R2_REO2SW2_RING_HP_HEAD_PTR_BMSK                                                               0xfffff
#define HWIO_REO_R2_REO2SW2_RING_HP_HEAD_PTR_SHFT                                                                     0

#define HWIO_REO_R2_REO2SW2_RING_TP_ADDR(x)                                                                  ((x) + 0x3054)
#define HWIO_REO_R2_REO2SW2_RING_TP_PHYS(x)                                                                  ((x) + 0x3054)
#define HWIO_REO_R2_REO2SW2_RING_TP_OFFS                                                                     (0x3054)
#define HWIO_REO_R2_REO2SW2_RING_TP_RMSK                                                                        0xfffff
#define HWIO_REO_R2_REO2SW2_RING_TP_POR                                                                      0x00000000
#define HWIO_REO_R2_REO2SW2_RING_TP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_REO2SW2_RING_TP_ATTR                                                                                  0x3
#define HWIO_REO_R2_REO2SW2_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW2_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO2SW2_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW2_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW2_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW2_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW2_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW2_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO2SW2_RING_TP_IN(x))
#define HWIO_REO_R2_REO2SW2_RING_TP_TAIL_PTR_BMSK                                                               0xfffff
#define HWIO_REO_R2_REO2SW2_RING_TP_TAIL_PTR_SHFT                                                                     0

#define HWIO_REO_R2_REO2SW3_RING_HP_ADDR(x)                                                                  ((x) + 0x3058)
#define HWIO_REO_R2_REO2SW3_RING_HP_PHYS(x)                                                                  ((x) + 0x3058)
#define HWIO_REO_R2_REO2SW3_RING_HP_OFFS                                                                     (0x3058)
#define HWIO_REO_R2_REO2SW3_RING_HP_RMSK                                                                        0xfffff
#define HWIO_REO_R2_REO2SW3_RING_HP_POR                                                                      0x00000000
#define HWIO_REO_R2_REO2SW3_RING_HP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_REO2SW3_RING_HP_ATTR                                                                                  0x3
#define HWIO_REO_R2_REO2SW3_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW3_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO2SW3_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW3_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW3_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW3_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW3_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW3_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO2SW3_RING_HP_IN(x))
#define HWIO_REO_R2_REO2SW3_RING_HP_HEAD_PTR_BMSK                                                               0xfffff
#define HWIO_REO_R2_REO2SW3_RING_HP_HEAD_PTR_SHFT                                                                     0

#define HWIO_REO_R2_REO2SW3_RING_TP_ADDR(x)                                                                  ((x) + 0x305c)
#define HWIO_REO_R2_REO2SW3_RING_TP_PHYS(x)                                                                  ((x) + 0x305c)
#define HWIO_REO_R2_REO2SW3_RING_TP_OFFS                                                                     (0x305c)
#define HWIO_REO_R2_REO2SW3_RING_TP_RMSK                                                                        0xfffff
#define HWIO_REO_R2_REO2SW3_RING_TP_POR                                                                      0x00000000
#define HWIO_REO_R2_REO2SW3_RING_TP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_REO2SW3_RING_TP_ATTR                                                                                  0x3
#define HWIO_REO_R2_REO2SW3_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW3_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO2SW3_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW3_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW3_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW3_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW3_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW3_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO2SW3_RING_TP_IN(x))
#define HWIO_REO_R2_REO2SW3_RING_TP_TAIL_PTR_BMSK                                                               0xfffff
#define HWIO_REO_R2_REO2SW3_RING_TP_TAIL_PTR_SHFT                                                                     0

#define HWIO_REO_R2_REO2SW4_RING_HP_ADDR(x)                                                                  ((x) + 0x3060)
#define HWIO_REO_R2_REO2SW4_RING_HP_PHYS(x)                                                                  ((x) + 0x3060)
#define HWIO_REO_R2_REO2SW4_RING_HP_OFFS                                                                     (0x3060)
#define HWIO_REO_R2_REO2SW4_RING_HP_RMSK                                                                        0xfffff
#define HWIO_REO_R2_REO2SW4_RING_HP_POR                                                                      0x00000000
#define HWIO_REO_R2_REO2SW4_RING_HP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_REO2SW4_RING_HP_ATTR                                                                                  0x3
#define HWIO_REO_R2_REO2SW4_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW4_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO2SW4_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW4_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW4_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW4_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW4_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW4_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO2SW4_RING_HP_IN(x))
#define HWIO_REO_R2_REO2SW4_RING_HP_HEAD_PTR_BMSK                                                               0xfffff
#define HWIO_REO_R2_REO2SW4_RING_HP_HEAD_PTR_SHFT                                                                     0

#define HWIO_REO_R2_REO2SW4_RING_TP_ADDR(x)                                                                  ((x) + 0x3064)
#define HWIO_REO_R2_REO2SW4_RING_TP_PHYS(x)                                                                  ((x) + 0x3064)
#define HWIO_REO_R2_REO2SW4_RING_TP_OFFS                                                                     (0x3064)
#define HWIO_REO_R2_REO2SW4_RING_TP_RMSK                                                                        0xfffff
#define HWIO_REO_R2_REO2SW4_RING_TP_POR                                                                      0x00000000
#define HWIO_REO_R2_REO2SW4_RING_TP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_REO2SW4_RING_TP_ATTR                                                                                  0x3
#define HWIO_REO_R2_REO2SW4_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW4_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO2SW4_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW4_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW4_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW4_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW4_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW4_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO2SW4_RING_TP_IN(x))
#define HWIO_REO_R2_REO2SW4_RING_TP_TAIL_PTR_BMSK                                                               0xfffff
#define HWIO_REO_R2_REO2SW4_RING_TP_TAIL_PTR_SHFT                                                                     0

#define HWIO_REO_R2_REO2SW5_RING_HP_ADDR(x)                                                                  ((x) + 0x3068)
#define HWIO_REO_R2_REO2SW5_RING_HP_PHYS(x)                                                                  ((x) + 0x3068)
#define HWIO_REO_R2_REO2SW5_RING_HP_OFFS                                                                     (0x3068)
#define HWIO_REO_R2_REO2SW5_RING_HP_RMSK                                                                        0xfffff
#define HWIO_REO_R2_REO2SW5_RING_HP_POR                                                                      0x00000000
#define HWIO_REO_R2_REO2SW5_RING_HP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_REO2SW5_RING_HP_ATTR                                                                                  0x3
#define HWIO_REO_R2_REO2SW5_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW5_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO2SW5_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW5_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW5_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW5_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW5_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW5_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO2SW5_RING_HP_IN(x))
#define HWIO_REO_R2_REO2SW5_RING_HP_HEAD_PTR_BMSK                                                               0xfffff
#define HWIO_REO_R2_REO2SW5_RING_HP_HEAD_PTR_SHFT                                                                     0

#define HWIO_REO_R2_REO2SW5_RING_TP_ADDR(x)                                                                  ((x) + 0x306c)
#define HWIO_REO_R2_REO2SW5_RING_TP_PHYS(x)                                                                  ((x) + 0x306c)
#define HWIO_REO_R2_REO2SW5_RING_TP_OFFS                                                                     (0x306c)
#define HWIO_REO_R2_REO2SW5_RING_TP_RMSK                                                                        0xfffff
#define HWIO_REO_R2_REO2SW5_RING_TP_POR                                                                      0x00000000
#define HWIO_REO_R2_REO2SW5_RING_TP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_REO2SW5_RING_TP_ATTR                                                                                  0x3
#define HWIO_REO_R2_REO2SW5_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW5_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO2SW5_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW5_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW5_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW5_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW5_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW5_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO2SW5_RING_TP_IN(x))
#define HWIO_REO_R2_REO2SW5_RING_TP_TAIL_PTR_BMSK                                                               0xfffff
#define HWIO_REO_R2_REO2SW5_RING_TP_TAIL_PTR_SHFT                                                                     0

#define HWIO_REO_R2_REO2SW6_RING_HP_ADDR(x)                                                                  ((x) + 0x3070)
#define HWIO_REO_R2_REO2SW6_RING_HP_PHYS(x)                                                                  ((x) + 0x3070)
#define HWIO_REO_R2_REO2SW6_RING_HP_OFFS                                                                     (0x3070)
#define HWIO_REO_R2_REO2SW6_RING_HP_RMSK                                                                        0xfffff
#define HWIO_REO_R2_REO2SW6_RING_HP_POR                                                                      0x00000000
#define HWIO_REO_R2_REO2SW6_RING_HP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_REO2SW6_RING_HP_ATTR                                                                                  0x3
#define HWIO_REO_R2_REO2SW6_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW6_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO2SW6_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW6_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW6_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW6_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW6_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW6_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO2SW6_RING_HP_IN(x))
#define HWIO_REO_R2_REO2SW6_RING_HP_HEAD_PTR_BMSK                                                               0xfffff
#define HWIO_REO_R2_REO2SW6_RING_HP_HEAD_PTR_SHFT                                                                     0

#define HWIO_REO_R2_REO2SW6_RING_TP_ADDR(x)                                                                  ((x) + 0x3074)
#define HWIO_REO_R2_REO2SW6_RING_TP_PHYS(x)                                                                  ((x) + 0x3074)
#define HWIO_REO_R2_REO2SW6_RING_TP_OFFS                                                                     (0x3074)
#define HWIO_REO_R2_REO2SW6_RING_TP_RMSK                                                                        0xfffff
#define HWIO_REO_R2_REO2SW6_RING_TP_POR                                                                      0x00000000
#define HWIO_REO_R2_REO2SW6_RING_TP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_REO2SW6_RING_TP_ATTR                                                                                  0x3
#define HWIO_REO_R2_REO2SW6_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW6_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO2SW6_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW6_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW6_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW6_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW6_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW6_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO2SW6_RING_TP_IN(x))
#define HWIO_REO_R2_REO2SW6_RING_TP_TAIL_PTR_BMSK                                                               0xfffff
#define HWIO_REO_R2_REO2SW6_RING_TP_TAIL_PTR_SHFT                                                                     0

#define HWIO_REO_R2_REO2SW7_RING_HP_ADDR(x)                                                                  ((x) + 0x3078)
#define HWIO_REO_R2_REO2SW7_RING_HP_PHYS(x)                                                                  ((x) + 0x3078)
#define HWIO_REO_R2_REO2SW7_RING_HP_OFFS                                                                     (0x3078)
#define HWIO_REO_R2_REO2SW7_RING_HP_RMSK                                                                        0xfffff
#define HWIO_REO_R2_REO2SW7_RING_HP_POR                                                                      0x00000000
#define HWIO_REO_R2_REO2SW7_RING_HP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_REO2SW7_RING_HP_ATTR                                                                                  0x3
#define HWIO_REO_R2_REO2SW7_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW7_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO2SW7_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW7_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW7_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW7_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW7_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW7_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO2SW7_RING_HP_IN(x))
#define HWIO_REO_R2_REO2SW7_RING_HP_HEAD_PTR_BMSK                                                               0xfffff
#define HWIO_REO_R2_REO2SW7_RING_HP_HEAD_PTR_SHFT                                                                     0

#define HWIO_REO_R2_REO2SW7_RING_TP_ADDR(x)                                                                  ((x) + 0x307c)
#define HWIO_REO_R2_REO2SW7_RING_TP_PHYS(x)                                                                  ((x) + 0x307c)
#define HWIO_REO_R2_REO2SW7_RING_TP_OFFS                                                                     (0x307c)
#define HWIO_REO_R2_REO2SW7_RING_TP_RMSK                                                                        0xfffff
#define HWIO_REO_R2_REO2SW7_RING_TP_POR                                                                      0x00000000
#define HWIO_REO_R2_REO2SW7_RING_TP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_REO2SW7_RING_TP_ATTR                                                                                  0x3
#define HWIO_REO_R2_REO2SW7_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW7_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO2SW7_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW7_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW7_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW7_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW7_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW7_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO2SW7_RING_TP_IN(x))
#define HWIO_REO_R2_REO2SW7_RING_TP_TAIL_PTR_BMSK                                                               0xfffff
#define HWIO_REO_R2_REO2SW7_RING_TP_TAIL_PTR_SHFT                                                                     0

#define HWIO_REO_R2_REO2SW8_RING_HP_ADDR(x)                                                                  ((x) + 0x3080)
#define HWIO_REO_R2_REO2SW8_RING_HP_PHYS(x)                                                                  ((x) + 0x3080)
#define HWIO_REO_R2_REO2SW8_RING_HP_OFFS                                                                     (0x3080)
#define HWIO_REO_R2_REO2SW8_RING_HP_RMSK                                                                        0xfffff
#define HWIO_REO_R2_REO2SW8_RING_HP_POR                                                                      0x00000000
#define HWIO_REO_R2_REO2SW8_RING_HP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_REO2SW8_RING_HP_ATTR                                                                                  0x3
#define HWIO_REO_R2_REO2SW8_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW8_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO2SW8_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW8_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW8_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW8_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW8_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW8_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO2SW8_RING_HP_IN(x))
#define HWIO_REO_R2_REO2SW8_RING_HP_HEAD_PTR_BMSK                                                               0xfffff
#define HWIO_REO_R2_REO2SW8_RING_HP_HEAD_PTR_SHFT                                                                     0

#define HWIO_REO_R2_REO2SW8_RING_TP_ADDR(x)                                                                  ((x) + 0x3084)
#define HWIO_REO_R2_REO2SW8_RING_TP_PHYS(x)                                                                  ((x) + 0x3084)
#define HWIO_REO_R2_REO2SW8_RING_TP_OFFS                                                                     (0x3084)
#define HWIO_REO_R2_REO2SW8_RING_TP_RMSK                                                                        0xfffff
#define HWIO_REO_R2_REO2SW8_RING_TP_POR                                                                      0x00000000
#define HWIO_REO_R2_REO2SW8_RING_TP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_REO2SW8_RING_TP_ATTR                                                                                  0x3
#define HWIO_REO_R2_REO2SW8_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW8_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO2SW8_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW8_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW8_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW8_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW8_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW8_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO2SW8_RING_TP_IN(x))
#define HWIO_REO_R2_REO2SW8_RING_TP_TAIL_PTR_BMSK                                                               0xfffff
#define HWIO_REO_R2_REO2SW8_RING_TP_TAIL_PTR_SHFT                                                                     0

#define HWIO_REO_R2_REO2SW0_RING_HP_ADDR(x)                                                                  ((x) + 0x3088)
#define HWIO_REO_R2_REO2SW0_RING_HP_PHYS(x)                                                                  ((x) + 0x3088)
#define HWIO_REO_R2_REO2SW0_RING_HP_OFFS                                                                     (0x3088)
#define HWIO_REO_R2_REO2SW0_RING_HP_RMSK                                                                        0xfffff
#define HWIO_REO_R2_REO2SW0_RING_HP_POR                                                                      0x00000000
#define HWIO_REO_R2_REO2SW0_RING_HP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_REO2SW0_RING_HP_ATTR                                                                                  0x3
#define HWIO_REO_R2_REO2SW0_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW0_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO2SW0_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW0_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW0_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW0_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW0_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW0_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO2SW0_RING_HP_IN(x))
#define HWIO_REO_R2_REO2SW0_RING_HP_HEAD_PTR_BMSK                                                               0xfffff
#define HWIO_REO_R2_REO2SW0_RING_HP_HEAD_PTR_SHFT                                                                     0

#define HWIO_REO_R2_REO2SW0_RING_TP_ADDR(x)                                                                  ((x) + 0x308c)
#define HWIO_REO_R2_REO2SW0_RING_TP_PHYS(x)                                                                  ((x) + 0x308c)
#define HWIO_REO_R2_REO2SW0_RING_TP_OFFS                                                                     (0x308c)
#define HWIO_REO_R2_REO2SW0_RING_TP_RMSK                                                                        0xfffff
#define HWIO_REO_R2_REO2SW0_RING_TP_POR                                                                      0x00000000
#define HWIO_REO_R2_REO2SW0_RING_TP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_REO2SW0_RING_TP_ATTR                                                                                  0x3
#define HWIO_REO_R2_REO2SW0_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW0_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO2SW0_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW0_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW0_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW0_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW0_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW0_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO2SW0_RING_TP_IN(x))
#define HWIO_REO_R2_REO2SW0_RING_TP_TAIL_PTR_BMSK                                                               0xfffff
#define HWIO_REO_R2_REO2SW0_RING_TP_TAIL_PTR_SHFT                                                                     0

#define HWIO_REO_R2_REO2PPE_RING_HP_ADDR(x)                                                                  ((x) + 0x3090)
#define HWIO_REO_R2_REO2PPE_RING_HP_PHYS(x)                                                                  ((x) + 0x3090)
#define HWIO_REO_R2_REO2PPE_RING_HP_OFFS                                                                     (0x3090)
#define HWIO_REO_R2_REO2PPE_RING_HP_RMSK                                                                        0xfffff
#define HWIO_REO_R2_REO2PPE_RING_HP_POR                                                                      0x00000000
#define HWIO_REO_R2_REO2PPE_RING_HP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_REO2PPE_RING_HP_ATTR                                                                                  0x3
#define HWIO_REO_R2_REO2PPE_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2PPE_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO2PPE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2PPE_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO2PPE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2PPE_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO2PPE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2PPE_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO2PPE_RING_HP_IN(x))
#define HWIO_REO_R2_REO2PPE_RING_HP_HEAD_PTR_BMSK                                                               0xfffff
#define HWIO_REO_R2_REO2PPE_RING_HP_HEAD_PTR_SHFT                                                                     0

#define HWIO_REO_R2_REO2PPE_RING_TP_ADDR(x)                                                                  ((x) + 0x3094)
#define HWIO_REO_R2_REO2PPE_RING_TP_PHYS(x)                                                                  ((x) + 0x3094)
#define HWIO_REO_R2_REO2PPE_RING_TP_OFFS                                                                     (0x3094)
#define HWIO_REO_R2_REO2PPE_RING_TP_RMSK                                                                        0xfffff
#define HWIO_REO_R2_REO2PPE_RING_TP_POR                                                                      0x00000000
#define HWIO_REO_R2_REO2PPE_RING_TP_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R2_REO2PPE_RING_TP_ATTR                                                                                  0x3
#define HWIO_REO_R2_REO2PPE_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2PPE_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO2PPE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2PPE_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO2PPE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2PPE_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO2PPE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2PPE_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO2PPE_RING_TP_IN(x))
#define HWIO_REO_R2_REO2PPE_RING_TP_TAIL_PTR_BMSK                                                               0xfffff
#define HWIO_REO_R2_REO2PPE_RING_TP_TAIL_PTR_SHFT                                                                     0

#define HWIO_REO_R2_REO2FW_RING_HP_ADDR(x)                                                                   ((x) + 0x3098)
#define HWIO_REO_R2_REO2FW_RING_HP_PHYS(x)                                                                   ((x) + 0x3098)
#define HWIO_REO_R2_REO2FW_RING_HP_OFFS                                                                      (0x3098)
#define HWIO_REO_R2_REO2FW_RING_HP_RMSK                                                                         0xfffff
#define HWIO_REO_R2_REO2FW_RING_HP_POR                                                                       0x00000000
#define HWIO_REO_R2_REO2FW_RING_HP_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R2_REO2FW_RING_HP_ATTR                                                                                   0x3
#define HWIO_REO_R2_REO2FW_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2FW_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO2FW_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2FW_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO2FW_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2FW_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO2FW_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2FW_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO2FW_RING_HP_IN(x))
#define HWIO_REO_R2_REO2FW_RING_HP_HEAD_PTR_BMSK                                                                0xfffff
#define HWIO_REO_R2_REO2FW_RING_HP_HEAD_PTR_SHFT                                                                      0

#define HWIO_REO_R2_REO2FW_RING_TP_ADDR(x)                                                                   ((x) + 0x309c)
#define HWIO_REO_R2_REO2FW_RING_TP_PHYS(x)                                                                   ((x) + 0x309c)
#define HWIO_REO_R2_REO2FW_RING_TP_OFFS                                                                      (0x309c)
#define HWIO_REO_R2_REO2FW_RING_TP_RMSK                                                                         0xfffff
#define HWIO_REO_R2_REO2FW_RING_TP_POR                                                                       0x00000000
#define HWIO_REO_R2_REO2FW_RING_TP_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R2_REO2FW_RING_TP_ATTR                                                                                   0x3
#define HWIO_REO_R2_REO2FW_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2FW_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO2FW_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2FW_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO2FW_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2FW_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO2FW_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2FW_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO2FW_RING_TP_IN(x))
#define HWIO_REO_R2_REO2FW_RING_TP_TAIL_PTR_BMSK                                                                0xfffff
#define HWIO_REO_R2_REO2FW_RING_TP_TAIL_PTR_SHFT                                                                      0

#define HWIO_REO_R2_REO_STATUS_RING_HP_ADDR(x)                                                               ((x) + 0x30a8)
#define HWIO_REO_R2_REO_STATUS_RING_HP_PHYS(x)                                                               ((x) + 0x30a8)
#define HWIO_REO_R2_REO_STATUS_RING_HP_OFFS                                                                  (0x30a8)
#define HWIO_REO_R2_REO_STATUS_RING_HP_RMSK                                                                      0xffff
#define HWIO_REO_R2_REO_STATUS_RING_HP_POR                                                                   0x00000000
#define HWIO_REO_R2_REO_STATUS_RING_HP_POR_RMSK                                                              0xffffffff
#define HWIO_REO_R2_REO_STATUS_RING_HP_ATTR                                                                               0x3
#define HWIO_REO_R2_REO_STATUS_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO_STATUS_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO_STATUS_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO_STATUS_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO_STATUS_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO_STATUS_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO_STATUS_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO_STATUS_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO_STATUS_RING_HP_IN(x))
#define HWIO_REO_R2_REO_STATUS_RING_HP_HEAD_PTR_BMSK                                                             0xffff
#define HWIO_REO_R2_REO_STATUS_RING_HP_HEAD_PTR_SHFT                                                                  0

#define HWIO_REO_R2_REO_STATUS_RING_TP_ADDR(x)                                                               ((x) + 0x30ac)
#define HWIO_REO_R2_REO_STATUS_RING_TP_PHYS(x)                                                               ((x) + 0x30ac)
#define HWIO_REO_R2_REO_STATUS_RING_TP_OFFS                                                                  (0x30ac)
#define HWIO_REO_R2_REO_STATUS_RING_TP_RMSK                                                                      0xffff
#define HWIO_REO_R2_REO_STATUS_RING_TP_POR                                                                   0x00000000
#define HWIO_REO_R2_REO_STATUS_RING_TP_POR_RMSK                                                              0xffffffff
#define HWIO_REO_R2_REO_STATUS_RING_TP_ATTR                                                                               0x3
#define HWIO_REO_R2_REO_STATUS_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO_STATUS_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO_STATUS_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO_STATUS_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO_STATUS_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO_STATUS_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO_STATUS_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO_STATUS_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO_STATUS_RING_TP_IN(x))
#define HWIO_REO_R2_REO_STATUS_RING_TP_TAIL_PTR_BMSK                                                             0xffff
#define HWIO_REO_R2_REO_STATUS_RING_TP_TAIL_PTR_SHFT                                                                  0


#define MAC_TCL_REG_REG_BASE                                                                                (UMAC_BASE      + 0x00044000)
#define MAC_TCL_REG_REG_BASE_SIZE                                                                           0x3000
#define MAC_TCL_REG_REG_BASE_USED                                                                           0x205c
#define MAC_TCL_REG_REG_BASE_PHYS                                                                           (UMAC_BASE_PHYS + 0x00044000)
#define MAC_TCL_REG_REG_BASE_OFFS                                                                           0x00044000

#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_ADDR(x)                                                               ((x) + 0x0)
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_PHYS(x)                                                               ((x) + 0x0)
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_OFFS                                                                  (0x0)
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_RMSK                                                                     0x3ffe0
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_POR                                                                   0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_ATTR                                                                               0x3
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_CTRL_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_CTRL_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_CTRL_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_CTRL_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_CTRL_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_TIMEOUT_VAL_BMSK                                                         0x3ffc0
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_TIMEOUT_VAL_SHFT                                                               6
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_RNG_PRTY_BMSK                                                               0x20
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_RNG_PRTY_SHFT                                                                  5

#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_ADDR(x)                                                               ((x) + 0x4)
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_PHYS(x)                                                               ((x) + 0x4)
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_OFFS                                                                  (0x4)
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_RMSK                                                                     0x3ffe0
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_POR                                                                   0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_ATTR                                                                               0x3
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_CTRL_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_CTRL_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_CTRL_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_CTRL_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_CTRL_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_TIMEOUT_VAL_BMSK                                                         0x3ffc0
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_TIMEOUT_VAL_SHFT                                                               6
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_RNG_PRTY_BMSK                                                               0x20
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_RNG_PRTY_SHFT                                                                  5

#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_ADDR(x)                                                               ((x) + 0x8)
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_PHYS(x)                                                               ((x) + 0x8)
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_OFFS                                                                  (0x8)
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_RMSK                                                                     0x3ffe0
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_POR                                                                   0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_ATTR                                                                               0x3
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_CTRL_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_CTRL_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_CTRL_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_CTRL_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_CTRL_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_TIMEOUT_VAL_BMSK                                                         0x3ffc0
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_TIMEOUT_VAL_SHFT                                                               6
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_RNG_PRTY_BMSK                                                               0x20
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_RNG_PRTY_SHFT                                                                  5

#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_ADDR(x)                                                               ((x) + 0xc)
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_PHYS(x)                                                               ((x) + 0xc)
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_OFFS                                                                  (0xc)
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_RMSK                                                                     0x3ffe0
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_POR                                                                   0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_ATTR                                                                               0x3
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_CTRL_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_CTRL_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_CTRL_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_CTRL_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_CTRL_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_TIMEOUT_VAL_BMSK                                                         0x3ffc0
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_TIMEOUT_VAL_SHFT                                                               6
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_RNG_PRTY_BMSK                                                               0x20
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_RNG_PRTY_SHFT                                                                  5

#define HWIO_TCL_R0_SW2TCL5_RING_CTRL_ADDR(x)                                                               ((x) + 0x10)
#define HWIO_TCL_R0_SW2TCL5_RING_CTRL_PHYS(x)                                                               ((x) + 0x10)
#define HWIO_TCL_R0_SW2TCL5_RING_CTRL_OFFS                                                                  (0x10)
#define HWIO_TCL_R0_SW2TCL5_RING_CTRL_RMSK                                                                     0x3ffe0
#define HWIO_TCL_R0_SW2TCL5_RING_CTRL_POR                                                                   0x00000000
#define HWIO_TCL_R0_SW2TCL5_RING_CTRL_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_CTRL_ATTR                                                                               0x3
#define HWIO_TCL_R0_SW2TCL5_RING_CTRL_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL5_RING_CTRL_ADDR(x))
#define HWIO_TCL_R0_SW2TCL5_RING_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL5_RING_CTRL_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL5_RING_CTRL_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL5_RING_CTRL_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL5_RING_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL5_RING_CTRL_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL5_RING_CTRL_IN(x))
#define HWIO_TCL_R0_SW2TCL5_RING_CTRL_TIMEOUT_VAL_BMSK                                                         0x3ffc0
#define HWIO_TCL_R0_SW2TCL5_RING_CTRL_TIMEOUT_VAL_SHFT                                                               6
#define HWIO_TCL_R0_SW2TCL5_RING_CTRL_RNG_PRTY_BMSK                                                               0x20
#define HWIO_TCL_R0_SW2TCL5_RING_CTRL_RNG_PRTY_SHFT                                                                  5
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_ADDR(x)                                                         ((x) + 0x18)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_PHYS(x)                                                         ((x) + 0x18)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_OFFS                                                            (0x18)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_RMSK                                                               0x3ffe0
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_POR                                                             0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_POR_RMSK                                                        0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_ATTR                                                                         0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_TIMEOUT_VAL_BMSK                                                   0x3ffc0
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_TIMEOUT_VAL_SHFT                                                         6
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_RNG_PRTY_BMSK                                                         0x20
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_RNG_PRTY_SHFT                                                            5

#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_ADDR(x)                                                          ((x) + 0x20)
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_PHYS(x)                                                          ((x) + 0x20)
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_OFFS                                                             (0x20)
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_RMSK                                                              0xfffffff
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_POR                                                              0x0b700000
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_POR_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_ATTR                                                                          0x3
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_IN(x)            \
                in_dword(HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_ADDR(x))
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_ADDR(x), m)
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_ADDR(x),v)
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_ADDR(x),m,v,HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_IN(x))
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_PPE_RING_EN_BMSK                                                  0x8000000
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_PPE_RING_EN_SHFT                                                         27
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_VLAN_LLC_SEL_BMSK                                                 0x4000000
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_VLAN_LLC_SEL_SHFT                                                        26
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_INSERT_VLAN_EN_BMSK                                               0x2000000
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_INSERT_VLAN_EN_SHFT                                                      25
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_STOP_META_RD_AT_8B_BDRY_BMSK                                      0x1000000
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_STOP_META_RD_AT_8B_BDRY_SHFT                                             24
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_DSCP_TID_MAP_PROGRAM_EN_BMSK                                       0x800000
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_DSCP_TID_MAP_PROGRAM_EN_SHFT                                             23

#define HWIO_TCL_R0_CMN_CONFIG_ADDR(x)                                                                      ((x) + 0x24)
#define HWIO_TCL_R0_CMN_CONFIG_VDEVID_MISMATCH_EXCEPTION_BMSK                                                 0x400000
#define HWIO_TCL_R0_CMN_CONFIG_VDEVID_MISMATCH_EXCEPTION_SHFT                                                       22
#define HWIO_TCL_R0_CMN_CONFIG_MCAST_CMN_PN_SN_MLO_REINJECT_ENABLE_BMSK                                            0x1
#define HWIO_TCL_R0_CMN_CONFIG_MCAST_CMN_PN_SN_MLO_REINJECT_ENABLE_SHFT                                              0

#define HWIO_TCL_R0_RBM_MAPPING0_ADDR(x)                                                                    ((x) + 0x88)
#define HWIO_TCL_R0_RBM_MAPPING0_PHYS(x)                                                                    ((x) + 0x88)
#define HWIO_TCL_R0_RBM_MAPPING0_OFFS                                                                       (0x88)

#define HWIO_TCL_R0_RBM_MAPPING0_RMSK                                                                       0xffffffff
#define HWIO_TCL_R0_RBM_MAPPING0_POR                                                                        0x00000000
#define HWIO_TCL_R0_RBM_MAPPING0_POR_RMSK                                                                   0xffffffff
#define HWIO_TCL_R0_RBM_MAPPING0_ATTR                                                                                    0x3
#define HWIO_TCL_R0_RBM_MAPPING0_IN(x)            \
                in_dword(HWIO_TCL_R0_RBM_MAPPING0_ADDR(x))
#define HWIO_TCL_R0_RBM_MAPPING0_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_RBM_MAPPING0_ADDR(x), m)
#define HWIO_TCL_R0_RBM_MAPPING0_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_RBM_MAPPING0_ADDR(x),v)
#define HWIO_TCL_R0_RBM_MAPPING0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_RBM_MAPPING0_ADDR(x),m,v,HWIO_TCL_R0_RBM_MAPPING0_IN(x))
#define HWIO_TCL_R0_RBM_MAPPING0_PPE2TCL1_RING_BMSK                                                         0xf0000000
#define HWIO_TCL_R0_RBM_MAPPING0_PPE2TCL1_RING_SHFT                                                                 28
#define HWIO_TCL_R0_RBM_MAPPING0_SW2TCL_CREDIT_RING_BMSK                                                     0xf000000
#define HWIO_TCL_R0_RBM_MAPPING0_SW2TCL_CREDIT_RING_SHFT                                                            24
#define HWIO_TCL_R0_RBM_MAPPING0_FW2TCL_RING_BMSK                                                             0xf00000
#define HWIO_TCL_R0_RBM_MAPPING0_FW2TCL_RING_SHFT                                                                   20
#define HWIO_TCL_R0_RBM_MAPPING0_SW2TCL5_RING_BMSK                                                             0xf0000
#define HWIO_TCL_R0_RBM_MAPPING0_SW2TCL5_RING_SHFT                                                                  16
#define HWIO_TCL_R0_RBM_MAPPING0_SW2TCL4_RING_BMSK                                                              0xf000
#define HWIO_TCL_R0_RBM_MAPPING0_SW2TCL4_RING_SHFT                                                                  12
#define HWIO_TCL_R0_RBM_MAPPING0_SW2TCL3_RING_BMSK                                                               0xf00
#define HWIO_TCL_R0_RBM_MAPPING0_SW2TCL3_RING_SHFT                                                                   8
#define HWIO_TCL_R0_RBM_MAPPING0_SW2TCL2_RING_BMSK                                                                0xf0
#define HWIO_TCL_R0_RBM_MAPPING0_SW2TCL2_RING_SHFT                                                                   4
#define HWIO_TCL_R0_RBM_MAPPING0_SW2TCL1_RING_BMSK                                                                 0xf
#define HWIO_TCL_R0_RBM_MAPPING0_SW2TCL1_RING_SHFT                                                                   0

#define HWIO_TCL_R0_SW_CONFIG_BANK_n_ADDR(base,n)                                                           ((base) + 0X8C + (0x4*(n)))
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_PHYS(base,n)                                                           ((base) + 0X8C + (0x4*(n)))
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_OFFS(n)                                                                (0X8C + (0x4*(n)))
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_RMSK                                                                     0x7fffff
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_MAXn                                                                           47
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_POR                                                                    0x00000038
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_POR_RMSK                                                               0xffffffff
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_ATTR                                                                                0x3
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_INI(base,n)                \
                in_dword_masked(HWIO_TCL_R0_SW_CONFIG_BANK_n_ADDR(base,n), HWIO_TCL_R0_SW_CONFIG_BANK_n_RMSK)
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_INMI(base,n,mask)        \
                in_dword_masked(HWIO_TCL_R0_SW_CONFIG_BANK_n_ADDR(base,n), mask)
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_OUTI(base,n,val)        \
                out_dword(HWIO_TCL_R0_SW_CONFIG_BANK_n_ADDR(base,n),val)
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_OUTMI(base,n,mask,val) \
                out_dword_masked_ns(HWIO_TCL_R0_SW_CONFIG_BANK_n_ADDR(base,n),mask,val,HWIO_TCL_R0_SW_CONFIG_BANK_n_INI(base,n))
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_DSCP_TID_TABLE_NUM_BMSK                                                  0x7e0000
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_DSCP_TID_TABLE_NUM_SHFT                                                        17
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_PMAC_ID_BMSK                                                              0x18000
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_PMAC_ID_SHFT                                                                   15
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_VDEV_ID_CHECK_EN_BMSK                                                      0x4000
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_VDEV_ID_CHECK_EN_SHFT                                                          14
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_MESH_ENABLE_BMSK                                                           0x3000
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_MESH_ENABLE_SHFT                                                               12
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_ADDRY_EN_BMSK                                                               0x800
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_ADDRY_EN_SHFT                                                                  11
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_ADDRX_EN_BMSK                                                               0x400
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_ADDRX_EN_SHFT                                                                  10
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_INDEX_LOOKUP_ENABLE_BMSK                                                    0x200
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_INDEX_LOOKUP_ENABLE_SHFT                                                        9
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_LINK_META_SWAP_BMSK                                                         0x100
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_LINK_META_SWAP_SHFT                                                             8
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_SRC_BUFFER_SWAP_BMSK                                                         0x80
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_SRC_BUFFER_SWAP_SHFT                                                            7
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_ENCRYPT_TYPE_BMSK                                                            0x78
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_ENCRYPT_TYPE_SHFT                                                               3
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_ENCAP_TYPE_BMSK                                                               0x6
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_ENCAP_TYPE_SHFT                                                                 1
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_EPD_BMSK                                                                      0x1
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_EPD_SHFT                                                                        0
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_ADDR(base,n)                                               ((base) + 0X14C + (0x4*(n)))
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_PHYS(base,n)                                               ((base) + 0X14C + (0x4*(n)))
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_OFFS(n)                                                    (0X14C + (0x4*(n)))
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_MAXn                                                               15
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_POR                                                        0x00000000
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_ATTR                                                                    0x3
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_INI(base,n)                \
                in_dword_masked(HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_ADDR(base,n), HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_RMSK)
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_INMI(base,n,mask)        \
                in_dword_masked(HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_ADDR(base,n), mask)
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_OUTI(base,n,val)        \
                out_dword(HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_ADDR(base,n),val)
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_OUTMI(base,n,mask,val) \
                out_dword_masked_ns(HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_ADDR(base,n),mask,val,HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_INI(base,n))
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_VAL_BMSK                                                   0xffffffff
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_VAL_SHFT                                                            0
#define HWIO_TCL_R0_DSCP_TID_MAP_n_ADDR(base,n)                                                             ((base) + 0X240 + (0x4*(n)))
#define HWIO_TCL_R0_DSCP_TID_MAP_n_PHYS(base,n)                                                             ((base) + 0X240 + (0x4*(n)))
#define HWIO_TCL_R0_DSCP_TID_MAP_n_OFFS(n)                                                                  (0X240 + (0x4*(n)))
#define HWIO_TCL_R0_DSCP_TID_MAP_n_RMSK                                                                     0xffffffff
#define HWIO_TCL_R0_DSCP_TID_MAP_n_MAXn                                                                            287
#define HWIO_TCL_R0_DSCP_TID_MAP_n_POR                                                                      0x00000000
#define HWIO_TCL_R0_DSCP_TID_MAP_n_POR_RMSK                                                                 0xffffffff
#define HWIO_TCL_R0_DSCP_TID_MAP_n_ATTR                                                                                  0x3
#define HWIO_TCL_R0_DSCP_TID_MAP_n_INI(base,n)                \
                in_dword_masked(HWIO_TCL_R0_DSCP_TID_MAP_n_ADDR(base,n), HWIO_TCL_R0_DSCP_TID_MAP_n_RMSK)
#define HWIO_TCL_R0_DSCP_TID_MAP_n_INMI(base,n,mask)        \
                in_dword_masked(HWIO_TCL_R0_DSCP_TID_MAP_n_ADDR(base,n), mask)
#define HWIO_TCL_R0_DSCP_TID_MAP_n_OUTI(base,n,val)        \
                out_dword(HWIO_TCL_R0_DSCP_TID_MAP_n_ADDR(base,n),val)
#define HWIO_TCL_R0_DSCP_TID_MAP_n_OUTMI(base,n,mask,val) \
                out_dword_masked_ns(HWIO_TCL_R0_DSCP_TID_MAP_n_ADDR(base,n),mask,val,HWIO_TCL_R0_DSCP_TID_MAP_n_INI(base,n))
#define HWIO_TCL_R0_DSCP_TID_MAP_n_VAL_BMSK                                                                 0xffffffff
#define HWIO_TCL_R0_DSCP_TID_MAP_n_VAL_SHFT                                                                          0

#define HWIO_TCL_R0_PCP_TID_MAP_ADDR(x)                                                                     ((x) + 0x6c0)
#define HWIO_TCL_R0_PCP_TID_MAP_PHYS(x)                                                                     ((x) + 0x6c0)
#define HWIO_TCL_R0_PCP_TID_MAP_OFFS                                                                        (0x6c0)
#define HWIO_TCL_R0_PCP_TID_MAP_RMSK                                                                          0xffffff
#define HWIO_TCL_R0_PCP_TID_MAP_POR                                                                         0x00000000
#define HWIO_TCL_R0_PCP_TID_MAP_POR_RMSK                                                                    0xffffffff
#define HWIO_TCL_R0_PCP_TID_MAP_ATTR                                                                                     0x3
#define HWIO_TCL_R0_PCP_TID_MAP_IN(x)            \
                in_dword(HWIO_TCL_R0_PCP_TID_MAP_ADDR(x))
#define HWIO_TCL_R0_PCP_TID_MAP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_PCP_TID_MAP_ADDR(x), m)
#define HWIO_TCL_R0_PCP_TID_MAP_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_PCP_TID_MAP_ADDR(x),v)
#define HWIO_TCL_R0_PCP_TID_MAP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_PCP_TID_MAP_ADDR(x),m,v,HWIO_TCL_R0_PCP_TID_MAP_IN(x))
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_7_BMSK                                                                    0xe00000
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_7_SHFT                                                                          21
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_6_BMSK                                                                    0x1c0000
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_6_SHFT                                                                          18
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_5_BMSK                                                                     0x38000
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_5_SHFT                                                                          15
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_4_BMSK                                                                      0x7000
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_4_SHFT                                                                          12
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_3_BMSK                                                                       0xe00
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_3_SHFT                                                                           9
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_2_BMSK                                                                       0x1c0
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_2_SHFT                                                                           6
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_1_BMSK                                                                        0x38
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_1_SHFT                                                                           3
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_0_BMSK                                                                         0x7
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_0_SHFT                                                                           0

#define HWIO_TCL_R0_TID_MAP_PRTY_ADDR(x)                                                                    ((x) + 0x6e8)
#define HWIO_TCL_R0_TID_MAP_PRTY_PHYS(x)                                                                    ((x) + 0x6e8)
#define HWIO_TCL_R0_TID_MAP_PRTY_OFFS                                                                       (0x6e8)
#define HWIO_TCL_R0_TID_MAP_PRTY_RMSK                                                                             0xef
#define HWIO_TCL_R0_TID_MAP_PRTY_POR                                                                        0x00000000
#define HWIO_TCL_R0_TID_MAP_PRTY_POR_RMSK                                                                   0xffffffff
#define HWIO_TCL_R0_TID_MAP_PRTY_ATTR                                                                                    0x3
#define HWIO_TCL_R0_TID_MAP_PRTY_IN(x)            \
                in_dword(HWIO_TCL_R0_TID_MAP_PRTY_ADDR(x))
#define HWIO_TCL_R0_TID_MAP_PRTY_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TID_MAP_PRTY_ADDR(x), m)
#define HWIO_TCL_R0_TID_MAP_PRTY_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TID_MAP_PRTY_ADDR(x),v)
#define HWIO_TCL_R0_TID_MAP_PRTY_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TID_MAP_PRTY_ADDR(x),m,v,HWIO_TCL_R0_TID_MAP_PRTY_IN(x))
#define HWIO_TCL_R0_TID_MAP_PRTY_TID_DEF_BMSK                                                                     0xe0
#define HWIO_TCL_R0_TID_MAP_PRTY_TID_DEF_SHFT                                                                        5
#define HWIO_TCL_R0_TID_MAP_PRTY_VAL_BMSK                                                                          0xf
#define HWIO_TCL_R0_TID_MAP_PRTY_VAL_SHFT                                                                            0

#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_ADDR(x)                                                           ((x) + 0x900)
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_PHYS(x)                                                           ((x) + 0x900)
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_OFFS                                                              (0x900)
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_POR                                                               0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_ATTR                                                                           0x3
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                    0

#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_ADDR(x)                                                           ((x) + 0x904)
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_PHYS(x)                                                           ((x) + 0x904)
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_OFFS                                                              (0x904)
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_RMSK                                                               0xfffffff
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_POR                                                               0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_ATTR                                                                           0x3
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_RING_SIZE_BMSK                                                     0xfffff00
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_RING_SIZE_SHFT                                                             8
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                 0xff
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                    0

#define HWIO_TCL_R0_SW2TCL1_RING_ID_ADDR(x)                                                                 ((x) + 0x908)
#define HWIO_TCL_R0_SW2TCL1_RING_ID_PHYS(x)                                                                 ((x) + 0x908)
#define HWIO_TCL_R0_SW2TCL1_RING_ID_OFFS                                                                    (0x908)
#define HWIO_TCL_R0_SW2TCL1_RING_ID_RMSK                                                                          0xff
#define HWIO_TCL_R0_SW2TCL1_RING_ID_POR                                                                     0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_ID_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_ID_ATTR                                                                                 0x3
#define HWIO_TCL_R0_SW2TCL1_RING_ID_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_ID_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_ID_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_ID_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_ID_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_ID_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_ID_ENTRY_SIZE_BMSK                                                               0xff
#define HWIO_TCL_R0_SW2TCL1_RING_ID_ENTRY_SIZE_SHFT                                                                  0

#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_ADDR(x)                                                             ((x) + 0x90c)
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_PHYS(x)                                                             ((x) + 0x90c)
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_OFFS                                                                (0x90c)
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_POR                                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_ATTR                                                                             0x1
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                0xffff0000
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                        16
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_NUM_VALID_WORDS_BMSK                                                    0xffff
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_NUM_VALID_WORDS_SHFT                                                         0

#define HWIO_TCL_R0_SW2TCL1_RING_MISC_ADDR(x)                                                               ((x) + 0x910)
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_PHYS(x)                                                               ((x) + 0x910)
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_OFFS                                                                  (0x910)
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_RMSK                                                                    0x3fffff
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_POR                                                                   0x00000080
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_ATTR                                                                               0x3
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_MISC_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_MISC_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_MISC_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_MISC_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_MISC_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SPARE_CONTROL_BMSK                                                      0x3fc000
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SPARE_CONTROL_SHFT                                                            14
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SRNG_SM_STATE2_BMSK                                                       0x3000
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SRNG_SM_STATE2_SHFT                                                           12
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SRNG_SM_STATE1_BMSK                                                        0xf00
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SRNG_SM_STATE1_SHFT                                                            8
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SRNG_IS_IDLE_BMSK                                                           0x80
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SRNG_IS_IDLE_SHFT                                                              7
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SRNG_ENABLE_BMSK                                                            0x40
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SRNG_ENABLE_SHFT                                                               6
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                      0x20
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                         5
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                       0x10
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                          4
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_MSI_SWAP_BIT_BMSK                                                            0x8
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_MSI_SWAP_BIT_SHFT                                                              3
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SECURITY_BIT_BMSK                                                            0x4
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SECURITY_BIT_SHFT                                                              2
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_LOOPCNT_DISABLE_BMSK                                                         0x2
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_LOOPCNT_DISABLE_SHFT                                                           1
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_RING_ID_DISABLE_BMSK                                                         0x1
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_RING_ID_DISABLE_SHFT                                                           0

#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_ADDR(x)                                                        ((x) + 0x91c)
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_PHYS(x)                                                        ((x) + 0x91c)
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_OFFS                                                           (0x91c)
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_RMSK                                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_POR                                                            0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_ATTR                                                                        0x3
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                      0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                               0

#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_ADDR(x)                                                        ((x) + 0x920)
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_PHYS(x)                                                        ((x) + 0x920)
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_OFFS                                                           (0x920)
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_RMSK                                                                 0xff
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_POR                                                            0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_ATTR                                                                        0x3
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                            0xff
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                               0

#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                             ((x) + 0x930)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                             ((x) + 0x930)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                (0x930)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                             ((x) + 0x934)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                             ((x) + 0x934)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                (0x934)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                    0xffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                      0xffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                           0

#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_ADDR(x)                                                ((x) + 0x938)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_PHYS(x)                                                ((x) + 0x938)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_OFFS                                                   (0x938)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_POR                                                    0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_ATTR                                                                0x1
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                     0xffff0000
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                             16
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                0x8000
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                    15
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                          0x7fff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                               0

#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                             ((x) + 0x93c)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                             ((x) + 0x93c)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                (0x93c)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                     0x3ff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                  0x3ff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                      0

#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                            ((x) + 0x940)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                            ((x) + 0x940)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_OFFS                                               (0x940)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                      0x7
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_POR                                                0x00000003
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                            0x3
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                 0x7
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                   0

#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                           ((x) + 0x944)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                           ((x) + 0x944)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_OFFS                                              (0x944)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_RMSK                                               0xfffffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_POR                                               0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                           0x1
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                0xff00000
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                       20
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                               0xfffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                     0

#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_ADDR(x)                                                      ((x) + 0x948)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_PHYS(x)                                                      ((x) + 0x948)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_OFFS                                                         (0x948)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_POR                                                          0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_ADDR(x)                                                      ((x) + 0x94c)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_PHYS(x)                                                      ((x) + 0x94c)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_OFFS                                                         (0x94c)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_POR                                                          0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                  0x100
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                      8
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_ADDR(x)                                                          ((x) + 0x950)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_PHYS(x)                                                          ((x) + 0x950)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_OFFS                                                             (0x950)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_RMSK                                                             0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_POR                                                              0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_ATTR                                                                          0x3
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_VALUE_SHFT                                                                0

#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_ADDR(x)                                                    ((x) + 0x970)
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_PHYS(x)                                                    ((x) + 0x970)
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_OFFS                                                       (0x970)
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_RMSK                                                           0xffff
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_POR                                                        0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_ATTR                                                                    0x3
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                        0xffff
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                             0

#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_ADDR(x)                                                             ((x) + 0x974)
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_PHYS(x)                                                             ((x) + 0x974)
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_OFFS                                                                (0x974)
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_RMSK                                                                0xffff003f
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_POR                                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_ATTR                                                                             0x3
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_MISC_1_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_MISC_1_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_MISC_1_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_MISC_1_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_MISC_1_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                       0xffff0000
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                               16
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                              0x3f
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                 0

#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_ADDR(x)                                                           ((x) + 0x978)
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_PHYS(x)                                                           ((x) + 0x978)
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_OFFS                                                              (0x978)
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_POR                                                               0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_ATTR                                                                           0x3
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                    0

#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_ADDR(x)                                                           ((x) + 0x97c)
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_PHYS(x)                                                           ((x) + 0x97c)
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_OFFS                                                              (0x97c)
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_RMSK                                                               0xfffffff
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_POR                                                               0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_ATTR                                                                           0x3
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_RING_SIZE_BMSK                                                     0xfffff00
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_RING_SIZE_SHFT                                                             8
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                 0xff
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                    0

#define HWIO_TCL_R0_SW2TCL2_RING_ID_ADDR(x)                                                                 ((x) + 0x980)
#define HWIO_TCL_R0_SW2TCL2_RING_ID_PHYS(x)                                                                 ((x) + 0x980)
#define HWIO_TCL_R0_SW2TCL2_RING_ID_OFFS                                                                    (0x980)
#define HWIO_TCL_R0_SW2TCL2_RING_ID_RMSK                                                                          0xff
#define HWIO_TCL_R0_SW2TCL2_RING_ID_POR                                                                     0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_ID_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_ID_ATTR                                                                                 0x3
#define HWIO_TCL_R0_SW2TCL2_RING_ID_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_ID_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_ID_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_ID_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_ID_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_ID_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_ID_ENTRY_SIZE_BMSK                                                               0xff
#define HWIO_TCL_R0_SW2TCL2_RING_ID_ENTRY_SIZE_SHFT                                                                  0

#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_ADDR(x)                                                             ((x) + 0x984)
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_PHYS(x)                                                             ((x) + 0x984)
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_OFFS                                                                (0x984)
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_POR                                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_ATTR                                                                             0x1
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                0xffff0000
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                        16
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_NUM_VALID_WORDS_BMSK                                                    0xffff
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_NUM_VALID_WORDS_SHFT                                                         0

#define HWIO_TCL_R0_SW2TCL2_RING_MISC_ADDR(x)                                                               ((x) + 0x988)
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_PHYS(x)                                                               ((x) + 0x988)
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_OFFS                                                                  (0x988)
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_RMSK                                                                    0x3fffff
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_POR                                                                   0x00000080
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_ATTR                                                                               0x3
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_MISC_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_MISC_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_MISC_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_MISC_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_MISC_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SPARE_CONTROL_BMSK                                                      0x3fc000
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SPARE_CONTROL_SHFT                                                            14
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SRNG_SM_STATE2_BMSK                                                       0x3000
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SRNG_SM_STATE2_SHFT                                                           12
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SRNG_SM_STATE1_BMSK                                                        0xf00
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SRNG_SM_STATE1_SHFT                                                            8
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SRNG_IS_IDLE_BMSK                                                           0x80
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SRNG_IS_IDLE_SHFT                                                              7
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SRNG_ENABLE_BMSK                                                            0x40
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SRNG_ENABLE_SHFT                                                               6
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                      0x20
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                         5
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                       0x10
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                          4
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_MSI_SWAP_BIT_BMSK                                                            0x8
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_MSI_SWAP_BIT_SHFT                                                              3
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SECURITY_BIT_BMSK                                                            0x4
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SECURITY_BIT_SHFT                                                              2
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_LOOPCNT_DISABLE_BMSK                                                         0x2
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_LOOPCNT_DISABLE_SHFT                                                           1
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_RING_ID_DISABLE_BMSK                                                         0x1
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_RING_ID_DISABLE_SHFT                                                           0

#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_ADDR(x)                                                        ((x) + 0x994)
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_PHYS(x)                                                        ((x) + 0x994)
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_OFFS                                                           (0x994)
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_RMSK                                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_POR                                                            0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_ATTR                                                                        0x3
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                      0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                               0

#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_ADDR(x)                                                        ((x) + 0x998)
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_PHYS(x)                                                        ((x) + 0x998)
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_OFFS                                                           (0x998)
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_RMSK                                                                 0xff
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_POR                                                            0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_ATTR                                                                        0x3
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                            0xff
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                               0

#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                             ((x) + 0x9a8)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                             ((x) + 0x9a8)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                (0x9a8)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                             ((x) + 0x9ac)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                             ((x) + 0x9ac)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                (0x9ac)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                    0xffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                      0xffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                           0

#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_ADDR(x)                                                ((x) + 0x9b0)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_PHYS(x)                                                ((x) + 0x9b0)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_OFFS                                                   (0x9b0)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_POR                                                    0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_ATTR                                                                0x1
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                     0xffff0000
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                             16
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                0x8000
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                    15
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                          0x7fff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                               0

#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                             ((x) + 0x9b4)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                             ((x) + 0x9b4)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                (0x9b4)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                     0x3ff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                  0x3ff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                      0

#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                            ((x) + 0x9b8)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                            ((x) + 0x9b8)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_OFFS                                               (0x9b8)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                      0x7
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_POR                                                0x00000003
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                            0x3
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                 0x7
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                   0

#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                           ((x) + 0x9bc)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                           ((x) + 0x9bc)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_OFFS                                              (0x9bc)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_RMSK                                               0xfffffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_POR                                               0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                           0x1
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                0xff00000
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                       20
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                               0xfffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                     0

#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_ADDR(x)                                                      ((x) + 0x9c0)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_PHYS(x)                                                      ((x) + 0x9c0)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_OFFS                                                         (0x9c0)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_POR                                                          0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_ADDR(x)                                                      ((x) + 0x9c4)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_PHYS(x)                                                      ((x) + 0x9c4)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_OFFS                                                         (0x9c4)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_POR                                                          0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                  0x100
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                      8
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_ADDR(x)                                                          ((x) + 0x9c8)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_PHYS(x)                                                          ((x) + 0x9c8)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_OFFS                                                             (0x9c8)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_RMSK                                                             0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_POR                                                              0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_ATTR                                                                          0x3
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_VALUE_SHFT                                                                0

#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_ADDR(x)                                                    ((x) + 0x9e8)
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_PHYS(x)                                                    ((x) + 0x9e8)
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_OFFS                                                       (0x9e8)
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_RMSK                                                           0xffff
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_POR                                                        0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_ATTR                                                                    0x3
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                        0xffff
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                             0

#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_ADDR(x)                                                             ((x) + 0x9ec)
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_PHYS(x)                                                             ((x) + 0x9ec)
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_OFFS                                                                (0x9ec)
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_RMSK                                                                0xffff003f
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_POR                                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_ATTR                                                                             0x3
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_MISC_1_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_MISC_1_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_MISC_1_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_MISC_1_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_MISC_1_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                       0xffff0000
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                               16
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                              0x3f
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                 0

#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_ADDR(x)                                                           ((x) + 0x9f0)
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_PHYS(x)                                                           ((x) + 0x9f0)
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_OFFS                                                              (0x9f0)
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_POR                                                               0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_ATTR                                                                           0x3
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                    0

#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_ADDR(x)                                                           ((x) + 0x9f4)
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_PHYS(x)                                                           ((x) + 0x9f4)
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_OFFS                                                              (0x9f4)
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_RMSK                                                               0xfffffff
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_POR                                                               0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_ATTR                                                                           0x3
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_RING_SIZE_BMSK                                                     0xfffff00
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_RING_SIZE_SHFT                                                             8
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                 0xff
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                    0

#define HWIO_TCL_R0_SW2TCL3_RING_ID_ADDR(x)                                                                 ((x) + 0x9f8)
#define HWIO_TCL_R0_SW2TCL3_RING_ID_PHYS(x)                                                                 ((x) + 0x9f8)
#define HWIO_TCL_R0_SW2TCL3_RING_ID_OFFS                                                                    (0x9f8)
#define HWIO_TCL_R0_SW2TCL3_RING_ID_RMSK                                                                          0xff
#define HWIO_TCL_R0_SW2TCL3_RING_ID_POR                                                                     0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_ID_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_ID_ATTR                                                                                 0x3
#define HWIO_TCL_R0_SW2TCL3_RING_ID_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_ID_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_ID_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_ID_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_ID_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_ID_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_ID_ENTRY_SIZE_BMSK                                                               0xff
#define HWIO_TCL_R0_SW2TCL3_RING_ID_ENTRY_SIZE_SHFT                                                                  0

#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_ADDR(x)                                                             ((x) + 0x9fc)
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_PHYS(x)                                                             ((x) + 0x9fc)
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_OFFS                                                                (0x9fc)
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_POR                                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_ATTR                                                                             0x1
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                0xffff0000
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                        16
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_NUM_VALID_WORDS_BMSK                                                    0xffff
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_NUM_VALID_WORDS_SHFT                                                         0

#define HWIO_TCL_R0_SW2TCL3_RING_MISC_ADDR(x)                                                               ((x) + 0xa00)
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_PHYS(x)                                                               ((x) + 0xa00)
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_OFFS                                                                  (0xa00)
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_RMSK                                                                    0x3fffff
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_POR                                                                   0x00000080
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_ATTR                                                                               0x3
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_MISC_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_MISC_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_MISC_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_MISC_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_MISC_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SPARE_CONTROL_BMSK                                                      0x3fc000
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SPARE_CONTROL_SHFT                                                            14
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SRNG_SM_STATE2_BMSK                                                       0x3000
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SRNG_SM_STATE2_SHFT                                                           12
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SRNG_SM_STATE1_BMSK                                                        0xf00
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SRNG_SM_STATE1_SHFT                                                            8
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SRNG_IS_IDLE_BMSK                                                           0x80
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SRNG_IS_IDLE_SHFT                                                              7
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SRNG_ENABLE_BMSK                                                            0x40
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SRNG_ENABLE_SHFT                                                               6
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                      0x20
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                         5
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                       0x10
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                          4
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_MSI_SWAP_BIT_BMSK                                                            0x8
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_MSI_SWAP_BIT_SHFT                                                              3
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SECURITY_BIT_BMSK                                                            0x4
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SECURITY_BIT_SHFT                                                              2
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_LOOPCNT_DISABLE_BMSK                                                         0x2
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_LOOPCNT_DISABLE_SHFT                                                           1
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_RING_ID_DISABLE_BMSK                                                         0x1
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_RING_ID_DISABLE_SHFT                                                           0

#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_ADDR(x)                                                        ((x) + 0xa0c)
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_PHYS(x)                                                        ((x) + 0xa0c)
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_OFFS                                                           (0xa0c)
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_RMSK                                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_POR                                                            0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_ATTR                                                                        0x3
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                      0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                               0

#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_ADDR(x)                                                        ((x) + 0xa10)
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_PHYS(x)                                                        ((x) + 0xa10)
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_OFFS                                                           (0xa10)
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_RMSK                                                                 0xff
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_POR                                                            0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_ATTR                                                                        0x3
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                            0xff
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                               0

#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                             ((x) + 0xa20)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                             ((x) + 0xa20)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                (0xa20)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                             ((x) + 0xa24)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                             ((x) + 0xa24)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                (0xa24)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                    0xffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                      0xffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                           0

#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_ADDR(x)                                                ((x) + 0xa28)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_PHYS(x)                                                ((x) + 0xa28)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_OFFS                                                   (0xa28)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_POR                                                    0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_ATTR                                                                0x1
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                     0xffff0000
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                             16
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                0x8000
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                    15
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                          0x7fff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                               0

#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                             ((x) + 0xa2c)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                             ((x) + 0xa2c)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                (0xa2c)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                     0x3ff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                  0x3ff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                      0

#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                            ((x) + 0xa30)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                            ((x) + 0xa30)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_OFFS                                               (0xa30)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                      0x7
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_POR                                                0x00000003
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                            0x3
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                 0x7
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                   0

#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                           ((x) + 0xa34)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                           ((x) + 0xa34)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_OFFS                                              (0xa34)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_RMSK                                               0xfffffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_POR                                               0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                           0x1
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                0xff00000
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                       20
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                               0xfffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                     0

#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_ADDR(x)                                                      ((x) + 0xa38)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_PHYS(x)                                                      ((x) + 0xa38)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_OFFS                                                         (0xa38)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_POR                                                          0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_ADDR(x)                                                      ((x) + 0xa3c)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_PHYS(x)                                                      ((x) + 0xa3c)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_OFFS                                                         (0xa3c)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_POR                                                          0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                  0x100
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                      8
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_ADDR(x)                                                          ((x) + 0xa40)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_PHYS(x)                                                          ((x) + 0xa40)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_OFFS                                                             (0xa40)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_RMSK                                                             0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_POR                                                              0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_ATTR                                                                          0x3
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_VALUE_SHFT                                                                0

#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_ADDR(x)                                                    ((x) + 0xa60)
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_PHYS(x)                                                    ((x) + 0xa60)
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_OFFS                                                       (0xa60)
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_RMSK                                                           0xffff
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_POR                                                        0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_ATTR                                                                    0x3
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                        0xffff
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                             0

#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_ADDR(x)                                                             ((x) + 0xa64)
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_PHYS(x)                                                             ((x) + 0xa64)
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_OFFS                                                                (0xa64)
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_RMSK                                                                0xffff003f
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_POR                                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_ATTR                                                                             0x3
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_MISC_1_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_MISC_1_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_MISC_1_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_MISC_1_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_MISC_1_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                       0xffff0000
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                               16
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                              0x3f
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                 0

#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_ADDR(x)                                                           ((x) + 0xa68)
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_PHYS(x)                                                           ((x) + 0xa68)
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_OFFS                                                              (0xa68)
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_POR                                                               0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_ATTR                                                                           0x3
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                    0

#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_ADDR(x)                                                           ((x) + 0xa6c)
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_PHYS(x)                                                           ((x) + 0xa6c)
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_OFFS                                                              (0xa6c)
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_RMSK                                                               0xfffffff
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_POR                                                               0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_ATTR                                                                           0x3
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_RING_SIZE_BMSK                                                     0xfffff00
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_RING_SIZE_SHFT                                                             8
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                 0xff
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                    0

#define HWIO_TCL_R0_SW2TCL4_RING_ID_ADDR(x)                                                                 ((x) + 0xa70)
#define HWIO_TCL_R0_SW2TCL4_RING_ID_PHYS(x)                                                                 ((x) + 0xa70)
#define HWIO_TCL_R0_SW2TCL4_RING_ID_OFFS                                                                    (0xa70)
#define HWIO_TCL_R0_SW2TCL4_RING_ID_RMSK                                                                          0xff
#define HWIO_TCL_R0_SW2TCL4_RING_ID_POR                                                                     0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_ID_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_ID_ATTR                                                                                 0x3
#define HWIO_TCL_R0_SW2TCL4_RING_ID_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_ID_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_ID_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_ID_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_ID_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_ID_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_ID_ENTRY_SIZE_BMSK                                                               0xff
#define HWIO_TCL_R0_SW2TCL4_RING_ID_ENTRY_SIZE_SHFT                                                                  0

#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_ADDR(x)                                                             ((x) + 0xa74)
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_PHYS(x)                                                             ((x) + 0xa74)
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_OFFS                                                                (0xa74)
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_POR                                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_ATTR                                                                             0x1
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                0xffff0000
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                        16
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_NUM_VALID_WORDS_BMSK                                                    0xffff
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_NUM_VALID_WORDS_SHFT                                                         0

#define HWIO_TCL_R0_SW2TCL4_RING_MISC_ADDR(x)                                                               ((x) + 0xa78)
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_PHYS(x)                                                               ((x) + 0xa78)
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_OFFS                                                                  (0xa78)
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_RMSK                                                                    0x3fffff
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_POR                                                                   0x00000080
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_ATTR                                                                               0x3
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_MISC_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_MISC_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_MISC_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_MISC_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_MISC_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SPARE_CONTROL_BMSK                                                      0x3fc000
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SPARE_CONTROL_SHFT                                                            14
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SRNG_SM_STATE2_BMSK                                                       0x3000
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SRNG_SM_STATE2_SHFT                                                           12
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SRNG_SM_STATE1_BMSK                                                        0xf00
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SRNG_SM_STATE1_SHFT                                                            8
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SRNG_IS_IDLE_BMSK                                                           0x80
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SRNG_IS_IDLE_SHFT                                                              7
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SRNG_ENABLE_BMSK                                                            0x40
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SRNG_ENABLE_SHFT                                                               6
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                      0x20
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                         5
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                       0x10
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                          4
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_MSI_SWAP_BIT_BMSK                                                            0x8
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_MSI_SWAP_BIT_SHFT                                                              3
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SECURITY_BIT_BMSK                                                            0x4
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SECURITY_BIT_SHFT                                                              2
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_LOOPCNT_DISABLE_BMSK                                                         0x2
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_LOOPCNT_DISABLE_SHFT                                                           1
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_RING_ID_DISABLE_BMSK                                                         0x1
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_RING_ID_DISABLE_SHFT                                                           0

#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_ADDR(x)                                                        ((x) + 0xa84)
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_PHYS(x)                                                        ((x) + 0xa84)
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_OFFS                                                           (0xa84)
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_RMSK                                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_POR                                                            0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_ATTR                                                                        0x3
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                      0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                               0

#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_ADDR(x)                                                        ((x) + 0xa88)
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_PHYS(x)                                                        ((x) + 0xa88)
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_OFFS                                                           (0xa88)
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_RMSK                                                                 0xff
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_POR                                                            0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_ATTR                                                                        0x3
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                            0xff
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                               0

#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                             ((x) + 0xa98)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                             ((x) + 0xa98)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                (0xa98)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                             ((x) + 0xa9c)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                             ((x) + 0xa9c)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                (0xa9c)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                    0xffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                      0xffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                           0

#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_ADDR(x)                                                ((x) + 0xaa0)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_PHYS(x)                                                ((x) + 0xaa0)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_OFFS                                                   (0xaa0)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_POR                                                    0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_ATTR                                                                0x1
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                     0xffff0000
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                             16
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                0x8000
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                    15
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                          0x7fff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                               0

#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                             ((x) + 0xaa4)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                             ((x) + 0xaa4)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                (0xaa4)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                     0x3ff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                  0x3ff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                      0

#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                            ((x) + 0xaa8)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                            ((x) + 0xaa8)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_OFFS                                               (0xaa8)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                      0x7
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_POR                                                0x00000003
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                            0x3
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                 0x7
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                   0

#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                           ((x) + 0xaac)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                           ((x) + 0xaac)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_OFFS                                              (0xaac)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_RMSK                                               0xfffffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_POR                                               0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                           0x1
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                0xff00000
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                       20
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                               0xfffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                     0

#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_ADDR(x)                                                      ((x) + 0xab0)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_PHYS(x)                                                      ((x) + 0xab0)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_OFFS                                                         (0xab0)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_POR                                                          0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_ADDR(x)                                                      ((x) + 0xab4)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_PHYS(x)                                                      ((x) + 0xab4)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_OFFS                                                         (0xab4)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_POR                                                          0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                  0x100
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                      8
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_ADDR(x)                                                          ((x) + 0xab8)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_PHYS(x)                                                          ((x) + 0xab8)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_OFFS                                                             (0xab8)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_RMSK                                                             0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_POR                                                              0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_ATTR                                                                          0x3
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_VALUE_SHFT                                                                0

#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_ADDR(x)                                                    ((x) + 0xad8)
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_PHYS(x)                                                    ((x) + 0xad8)
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_OFFS                                                       (0xad8)
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_RMSK                                                           0xffff
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_POR                                                        0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_ATTR                                                                    0x3
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                        0xffff
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                             0

#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_ADDR(x)                                                             ((x) + 0xadc)
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_PHYS(x)                                                             ((x) + 0xadc)
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_OFFS                                                                (0xadc)
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_RMSK                                                                0xffff003f
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_POR                                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_ATTR                                                                             0x3
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_MISC_1_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_MISC_1_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_MISC_1_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_MISC_1_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_MISC_1_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                       0xffff0000
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                               16
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                              0x3f
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                 0

#define HWIO_TCL_R0_SW2TCL5_RING_BASE_LSB_ADDR(x)                                                           ((x) + 0xae0)
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_LSB_PHYS(x)                                                           ((x) + 0xae0)
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_LSB_OFFS                                                              (0xae0)
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_LSB_POR                                                               0x00000000
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_LSB_ATTR                                                                           0x3
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL5_RING_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL5_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL5_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL5_RING_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL5_RING_BASE_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                    0

#define HWIO_TCL_R0_SW2TCL5_RING_BASE_MSB_ADDR(x)                                                           ((x) + 0xae4)
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_MSB_PHYS(x)                                                           ((x) + 0xae4)
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_MSB_OFFS                                                              (0xae4)
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_MSB_RMSK                                                               0xfffffff
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_MSB_POR                                                               0x00000000
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_MSB_ATTR                                                                           0x3
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL5_RING_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL5_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL5_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL5_RING_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL5_RING_BASE_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_MSB_RING_SIZE_BMSK                                                     0xfffff00
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_MSB_RING_SIZE_SHFT                                                             8
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                 0xff
#define HWIO_TCL_R0_SW2TCL5_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                    0

#define HWIO_TCL_R0_SW2TCL5_RING_ID_ADDR(x)                                                                 ((x) + 0xae8)
#define HWIO_TCL_R0_SW2TCL5_RING_ID_PHYS(x)                                                                 ((x) + 0xae8)
#define HWIO_TCL_R0_SW2TCL5_RING_ID_OFFS                                                                    (0xae8)
#define HWIO_TCL_R0_SW2TCL5_RING_ID_RMSK                                                                          0xff
#define HWIO_TCL_R0_SW2TCL5_RING_ID_POR                                                                     0x00000000
#define HWIO_TCL_R0_SW2TCL5_RING_ID_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_ID_ATTR                                                                                 0x3
#define HWIO_TCL_R0_SW2TCL5_RING_ID_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL5_RING_ID_ADDR(x))
#define HWIO_TCL_R0_SW2TCL5_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL5_RING_ID_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL5_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL5_RING_ID_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL5_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL5_RING_ID_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL5_RING_ID_IN(x))
#define HWIO_TCL_R0_SW2TCL5_RING_ID_ENTRY_SIZE_BMSK                                                               0xff
#define HWIO_TCL_R0_SW2TCL5_RING_ID_ENTRY_SIZE_SHFT                                                                  0

#define HWIO_TCL_R0_SW2TCL5_RING_STATUS_ADDR(x)                                                             ((x) + 0xaec)
#define HWIO_TCL_R0_SW2TCL5_RING_STATUS_PHYS(x)                                                             ((x) + 0xaec)
#define HWIO_TCL_R0_SW2TCL5_RING_STATUS_OFFS                                                                (0xaec)
#define HWIO_TCL_R0_SW2TCL5_RING_STATUS_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_STATUS_POR                                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL5_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_STATUS_ATTR                                                                             0x1
#define HWIO_TCL_R0_SW2TCL5_RING_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL5_RING_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL5_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL5_RING_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL5_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                0xffff0000
#define HWIO_TCL_R0_SW2TCL5_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                        16
#define HWIO_TCL_R0_SW2TCL5_RING_STATUS_NUM_VALID_WORDS_BMSK                                                    0xffff
#define HWIO_TCL_R0_SW2TCL5_RING_STATUS_NUM_VALID_WORDS_SHFT                                                         0

#define HWIO_TCL_R0_SW2TCL5_RING_MISC_ADDR(x)                                                               ((x) + 0xaf0)
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_PHYS(x)                                                               ((x) + 0xaf0)
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_OFFS                                                                  (0xaf0)
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_RMSK                                                                    0x3fffff
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_POR                                                                   0x00000080
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_ATTR                                                                               0x3
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL5_RING_MISC_ADDR(x))
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL5_RING_MISC_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL5_RING_MISC_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL5_RING_MISC_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL5_RING_MISC_IN(x))
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_SPARE_CONTROL_BMSK                                                      0x3fc000
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_SPARE_CONTROL_SHFT                                                            14
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_SRNG_SM_STATE2_BMSK                                                       0x3000
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_SRNG_SM_STATE2_SHFT                                                           12
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_SRNG_SM_STATE1_BMSK                                                        0xf00
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_SRNG_SM_STATE1_SHFT                                                            8
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_SRNG_IS_IDLE_BMSK                                                           0x80
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_SRNG_IS_IDLE_SHFT                                                              7
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_SRNG_ENABLE_BMSK                                                            0x40
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_SRNG_ENABLE_SHFT                                                               6
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                      0x20
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                         5
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                       0x10
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                          4
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_MSI_SWAP_BIT_BMSK                                                            0x8
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_MSI_SWAP_BIT_SHFT                                                              3
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_SECURITY_BIT_BMSK                                                            0x4
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_SECURITY_BIT_SHFT                                                              2
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_LOOPCNT_DISABLE_BMSK                                                         0x2
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_LOOPCNT_DISABLE_SHFT                                                           1
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_RING_ID_DISABLE_BMSK                                                         0x1
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_RING_ID_DISABLE_SHFT                                                           0

#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_LSB_ADDR(x)                                                        ((x) + 0xafc)
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_LSB_PHYS(x)                                                        ((x) + 0xafc)
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_LSB_OFFS                                                           (0xafc)
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_LSB_RMSK                                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_LSB_POR                                                            0x00000000
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_LSB_ATTR                                                                        0x3
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                      0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                               0

#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_MSB_ADDR(x)                                                        ((x) + 0xb00)
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_MSB_PHYS(x)                                                        ((x) + 0xb00)
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_MSB_OFFS                                                           (0xb00)
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_MSB_RMSK                                                                 0xff
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_MSB_POR                                                            0x00000000
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_MSB_ATTR                                                                        0x3
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                            0xff
#define HWIO_TCL_R0_SW2TCL5_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                               0

#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                             ((x) + 0xb10)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                             ((x) + 0xb10)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                (0xb10)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX0_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                             ((x) + 0xb14)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                             ((x) + 0xb14)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                (0xb14)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                    0xffff
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX1_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                      0xffff
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                           0

#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_STATUS_ADDR(x)                                                ((x) + 0xb18)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_STATUS_PHYS(x)                                                ((x) + 0xb18)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_STATUS_OFFS                                                   (0xb18)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_STATUS_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_STATUS_POR                                                    0x00000000
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_STATUS_ATTR                                                                0x1
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                     0xffff0000
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                             16
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                0x8000
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                    15
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                          0x7fff
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                               0

#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                             ((x) + 0xb1c)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                             ((x) + 0xb1c)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                (0xb1c)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                     0x3ff
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_EMPTY_COUNTER_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                  0x3ff
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                      0

#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                            ((x) + 0xb20)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                            ((x) + 0xb20)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_TIMER_OFFS                                               (0xb20)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                      0x7
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_TIMER_POR                                                0x00000003
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                            0x3
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                 0x7
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                   0

#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                           ((x) + 0xb24)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                           ((x) + 0xb24)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_STATUS_OFFS                                              (0xb24)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_STATUS_RMSK                                               0xfffffff
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_STATUS_POR                                               0x00000000
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                           0x1
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                0xff00000
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                       20
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                               0xfffff
#define HWIO_TCL_R0_SW2TCL5_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                     0

#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_LSB_ADDR(x)                                                      ((x) + 0xb28)
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_LSB_PHYS(x)                                                      ((x) + 0xb28)
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_LSB_OFFS                                                         (0xb28)
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_LSB_POR                                                          0x00000000
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_LSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_MSB_ADDR(x)                                                      ((x) + 0xb2c)
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_MSB_PHYS(x)                                                      ((x) + 0xb2c)
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_MSB_OFFS                                                         (0xb2c)
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_MSB_POR                                                          0x00000000
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_MSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                  0x100
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                      8
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_DATA_ADDR(x)                                                          ((x) + 0xb30)
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_DATA_PHYS(x)                                                          ((x) + 0xb30)
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_DATA_OFFS                                                             (0xb30)
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_DATA_RMSK                                                             0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_DATA_POR                                                              0x00000000
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_DATA_ATTR                                                                          0x3
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL5_RING_MSI1_DATA_ADDR(x))
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL5_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL5_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL5_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL5_RING_MSI1_DATA_IN(x))
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_MSI1_DATA_VALUE_SHFT                                                                0

#define HWIO_TCL_R0_SW2TCL5_RING_HP_TP_SW_OFFSET_ADDR(x)                                                    ((x) + 0xb50)
#define HWIO_TCL_R0_SW2TCL5_RING_HP_TP_SW_OFFSET_PHYS(x)                                                    ((x) + 0xb50)
#define HWIO_TCL_R0_SW2TCL5_RING_HP_TP_SW_OFFSET_OFFS                                                       (0xb50)
#define HWIO_TCL_R0_SW2TCL5_RING_HP_TP_SW_OFFSET_RMSK                                                           0xffff
#define HWIO_TCL_R0_SW2TCL5_RING_HP_TP_SW_OFFSET_POR                                                        0x00000000
#define HWIO_TCL_R0_SW2TCL5_RING_HP_TP_SW_OFFSET_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_HP_TP_SW_OFFSET_ATTR                                                                    0x3
#define HWIO_TCL_R0_SW2TCL5_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL5_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TCL_R0_SW2TCL5_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL5_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL5_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL5_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL5_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL5_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL5_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TCL_R0_SW2TCL5_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                        0xffff
#define HWIO_TCL_R0_SW2TCL5_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                             0

#define HWIO_TCL_R0_SW2TCL5_RING_MISC_1_ADDR(x)                                                             ((x) + 0xb54)
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_1_PHYS(x)                                                             ((x) + 0xb54)
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_1_OFFS                                                                (0xb54)
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_1_RMSK                                                                0xffff003f
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_1_POR                                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_1_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_1_ATTR                                                                             0x3
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL5_RING_MISC_1_ADDR(x))
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL5_RING_MISC_1_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL5_RING_MISC_1_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL5_RING_MISC_1_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL5_RING_MISC_1_IN(x))
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                       0xffff0000
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                               16
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                              0x3f
#define HWIO_TCL_R0_SW2TCL5_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                 0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_ADDR(x)                                                     ((x) + 0xb58)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_PHYS(x)                                                     ((x) + 0xb58)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_OFFS                                                        (0xb58)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_RMSK                                                        0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_POR                                                         0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_POR_RMSK                                                    0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_ATTR                                                                     0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                              0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_ADDR(x)                                                     ((x) + 0xb5c)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_PHYS(x)                                                     ((x) + 0xb5c)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_OFFS                                                        (0xb5c)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_RMSK                                                         0xfffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_POR                                                         0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_POR_RMSK                                                    0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_ATTR                                                                     0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_RING_SIZE_BMSK                                               0xfffff00
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_RING_SIZE_SHFT                                                       8
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                           0xff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                              0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_ADDR(x)                                                           ((x) + 0xb60)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_PHYS(x)                                                           ((x) + 0xb60)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_OFFS                                                              (0xb60)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_RMSK                                                                    0xff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_POR                                                               0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_ATTR                                                                           0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_ENTRY_SIZE_BMSK                                                         0xff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_ENTRY_SIZE_SHFT                                                            0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_ADDR(x)                                                       ((x) + 0xb64)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_PHYS(x)                                                       ((x) + 0xb64)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_OFFS                                                          (0xb64)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_POR                                                           0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_POR_RMSK                                                      0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_ATTR                                                                       0x1
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                          0xffff0000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                  16
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_NUM_VALID_WORDS_BMSK                                              0xffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_NUM_VALID_WORDS_SHFT                                                   0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_ADDR(x)                                                         ((x) + 0xb68)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_PHYS(x)                                                         ((x) + 0xb68)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_OFFS                                                            (0xb68)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_RMSK                                                              0x3fffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_POR                                                             0x00000080
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_POR_RMSK                                                        0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_ATTR                                                                         0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SPARE_CONTROL_BMSK                                                0x3fc000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SPARE_CONTROL_SHFT                                                      14
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SRNG_SM_STATE2_BMSK                                                 0x3000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SRNG_SM_STATE2_SHFT                                                     12
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SRNG_SM_STATE1_BMSK                                                  0xf00
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SRNG_SM_STATE1_SHFT                                                      8
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SRNG_IS_IDLE_BMSK                                                     0x80
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SRNG_IS_IDLE_SHFT                                                        7
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SRNG_ENABLE_BMSK                                                      0x40
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SRNG_ENABLE_SHFT                                                         6
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                0x20
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                   5
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                 0x10
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                    4
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_MSI_SWAP_BIT_BMSK                                                      0x8
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_MSI_SWAP_BIT_SHFT                                                        3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SECURITY_BIT_BMSK                                                      0x4
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SECURITY_BIT_SHFT                                                        2
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_LOOPCNT_DISABLE_BMSK                                                   0x2
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_LOOPCNT_DISABLE_SHFT                                                     1
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_RING_ID_DISABLE_BMSK                                                   0x1
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_RING_ID_DISABLE_SHFT                                                     0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_ADDR(x)                                                  ((x) + 0xb74)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_PHYS(x)                                                  ((x) + 0xb74)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_OFFS                                                     (0xb74)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_POR                                                      0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_ATTR                                                                  0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                         0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_ADDR(x)                                                  ((x) + 0xb78)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_PHYS(x)                                                  ((x) + 0xb78)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_OFFS                                                     (0xb78)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_RMSK                                                           0xff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_POR                                                      0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_ATTR                                                                  0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                      0xff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                         0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                       ((x) + 0xb88)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                       ((x) + 0xb88)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_OFFS                                          (0xb88)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_RMSK                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_POR                                           0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                      0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                       0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                0xffff0000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                        16
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                            0x8000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                15
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                      0x7fff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                           0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                       ((x) + 0xb8c)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                       ((x) + 0xb8c)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_OFFS                                          (0xb8c)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_RMSK                                              0xffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_POR                                           0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                      0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                       0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                0xffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                     0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_ADDR(x)                                          ((x) + 0xb90)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_PHYS(x)                                          ((x) + 0xb90)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_OFFS                                             (0xb90)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_RMSK                                             0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_POR                                              0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_POR_RMSK                                         0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_ATTR                                                          0x1
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK               0xffff0000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                       16
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                          0x8000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                              15
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                    0x7fff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                         0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                       ((x) + 0xb94)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                       ((x) + 0xb94)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_OFFS                                          (0xb94)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_RMSK                                               0x3ff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_POR                                           0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                      0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                       0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                            0x3ff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                      ((x) + 0xb98)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                      ((x) + 0xb98)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_OFFS                                         (0xb98)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                0x7
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_POR                                          0x00000003
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                      0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                           0x7
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                             0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                     ((x) + 0xb9c)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                     ((x) + 0xb9c)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_OFFS                                        (0xb9c)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_RMSK                                         0xfffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_POR                                         0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                    0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                     0x1
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                          0xff00000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                 20
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                         0xfffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                               0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_ADDR(x)                                                ((x) + 0xba0)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_PHYS(x)                                                ((x) + 0xba0)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_OFFS                                                   (0xba0)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_POR                                                    0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_POR_RMSK                                               0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_ATTR                                                                0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_ADDR_BMSK                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_ADDR_SHFT                                                       0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_ADDR(x)                                                ((x) + 0xba4)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_PHYS(x)                                                ((x) + 0xba4)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_OFFS                                                   (0xba4)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_RMSK                                                        0x1ff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_POR                                                    0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_POR_RMSK                                               0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_ATTR                                                                0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                            0x100
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                8
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_ADDR_BMSK                                                    0xff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_ADDR_SHFT                                                       0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_ADDR(x)                                                    ((x) + 0xba8)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_PHYS(x)                                                    ((x) + 0xba8)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_OFFS                                                       (0xba8)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_POR                                                        0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_ATTR                                                                    0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_VALUE_BMSK                                                 0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_VALUE_SHFT                                                          0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_ADDR(x)                                              ((x) + 0xbc8)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_PHYS(x)                                              ((x) + 0xbc8)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_OFFS                                                 (0xbc8)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_RMSK                                                     0xffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_POR                                                  0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_POR_RMSK                                             0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_ATTR                                                              0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                  0xffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                       0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_ADDR(x)                                                       ((x) + 0xbcc)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_PHYS(x)                                                       ((x) + 0xbcc)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_OFFS                                                          (0xbcc)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_RMSK                                                          0xffff003f
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_POR                                                           0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_POR_RMSK                                                      0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_ATTR                                                                       0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                 0xffff0000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                         16
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                        0x3f
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                           0

#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_LSB_ADDR(x)                                                          ((x) + 0xc48)
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_LSB_PHYS(x)                                                          ((x) + 0xc48)
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_LSB_OFFS                                                             (0xc48)
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_LSB_RMSK                                                             0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_LSB_POR                                                              0x00000000
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_LSB_POR_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_LSB_ATTR                                                                          0x3
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_PPE2TCL1_RING_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_PPE2TCL1_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_PPE2TCL1_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_PPE2TCL1_RING_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_PPE2TCL1_RING_BASE_LSB_IN(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                          0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                   0

#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_MSB_ADDR(x)                                                          ((x) + 0xc4c)
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_MSB_PHYS(x)                                                          ((x) + 0xc4c)
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_MSB_OFFS                                                             (0xc4c)
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_MSB_RMSK                                                              0xfffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_MSB_POR                                                              0x00000000
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_MSB_POR_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_MSB_ATTR                                                                          0x3
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_PPE2TCL1_RING_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_PPE2TCL1_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_PPE2TCL1_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_PPE2TCL1_RING_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_PPE2TCL1_RING_BASE_MSB_IN(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_MSB_RING_SIZE_BMSK                                                    0xfffff00
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_MSB_RING_SIZE_SHFT                                                            8
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                0xff
#define HWIO_TCL_R0_PPE2TCL1_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                   0

#define HWIO_TCL_R0_PPE2TCL1_RING_ID_ADDR(x)                                                                ((x) + 0xc50)
#define HWIO_TCL_R0_PPE2TCL1_RING_ID_PHYS(x)                                                                ((x) + 0xc50)
#define HWIO_TCL_R0_PPE2TCL1_RING_ID_OFFS                                                                   (0xc50)
#define HWIO_TCL_R0_PPE2TCL1_RING_ID_RMSK                                                                         0xff
#define HWIO_TCL_R0_PPE2TCL1_RING_ID_POR                                                                    0x00000000
#define HWIO_TCL_R0_PPE2TCL1_RING_ID_POR_RMSK                                                               0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_ID_ATTR                                                                                0x3
#define HWIO_TCL_R0_PPE2TCL1_RING_ID_IN(x)            \
                in_dword(HWIO_TCL_R0_PPE2TCL1_RING_ID_ADDR(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_PPE2TCL1_RING_ID_ADDR(x), m)
#define HWIO_TCL_R0_PPE2TCL1_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_PPE2TCL1_RING_ID_ADDR(x),v)
#define HWIO_TCL_R0_PPE2TCL1_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_PPE2TCL1_RING_ID_ADDR(x),m,v,HWIO_TCL_R0_PPE2TCL1_RING_ID_IN(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_ID_ENTRY_SIZE_BMSK                                                              0xff
#define HWIO_TCL_R0_PPE2TCL1_RING_ID_ENTRY_SIZE_SHFT                                                                 0

#define HWIO_TCL_R0_PPE2TCL1_RING_STATUS_ADDR(x)                                                            ((x) + 0xc54)
#define HWIO_TCL_R0_PPE2TCL1_RING_STATUS_PHYS(x)                                                            ((x) + 0xc54)
#define HWIO_TCL_R0_PPE2TCL1_RING_STATUS_OFFS                                                               (0xc54)
#define HWIO_TCL_R0_PPE2TCL1_RING_STATUS_RMSK                                                               0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_STATUS_POR                                                                0x00000000
#define HWIO_TCL_R0_PPE2TCL1_RING_STATUS_POR_RMSK                                                           0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_STATUS_ATTR                                                                            0x1
#define HWIO_TCL_R0_PPE2TCL1_RING_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_PPE2TCL1_RING_STATUS_ADDR(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_PPE2TCL1_RING_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_PPE2TCL1_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                               0xffff0000
#define HWIO_TCL_R0_PPE2TCL1_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                       16
#define HWIO_TCL_R0_PPE2TCL1_RING_STATUS_NUM_VALID_WORDS_BMSK                                                   0xffff
#define HWIO_TCL_R0_PPE2TCL1_RING_STATUS_NUM_VALID_WORDS_SHFT                                                        0

#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_ADDR(x)                                                              ((x) + 0xc58)
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_PHYS(x)                                                              ((x) + 0xc58)
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_OFFS                                                                 (0xc58)
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_RMSK                                                                   0x3fffff
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_POR                                                                  0x00000080
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_POR_RMSK                                                             0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_ATTR                                                                              0x3
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_IN(x)            \
                in_dword(HWIO_TCL_R0_PPE2TCL1_RING_MISC_ADDR(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_PPE2TCL1_RING_MISC_ADDR(x), m)
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_PPE2TCL1_RING_MISC_ADDR(x),v)
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_PPE2TCL1_RING_MISC_ADDR(x),m,v,HWIO_TCL_R0_PPE2TCL1_RING_MISC_IN(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_SPARE_CONTROL_BMSK                                                     0x3fc000
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_SPARE_CONTROL_SHFT                                                           14
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_SRNG_SM_STATE2_BMSK                                                      0x3000
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_SRNG_SM_STATE2_SHFT                                                          12
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_SRNG_SM_STATE1_BMSK                                                       0xf00
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_SRNG_SM_STATE1_SHFT                                                           8
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_SRNG_IS_IDLE_BMSK                                                          0x80
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_SRNG_IS_IDLE_SHFT                                                             7
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_SRNG_ENABLE_BMSK                                                           0x40
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_SRNG_ENABLE_SHFT                                                              6
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                     0x20
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                        5
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                      0x10
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                         4
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_MSI_SWAP_BIT_BMSK                                                           0x8
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_MSI_SWAP_BIT_SHFT                                                             3
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_SECURITY_BIT_BMSK                                                           0x4
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_SECURITY_BIT_SHFT                                                             2
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_LOOPCNT_DISABLE_BMSK                                                        0x2
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_LOOPCNT_DISABLE_SHFT                                                          1
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_RING_ID_DISABLE_BMSK                                                        0x1
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_RING_ID_DISABLE_SHFT                                                          0

#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_LSB_ADDR(x)                                                       ((x) + 0xc64)
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_LSB_PHYS(x)                                                       ((x) + 0xc64)
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_LSB_OFFS                                                          (0xc64)
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_LSB_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_LSB_POR                                                           0x00000000
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_LSB_ATTR                                                                       0x3
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_LSB_IN(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                     0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                              0

#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_MSB_ADDR(x)                                                       ((x) + 0xc68)
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_MSB_PHYS(x)                                                       ((x) + 0xc68)
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_MSB_OFFS                                                          (0xc68)
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_MSB_RMSK                                                                0xff
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_MSB_POR                                                           0x00000000
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_MSB_ATTR                                                                       0x3
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_MSB_IN(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                           0xff
#define HWIO_TCL_R0_PPE2TCL1_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                              0

#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                            ((x) + 0xc78)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                            ((x) + 0xc78)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX0_OFFS                                               (0xc78)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX0_RMSK                                               0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX0_POR                                                0x00000000
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                           0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                            0x3
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                     0xffff0000
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                             16
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                 0x8000
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                     15
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                           0x7fff
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                0

#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                            ((x) + 0xc7c)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                            ((x) + 0xc7c)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX1_OFFS                                               (0xc7c)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                   0xffff
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX1_POR                                                0x00000000
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                           0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                            0x3
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                     0xffff
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                          0

#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_STATUS_ADDR(x)                                               ((x) + 0xc80)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_STATUS_PHYS(x)                                               ((x) + 0xc80)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_STATUS_OFFS                                                  (0xc80)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_STATUS_RMSK                                                  0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_STATUS_POR                                                   0x00000000
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_STATUS_POR_RMSK                                              0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_STATUS_ATTR                                                               0x1
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                    0xffff0000
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                            16
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                               0x8000
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                   15
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                         0x7fff
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                              0

#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                            ((x) + 0xc84)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                            ((x) + 0xc84)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_EMPTY_COUNTER_OFFS                                               (0xc84)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                    0x3ff
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_EMPTY_COUNTER_POR                                                0x00000000
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                           0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                            0x3
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                 0x3ff
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                     0

#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                           ((x) + 0xc88)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                           ((x) + 0xc88)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_TIMER_OFFS                                              (0xc88)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                     0x7
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_TIMER_POR                                               0x00000003
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                          0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                           0x3
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                0x7
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                  0

#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                          ((x) + 0xc8c)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                          ((x) + 0xc8c)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_STATUS_OFFS                                             (0xc8c)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_STATUS_RMSK                                              0xfffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_STATUS_POR                                              0x00000000
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                         0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                          0x1
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                               0xff00000
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                      20
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                              0xfffff
#define HWIO_TCL_R0_PPE2TCL1_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                    0

#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_LSB_ADDR(x)                                                     ((x) + 0xc90)
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_LSB_PHYS(x)                                                     ((x) + 0xc90)
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_LSB_OFFS                                                        (0xc90)
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_LSB_RMSK                                                        0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_LSB_POR                                                         0x00000000
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_LSB_POR_RMSK                                                    0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_LSB_ATTR                                                                     0x3
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_LSB_ADDR_BMSK                                                   0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_LSB_ADDR_SHFT                                                            0

#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_MSB_ADDR(x)                                                     ((x) + 0xc94)
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_MSB_PHYS(x)                                                     ((x) + 0xc94)
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_MSB_OFFS                                                        (0xc94)
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_MSB_RMSK                                                             0x1ff
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_MSB_POR                                                         0x00000000
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_MSB_POR_RMSK                                                    0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_MSB_ATTR                                                                     0x3
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                 0x100
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                     8
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_MSB_ADDR_BMSK                                                         0xff
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_BASE_MSB_ADDR_SHFT                                                            0

#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_DATA_ADDR(x)                                                         ((x) + 0xc98)
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_DATA_PHYS(x)                                                         ((x) + 0xc98)
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_DATA_OFFS                                                            (0xc98)
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_DATA_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_DATA_POR                                                             0x00000000
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_DATA_POR_RMSK                                                        0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_DATA_ATTR                                                                         0x3
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TCL_R0_PPE2TCL1_RING_MSI1_DATA_ADDR(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_PPE2TCL1_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_PPE2TCL1_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_PPE2TCL1_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TCL_R0_PPE2TCL1_RING_MSI1_DATA_IN(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_DATA_VALUE_BMSK                                                      0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_MSI1_DATA_VALUE_SHFT                                                               0

#define HWIO_TCL_R0_PPE2TCL1_RING_HP_TP_SW_OFFSET_ADDR(x)                                                   ((x) + 0xcb8)
#define HWIO_TCL_R0_PPE2TCL1_RING_HP_TP_SW_OFFSET_PHYS(x)                                                   ((x) + 0xcb8)
#define HWIO_TCL_R0_PPE2TCL1_RING_HP_TP_SW_OFFSET_OFFS                                                      (0xcb8)
#define HWIO_TCL_R0_PPE2TCL1_RING_HP_TP_SW_OFFSET_RMSK                                                          0xffff
#define HWIO_TCL_R0_PPE2TCL1_RING_HP_TP_SW_OFFSET_POR                                                       0x00000000
#define HWIO_TCL_R0_PPE2TCL1_RING_HP_TP_SW_OFFSET_POR_RMSK                                                  0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_HP_TP_SW_OFFSET_ATTR                                                                   0x3
#define HWIO_TCL_R0_PPE2TCL1_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TCL_R0_PPE2TCL1_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_PPE2TCL1_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TCL_R0_PPE2TCL1_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_PPE2TCL1_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TCL_R0_PPE2TCL1_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_PPE2TCL1_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TCL_R0_PPE2TCL1_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                       0xffff
#define HWIO_TCL_R0_PPE2TCL1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                            0

#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_1_ADDR(x)                                                            ((x) + 0xcbc)
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_1_PHYS(x)                                                            ((x) + 0xcbc)
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_1_OFFS                                                               (0xcbc)
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_1_RMSK                                                               0xffff003f
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_1_POR                                                                0x00000000
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_1_POR_RMSK                                                           0xffffffff
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_1_ATTR                                                                            0x3
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TCL_R0_PPE2TCL1_RING_MISC_1_ADDR(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_PPE2TCL1_RING_MISC_1_ADDR(x), m)
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_PPE2TCL1_RING_MISC_1_ADDR(x),v)
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_PPE2TCL1_RING_MISC_1_ADDR(x),m,v,HWIO_TCL_R0_PPE2TCL1_RING_MISC_1_IN(x))
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                      0xffff0000
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                              16
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                             0x3f
#define HWIO_TCL_R0_PPE2TCL1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                0

#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_ADDR(x)                                                       ((x) + 0xd38)
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_PHYS(x)                                                       ((x) + 0xd38)
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_OFFS                                                          (0xd38)
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_POR                                                           0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_ATTR                                                                       0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                       0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                0

#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_ADDR(x)                                                       ((x) + 0xd3c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_PHYS(x)                                                       ((x) + 0xd3c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_OFFS                                                          (0xd3c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_RMSK                                                            0xffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_POR                                                           0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_ATTR                                                                       0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_RING_SIZE_BMSK                                                  0xffff00
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_RING_SIZE_SHFT                                                         8
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                             0xff
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                0

#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_ADDR(x)                                                             ((x) + 0xd40)
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_PHYS(x)                                                             ((x) + 0xd40)
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_OFFS                                                                (0xd40)
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_RMSK                                                                    0xffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_POR                                                                 0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_ATTR                                                                             0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_ID_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_ID_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_ID_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_ID_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_ID_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_RING_ID_BMSK                                                            0xff00
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_RING_ID_SHFT                                                                 8
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_ENTRY_SIZE_BMSK                                                           0xff
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_ENTRY_SIZE_SHFT                                                              0

#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_ADDR(x)                                                         ((x) + 0xd44)
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_PHYS(x)                                                         ((x) + 0xd44)
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_OFFS                                                            (0xd44)
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_POR                                                             0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_POR_RMSK                                                        0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_ATTR                                                                         0x1
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                            0xffff0000
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                    16
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_NUM_VALID_WORDS_BMSK                                                0xffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_NUM_VALID_WORDS_SHFT                                                     0

#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_ADDR(x)                                                           ((x) + 0xd48)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_PHYS(x)                                                           ((x) + 0xd48)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_OFFS                                                              (0xd48)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_RMSK                                                               0x7ffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_POR                                                               0x00000080
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_ATTR                                                                           0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MISC_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_MISC_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MISC_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_MISC_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_MISC_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                       0x4000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                              26
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_LOOP_CNT_BMSK                                                      0x3c00000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_LOOP_CNT_SHFT                                                             22
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SPARE_CONTROL_BMSK                                                  0x3fc000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SPARE_CONTROL_SHFT                                                        14
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SRNG_SM_STATE2_BMSK                                                   0x3000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SRNG_SM_STATE2_SHFT                                                       12
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SRNG_SM_STATE1_BMSK                                                    0xf00
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SRNG_SM_STATE1_SHFT                                                        8
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SRNG_IS_IDLE_BMSK                                                       0x80
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SRNG_IS_IDLE_SHFT                                                          7
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SRNG_ENABLE_BMSK                                                        0x40
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SRNG_ENABLE_SHFT                                                           6
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                  0x20
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                     5
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                   0x10
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                      4
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_MSI_SWAP_BIT_BMSK                                                        0x8
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_MSI_SWAP_BIT_SHFT                                                          3
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SECURITY_BIT_BMSK                                                        0x4
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SECURITY_BIT_SHFT                                                          2
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_LOOPCNT_DISABLE_BMSK                                                     0x2
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_LOOPCNT_DISABLE_SHFT                                                       1
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_RING_ID_DISABLE_BMSK                                                     0x1
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_RING_ID_DISABLE_SHFT                                                       0

#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_ADDR(x)                                                    ((x) + 0xd4c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_PHYS(x)                                                    ((x) + 0xd4c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_OFFS                                                       (0xd4c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_POR                                                        0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_ATTR                                                                    0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                  0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                           0

#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_ADDR(x)                                                    ((x) + 0xd50)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_PHYS(x)                                                    ((x) + 0xd50)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_OFFS                                                       (0xd50)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_RMSK                                                             0xff
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_POR                                                        0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_ATTR                                                                    0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                        0xff
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                           0

#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_ADDR(x)                                             ((x) + 0xd5c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_PHYS(x)                                             ((x) + 0xd5c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_OFFS                                                (0xd5c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_RMSK                                                0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_POR                                                 0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_ATTR                                                             0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_ADDR(x)                                            ((x) + 0xd60)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_PHYS(x)                                            ((x) + 0xd60)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_OFFS                                               (0xd60)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_RMSK                                               0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_POR                                                0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_ATTR                                                            0x1
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                 0xffff0000
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                         16
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                         0x8000
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                             15
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                      0x7fff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                           0

#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                          ((x) + 0xd64)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                          ((x) + 0xd64)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_OFFS                                             (0xd64)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_RMSK                                                  0x3ff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_POR                                              0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                         0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_ATTR                                                          0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                0x3ff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                    0

#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_ADDR(x)                                                  ((x) + 0xd80)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_PHYS(x)                                                  ((x) + 0xd80)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_OFFS                                                     (0xd80)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_POR                                                      0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_ATTR                                                                  0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_ADDR(x)                                                  ((x) + 0xd84)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_PHYS(x)                                                  ((x) + 0xd84)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_OFFS                                                     (0xd84)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_POR                                                      0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_ATTR                                                                  0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                              0x100
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                  8
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_ADDR(x)                                                      ((x) + 0xd88)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_PHYS(x)                                                      ((x) + 0xd88)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_OFFS                                                         (0xd88)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_POR                                                          0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_ATTR                                                                      0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_VALUE_SHFT                                                            0

#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_ADDR(x)                                            ((x) + 0xd8c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_PHYS(x)                                            ((x) + 0xd8c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_OFFS                                               (0xd8c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_RMSK                                               0xffc0ffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_POR                                                0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_POR_RMSK                                           0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_ATTR                                                            0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                    0xff000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                            24
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                     0x800000
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                           23
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                   0x400000
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                         22
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                    0xffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                         0

#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_ADDR(x)                                                  ((x) + 0xd90)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_PHYS(x)                                                  ((x) + 0xd90)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_OFFS                                                     (0xd90)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_POR                                                      0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_ATTR                                                                  0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_ADDR(x)                                                  ((x) + 0xd94)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_PHYS(x)                                                  ((x) + 0xd94)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_OFFS                                                     (0xd94)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_POR                                                      0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_ATTR                                                                  0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                              0x100
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                  8
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_ADDR(x)                                                      ((x) + 0xd98)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_PHYS(x)                                                      ((x) + 0xd98)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_OFFS                                                         (0xd98)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_POR                                                          0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_ATTR                                                                      0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_VALUE_SHFT                                                            0

#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_ADDR(x)                                                ((x) + 0xda8)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_PHYS(x)                                                ((x) + 0xda8)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_OFFS                                                   (0xda8)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_RMSK                                                       0xffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_POR                                                    0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_POR_RMSK                                               0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_ATTR                                                                0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                    0xffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                         0

#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_ADDR(x)                                                         ((x) + 0xdac)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_PHYS(x)                                                         ((x) + 0xdac)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_OFFS                                                            (0xdac)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_RMSK                                                            0xffff003f
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_POR                                                             0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_POR_RMSK                                                        0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_ATTR                                                                         0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                   0xffff0000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                           16
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                          0x3f
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                             0

#define HWIO_TCL_R2_SW2TCL1_RING_HP_ADDR(x)                                                                 ((x) + 0x2000)
#define HWIO_TCL_R2_SW2TCL1_RING_HP_PHYS(x)                                                                 ((x) + 0x2000)
#define HWIO_TCL_R2_SW2TCL1_RING_HP_OFFS                                                                    (0x2000)
#define HWIO_TCL_R2_SW2TCL1_RING_HP_RMSK                                                                       0xfffff
#define HWIO_TCL_R2_SW2TCL1_RING_HP_POR                                                                     0x00000000
#define HWIO_TCL_R2_SW2TCL1_RING_HP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_SW2TCL1_RING_HP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_SW2TCL1_RING_HP_IN(x)            \
                in_dword(HWIO_TCL_R2_SW2TCL1_RING_HP_ADDR(x))
#define HWIO_TCL_R2_SW2TCL1_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_SW2TCL1_RING_HP_ADDR(x), m)
#define HWIO_TCL_R2_SW2TCL1_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_SW2TCL1_RING_HP_ADDR(x),v)
#define HWIO_TCL_R2_SW2TCL1_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_SW2TCL1_RING_HP_ADDR(x),m,v,HWIO_TCL_R2_SW2TCL1_RING_HP_IN(x))
#define HWIO_TCL_R2_SW2TCL1_RING_HP_HEAD_PTR_BMSK                                                              0xfffff
#define HWIO_TCL_R2_SW2TCL1_RING_HP_HEAD_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_SW2TCL1_RING_TP_ADDR(x)                                                                 ((x) + 0x2004)
#define HWIO_TCL_R2_SW2TCL1_RING_TP_PHYS(x)                                                                 ((x) + 0x2004)
#define HWIO_TCL_R2_SW2TCL1_RING_TP_OFFS                                                                    (0x2004)
#define HWIO_TCL_R2_SW2TCL1_RING_TP_RMSK                                                                       0xfffff
#define HWIO_TCL_R2_SW2TCL1_RING_TP_POR                                                                     0x00000000
#define HWIO_TCL_R2_SW2TCL1_RING_TP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_SW2TCL1_RING_TP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_SW2TCL1_RING_TP_IN(x)            \
                in_dword(HWIO_TCL_R2_SW2TCL1_RING_TP_ADDR(x))
#define HWIO_TCL_R2_SW2TCL1_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_SW2TCL1_RING_TP_ADDR(x), m)
#define HWIO_TCL_R2_SW2TCL1_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_SW2TCL1_RING_TP_ADDR(x),v)
#define HWIO_TCL_R2_SW2TCL1_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_SW2TCL1_RING_TP_ADDR(x),m,v,HWIO_TCL_R2_SW2TCL1_RING_TP_IN(x))
#define HWIO_TCL_R2_SW2TCL1_RING_TP_TAIL_PTR_BMSK                                                              0xfffff
#define HWIO_TCL_R2_SW2TCL1_RING_TP_TAIL_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_SW2TCL2_RING_HP_ADDR(x)                                                                 ((x) + 0x2008)
#define HWIO_TCL_R2_SW2TCL2_RING_HP_PHYS(x)                                                                 ((x) + 0x2008)
#define HWIO_TCL_R2_SW2TCL2_RING_HP_OFFS                                                                    (0x2008)
#define HWIO_TCL_R2_SW2TCL2_RING_HP_RMSK                                                                       0xfffff
#define HWIO_TCL_R2_SW2TCL2_RING_HP_POR                                                                     0x00000000
#define HWIO_TCL_R2_SW2TCL2_RING_HP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_SW2TCL2_RING_HP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_SW2TCL2_RING_HP_IN(x)            \
                in_dword(HWIO_TCL_R2_SW2TCL2_RING_HP_ADDR(x))
#define HWIO_TCL_R2_SW2TCL2_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_SW2TCL2_RING_HP_ADDR(x), m)
#define HWIO_TCL_R2_SW2TCL2_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_SW2TCL2_RING_HP_ADDR(x),v)
#define HWIO_TCL_R2_SW2TCL2_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_SW2TCL2_RING_HP_ADDR(x),m,v,HWIO_TCL_R2_SW2TCL2_RING_HP_IN(x))
#define HWIO_TCL_R2_SW2TCL2_RING_HP_HEAD_PTR_BMSK                                                              0xfffff
#define HWIO_TCL_R2_SW2TCL2_RING_HP_HEAD_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_SW2TCL2_RING_TP_ADDR(x)                                                                 ((x) + 0x200c)
#define HWIO_TCL_R2_SW2TCL2_RING_TP_PHYS(x)                                                                 ((x) + 0x200c)
#define HWIO_TCL_R2_SW2TCL2_RING_TP_OFFS                                                                    (0x200c)
#define HWIO_TCL_R2_SW2TCL2_RING_TP_RMSK                                                                       0xfffff
#define HWIO_TCL_R2_SW2TCL2_RING_TP_POR                                                                     0x00000000
#define HWIO_TCL_R2_SW2TCL2_RING_TP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_SW2TCL2_RING_TP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_SW2TCL2_RING_TP_IN(x)            \
                in_dword(HWIO_TCL_R2_SW2TCL2_RING_TP_ADDR(x))
#define HWIO_TCL_R2_SW2TCL2_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_SW2TCL2_RING_TP_ADDR(x), m)
#define HWIO_TCL_R2_SW2TCL2_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_SW2TCL2_RING_TP_ADDR(x),v)
#define HWIO_TCL_R2_SW2TCL2_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_SW2TCL2_RING_TP_ADDR(x),m,v,HWIO_TCL_R2_SW2TCL2_RING_TP_IN(x))
#define HWIO_TCL_R2_SW2TCL2_RING_TP_TAIL_PTR_BMSK                                                              0xfffff
#define HWIO_TCL_R2_SW2TCL2_RING_TP_TAIL_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_SW2TCL3_RING_HP_ADDR(x)                                                                 ((x) + 0x2010)
#define HWIO_TCL_R2_SW2TCL3_RING_HP_PHYS(x)                                                                 ((x) + 0x2010)
#define HWIO_TCL_R2_SW2TCL3_RING_HP_OFFS                                                                    (0x2010)
#define HWIO_TCL_R2_SW2TCL3_RING_HP_RMSK                                                                       0xfffff
#define HWIO_TCL_R2_SW2TCL3_RING_HP_POR                                                                     0x00000000
#define HWIO_TCL_R2_SW2TCL3_RING_HP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_SW2TCL3_RING_HP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_SW2TCL3_RING_HP_IN(x)            \
                in_dword(HWIO_TCL_R2_SW2TCL3_RING_HP_ADDR(x))
#define HWIO_TCL_R2_SW2TCL3_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_SW2TCL3_RING_HP_ADDR(x), m)
#define HWIO_TCL_R2_SW2TCL3_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_SW2TCL3_RING_HP_ADDR(x),v)
#define HWIO_TCL_R2_SW2TCL3_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_SW2TCL3_RING_HP_ADDR(x),m,v,HWIO_TCL_R2_SW2TCL3_RING_HP_IN(x))
#define HWIO_TCL_R2_SW2TCL3_RING_HP_HEAD_PTR_BMSK                                                              0xfffff
#define HWIO_TCL_R2_SW2TCL3_RING_HP_HEAD_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_SW2TCL3_RING_TP_ADDR(x)                                                                 ((x) + 0x2014)
#define HWIO_TCL_R2_SW2TCL3_RING_TP_PHYS(x)                                                                 ((x) + 0x2014)
#define HWIO_TCL_R2_SW2TCL3_RING_TP_OFFS                                                                    (0x2014)
#define HWIO_TCL_R2_SW2TCL3_RING_TP_RMSK                                                                       0xfffff
#define HWIO_TCL_R2_SW2TCL3_RING_TP_POR                                                                     0x00000000
#define HWIO_TCL_R2_SW2TCL3_RING_TP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_SW2TCL3_RING_TP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_SW2TCL3_RING_TP_IN(x)            \
                in_dword(HWIO_TCL_R2_SW2TCL3_RING_TP_ADDR(x))
#define HWIO_TCL_R2_SW2TCL3_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_SW2TCL3_RING_TP_ADDR(x), m)
#define HWIO_TCL_R2_SW2TCL3_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_SW2TCL3_RING_TP_ADDR(x),v)
#define HWIO_TCL_R2_SW2TCL3_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_SW2TCL3_RING_TP_ADDR(x),m,v,HWIO_TCL_R2_SW2TCL3_RING_TP_IN(x))
#define HWIO_TCL_R2_SW2TCL3_RING_TP_TAIL_PTR_BMSK                                                              0xfffff
#define HWIO_TCL_R2_SW2TCL3_RING_TP_TAIL_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_SW2TCL4_RING_HP_ADDR(x)                                                                 ((x) + 0x2018)
#define HWIO_TCL_R2_SW2TCL4_RING_HP_PHYS(x)                                                                 ((x) + 0x2018)
#define HWIO_TCL_R2_SW2TCL4_RING_HP_OFFS                                                                    (0x2018)
#define HWIO_TCL_R2_SW2TCL4_RING_HP_RMSK                                                                       0xfffff
#define HWIO_TCL_R2_SW2TCL4_RING_HP_POR                                                                     0x00000000
#define HWIO_TCL_R2_SW2TCL4_RING_HP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_SW2TCL4_RING_HP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_SW2TCL4_RING_HP_IN(x)            \
                in_dword(HWIO_TCL_R2_SW2TCL4_RING_HP_ADDR(x))
#define HWIO_TCL_R2_SW2TCL4_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_SW2TCL4_RING_HP_ADDR(x), m)
#define HWIO_TCL_R2_SW2TCL4_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_SW2TCL4_RING_HP_ADDR(x),v)
#define HWIO_TCL_R2_SW2TCL4_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_SW2TCL4_RING_HP_ADDR(x),m,v,HWIO_TCL_R2_SW2TCL4_RING_HP_IN(x))
#define HWIO_TCL_R2_SW2TCL4_RING_HP_HEAD_PTR_BMSK                                                              0xfffff
#define HWIO_TCL_R2_SW2TCL4_RING_HP_HEAD_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_SW2TCL4_RING_TP_ADDR(x)                                                                 ((x) + 0x201c)
#define HWIO_TCL_R2_SW2TCL4_RING_TP_PHYS(x)                                                                 ((x) + 0x201c)
#define HWIO_TCL_R2_SW2TCL4_RING_TP_OFFS                                                                    (0x201c)
#define HWIO_TCL_R2_SW2TCL4_RING_TP_RMSK                                                                       0xfffff
#define HWIO_TCL_R2_SW2TCL4_RING_TP_POR                                                                     0x00000000
#define HWIO_TCL_R2_SW2TCL4_RING_TP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_SW2TCL4_RING_TP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_SW2TCL4_RING_TP_IN(x)            \
                in_dword(HWIO_TCL_R2_SW2TCL4_RING_TP_ADDR(x))
#define HWIO_TCL_R2_SW2TCL4_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_SW2TCL4_RING_TP_ADDR(x), m)
#define HWIO_TCL_R2_SW2TCL4_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_SW2TCL4_RING_TP_ADDR(x),v)
#define HWIO_TCL_R2_SW2TCL4_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_SW2TCL4_RING_TP_ADDR(x),m,v,HWIO_TCL_R2_SW2TCL4_RING_TP_IN(x))
#define HWIO_TCL_R2_SW2TCL4_RING_TP_TAIL_PTR_BMSK                                                              0xfffff
#define HWIO_TCL_R2_SW2TCL4_RING_TP_TAIL_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_SW2TCL5_RING_HP_ADDR(x)                                                                 ((x) + 0x2020)
#define HWIO_TCL_R2_SW2TCL5_RING_HP_PHYS(x)                                                                 ((x) + 0x2020)
#define HWIO_TCL_R2_SW2TCL5_RING_HP_OFFS                                                                    (0x2020)
#define HWIO_TCL_R2_SW2TCL5_RING_HP_RMSK                                                                       0xfffff
#define HWIO_TCL_R2_SW2TCL5_RING_HP_POR                                                                     0x00000000
#define HWIO_TCL_R2_SW2TCL5_RING_HP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_SW2TCL5_RING_HP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_SW2TCL5_RING_HP_IN(x)            \
                in_dword(HWIO_TCL_R2_SW2TCL5_RING_HP_ADDR(x))
#define HWIO_TCL_R2_SW2TCL5_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_SW2TCL5_RING_HP_ADDR(x), m)
#define HWIO_TCL_R2_SW2TCL5_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_SW2TCL5_RING_HP_ADDR(x),v)
#define HWIO_TCL_R2_SW2TCL5_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_SW2TCL5_RING_HP_ADDR(x),m,v,HWIO_TCL_R2_SW2TCL5_RING_HP_IN(x))
#define HWIO_TCL_R2_SW2TCL5_RING_HP_HEAD_PTR_BMSK                                                              0xfffff
#define HWIO_TCL_R2_SW2TCL5_RING_HP_HEAD_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_SW2TCL5_RING_TP_ADDR(x)                                                                 ((x) + 0x2024)
#define HWIO_TCL_R2_SW2TCL5_RING_TP_PHYS(x)                                                                 ((x) + 0x2024)
#define HWIO_TCL_R2_SW2TCL5_RING_TP_OFFS                                                                    (0x2024)
#define HWIO_TCL_R2_SW2TCL5_RING_TP_RMSK                                                                       0xfffff
#define HWIO_TCL_R2_SW2TCL5_RING_TP_POR                                                                     0x00000000
#define HWIO_TCL_R2_SW2TCL5_RING_TP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_SW2TCL5_RING_TP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_SW2TCL5_RING_TP_IN(x)            \
                in_dword(HWIO_TCL_R2_SW2TCL5_RING_TP_ADDR(x))
#define HWIO_TCL_R2_SW2TCL5_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_SW2TCL5_RING_TP_ADDR(x), m)
#define HWIO_TCL_R2_SW2TCL5_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_SW2TCL5_RING_TP_ADDR(x),v)
#define HWIO_TCL_R2_SW2TCL5_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_SW2TCL5_RING_TP_ADDR(x),m,v,HWIO_TCL_R2_SW2TCL5_RING_TP_IN(x))
#define HWIO_TCL_R2_SW2TCL5_RING_TP_TAIL_PTR_BMSK                                                              0xfffff
#define HWIO_TCL_R2_SW2TCL5_RING_TP_TAIL_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_ADDR(x)                                                           ((x) + 0x2028)
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_PHYS(x)                                                           ((x) + 0x2028)
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_OFFS                                                              (0x2028)
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_RMSK                                                                 0xfffff
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_POR                                                               0x00000000
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_ATTR                                                                           0x3
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_IN(x)            \
                in_dword(HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_ADDR(x))
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_ADDR(x), m)
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_ADDR(x),v)
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_ADDR(x),m,v,HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_IN(x))
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_HEAD_PTR_BMSK                                                        0xfffff
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_HEAD_PTR_SHFT                                                              0

#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_ADDR(x)                                                           ((x) + 0x202c)
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_PHYS(x)                                                           ((x) + 0x202c)
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_OFFS                                                              (0x202c)
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_RMSK                                                                 0xfffff
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_POR                                                               0x00000000
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_ATTR                                                                           0x3
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_IN(x)            \
                in_dword(HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_ADDR(x))
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_ADDR(x), m)
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_ADDR(x),v)
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_ADDR(x),m,v,HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_IN(x))
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_TAIL_PTR_BMSK                                                        0xfffff
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_TAIL_PTR_SHFT                                                              0

#define HWIO_TCL_R2_FW2TCL1_RING_HP_ADDR(x)                                                                 ((x) + 0x2030)
#define HWIO_TCL_R2_FW2TCL1_RING_HP_PHYS(x)                                                                 ((x) + 0x2030)
#define HWIO_TCL_R2_FW2TCL1_RING_HP_OFFS                                                                    (0x2030)
#define HWIO_TCL_R2_FW2TCL1_RING_HP_RMSK                                                                        0xffff
#define HWIO_TCL_R2_FW2TCL1_RING_HP_POR                                                                     0x00000000
#define HWIO_TCL_R2_FW2TCL1_RING_HP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_FW2TCL1_RING_HP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_FW2TCL1_RING_HP_IN(x)            \
                in_dword(HWIO_TCL_R2_FW2TCL1_RING_HP_ADDR(x))
#define HWIO_TCL_R2_FW2TCL1_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_FW2TCL1_RING_HP_ADDR(x), m)
#define HWIO_TCL_R2_FW2TCL1_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_FW2TCL1_RING_HP_ADDR(x),v)
#define HWIO_TCL_R2_FW2TCL1_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_FW2TCL1_RING_HP_ADDR(x),m,v,HWIO_TCL_R2_FW2TCL1_RING_HP_IN(x))
#define HWIO_TCL_R2_FW2TCL1_RING_HP_HEAD_PTR_BMSK                                                               0xffff
#define HWIO_TCL_R2_FW2TCL1_RING_HP_HEAD_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_FW2TCL1_RING_TP_ADDR(x)                                                                 ((x) + 0x2034)
#define HWIO_TCL_R2_FW2TCL1_RING_TP_PHYS(x)                                                                 ((x) + 0x2034)
#define HWIO_TCL_R2_FW2TCL1_RING_TP_OFFS                                                                    (0x2034)
#define HWIO_TCL_R2_FW2TCL1_RING_TP_RMSK                                                                        0xffff
#define HWIO_TCL_R2_FW2TCL1_RING_TP_POR                                                                     0x00000000
#define HWIO_TCL_R2_FW2TCL1_RING_TP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_FW2TCL1_RING_TP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_FW2TCL1_RING_TP_IN(x)            \
                in_dword(HWIO_TCL_R2_FW2TCL1_RING_TP_ADDR(x))
#define HWIO_TCL_R2_FW2TCL1_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_FW2TCL1_RING_TP_ADDR(x), m)
#define HWIO_TCL_R2_FW2TCL1_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_FW2TCL1_RING_TP_ADDR(x),v)
#define HWIO_TCL_R2_FW2TCL1_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_FW2TCL1_RING_TP_ADDR(x),m,v,HWIO_TCL_R2_FW2TCL1_RING_TP_IN(x))
#define HWIO_TCL_R2_FW2TCL1_RING_TP_TAIL_PTR_BMSK                                                               0xffff
#define HWIO_TCL_R2_FW2TCL1_RING_TP_TAIL_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_PPE2TCL1_RING_HP_ADDR(x)                                                                ((x) + 0x2038)
#define HWIO_TCL_R2_PPE2TCL1_RING_HP_PHYS(x)                                                                ((x) + 0x2038)
#define HWIO_TCL_R2_PPE2TCL1_RING_HP_OFFS                                                                   (0x2038)
#define HWIO_TCL_R2_PPE2TCL1_RING_HP_RMSK                                                                      0xfffff
#define HWIO_TCL_R2_PPE2TCL1_RING_HP_POR                                                                    0x00000000
#define HWIO_TCL_R2_PPE2TCL1_RING_HP_POR_RMSK                                                               0xffffffff
#define HWIO_TCL_R2_PPE2TCL1_RING_HP_ATTR                                                                                0x3
#define HWIO_TCL_R2_PPE2TCL1_RING_HP_IN(x)            \
                in_dword(HWIO_TCL_R2_PPE2TCL1_RING_HP_ADDR(x))
#define HWIO_TCL_R2_PPE2TCL1_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_PPE2TCL1_RING_HP_ADDR(x), m)
#define HWIO_TCL_R2_PPE2TCL1_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_PPE2TCL1_RING_HP_ADDR(x),v)
#define HWIO_TCL_R2_PPE2TCL1_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_PPE2TCL1_RING_HP_ADDR(x),m,v,HWIO_TCL_R2_PPE2TCL1_RING_HP_IN(x))
#define HWIO_TCL_R2_PPE2TCL1_RING_HP_HEAD_PTR_BMSK                                                             0xfffff
#define HWIO_TCL_R2_PPE2TCL1_RING_HP_HEAD_PTR_SHFT                                                                   0

#define HWIO_TCL_R2_PPE2TCL1_RING_TP_ADDR(x)                                                                ((x) + 0x203c)
#define HWIO_TCL_R2_PPE2TCL1_RING_TP_PHYS(x)                                                                ((x) + 0x203c)
#define HWIO_TCL_R2_PPE2TCL1_RING_TP_OFFS                                                                   (0x203c)
#define HWIO_TCL_R2_PPE2TCL1_RING_TP_RMSK                                                                      0xfffff
#define HWIO_TCL_R2_PPE2TCL1_RING_TP_POR                                                                    0x00000000
#define HWIO_TCL_R2_PPE2TCL1_RING_TP_POR_RMSK                                                               0xffffffff
#define HWIO_TCL_R2_PPE2TCL1_RING_TP_ATTR                                                                                0x3
#define HWIO_TCL_R2_PPE2TCL1_RING_TP_IN(x)            \
                in_dword(HWIO_TCL_R2_PPE2TCL1_RING_TP_ADDR(x))
#define HWIO_TCL_R2_PPE2TCL1_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_PPE2TCL1_RING_TP_ADDR(x), m)
#define HWIO_TCL_R2_PPE2TCL1_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_PPE2TCL1_RING_TP_ADDR(x),v)
#define HWIO_TCL_R2_PPE2TCL1_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_PPE2TCL1_RING_TP_ADDR(x),m,v,HWIO_TCL_R2_PPE2TCL1_RING_TP_IN(x))
#define HWIO_TCL_R2_PPE2TCL1_RING_TP_TAIL_PTR_BMSK                                                             0xfffff
#define HWIO_TCL_R2_PPE2TCL1_RING_TP_TAIL_PTR_SHFT                                                                   0

#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_ADDR(x)                                                             ((x) + 0x2048)
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_PHYS(x)                                                             ((x) + 0x2048)
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_OFFS                                                                (0x2048)
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_RMSK                                                                    0xffff
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_POR                                                                 0x00000000
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_ATTR                                                                             0x3
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_IN(x)            \
                in_dword(HWIO_TCL_R2_TCL_STATUS1_RING_HP_ADDR(x))
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_TCL_STATUS1_RING_HP_ADDR(x), m)
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_TCL_STATUS1_RING_HP_ADDR(x),v)
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_TCL_STATUS1_RING_HP_ADDR(x),m,v,HWIO_TCL_R2_TCL_STATUS1_RING_HP_IN(x))
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_HEAD_PTR_BMSK                                                           0xffff
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_HEAD_PTR_SHFT                                                                0

#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_ADDR(x)                                                             ((x) + 0x204c)
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_PHYS(x)                                                             ((x) + 0x204c)
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_OFFS                                                                (0x204c)
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_RMSK                                                                    0xffff
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_POR                                                                 0x00000000
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_ATTR                                                                             0x3
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_IN(x)            \
                in_dword(HWIO_TCL_R2_TCL_STATUS1_RING_TP_ADDR(x))
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_TCL_STATUS1_RING_TP_ADDR(x), m)
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_TCL_STATUS1_RING_TP_ADDR(x),v)
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_TCL_STATUS1_RING_TP_ADDR(x),m,v,HWIO_TCL_R2_TCL_STATUS1_RING_TP_IN(x))
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_TAIL_PTR_BMSK                                                           0xffff
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_TAIL_PTR_SHFT                                                                0

#define HWIO_TCL_R0_CMN_CONFIG_PPE_ADDR(x)                                                                  ((x) + 0x28)
#define HWIO_TCL_R0_CMN_CONFIG_PPE_PHYS(x)                                                                  ((x) + 0x28)
#define HWIO_TCL_R0_CMN_CONFIG_PPE_OFFS                                                                     (0x28)
#define HWIO_TCL_R0_CMN_CONFIG_PPE_RMSK                                                                     0x7fffffff
#define HWIO_TCL_R0_CMN_CONFIG_PPE_POR                                                                      0x120c3fe8
#define HWIO_TCL_R0_CMN_CONFIG_PPE_POR_RMSK                                                                 0xffffffff
#define HWIO_TCL_R0_CMN_CONFIG_PPE_ATTR                                                                                  0x3
#define HWIO_TCL_R0_CMN_CONFIG_PPE_IN(x)            \
                in_dword(HWIO_TCL_R0_CMN_CONFIG_PPE_ADDR(x))
#define HWIO_TCL_R0_CMN_CONFIG_PPE_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_CMN_CONFIG_PPE_ADDR(x), m)
#define HWIO_TCL_R0_CMN_CONFIG_PPE_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_CMN_CONFIG_PPE_ADDR(x),v)
#define HWIO_TCL_R0_CMN_CONFIG_PPE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_CMN_CONFIG_PPE_ADDR(x),m,v,HWIO_TCL_R0_CMN_CONFIG_PPE_IN(x))
#define HWIO_TCL_R0_CMN_CONFIG_PPE_PPE_MAX_DATA_LENGTH_BMSK                                                 0x7ffe0000
#define HWIO_TCL_R0_CMN_CONFIG_PPE_PPE_MAX_DATA_LENGTH_SHFT                                                         17
#define HWIO_TCL_R0_CMN_CONFIG_PPE_PPE_MAX_DATA_OFFSET_BMSK                                                    0x1ffe0
#define HWIO_TCL_R0_CMN_CONFIG_PPE_PPE_MAX_DATA_OFFSET_SHFT                                                          5
#define HWIO_TCL_R0_CMN_CONFIG_PPE_L3_L4_CSUM_ERR_EXCEPTION_BMSK                                                  0x10
#define HWIO_TCL_R0_CMN_CONFIG_PPE_L3_L4_CSUM_ERR_EXCEPTION_SHFT                                                     4
#define HWIO_TCL_R0_CMN_CONFIG_PPE_DATA_BUF_ERR_EXCEPTION_BMSK                                                     0x8
#define HWIO_TCL_R0_CMN_CONFIG_PPE_DATA_BUF_ERR_EXCEPTION_SHFT                                                       3
#define HWIO_TCL_R0_CMN_CONFIG_PPE_CPU_CODE_VALID_EXCEPTION_BMSK                                                   0x4
#define HWIO_TCL_R0_CMN_CONFIG_PPE_CPU_CODE_VALID_EXCEPTION_SHFT                                                     2
#define HWIO_TCL_R0_CMN_CONFIG_PPE_FAKE_MAC_HDR_EXCEPTION_BMSK                                                     0x2
#define HWIO_TCL_R0_CMN_CONFIG_PPE_FAKE_MAC_HDR_EXCEPTION_SHFT                                                       1
#define HWIO_TCL_R0_CMN_CONFIG_PPE_DROP_PREC_ERR_EXCEPTION_BMSK                                                    0x1
#define HWIO_TCL_R0_CMN_CONFIG_PPE_DROP_PREC_ERR_EXCEPTION_SHFT                                                      0

#define HWIO_TCL_R0_PPE_DESC_DST_INFO_VALID_ADDR(x)                                                         ((x) + 0x190)
#define HWIO_TCL_R0_PPE_DESC_DST_INFO_VALID_PHYS(x)                                                         ((x) + 0x190)
#define HWIO_TCL_R0_PPE_DESC_DST_INFO_VALID_OFFS                                                            (0x190)
#define HWIO_TCL_R0_PPE_DESC_DST_INFO_VALID_RMSK                                                                   0xf
#define HWIO_TCL_R0_PPE_DESC_DST_INFO_VALID_POR                                                             0x00000002
#define HWIO_TCL_R0_PPE_DESC_DST_INFO_VALID_POR_RMSK                                                        0xffffffff
#define HWIO_TCL_R0_PPE_DESC_DST_INFO_VALID_ATTR                                                                         0x3
#define HWIO_TCL_R0_PPE_DESC_DST_INFO_VALID_IN(x)            \
	                in_dword(HWIO_TCL_R0_PPE_DESC_DST_INFO_VALID_ADDR(x))
#define HWIO_TCL_R0_PPE_DESC_DST_INFO_VALID_INM(x, m)            \
	                in_dword_masked(HWIO_TCL_R0_PPE_DESC_DST_INFO_VALID_ADDR(x), m)
#define HWIO_TCL_R0_PPE_DESC_DST_INFO_VALID_OUT(x, v)            \
	                out_dword(HWIO_TCL_R0_PPE_DESC_DST_INFO_VALID_ADDR(x),v)
#define HWIO_TCL_R0_PPE_DESC_DST_INFO_VALID_OUTM(x,m,v) \
	                out_dword_masked_ns(HWIO_TCL_R0_PPE_DESC_DST_INFO_VALID_ADDR(x),m,v,HWIO_TCL_R0_PPE_DESC_DST_INFO_VALID_IN(x))
#define HWIO_TCL_R0_PPE_DESC_DST_INFO_VALID_MSB_BMSK                                                               0xf
#define HWIO_TCL_R0_PPE_DESC_DST_INFO_VALID_MSB_SHFT                                                                 0

#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_ADDR(base,n)                                                      ((base) + 0X194 + (0x4*(n)))
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_PHYS(base,n)                                                      ((base) + 0X194 + (0x4*(n)))
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_OFFS(n)                                                           (0X194 + (0x4*(n)))
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_RMSK                                                              0x3fffffff
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_MAXn                                                                      31
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_POR                                                               0x20000000
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_ATTR                                                                           0x3
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_INI(base,n)                \
	                in_dword_masked(HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_ADDR(base,n), HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_RMSK)
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_INMI(base,n,mask)        \
	                in_dword_masked(HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_ADDR(base,n), mask)
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_OUTI(base,n,val)        \
	                out_dword(HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_ADDR(base,n),val)
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_OUTMI(base,n,mask,val) \
	                out_dword_masked_ns(HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_ADDR(base,n),mask,val,HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_INI(base,n))
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_DROP_PREC_ENABLE_BMSK                                             0x20000000
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_DROP_PREC_ENABLE_SHFT                                                     29
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_TO_FW_BMSK                                                        0x10000000
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_TO_FW_SHFT                                                                28
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_USE_PPE_INT_PRI_FOR_TID_BMSK                                       0x8000000
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_USE_PPE_INT_PRI_FOR_TID_SHFT                                              27
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_SEARCH_INDEX_REG_NUM_BMSK                                          0x7000000
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_SEARCH_INDEX_REG_NUM_SHFT                                                 24
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_VDEV_ID_BMSK                                                        0xff0000
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_VDEV_ID_SHFT                                                              16
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_BANK_ID_BMSK                                                          0xfc00
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_BANK_ID_SHFT                                                              10
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_PMAC_ID_BMSK                                                           0x300
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_PMAC_ID_SHFT                                                               8
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_VP_NUM_BMSK                                                             0xff
#define HWIO_TCL_R0_PPE_VP_CONFIG_TABLE_n_VP_NUM_SHFT                                                                0

#define HWIO_TCL_R0_PPE_INDEX_MAPPING_TABLE_n_ADDR(base,n)                                                  ((base) + 0X214 + (0x4*(n)))
#define HWIO_TCL_R0_PPE_INDEX_MAPPING_TABLE_n_PHYS(base,n)                                                  ((base) + 0X214 + (0x4*(n)))
#define HWIO_TCL_R0_PPE_INDEX_MAPPING_TABLE_n_OFFS(n)                                                       (0X214 + (0x4*(n)))
#define HWIO_TCL_R0_PPE_INDEX_MAPPING_TABLE_n_RMSK                                                            0xffffff
#define HWIO_TCL_R0_PPE_INDEX_MAPPING_TABLE_n_MAXn                                                                   7
#define HWIO_TCL_R0_PPE_INDEX_MAPPING_TABLE_n_POR                                                           0x00000000
#define HWIO_TCL_R0_PPE_INDEX_MAPPING_TABLE_n_POR_RMSK                                                      0xffffffff
#define HWIO_TCL_R0_PPE_INDEX_MAPPING_TABLE_n_ATTR                                                                       0x3
#define HWIO_TCL_R0_PPE_INDEX_MAPPING_TABLE_n_INI(base,n)                \
	                in_dword_masked(HWIO_TCL_R0_PPE_INDEX_MAPPING_TABLE_n_ADDR(base,n), HWIO_TCL_R0_PPE_INDEX_MAPPING_TABLE_n_RMSK)
#define HWIO_TCL_R0_PPE_INDEX_MAPPING_TABLE_n_INMI(base,n,mask)        \
	                in_dword_masked(HWIO_TCL_R0_PPE_INDEX_MAPPING_TABLE_n_ADDR(base,n), mask)
#define HWIO_TCL_R0_PPE_INDEX_MAPPING_TABLE_n_OUTI(base,n,val)        \
	                out_dword(HWIO_TCL_R0_PPE_INDEX_MAPPING_TABLE_n_ADDR(base,n),val)
#define HWIO_TCL_R0_PPE_INDEX_MAPPING_TABLE_n_OUTMI(base,n,mask,val) \
	                out_dword_masked_ns(HWIO_TCL_R0_PPE_INDEX_MAPPING_TABLE_n_ADDR(base,n),mask,val,HWIO_TCL_R0_PPE_INDEX_MAPPING_TABLE_n_INI(base,n))
#define HWIO_TCL_R0_PPE_INDEX_MAPPING_TABLE_n_CACHE_SET_BMSK                                                  0xf00000
#define HWIO_TCL_R0_PPE_INDEX_MAPPING_TABLE_n_CACHE_SET_SHFT                                                        20
#define HWIO_TCL_R0_PPE_INDEX_MAPPING_TABLE_n_SEARCH_INDEX_BMSK                                                0xfffff
#define HWIO_TCL_R0_PPE_INDEX_MAPPING_TABLE_n_SEARCH_INDEX_SHFT                                                      0

#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_ADDR(x)                                                            ((x) + 0x234)
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_PHYS(x)                                                            ((x) + 0x234)
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_OFFS                                                               (0x234)
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_RMSK                                                               0x3fffffff
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_POR                                                                0x00000000
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_POR_RMSK                                                           0xffffffff
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_ATTR                                                                            0x3
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_IN(x)            \
	                in_dword(HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_ADDR(x))
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_INM(x, m)            \
	                in_dword_masked(HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_ADDR(x), m)
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_OUT(x, v)            \
	                out_dword(HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_ADDR(x),v)
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_OUTM(x,m,v) \
	                out_dword_masked_ns(HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_ADDR(x),m,v,HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_IN(x))
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_INT_PRI_9_BMSK                                                     0x38000000
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_INT_PRI_9_SHFT                                                             27
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_INT_PRI_8_BMSK                                                      0x7000000
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_INT_PRI_8_SHFT                                                             24
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_INT_PRI_7_BMSK                                                       0xe00000
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_INT_PRI_7_SHFT                                                             21
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_INT_PRI_6_BMSK                                                       0x1c0000
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_INT_PRI_6_SHFT                                                             18
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_INT_PRI_5_BMSK                                                        0x38000
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_INT_PRI_5_SHFT                                                             15
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_INT_PRI_4_BMSK                                                         0x7000
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_INT_PRI_4_SHFT                                                             12
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_INT_PRI_3_BMSK                                                          0xe00
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_INT_PRI_3_SHFT                                                              9
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_INT_PRI_2_BMSK                                                          0x1c0
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_INT_PRI_2_SHFT                                                              6
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_INT_PRI_1_BMSK                                                           0x38
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_INT_PRI_1_SHFT                                                              3
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_INT_PRI_0_BMSK                                                            0x7
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP0_INT_PRI_0_SHFT                                                              0

#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_ADDR(x)                                                            ((x) + 0x238)
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_PHYS(x)                                                            ((x) + 0x238)
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_OFFS                                                               (0x238)
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_RMSK                                                                  0x3ffff
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_POR                                                                0x00000000
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_POR_RMSK                                                           0xffffffff
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_ATTR                                                                            0x3
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_IN(x)            \
	                in_dword(HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_ADDR(x))
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_INM(x, m)            \
	                in_dword_masked(HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_ADDR(x), m)
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_OUT(x, v)            \
	                out_dword(HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_ADDR(x),v)
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_OUTM(x,m,v) \
	                out_dword_masked_ns(HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_ADDR(x),m,v,HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_IN(x))
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_INT_PRI_15_BMSK                                                       0x38000
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_INT_PRI_15_SHFT                                                            15
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_INT_PRI_14_BMSK                                                        0x7000
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_INT_PRI_14_SHFT                                                            12
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_INT_PRI_13_BMSK                                                         0xe00
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_INT_PRI_13_SHFT                                                             9
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_INT_PRI_12_BMSK                                                         0x1c0
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_INT_PRI_12_SHFT                                                             6
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_INT_PRI_11_BMSK                                                          0x38
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_INT_PRI_11_SHFT                                                             3
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_INT_PRI_10_BMSK                                                           0x7
#define HWIO_TCL_R0_PPE_INT_PRI_TID_MAP1_INT_PRI_10_SHFT                                                             0

#define HWIO_TCL_R0_PPE_DROP_PREC_MAPPING_ADDR(x)                                                           ((x) + 0x23c)
#define HWIO_TCL_R0_PPE_DROP_PREC_MAPPING_PHYS(x)                                                           ((x) + 0x23c)
#define HWIO_TCL_R0_PPE_DROP_PREC_MAPPING_OFFS                                                              (0x23c)
#define HWIO_TCL_R0_PPE_DROP_PREC_MAPPING_RMSK                                                                    0x3f
#define HWIO_TCL_R0_PPE_DROP_PREC_MAPPING_POR                                                               0x00000039
#define HWIO_TCL_R0_PPE_DROP_PREC_MAPPING_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_PPE_DROP_PREC_MAPPING_ATTR                                                                           0x3
#define HWIO_TCL_R0_PPE_DROP_PREC_MAPPING_IN(x)            \
	                in_dword(HWIO_TCL_R0_PPE_DROP_PREC_MAPPING_ADDR(x))
#define HWIO_TCL_R0_PPE_DROP_PREC_MAPPING_INM(x, m)            \
	                in_dword_masked(HWIO_TCL_R0_PPE_DROP_PREC_MAPPING_ADDR(x), m)
#define HWIO_TCL_R0_PPE_DROP_PREC_MAPPING_OUT(x, v)            \
	                out_dword(HWIO_TCL_R0_PPE_DROP_PREC_MAPPING_ADDR(x),v)
#define HWIO_TCL_R0_PPE_DROP_PREC_MAPPING_OUTM(x,m,v) \
	                out_dword_masked_ns(HWIO_TCL_R0_PPE_DROP_PREC_MAPPING_ADDR(x),m,v,HWIO_TCL_R0_PPE_DROP_PREC_MAPPING_IN(x))
#define HWIO_TCL_R0_PPE_DROP_PREC_MAPPING_RED_2_BMSK                                                              0x30
#define HWIO_TCL_R0_PPE_DROP_PREC_MAPPING_RED_2_SHFT                                                                 4
#define HWIO_TCL_R0_PPE_DROP_PREC_MAPPING_YELLOW_1_BMSK                                                            0xc
#define HWIO_TCL_R0_PPE_DROP_PREC_MAPPING_YELLOW_1_SHFT                                                              2
#define HWIO_TCL_R0_PPE_DROP_PREC_MAPPING_GREEN_0_BMSK                                                             0x3
#define HWIO_TCL_R0_PPE_DROP_PREC_MAPPING_GREEN_0_SHFT                                                               0

#endif
